"use strict";
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __restKey = (key) => typeof key === "symbol" ? key : key + "";
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
var __esm = (fn, res) => function __init() {
  return fn && (res = (0, fn[__getOwnPropNames(fn)[0]])(fn = 0)), res;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from2, except, desc) => {
  if (from2 && typeof from2 === "object" || typeof from2 === "function") {
    for (let key of __getOwnPropNames(from2))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from2[key], enumerable: !(desc = __getOwnPropDesc(from2, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __publicField = (obj, key, value) => __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);

// ../../../node_modules/.pnpm/@esbuild-plugins+node-globals-polyfill@0.2.3_esbuild@0.24.0/node_modules/@esbuild-plugins/node-globals-polyfill/process.js
function defaultSetTimout() {
  throw new Error("setTimeout has not been defined");
}
function defaultClearTimeout() {
  throw new Error("clearTimeout has not been defined");
}
function runTimeout(fun) {
  if (cachedSetTimeout === setTimeout) {
    return setTimeout(fun, 0);
  }
  if ((cachedSetTimeout === defaultSetTimout || !cachedSetTimeout) && setTimeout) {
    cachedSetTimeout = setTimeout;
    return setTimeout(fun, 0);
  }
  try {
    return cachedSetTimeout(fun, 0);
  } catch (e) {
    try {
      return cachedSetTimeout.call(null, fun, 0);
    } catch (e2) {
      return cachedSetTimeout.call(this, fun, 0);
    }
  }
}
function runClearTimeout(marker) {
  if (cachedClearTimeout === clearTimeout) {
    return clearTimeout(marker);
  }
  if ((cachedClearTimeout === defaultClearTimeout || !cachedClearTimeout) && clearTimeout) {
    cachedClearTimeout = clearTimeout;
    return clearTimeout(marker);
  }
  try {
    return cachedClearTimeout(marker);
  } catch (e) {
    try {
      return cachedClearTimeout.call(null, marker);
    } catch (e2) {
      return cachedClearTimeout.call(this, marker);
    }
  }
}
function cleanUpNextTick() {
  if (!draining || !currentQueue) {
    return;
  }
  draining = false;
  if (currentQueue.length) {
    queue = currentQueue.concat(queue);
  } else {
    queueIndex = -1;
  }
  if (queue.length) {
    drainQueue();
  }
}
function drainQueue() {
  if (draining) {
    return;
  }
  var timeout = runTimeout(cleanUpNextTick);
  draining = true;
  var len = queue.length;
  while (len) {
    currentQueue = queue;
    queue = [];
    while (++queueIndex < len) {
      if (currentQueue) {
        currentQueue[queueIndex].run();
      }
    }
    queueIndex = -1;
    len = queue.length;
  }
  currentQueue = null;
  draining = false;
  runClearTimeout(timeout);
}
function nextTick(fun) {
  var args = new Array(arguments.length - 1);
  if (arguments.length > 1) {
    for (var i = 1; i < arguments.length; i++) {
      args[i - 1] = arguments[i];
    }
  }
  queue.push(new Item(fun, args));
  if (queue.length === 1 && !draining) {
    runTimeout(drainQueue);
  }
}
function Item(fun, array) {
  this.fun = fun;
  this.array = array;
}
function noop() {
}
function binding(name) {
  throw new Error("process.binding is not supported");
}
function cwd() {
  return "/";
}
function chdir(dir) {
  throw new Error("process.chdir is not supported");
}
function umask() {
  return 0;
}
function hrtime(previousTimestamp) {
  var clocktime = performanceNow.call(performance) * 1e-3;
  var seconds = Math.floor(clocktime);
  var nanoseconds = Math.floor(clocktime % 1 * 1e9);
  if (previousTimestamp) {
    seconds = seconds - previousTimestamp[0];
    nanoseconds = nanoseconds - previousTimestamp[1];
    if (nanoseconds < 0) {
      seconds--;
      nanoseconds += 1e9;
    }
  }
  return [seconds, nanoseconds];
}
function uptime() {
  var currentTime = /* @__PURE__ */ new Date();
  var dif = currentTime - startTime;
  return dif / 1e3;
}
var cachedSetTimeout, cachedClearTimeout, queue, draining, currentQueue, queueIndex, title, platform, browser, env, argv, version, versions, release, config, on, addListener, once, off, removeListener, removeAllListeners, emit, performance, performanceNow, startTime, process, defines;
var init_process = __esm({
  "../../../node_modules/.pnpm/@esbuild-plugins+node-globals-polyfill@0.2.3_esbuild@0.24.0/node_modules/@esbuild-plugins/node-globals-polyfill/process.js"() {
    "use strict";
    cachedSetTimeout = defaultSetTimout;
    cachedClearTimeout = defaultClearTimeout;
    if (typeof globalThis.setTimeout === "function") {
      cachedSetTimeout = setTimeout;
    }
    if (typeof globalThis.clearTimeout === "function") {
      cachedClearTimeout = clearTimeout;
    }
    queue = [];
    draining = false;
    queueIndex = -1;
    Item.prototype.run = function() {
      this.fun.apply(null, this.array);
    };
    title = "browser";
    platform = "browser";
    browser = true;
    env = {};
    argv = [];
    version = "";
    versions = {};
    release = {};
    config = {};
    on = noop;
    addListener = noop;
    once = noop;
    off = noop;
    removeListener = noop;
    removeAllListeners = noop;
    emit = noop;
    performance = globalThis.performance || {};
    performanceNow = performance.now || performance.mozNow || performance.msNow || performance.oNow || performance.webkitNow || function() {
      return (/* @__PURE__ */ new Date()).getTime();
    };
    startTime = /* @__PURE__ */ new Date();
    process = {
      nextTick,
      title,
      browser,
      env,
      argv,
      version,
      versions,
      on,
      addListener,
      once,
      off,
      removeListener,
      removeAllListeners,
      emit,
      binding,
      cwd,
      chdir,
      umask,
      hrtime,
      platform,
      release,
      config,
      uptime
    };
    defines = {};
    Object.keys(defines).forEach((key) => {
      const segs = key.split(".");
      let target = process;
      for (let i = 0; i < segs.length; i++) {
        const seg = segs[i];
        if (i === segs.length - 1) {
          target[seg] = defines[key];
        } else {
          target = target[seg] || (target[seg] = {});
        }
      }
    });
  }
});

// ../../../node_modules/.pnpm/@esbuild-plugins+node-globals-polyfill@0.2.3_esbuild@0.24.0/node_modules/@esbuild-plugins/node-globals-polyfill/Buffer.js
function init() {
  inited = true;
  var code = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
  for (var i = 0, len = code.length; i < len; ++i) {
    lookup[i] = code[i];
    revLookup[code.charCodeAt(i)] = i;
  }
  revLookup["-".charCodeAt(0)] = 62;
  revLookup["_".charCodeAt(0)] = 63;
}
function base64toByteArray(b64) {
  if (!inited) {
    init();
  }
  var i, j, l, tmp, placeHolders, arr;
  var len = b64.length;
  if (len % 4 > 0) {
    throw new Error("Invalid string. Length must be a multiple of 4");
  }
  placeHolders = b64[len - 2] === "=" ? 2 : b64[len - 1] === "=" ? 1 : 0;
  arr = new Arr(len * 3 / 4 - placeHolders);
  l = placeHolders > 0 ? len - 4 : len;
  var L = 0;
  for (i = 0, j = 0; i < l; i += 4, j += 3) {
    tmp = revLookup[b64.charCodeAt(i)] << 18 | revLookup[b64.charCodeAt(i + 1)] << 12 | revLookup[b64.charCodeAt(i + 2)] << 6 | revLookup[b64.charCodeAt(i + 3)];
    arr[L++] = tmp >> 16 & 255;
    arr[L++] = tmp >> 8 & 255;
    arr[L++] = tmp & 255;
  }
  if (placeHolders === 2) {
    tmp = revLookup[b64.charCodeAt(i)] << 2 | revLookup[b64.charCodeAt(i + 1)] >> 4;
    arr[L++] = tmp & 255;
  } else if (placeHolders === 1) {
    tmp = revLookup[b64.charCodeAt(i)] << 10 | revLookup[b64.charCodeAt(i + 1)] << 4 | revLookup[b64.charCodeAt(i + 2)] >> 2;
    arr[L++] = tmp >> 8 & 255;
    arr[L++] = tmp & 255;
  }
  return arr;
}
function tripletToBase64(num) {
  return lookup[num >> 18 & 63] + lookup[num >> 12 & 63] + lookup[num >> 6 & 63] + lookup[num & 63];
}
function encodeChunk(uint8, start, end) {
  var tmp;
  var output = [];
  for (var i = start; i < end; i += 3) {
    tmp = (uint8[i] << 16) + (uint8[i + 1] << 8) + uint8[i + 2];
    output.push(tripletToBase64(tmp));
  }
  return output.join("");
}
function base64fromByteArray(uint8) {
  if (!inited) {
    init();
  }
  var tmp;
  var len = uint8.length;
  var extraBytes = len % 3;
  var output = "";
  var parts = [];
  var maxChunkLength = 16383;
  for (var i = 0, len2 = len - extraBytes; i < len2; i += maxChunkLength) {
    parts.push(
      encodeChunk(
        uint8,
        i,
        i + maxChunkLength > len2 ? len2 : i + maxChunkLength
      )
    );
  }
  if (extraBytes === 1) {
    tmp = uint8[len - 1];
    output += lookup[tmp >> 2];
    output += lookup[tmp << 4 & 63];
    output += "==";
  } else if (extraBytes === 2) {
    tmp = (uint8[len - 2] << 8) + uint8[len - 1];
    output += lookup[tmp >> 10];
    output += lookup[tmp >> 4 & 63];
    output += lookup[tmp << 2 & 63];
    output += "=";
  }
  parts.push(output);
  return parts.join("");
}
function kMaxLength() {
  return Buffer2.TYPED_ARRAY_SUPPORT ? 2147483647 : 1073741823;
}
function createBuffer(that, length) {
  if (kMaxLength() < length) {
    throw new RangeError("Invalid typed array length");
  }
  if (Buffer2.TYPED_ARRAY_SUPPORT) {
    that = new Uint8Array(length);
    that.__proto__ = Buffer2.prototype;
  } else {
    if (that === null) {
      that = new Buffer2(length);
    }
    that.length = length;
  }
  return that;
}
function Buffer2(arg, encodingOrOffset, length) {
  if (!Buffer2.TYPED_ARRAY_SUPPORT && !(this instanceof Buffer2)) {
    return new Buffer2(arg, encodingOrOffset, length);
  }
  if (typeof arg === "number") {
    if (typeof encodingOrOffset === "string") {
      throw new Error(
        "If encoding is specified then the first argument must be a string"
      );
    }
    return allocUnsafe(this, arg);
  }
  return from(this, arg, encodingOrOffset, length);
}
function from(that, value, encodingOrOffset, length) {
  if (typeof value === "number") {
    throw new TypeError('"value" argument must not be a number');
  }
  if (typeof ArrayBuffer !== "undefined" && value instanceof ArrayBuffer) {
    return fromArrayBuffer(that, value, encodingOrOffset, length);
  }
  if (typeof value === "string") {
    return fromString(that, value, encodingOrOffset);
  }
  return fromObject(that, value);
}
function assertSize(size) {
  if (typeof size !== "number") {
    throw new TypeError('"size" argument must be a number');
  } else if (size < 0) {
    throw new RangeError('"size" argument must not be negative');
  }
}
function alloc(that, size, fill2, encoding) {
  assertSize(size);
  if (size <= 0) {
    return createBuffer(that, size);
  }
  if (fill2 !== void 0) {
    return typeof encoding === "string" ? createBuffer(that, size).fill(fill2, encoding) : createBuffer(that, size).fill(fill2);
  }
  return createBuffer(that, size);
}
function allocUnsafe(that, size) {
  assertSize(size);
  that = createBuffer(that, size < 0 ? 0 : checked(size) | 0);
  if (!Buffer2.TYPED_ARRAY_SUPPORT) {
    for (var i = 0; i < size; ++i) {
      that[i] = 0;
    }
  }
  return that;
}
function fromString(that, string, encoding) {
  if (typeof encoding !== "string" || encoding === "") {
    encoding = "utf8";
  }
  if (!Buffer2.isEncoding(encoding)) {
    throw new TypeError('"encoding" must be a valid string encoding');
  }
  var length = byteLength(string, encoding) | 0;
  that = createBuffer(that, length);
  var actual = that.write(string, encoding);
  if (actual !== length) {
    that = that.slice(0, actual);
  }
  return that;
}
function fromArrayLike(that, array) {
  var length = array.length < 0 ? 0 : checked(array.length) | 0;
  that = createBuffer(that, length);
  for (var i = 0; i < length; i += 1) {
    that[i] = array[i] & 255;
  }
  return that;
}
function fromArrayBuffer(that, array, byteOffset, length) {
  array.byteLength;
  if (byteOffset < 0 || array.byteLength < byteOffset) {
    throw new RangeError("'offset' is out of bounds");
  }
  if (array.byteLength < byteOffset + (length || 0)) {
    throw new RangeError("'length' is out of bounds");
  }
  if (byteOffset === void 0 && length === void 0) {
    array = new Uint8Array(array);
  } else if (length === void 0) {
    array = new Uint8Array(array, byteOffset);
  } else {
    array = new Uint8Array(array, byteOffset, length);
  }
  if (Buffer2.TYPED_ARRAY_SUPPORT) {
    that = array;
    that.__proto__ = Buffer2.prototype;
  } else {
    that = fromArrayLike(that, array);
  }
  return that;
}
function fromObject(that, obj) {
  if (internalIsBuffer(obj)) {
    var len = checked(obj.length) | 0;
    that = createBuffer(that, len);
    if (that.length === 0) {
      return that;
    }
    obj.copy(that, 0, 0, len);
    return that;
  }
  if (obj) {
    if (typeof ArrayBuffer !== "undefined" && obj.buffer instanceof ArrayBuffer || "length" in obj) {
      if (typeof obj.length !== "number" || isnan(obj.length)) {
        return createBuffer(that, 0);
      }
      return fromArrayLike(that, obj);
    }
    if (obj.type === "Buffer" && Array.isArray(obj.data)) {
      return fromArrayLike(that, obj.data);
    }
  }
  throw new TypeError(
    "First argument must be a string, Buffer, ArrayBuffer, Array, or array-like object."
  );
}
function checked(length) {
  if (length >= kMaxLength()) {
    throw new RangeError(
      "Attempt to allocate Buffer larger than maximum size: 0x" + kMaxLength().toString(16) + " bytes"
    );
  }
  return length | 0;
}
function internalIsBuffer(b) {
  return !!(b != null && b._isBuffer);
}
function byteLength(string, encoding) {
  if (internalIsBuffer(string)) {
    return string.length;
  }
  if (typeof ArrayBuffer !== "undefined" && typeof ArrayBuffer.isView === "function" && (ArrayBuffer.isView(string) || string instanceof ArrayBuffer)) {
    return string.byteLength;
  }
  if (typeof string !== "string") {
    string = "" + string;
  }
  var len = string.length;
  if (len === 0) return 0;
  var loweredCase = false;
  for (; ; ) {
    switch (encoding) {
      case "ascii":
      case "latin1":
      case "binary":
        return len;
      case "utf8":
      case "utf-8":
      case void 0:
        return utf8ToBytes(string).length;
      case "ucs2":
      case "ucs-2":
      case "utf16le":
      case "utf-16le":
        return len * 2;
      case "hex":
        return len >>> 1;
      case "base64":
        return base64ToBytes(string).length;
      default:
        if (loweredCase) return utf8ToBytes(string).length;
        encoding = ("" + encoding).toLowerCase();
        loweredCase = true;
    }
  }
}
function slowToString(encoding, start, end) {
  var loweredCase = false;
  if (start === void 0 || start < 0) {
    start = 0;
  }
  if (start > this.length) {
    return "";
  }
  if (end === void 0 || end > this.length) {
    end = this.length;
  }
  if (end <= 0) {
    return "";
  }
  end >>>= 0;
  start >>>= 0;
  if (end <= start) {
    return "";
  }
  if (!encoding) encoding = "utf8";
  while (true) {
    switch (encoding) {
      case "hex":
        return hexSlice(this, start, end);
      case "utf8":
      case "utf-8":
        return utf8Slice(this, start, end);
      case "ascii":
        return asciiSlice(this, start, end);
      case "latin1":
      case "binary":
        return latin1Slice(this, start, end);
      case "base64":
        return base64Slice(this, start, end);
      case "ucs2":
      case "ucs-2":
      case "utf16le":
      case "utf-16le":
        return utf16leSlice(this, start, end);
      default:
        if (loweredCase)
          throw new TypeError("Unknown encoding: " + encoding);
        encoding = (encoding + "").toLowerCase();
        loweredCase = true;
    }
  }
}
function swap(b, n, m) {
  var i = b[n];
  b[n] = b[m];
  b[m] = i;
}
function bidirectionalIndexOf(buffer, val, byteOffset, encoding, dir) {
  if (buffer.length === 0) return -1;
  if (typeof byteOffset === "string") {
    encoding = byteOffset;
    byteOffset = 0;
  } else if (byteOffset > 2147483647) {
    byteOffset = 2147483647;
  } else if (byteOffset < -2147483648) {
    byteOffset = -2147483648;
  }
  byteOffset = +byteOffset;
  if (isNaN(byteOffset)) {
    byteOffset = dir ? 0 : buffer.length - 1;
  }
  if (byteOffset < 0) byteOffset = buffer.length + byteOffset;
  if (byteOffset >= buffer.length) {
    if (dir) return -1;
    else byteOffset = buffer.length - 1;
  } else if (byteOffset < 0) {
    if (dir) byteOffset = 0;
    else return -1;
  }
  if (typeof val === "string") {
    val = Buffer2.from(val, encoding);
  }
  if (internalIsBuffer(val)) {
    if (val.length === 0) {
      return -1;
    }
    return arrayIndexOf(buffer, val, byteOffset, encoding, dir);
  } else if (typeof val === "number") {
    val = val & 255;
    if (Buffer2.TYPED_ARRAY_SUPPORT && typeof Uint8Array.prototype.indexOf === "function") {
      if (dir) {
        return Uint8Array.prototype.indexOf.call(
          buffer,
          val,
          byteOffset
        );
      } else {
        return Uint8Array.prototype.lastIndexOf.call(
          buffer,
          val,
          byteOffset
        );
      }
    }
    return arrayIndexOf(buffer, [val], byteOffset, encoding, dir);
  }
  throw new TypeError("val must be string, number or Buffer");
}
function arrayIndexOf(arr, val, byteOffset, encoding, dir) {
  var indexSize = 1;
  var arrLength = arr.length;
  var valLength = val.length;
  if (encoding !== void 0) {
    encoding = String(encoding).toLowerCase();
    if (encoding === "ucs2" || encoding === "ucs-2" || encoding === "utf16le" || encoding === "utf-16le") {
      if (arr.length < 2 || val.length < 2) {
        return -1;
      }
      indexSize = 2;
      arrLength /= 2;
      valLength /= 2;
      byteOffset /= 2;
    }
  }
  function read(buf, i2) {
    if (indexSize === 1) {
      return buf[i2];
    } else {
      return buf.readUInt16BE(i2 * indexSize);
    }
  }
  var i;
  if (dir) {
    var foundIndex = -1;
    for (i = byteOffset; i < arrLength; i++) {
      if (read(arr, i) === read(val, foundIndex === -1 ? 0 : i - foundIndex)) {
        if (foundIndex === -1) foundIndex = i;
        if (i - foundIndex + 1 === valLength)
          return foundIndex * indexSize;
      } else {
        if (foundIndex !== -1) i -= i - foundIndex;
        foundIndex = -1;
      }
    }
  } else {
    if (byteOffset + valLength > arrLength)
      byteOffset = arrLength - valLength;
    for (i = byteOffset; i >= 0; i--) {
      var found = true;
      for (var j = 0; j < valLength; j++) {
        if (read(arr, i + j) !== read(val, j)) {
          found = false;
          break;
        }
      }
      if (found) return i;
    }
  }
  return -1;
}
function hexWrite(buf, string, offset, length) {
  offset = Number(offset) || 0;
  var remaining = buf.length - offset;
  if (!length) {
    length = remaining;
  } else {
    length = Number(length);
    if (length > remaining) {
      length = remaining;
    }
  }
  var strLen = string.length;
  if (strLen % 2 !== 0) throw new TypeError("Invalid hex string");
  if (length > strLen / 2) {
    length = strLen / 2;
  }
  for (var i = 0; i < length; ++i) {
    var parsed = parseInt(string.substr(i * 2, 2), 16);
    if (isNaN(parsed)) return i;
    buf[offset + i] = parsed;
  }
  return i;
}
function utf8Write(buf, string, offset, length) {
  return blitBuffer(
    utf8ToBytes(string, buf.length - offset),
    buf,
    offset,
    length
  );
}
function asciiWrite(buf, string, offset, length) {
  return blitBuffer(asciiToBytes(string), buf, offset, length);
}
function latin1Write(buf, string, offset, length) {
  return asciiWrite(buf, string, offset, length);
}
function base64Write(buf, string, offset, length) {
  return blitBuffer(base64ToBytes(string), buf, offset, length);
}
function ucs2Write(buf, string, offset, length) {
  return blitBuffer(
    utf16leToBytes(string, buf.length - offset),
    buf,
    offset,
    length
  );
}
function base64Slice(buf, start, end) {
  if (start === 0 && end === buf.length) {
    return base64fromByteArray(buf);
  } else {
    return base64fromByteArray(buf.slice(start, end));
  }
}
function utf8Slice(buf, start, end) {
  end = Math.min(buf.length, end);
  var res = [];
  var i = start;
  while (i < end) {
    var firstByte = buf[i];
    var codePoint = null;
    var bytesPerSequence = firstByte > 239 ? 4 : firstByte > 223 ? 3 : firstByte > 191 ? 2 : 1;
    if (i + bytesPerSequence <= end) {
      var secondByte, thirdByte, fourthByte, tempCodePoint;
      switch (bytesPerSequence) {
        case 1:
          if (firstByte < 128) {
            codePoint = firstByte;
          }
          break;
        case 2:
          secondByte = buf[i + 1];
          if ((secondByte & 192) === 128) {
            tempCodePoint = (firstByte & 31) << 6 | secondByte & 63;
            if (tempCodePoint > 127) {
              codePoint = tempCodePoint;
            }
          }
          break;
        case 3:
          secondByte = buf[i + 1];
          thirdByte = buf[i + 2];
          if ((secondByte & 192) === 128 && (thirdByte & 192) === 128) {
            tempCodePoint = (firstByte & 15) << 12 | (secondByte & 63) << 6 | thirdByte & 63;
            if (tempCodePoint > 2047 && (tempCodePoint < 55296 || tempCodePoint > 57343)) {
              codePoint = tempCodePoint;
            }
          }
          break;
        case 4:
          secondByte = buf[i + 1];
          thirdByte = buf[i + 2];
          fourthByte = buf[i + 3];
          if ((secondByte & 192) === 128 && (thirdByte & 192) === 128 && (fourthByte & 192) === 128) {
            tempCodePoint = (firstByte & 15) << 18 | (secondByte & 63) << 12 | (thirdByte & 63) << 6 | fourthByte & 63;
            if (tempCodePoint > 65535 && tempCodePoint < 1114112) {
              codePoint = tempCodePoint;
            }
          }
      }
    }
    if (codePoint === null) {
      codePoint = 65533;
      bytesPerSequence = 1;
    } else if (codePoint > 65535) {
      codePoint -= 65536;
      res.push(codePoint >>> 10 & 1023 | 55296);
      codePoint = 56320 | codePoint & 1023;
    }
    res.push(codePoint);
    i += bytesPerSequence;
  }
  return decodeCodePointsArray(res);
}
function decodeCodePointsArray(codePoints) {
  var len = codePoints.length;
  if (len <= MAX_ARGUMENTS_LENGTH) {
    return String.fromCharCode.apply(String, codePoints);
  }
  var res = "";
  var i = 0;
  while (i < len) {
    res += String.fromCharCode.apply(
      String,
      codePoints.slice(i, i += MAX_ARGUMENTS_LENGTH)
    );
  }
  return res;
}
function asciiSlice(buf, start, end) {
  var ret = "";
  end = Math.min(buf.length, end);
  for (var i = start; i < end; ++i) {
    ret += String.fromCharCode(buf[i] & 127);
  }
  return ret;
}
function latin1Slice(buf, start, end) {
  var ret = "";
  end = Math.min(buf.length, end);
  for (var i = start; i < end; ++i) {
    ret += String.fromCharCode(buf[i]);
  }
  return ret;
}
function hexSlice(buf, start, end) {
  var len = buf.length;
  if (!start || start < 0) start = 0;
  if (!end || end < 0 || end > len) end = len;
  var out = "";
  for (var i = start; i < end; ++i) {
    out += toHex(buf[i]);
  }
  return out;
}
function utf16leSlice(buf, start, end) {
  var bytes = buf.slice(start, end);
  var res = "";
  for (var i = 0; i < bytes.length; i += 2) {
    res += String.fromCharCode(bytes[i] + bytes[i + 1] * 256);
  }
  return res;
}
function checkOffset(offset, ext, length) {
  if (offset % 1 !== 0 || offset < 0)
    throw new RangeError("offset is not uint");
  if (offset + ext > length)
    throw new RangeError("Trying to access beyond buffer length");
}
function checkInt(buf, value, offset, ext, max, min) {
  if (!internalIsBuffer(buf))
    throw new TypeError('"buffer" argument must be a Buffer instance');
  if (value > max || value < min)
    throw new RangeError('"value" argument is out of bounds');
  if (offset + ext > buf.length) throw new RangeError("Index out of range");
}
function objectWriteUInt16(buf, value, offset, littleEndian) {
  if (value < 0) value = 65535 + value + 1;
  for (var i = 0, j = Math.min(buf.length - offset, 2); i < j; ++i) {
    buf[offset + i] = (value & 255 << 8 * (littleEndian ? i : 1 - i)) >>> (littleEndian ? i : 1 - i) * 8;
  }
}
function objectWriteUInt32(buf, value, offset, littleEndian) {
  if (value < 0) value = 4294967295 + value + 1;
  for (var i = 0, j = Math.min(buf.length - offset, 4); i < j; ++i) {
    buf[offset + i] = value >>> (littleEndian ? i : 3 - i) * 8 & 255;
  }
}
function checkIEEE754(buf, value, offset, ext, max, min) {
  if (offset + ext > buf.length) throw new RangeError("Index out of range");
  if (offset < 0) throw new RangeError("Index out of range");
}
function writeFloat(buf, value, offset, littleEndian, noAssert) {
  if (!noAssert) {
    checkIEEE754(
      buf,
      value,
      offset,
      4,
      34028234663852886e22,
      -34028234663852886e22
    );
  }
  ieee754write(buf, value, offset, littleEndian, 23, 4);
  return offset + 4;
}
function writeDouble(buf, value, offset, littleEndian, noAssert) {
  if (!noAssert) {
    checkIEEE754(
      buf,
      value,
      offset,
      8,
      17976931348623157e292,
      -17976931348623157e292
    );
  }
  ieee754write(buf, value, offset, littleEndian, 52, 8);
  return offset + 8;
}
function base64clean(str) {
  str = stringtrim(str).replace(INVALID_BASE64_RE, "");
  if (str.length < 2) return "";
  while (str.length % 4 !== 0) {
    str = str + "=";
  }
  return str;
}
function stringtrim(str) {
  if (str.trim) return str.trim();
  return str.replace(/^\s+|\s+$/g, "");
}
function toHex(n) {
  if (n < 16) return "0" + n.toString(16);
  return n.toString(16);
}
function utf8ToBytes(string, units) {
  units = units || Infinity;
  var codePoint;
  var length = string.length;
  var leadSurrogate = null;
  var bytes = [];
  for (var i = 0; i < length; ++i) {
    codePoint = string.charCodeAt(i);
    if (codePoint > 55295 && codePoint < 57344) {
      if (!leadSurrogate) {
        if (codePoint > 56319) {
          if ((units -= 3) > -1) bytes.push(239, 191, 189);
          continue;
        } else if (i + 1 === length) {
          if ((units -= 3) > -1) bytes.push(239, 191, 189);
          continue;
        }
        leadSurrogate = codePoint;
        continue;
      }
      if (codePoint < 56320) {
        if ((units -= 3) > -1) bytes.push(239, 191, 189);
        leadSurrogate = codePoint;
        continue;
      }
      codePoint = (leadSurrogate - 55296 << 10 | codePoint - 56320) + 65536;
    } else if (leadSurrogate) {
      if ((units -= 3) > -1) bytes.push(239, 191, 189);
    }
    leadSurrogate = null;
    if (codePoint < 128) {
      if ((units -= 1) < 0) break;
      bytes.push(codePoint);
    } else if (codePoint < 2048) {
      if ((units -= 2) < 0) break;
      bytes.push(codePoint >> 6 | 192, codePoint & 63 | 128);
    } else if (codePoint < 65536) {
      if ((units -= 3) < 0) break;
      bytes.push(
        codePoint >> 12 | 224,
        codePoint >> 6 & 63 | 128,
        codePoint & 63 | 128
      );
    } else if (codePoint < 1114112) {
      if ((units -= 4) < 0) break;
      bytes.push(
        codePoint >> 18 | 240,
        codePoint >> 12 & 63 | 128,
        codePoint >> 6 & 63 | 128,
        codePoint & 63 | 128
      );
    } else {
      throw new Error("Invalid code point");
    }
  }
  return bytes;
}
function asciiToBytes(str) {
  var byteArray = [];
  for (var i = 0; i < str.length; ++i) {
    byteArray.push(str.charCodeAt(i) & 255);
  }
  return byteArray;
}
function utf16leToBytes(str, units) {
  var c, hi, lo;
  var byteArray = [];
  for (var i = 0; i < str.length; ++i) {
    if ((units -= 2) < 0) break;
    c = str.charCodeAt(i);
    hi = c >> 8;
    lo = c % 256;
    byteArray.push(lo);
    byteArray.push(hi);
  }
  return byteArray;
}
function base64ToBytes(str) {
  return base64toByteArray(base64clean(str));
}
function blitBuffer(src, dst, offset, length) {
  for (var i = 0; i < length; ++i) {
    if (i + offset >= dst.length || i >= src.length) break;
    dst[i + offset] = src[i];
  }
  return i;
}
function isnan(val) {
  return val !== val;
}
function isBuffer(obj) {
  return obj != null && (!!obj._isBuffer || isFastBuffer(obj) || isSlowBuffer(obj));
}
function isFastBuffer(obj) {
  return !!obj.constructor && typeof obj.constructor.isBuffer === "function" && obj.constructor.isBuffer(obj);
}
function isSlowBuffer(obj) {
  return typeof obj.readFloatLE === "function" && typeof obj.slice === "function" && isFastBuffer(obj.slice(0, 0));
}
function ieee754read(buffer, offset, isLE, mLen, nBytes) {
  var e, m;
  var eLen = nBytes * 8 - mLen - 1;
  var eMax = (1 << eLen) - 1;
  var eBias = eMax >> 1;
  var nBits = -7;
  var i = isLE ? nBytes - 1 : 0;
  var d = isLE ? -1 : 1;
  var s = buffer[offset + i];
  i += d;
  e = s & (1 << -nBits) - 1;
  s >>= -nBits;
  nBits += eLen;
  for (; nBits > 0; e = e * 256 + buffer[offset + i], i += d, nBits -= 8) {
  }
  m = e & (1 << -nBits) - 1;
  e >>= -nBits;
  nBits += mLen;
  for (; nBits > 0; m = m * 256 + buffer[offset + i], i += d, nBits -= 8) {
  }
  if (e === 0) {
    e = 1 - eBias;
  } else if (e === eMax) {
    return m ? NaN : (s ? -1 : 1) * Infinity;
  } else {
    m = m + Math.pow(2, mLen);
    e = e - eBias;
  }
  return (s ? -1 : 1) * m * Math.pow(2, e - mLen);
}
function ieee754write(buffer, value, offset, isLE, mLen, nBytes) {
  var e, m, c;
  var eLen = nBytes * 8 - mLen - 1;
  var eMax = (1 << eLen) - 1;
  var eBias = eMax >> 1;
  var rt = mLen === 23 ? Math.pow(2, -24) - Math.pow(2, -77) : 0;
  var i = isLE ? 0 : nBytes - 1;
  var d = isLE ? 1 : -1;
  var s = value < 0 || value === 0 && 1 / value < 0 ? 1 : 0;
  value = Math.abs(value);
  if (isNaN(value) || value === Infinity) {
    m = isNaN(value) ? 1 : 0;
    e = eMax;
  } else {
    e = Math.floor(Math.log(value) / Math.LN2);
    if (value * (c = Math.pow(2, -e)) < 1) {
      e--;
      c *= 2;
    }
    if (e + eBias >= 1) {
      value += rt / c;
    } else {
      value += rt * Math.pow(2, 1 - eBias);
    }
    if (value * c >= 2) {
      e++;
      c /= 2;
    }
    if (e + eBias >= eMax) {
      m = 0;
      e = eMax;
    } else if (e + eBias >= 1) {
      m = (value * c - 1) * Math.pow(2, mLen);
      e = e + eBias;
    } else {
      m = value * Math.pow(2, eBias - 1) * Math.pow(2, mLen);
      e = 0;
    }
  }
  for (; mLen >= 8; buffer[offset + i] = m & 255, i += d, m /= 256, mLen -= 8) {
  }
  e = e << mLen | m;
  eLen += mLen;
  for (; eLen > 0; buffer[offset + i] = e & 255, i += d, e /= 256, eLen -= 8) {
  }
  buffer[offset + i - d] |= s * 128;
}
var lookup, revLookup, Arr, inited, MAX_ARGUMENTS_LENGTH, INVALID_BASE64_RE;
var init_Buffer = __esm({
  "../../../node_modules/.pnpm/@esbuild-plugins+node-globals-polyfill@0.2.3_esbuild@0.24.0/node_modules/@esbuild-plugins/node-globals-polyfill/Buffer.js"() {
    "use strict";
    init_process();
    init_buffer();
    lookup = [];
    revLookup = [];
    Arr = typeof Uint8Array !== "undefined" ? Uint8Array : Array;
    inited = false;
    Buffer2.TYPED_ARRAY_SUPPORT = globalThis.TYPED_ARRAY_SUPPORT !== void 0 ? globalThis.TYPED_ARRAY_SUPPORT : true;
    Buffer2.poolSize = 8192;
    Buffer2._augment = function(arr) {
      arr.__proto__ = Buffer2.prototype;
      return arr;
    };
    Buffer2.from = function(value, encodingOrOffset, length) {
      return from(null, value, encodingOrOffset, length);
    };
    Buffer2.kMaxLength = kMaxLength();
    if (Buffer2.TYPED_ARRAY_SUPPORT) {
      Buffer2.prototype.__proto__ = Uint8Array.prototype;
      Buffer2.__proto__ = Uint8Array;
      if (typeof Symbol !== "undefined" && Symbol.species && Buffer2[Symbol.species] === Buffer2) {
      }
    }
    Buffer2.alloc = function(size, fill2, encoding) {
      return alloc(null, size, fill2, encoding);
    };
    Buffer2.allocUnsafe = function(size) {
      return allocUnsafe(null, size);
    };
    Buffer2.allocUnsafeSlow = function(size) {
      return allocUnsafe(null, size);
    };
    Buffer2.isBuffer = isBuffer;
    Buffer2.compare = function compare(a, b) {
      if (!internalIsBuffer(a) || !internalIsBuffer(b)) {
        throw new TypeError("Arguments must be Buffers");
      }
      if (a === b) return 0;
      var x = a.length;
      var y = b.length;
      for (var i = 0, len = Math.min(x, y); i < len; ++i) {
        if (a[i] !== b[i]) {
          x = a[i];
          y = b[i];
          break;
        }
      }
      if (x < y) return -1;
      if (y < x) return 1;
      return 0;
    };
    Buffer2.isEncoding = function isEncoding(encoding) {
      switch (String(encoding).toLowerCase()) {
        case "hex":
        case "utf8":
        case "utf-8":
        case "ascii":
        case "latin1":
        case "binary":
        case "base64":
        case "ucs2":
        case "ucs-2":
        case "utf16le":
        case "utf-16le":
          return true;
        default:
          return false;
      }
    };
    Buffer2.concat = function concat(list, length) {
      if (!Array.isArray(list)) {
        throw new TypeError('"list" argument must be an Array of Buffers');
      }
      if (list.length === 0) {
        return Buffer2.alloc(0);
      }
      var i;
      if (length === void 0) {
        length = 0;
        for (i = 0; i < list.length; ++i) {
          length += list[i].length;
        }
      }
      var buffer = Buffer2.allocUnsafe(length);
      var pos = 0;
      for (i = 0; i < list.length; ++i) {
        var buf = list[i];
        if (!internalIsBuffer(buf)) {
          throw new TypeError('"list" argument must be an Array of Buffers');
        }
        buf.copy(buffer, pos);
        pos += buf.length;
      }
      return buffer;
    };
    Buffer2.byteLength = byteLength;
    Buffer2.prototype._isBuffer = true;
    Buffer2.prototype.swap16 = function swap16() {
      var len = this.length;
      if (len % 2 !== 0) {
        throw new RangeError("Buffer size must be a multiple of 16-bits");
      }
      for (var i = 0; i < len; i += 2) {
        swap(this, i, i + 1);
      }
      return this;
    };
    Buffer2.prototype.swap32 = function swap32() {
      var len = this.length;
      if (len % 4 !== 0) {
        throw new RangeError("Buffer size must be a multiple of 32-bits");
      }
      for (var i = 0; i < len; i += 4) {
        swap(this, i, i + 3);
        swap(this, i + 1, i + 2);
      }
      return this;
    };
    Buffer2.prototype.swap64 = function swap64() {
      var len = this.length;
      if (len % 8 !== 0) {
        throw new RangeError("Buffer size must be a multiple of 64-bits");
      }
      for (var i = 0; i < len; i += 8) {
        swap(this, i, i + 7);
        swap(this, i + 1, i + 6);
        swap(this, i + 2, i + 5);
        swap(this, i + 3, i + 4);
      }
      return this;
    };
    Buffer2.prototype.toString = function toString() {
      var length = this.length | 0;
      if (length === 0) return "";
      if (arguments.length === 0) return utf8Slice(this, 0, length);
      return slowToString.apply(this, arguments);
    };
    Buffer2.prototype.equals = function equals(b) {
      if (!internalIsBuffer(b)) throw new TypeError("Argument must be a Buffer");
      if (this === b) return true;
      return Buffer2.compare(this, b) === 0;
    };
    Buffer2.prototype.compare = function compare2(target, start, end, thisStart, thisEnd) {
      if (!internalIsBuffer(target)) {
        throw new TypeError("Argument must be a Buffer");
      }
      if (start === void 0) {
        start = 0;
      }
      if (end === void 0) {
        end = target ? target.length : 0;
      }
      if (thisStart === void 0) {
        thisStart = 0;
      }
      if (thisEnd === void 0) {
        thisEnd = this.length;
      }
      if (start < 0 || end > target.length || thisStart < 0 || thisEnd > this.length) {
        throw new RangeError("out of range index");
      }
      if (thisStart >= thisEnd && start >= end) {
        return 0;
      }
      if (thisStart >= thisEnd) {
        return -1;
      }
      if (start >= end) {
        return 1;
      }
      start >>>= 0;
      end >>>= 0;
      thisStart >>>= 0;
      thisEnd >>>= 0;
      if (this === target) return 0;
      var x = thisEnd - thisStart;
      var y = end - start;
      var len = Math.min(x, y);
      var thisCopy = this.slice(thisStart, thisEnd);
      var targetCopy = target.slice(start, end);
      for (var i = 0; i < len; ++i) {
        if (thisCopy[i] !== targetCopy[i]) {
          x = thisCopy[i];
          y = targetCopy[i];
          break;
        }
      }
      if (x < y) return -1;
      if (y < x) return 1;
      return 0;
    };
    Buffer2.prototype.includes = function includes(val, byteOffset, encoding) {
      return this.indexOf(val, byteOffset, encoding) !== -1;
    };
    Buffer2.prototype.indexOf = function indexOf(val, byteOffset, encoding) {
      return bidirectionalIndexOf(this, val, byteOffset, encoding, true);
    };
    Buffer2.prototype.lastIndexOf = function lastIndexOf(val, byteOffset, encoding) {
      return bidirectionalIndexOf(this, val, byteOffset, encoding, false);
    };
    Buffer2.prototype.write = function write(string, offset, length, encoding) {
      if (offset === void 0) {
        encoding = "utf8";
        length = this.length;
        offset = 0;
      } else if (length === void 0 && typeof offset === "string") {
        encoding = offset;
        length = this.length;
        offset = 0;
      } else if (isFinite(offset)) {
        offset = offset | 0;
        if (isFinite(length)) {
          length = length | 0;
          if (encoding === void 0) encoding = "utf8";
        } else {
          encoding = length;
          length = void 0;
        }
      } else {
        throw new Error(
          "Buffer.write(string, encoding, offset[, length]) is no longer supported"
        );
      }
      var remaining = this.length - offset;
      if (length === void 0 || length > remaining) length = remaining;
      if (string.length > 0 && (length < 0 || offset < 0) || offset > this.length) {
        throw new RangeError("Attempt to write outside buffer bounds");
      }
      if (!encoding) encoding = "utf8";
      var loweredCase = false;
      for (; ; ) {
        switch (encoding) {
          case "hex":
            return hexWrite(this, string, offset, length);
          case "utf8":
          case "utf-8":
            return utf8Write(this, string, offset, length);
          case "ascii":
            return asciiWrite(this, string, offset, length);
          case "latin1":
          case "binary":
            return latin1Write(this, string, offset, length);
          case "base64":
            return base64Write(this, string, offset, length);
          case "ucs2":
          case "ucs-2":
          case "utf16le":
          case "utf-16le":
            return ucs2Write(this, string, offset, length);
          default:
            if (loweredCase)
              throw new TypeError("Unknown encoding: " + encoding);
            encoding = ("" + encoding).toLowerCase();
            loweredCase = true;
        }
      }
    };
    Buffer2.prototype.toJSON = function toJSON() {
      return {
        type: "Buffer",
        data: Array.prototype.slice.call(this._arr || this, 0)
      };
    };
    MAX_ARGUMENTS_LENGTH = 4096;
    Buffer2.prototype.slice = function slice(start, end) {
      var len = this.length;
      start = ~~start;
      end = end === void 0 ? len : ~~end;
      if (start < 0) {
        start += len;
        if (start < 0) start = 0;
      } else if (start > len) {
        start = len;
      }
      if (end < 0) {
        end += len;
        if (end < 0) end = 0;
      } else if (end > len) {
        end = len;
      }
      if (end < start) end = start;
      var newBuf;
      if (Buffer2.TYPED_ARRAY_SUPPORT) {
        newBuf = this.subarray(start, end);
        newBuf.__proto__ = Buffer2.prototype;
      } else {
        var sliceLen = end - start;
        newBuf = new Buffer2(sliceLen, void 0);
        for (var i = 0; i < sliceLen; ++i) {
          newBuf[i] = this[i + start];
        }
      }
      return newBuf;
    };
    Buffer2.prototype.readUIntLE = function readUIntLE(offset, byteLength2, noAssert) {
      offset = offset | 0;
      byteLength2 = byteLength2 | 0;
      if (!noAssert) checkOffset(offset, byteLength2, this.length);
      var val = this[offset];
      var mul = 1;
      var i = 0;
      while (++i < byteLength2 && (mul *= 256)) {
        val += this[offset + i] * mul;
      }
      return val;
    };
    Buffer2.prototype.readUIntBE = function readUIntBE(offset, byteLength2, noAssert) {
      offset = offset | 0;
      byteLength2 = byteLength2 | 0;
      if (!noAssert) {
        checkOffset(offset, byteLength2, this.length);
      }
      var val = this[offset + --byteLength2];
      var mul = 1;
      while (byteLength2 > 0 && (mul *= 256)) {
        val += this[offset + --byteLength2] * mul;
      }
      return val;
    };
    Buffer2.prototype.readUInt8 = function readUInt8(offset, noAssert) {
      if (!noAssert) checkOffset(offset, 1, this.length);
      return this[offset];
    };
    Buffer2.prototype.readUInt16LE = function readUInt16LE(offset, noAssert) {
      if (!noAssert) checkOffset(offset, 2, this.length);
      return this[offset] | this[offset + 1] << 8;
    };
    Buffer2.prototype.readUInt16BE = function readUInt16BE(offset, noAssert) {
      if (!noAssert) checkOffset(offset, 2, this.length);
      return this[offset] << 8 | this[offset + 1];
    };
    Buffer2.prototype.readUInt32LE = function readUInt32LE(offset, noAssert) {
      if (!noAssert) checkOffset(offset, 4, this.length);
      return (this[offset] | this[offset + 1] << 8 | this[offset + 2] << 16) + this[offset + 3] * 16777216;
    };
    Buffer2.prototype.readUInt32BE = function readUInt32BE(offset, noAssert) {
      if (!noAssert) checkOffset(offset, 4, this.length);
      return this[offset] * 16777216 + (this[offset + 1] << 16 | this[offset + 2] << 8 | this[offset + 3]);
    };
    Buffer2.prototype.readIntLE = function readIntLE(offset, byteLength2, noAssert) {
      offset = offset | 0;
      byteLength2 = byteLength2 | 0;
      if (!noAssert) checkOffset(offset, byteLength2, this.length);
      var val = this[offset];
      var mul = 1;
      var i = 0;
      while (++i < byteLength2 && (mul *= 256)) {
        val += this[offset + i] * mul;
      }
      mul *= 128;
      if (val >= mul) val -= Math.pow(2, 8 * byteLength2);
      return val;
    };
    Buffer2.prototype.readIntBE = function readIntBE(offset, byteLength2, noAssert) {
      offset = offset | 0;
      byteLength2 = byteLength2 | 0;
      if (!noAssert) checkOffset(offset, byteLength2, this.length);
      var i = byteLength2;
      var mul = 1;
      var val = this[offset + --i];
      while (i > 0 && (mul *= 256)) {
        val += this[offset + --i] * mul;
      }
      mul *= 128;
      if (val >= mul) val -= Math.pow(2, 8 * byteLength2);
      return val;
    };
    Buffer2.prototype.readInt8 = function readInt8(offset, noAssert) {
      if (!noAssert) checkOffset(offset, 1, this.length);
      if (!(this[offset] & 128)) return this[offset];
      return (255 - this[offset] + 1) * -1;
    };
    Buffer2.prototype.readInt16LE = function readInt16LE(offset, noAssert) {
      if (!noAssert) checkOffset(offset, 2, this.length);
      var val = this[offset] | this[offset + 1] << 8;
      return val & 32768 ? val | 4294901760 : val;
    };
    Buffer2.prototype.readInt16BE = function readInt16BE(offset, noAssert) {
      if (!noAssert) checkOffset(offset, 2, this.length);
      var val = this[offset + 1] | this[offset] << 8;
      return val & 32768 ? val | 4294901760 : val;
    };
    Buffer2.prototype.readInt32LE = function readInt32LE(offset, noAssert) {
      if (!noAssert) checkOffset(offset, 4, this.length);
      return this[offset] | this[offset + 1] << 8 | this[offset + 2] << 16 | this[offset + 3] << 24;
    };
    Buffer2.prototype.readInt32BE = function readInt32BE(offset, noAssert) {
      if (!noAssert) checkOffset(offset, 4, this.length);
      return this[offset] << 24 | this[offset + 1] << 16 | this[offset + 2] << 8 | this[offset + 3];
    };
    Buffer2.prototype.readFloatLE = function readFloatLE(offset, noAssert) {
      if (!noAssert) checkOffset(offset, 4, this.length);
      return ieee754read(this, offset, true, 23, 4);
    };
    Buffer2.prototype.readFloatBE = function readFloatBE(offset, noAssert) {
      if (!noAssert) checkOffset(offset, 4, this.length);
      return ieee754read(this, offset, false, 23, 4);
    };
    Buffer2.prototype.readDoubleLE = function readDoubleLE(offset, noAssert) {
      if (!noAssert) checkOffset(offset, 8, this.length);
      return ieee754read(this, offset, true, 52, 8);
    };
    Buffer2.prototype.readDoubleBE = function readDoubleBE(offset, noAssert) {
      if (!noAssert) checkOffset(offset, 8, this.length);
      return ieee754read(this, offset, false, 52, 8);
    };
    Buffer2.prototype.writeUIntLE = function writeUIntLE(value, offset, byteLength2, noAssert) {
      value = +value;
      offset = offset | 0;
      byteLength2 = byteLength2 | 0;
      if (!noAssert) {
        var maxBytes = Math.pow(2, 8 * byteLength2) - 1;
        checkInt(this, value, offset, byteLength2, maxBytes, 0);
      }
      var mul = 1;
      var i = 0;
      this[offset] = value & 255;
      while (++i < byteLength2 && (mul *= 256)) {
        this[offset + i] = value / mul & 255;
      }
      return offset + byteLength2;
    };
    Buffer2.prototype.writeUIntBE = function writeUIntBE(value, offset, byteLength2, noAssert) {
      value = +value;
      offset = offset | 0;
      byteLength2 = byteLength2 | 0;
      if (!noAssert) {
        var maxBytes = Math.pow(2, 8 * byteLength2) - 1;
        checkInt(this, value, offset, byteLength2, maxBytes, 0);
      }
      var i = byteLength2 - 1;
      var mul = 1;
      this[offset + i] = value & 255;
      while (--i >= 0 && (mul *= 256)) {
        this[offset + i] = value / mul & 255;
      }
      return offset + byteLength2;
    };
    Buffer2.prototype.writeUInt8 = function writeUInt8(value, offset, noAssert) {
      value = +value;
      offset = offset | 0;
      if (!noAssert) checkInt(this, value, offset, 1, 255, 0);
      if (!Buffer2.TYPED_ARRAY_SUPPORT) value = Math.floor(value);
      this[offset] = value & 255;
      return offset + 1;
    };
    Buffer2.prototype.writeUInt16LE = function writeUInt16LE(value, offset, noAssert) {
      value = +value;
      offset = offset | 0;
      if (!noAssert) checkInt(this, value, offset, 2, 65535, 0);
      if (Buffer2.TYPED_ARRAY_SUPPORT) {
        this[offset] = value & 255;
        this[offset + 1] = value >>> 8;
      } else {
        objectWriteUInt16(this, value, offset, true);
      }
      return offset + 2;
    };
    Buffer2.prototype.writeUInt16BE = function writeUInt16BE(value, offset, noAssert) {
      value = +value;
      offset = offset | 0;
      if (!noAssert) checkInt(this, value, offset, 2, 65535, 0);
      if (Buffer2.TYPED_ARRAY_SUPPORT) {
        this[offset] = value >>> 8;
        this[offset + 1] = value & 255;
      } else {
        objectWriteUInt16(this, value, offset, false);
      }
      return offset + 2;
    };
    Buffer2.prototype.writeUInt32LE = function writeUInt32LE(value, offset, noAssert) {
      value = +value;
      offset = offset | 0;
      if (!noAssert) checkInt(this, value, offset, 4, 4294967295, 0);
      if (Buffer2.TYPED_ARRAY_SUPPORT) {
        this[offset + 3] = value >>> 24;
        this[offset + 2] = value >>> 16;
        this[offset + 1] = value >>> 8;
        this[offset] = value & 255;
      } else {
        objectWriteUInt32(this, value, offset, true);
      }
      return offset + 4;
    };
    Buffer2.prototype.writeUInt32BE = function writeUInt32BE(value, offset, noAssert) {
      value = +value;
      offset = offset | 0;
      if (!noAssert) checkInt(this, value, offset, 4, 4294967295, 0);
      if (Buffer2.TYPED_ARRAY_SUPPORT) {
        this[offset] = value >>> 24;
        this[offset + 1] = value >>> 16;
        this[offset + 2] = value >>> 8;
        this[offset + 3] = value & 255;
      } else {
        objectWriteUInt32(this, value, offset, false);
      }
      return offset + 4;
    };
    Buffer2.prototype.writeIntLE = function writeIntLE(value, offset, byteLength2, noAssert) {
      value = +value;
      offset = offset | 0;
      if (!noAssert) {
        var limit = Math.pow(2, 8 * byteLength2 - 1);
        checkInt(this, value, offset, byteLength2, limit - 1, -limit);
      }
      var i = 0;
      var mul = 1;
      var sub = 0;
      this[offset] = value & 255;
      while (++i < byteLength2 && (mul *= 256)) {
        if (value < 0 && sub === 0 && this[offset + i - 1] !== 0) {
          sub = 1;
        }
        this[offset + i] = (value / mul >> 0) - sub & 255;
      }
      return offset + byteLength2;
    };
    Buffer2.prototype.writeIntBE = function writeIntBE(value, offset, byteLength2, noAssert) {
      value = +value;
      offset = offset | 0;
      if (!noAssert) {
        var limit = Math.pow(2, 8 * byteLength2 - 1);
        checkInt(this, value, offset, byteLength2, limit - 1, -limit);
      }
      var i = byteLength2 - 1;
      var mul = 1;
      var sub = 0;
      this[offset + i] = value & 255;
      while (--i >= 0 && (mul *= 256)) {
        if (value < 0 && sub === 0 && this[offset + i + 1] !== 0) {
          sub = 1;
        }
        this[offset + i] = (value / mul >> 0) - sub & 255;
      }
      return offset + byteLength2;
    };
    Buffer2.prototype.writeInt8 = function writeInt8(value, offset, noAssert) {
      value = +value;
      offset = offset | 0;
      if (!noAssert) checkInt(this, value, offset, 1, 127, -128);
      if (!Buffer2.TYPED_ARRAY_SUPPORT) value = Math.floor(value);
      if (value < 0) value = 255 + value + 1;
      this[offset] = value & 255;
      return offset + 1;
    };
    Buffer2.prototype.writeInt16LE = function writeInt16LE(value, offset, noAssert) {
      value = +value;
      offset = offset | 0;
      if (!noAssert) checkInt(this, value, offset, 2, 32767, -32768);
      if (Buffer2.TYPED_ARRAY_SUPPORT) {
        this[offset] = value & 255;
        this[offset + 1] = value >>> 8;
      } else {
        objectWriteUInt16(this, value, offset, true);
      }
      return offset + 2;
    };
    Buffer2.prototype.writeInt16BE = function writeInt16BE(value, offset, noAssert) {
      value = +value;
      offset = offset | 0;
      if (!noAssert) checkInt(this, value, offset, 2, 32767, -32768);
      if (Buffer2.TYPED_ARRAY_SUPPORT) {
        this[offset] = value >>> 8;
        this[offset + 1] = value & 255;
      } else {
        objectWriteUInt16(this, value, offset, false);
      }
      return offset + 2;
    };
    Buffer2.prototype.writeInt32LE = function writeInt32LE(value, offset, noAssert) {
      value = +value;
      offset = offset | 0;
      if (!noAssert) checkInt(this, value, offset, 4, 2147483647, -2147483648);
      if (Buffer2.TYPED_ARRAY_SUPPORT) {
        this[offset] = value & 255;
        this[offset + 1] = value >>> 8;
        this[offset + 2] = value >>> 16;
        this[offset + 3] = value >>> 24;
      } else {
        objectWriteUInt32(this, value, offset, true);
      }
      return offset + 4;
    };
    Buffer2.prototype.writeInt32BE = function writeInt32BE(value, offset, noAssert) {
      value = +value;
      offset = offset | 0;
      if (!noAssert) checkInt(this, value, offset, 4, 2147483647, -2147483648);
      if (value < 0) value = 4294967295 + value + 1;
      if (Buffer2.TYPED_ARRAY_SUPPORT) {
        this[offset] = value >>> 24;
        this[offset + 1] = value >>> 16;
        this[offset + 2] = value >>> 8;
        this[offset + 3] = value & 255;
      } else {
        objectWriteUInt32(this, value, offset, false);
      }
      return offset + 4;
    };
    Buffer2.prototype.writeFloatLE = function writeFloatLE(value, offset, noAssert) {
      return writeFloat(this, value, offset, true, noAssert);
    };
    Buffer2.prototype.writeFloatBE = function writeFloatBE(value, offset, noAssert) {
      return writeFloat(this, value, offset, false, noAssert);
    };
    Buffer2.prototype.writeDoubleLE = function writeDoubleLE(value, offset, noAssert) {
      return writeDouble(this, value, offset, true, noAssert);
    };
    Buffer2.prototype.writeDoubleBE = function writeDoubleBE(value, offset, noAssert) {
      return writeDouble(this, value, offset, false, noAssert);
    };
    Buffer2.prototype.copy = function copy(target, targetStart, start, end) {
      if (!start) start = 0;
      if (!end && end !== 0) end = this.length;
      if (targetStart >= target.length) targetStart = target.length;
      if (!targetStart) targetStart = 0;
      if (end > 0 && end < start) end = start;
      if (end === start) return 0;
      if (target.length === 0 || this.length === 0) return 0;
      if (targetStart < 0) {
        throw new RangeError("targetStart out of bounds");
      }
      if (start < 0 || start >= this.length)
        throw new RangeError("sourceStart out of bounds");
      if (end < 0) throw new RangeError("sourceEnd out of bounds");
      if (end > this.length) end = this.length;
      if (target.length - targetStart < end - start) {
        end = target.length - targetStart + start;
      }
      var len = end - start;
      var i;
      if (this === target && start < targetStart && targetStart < end) {
        for (i = len - 1; i >= 0; --i) {
          target[i + targetStart] = this[i + start];
        }
      } else if (len < 1e3 || !Buffer2.TYPED_ARRAY_SUPPORT) {
        for (i = 0; i < len; ++i) {
          target[i + targetStart] = this[i + start];
        }
      } else {
        Uint8Array.prototype.set.call(
          target,
          this.subarray(start, start + len),
          targetStart
        );
      }
      return len;
    };
    Buffer2.prototype.fill = function fill(val, start, end, encoding) {
      if (typeof val === "string") {
        if (typeof start === "string") {
          encoding = start;
          start = 0;
          end = this.length;
        } else if (typeof end === "string") {
          encoding = end;
          end = this.length;
        }
        if (val.length === 1) {
          var code = val.charCodeAt(0);
          if (code < 256) {
            val = code;
          }
        }
        if (encoding !== void 0 && typeof encoding !== "string") {
          throw new TypeError("encoding must be a string");
        }
        if (typeof encoding === "string" && !Buffer2.isEncoding(encoding)) {
          throw new TypeError("Unknown encoding: " + encoding);
        }
      } else if (typeof val === "number") {
        val = val & 255;
      }
      if (start < 0 || this.length < start || this.length < end) {
        throw new RangeError("Out of range index");
      }
      if (end <= start) {
        return this;
      }
      start = start >>> 0;
      end = end === void 0 ? this.length : end >>> 0;
      if (!val) val = 0;
      var i;
      if (typeof val === "number") {
        for (i = start; i < end; ++i) {
          this[i] = val;
        }
      } else {
        var bytes = internalIsBuffer(val) ? val : utf8ToBytes(new Buffer2(val, encoding).toString());
        var len = bytes.length;
        for (i = 0; i < end - start; ++i) {
          this[i + start] = bytes[i % len];
        }
      }
      return this;
    };
    INVALID_BASE64_RE = /[^+\/0-9A-Za-z-_]/g;
  }
});

// ../../../node_modules/.pnpm/@esbuild-plugins+node-globals-polyfill@0.2.3_esbuild@0.24.0/node_modules/@esbuild-plugins/node-globals-polyfill/_buffer.js
var init_buffer = __esm({
  "../../../node_modules/.pnpm/@esbuild-plugins+node-globals-polyfill@0.2.3_esbuild@0.24.0/node_modules/@esbuild-plugins/node-globals-polyfill/_buffer.js"() {
    "use strict";
    init_Buffer();
  }
});

// src/context/DynamicSnippetsGeneratorContext.ts
var DynamicSnippetsGeneratorContext_exports = {};
__export(DynamicSnippetsGeneratorContext_exports, {
  DynamicSnippetsGeneratorContext: () => DynamicSnippetsGeneratorContext
});
module.exports = __toCommonJS(DynamicSnippetsGeneratorContext_exports);
init_process();
init_buffer();

// ../../../packages/commons/core-utils/lib/index.js
init_process();
init_buffer();

// ../../../packages/commons/core-utils/lib/assertNever.js
init_process();
init_buffer();
function assertNever(x) {
  throw new Error("Unexpected value: " + JSON.stringify(x));
}

// ../../../packages/commons/core-utils/lib/objects/keys.js
init_process();
init_buffer();
function keys(object) {
  return Object.keys(object);
}

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/lodash.js
init_process();
init_buffer();

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isSymbol.js
init_process();
init_buffer();

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseGetTag.js
init_process();
init_buffer();

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_Symbol.js
init_process();
init_buffer();

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_root.js
init_process();
init_buffer();

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_freeGlobal.js
init_process();
init_buffer();
var freeGlobal = typeof globalThis == "object" && globalThis && globalThis.Object === Object && globalThis;
var freeGlobal_default = freeGlobal;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_root.js
var freeSelf = typeof self == "object" && self && self.Object === Object && self;
var root = freeGlobal_default || freeSelf || Function("return this")();
var root_default = root;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_Symbol.js
var Symbol2 = root_default.Symbol;
var Symbol_default = Symbol2;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_getRawTag.js
init_process();
init_buffer();
var objectProto = Object.prototype;
var hasOwnProperty = objectProto.hasOwnProperty;
var nativeObjectToString = objectProto.toString;
var symToStringTag = Symbol_default ? Symbol_default.toStringTag : void 0;
function getRawTag(value) {
  var isOwn = hasOwnProperty.call(value, symToStringTag), tag = value[symToStringTag];
  try {
    value[symToStringTag] = void 0;
    var unmasked = true;
  } catch (e) {
  }
  var result = nativeObjectToString.call(value);
  if (unmasked) {
    if (isOwn) {
      value[symToStringTag] = tag;
    } else {
      delete value[symToStringTag];
    }
  }
  return result;
}
var getRawTag_default = getRawTag;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_objectToString.js
init_process();
init_buffer();
var objectProto2 = Object.prototype;
var nativeObjectToString2 = objectProto2.toString;
function objectToString(value) {
  return nativeObjectToString2.call(value);
}
var objectToString_default = objectToString;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseGetTag.js
var nullTag = "[object Null]";
var undefinedTag = "[object Undefined]";
var symToStringTag2 = Symbol_default ? Symbol_default.toStringTag : void 0;
function baseGetTag(value) {
  if (value == null) {
    return value === void 0 ? undefinedTag : nullTag;
  }
  return symToStringTag2 && symToStringTag2 in Object(value) ? getRawTag_default(value) : objectToString_default(value);
}
var baseGetTag_default = baseGetTag;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isObjectLike.js
init_process();
init_buffer();
function isObjectLike(value) {
  return value != null && typeof value == "object";
}
var isObjectLike_default = isObjectLike;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isSymbol.js
var symbolTag = "[object Symbol]";
function isSymbol(value) {
  return typeof value == "symbol" || isObjectLike_default(value) && baseGetTag_default(value) == symbolTag;
}
var isSymbol_default = isSymbol;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseToString.js
init_process();
init_buffer();

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_arrayMap.js
init_process();
init_buffer();
function arrayMap(array, iteratee) {
  var index = -1, length = array == null ? 0 : array.length, result = Array(length);
  while (++index < length) {
    result[index] = iteratee(array[index], index, array);
  }
  return result;
}
var arrayMap_default = arrayMap;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isArray.js
init_process();
init_buffer();
var isArray = Array.isArray;
var isArray_default = isArray;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseToString.js
var INFINITY = 1 / 0;
var symbolProto = Symbol_default ? Symbol_default.prototype : void 0;
var symbolToString = symbolProto ? symbolProto.toString : void 0;
function baseToString(value) {
  if (typeof value == "string") {
    return value;
  }
  if (isArray_default(value)) {
    return arrayMap_default(value, baseToString) + "";
  }
  if (isSymbol_default(value)) {
    return symbolToString ? symbolToString.call(value) : "";
  }
  var result = value + "";
  return result == "0" && 1 / value == -INFINITY ? "-0" : result;
}
var baseToString_default = baseToString;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/toString.js
init_process();
init_buffer();
function toString2(value) {
  return value == null ? "" : baseToString_default(value);
}
var toString_default = toString2;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/camelCase.js
init_process();
init_buffer();

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/capitalize.js
init_process();
init_buffer();

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/upperFirst.js
init_process();
init_buffer();

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_createCaseFirst.js
init_process();
init_buffer();

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_castSlice.js
init_process();
init_buffer();

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseSlice.js
init_process();
init_buffer();
function baseSlice(array, start, end) {
  var index = -1, length = array.length;
  if (start < 0) {
    start = -start > length ? 0 : length + start;
  }
  end = end > length ? length : end;
  if (end < 0) {
    end += length;
  }
  length = start > end ? 0 : end - start >>> 0;
  start >>>= 0;
  var result = Array(length);
  while (++index < length) {
    result[index] = array[index + start];
  }
  return result;
}
var baseSlice_default = baseSlice;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_castSlice.js
function castSlice(array, start, end) {
  var length = array.length;
  end = end === void 0 ? length : end;
  return !start && end >= length ? array : baseSlice_default(array, start, end);
}
var castSlice_default = castSlice;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_hasUnicode.js
init_process();
init_buffer();
var rsAstralRange = "\\ud800-\\udfff";
var rsComboMarksRange = "\\u0300-\\u036f";
var reComboHalfMarksRange = "\\ufe20-\\ufe2f";
var rsComboSymbolsRange = "\\u20d0-\\u20ff";
var rsComboRange = rsComboMarksRange + reComboHalfMarksRange + rsComboSymbolsRange;
var rsVarRange = "\\ufe0e\\ufe0f";
var rsZWJ = "\\u200d";
var reHasUnicode = RegExp("[" + rsZWJ + rsAstralRange + rsComboRange + rsVarRange + "]");
function hasUnicode(string) {
  return reHasUnicode.test(string);
}
var hasUnicode_default = hasUnicode;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_stringToArray.js
init_process();
init_buffer();

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_asciiToArray.js
init_process();
init_buffer();
function asciiToArray(string) {
  return string.split("");
}
var asciiToArray_default = asciiToArray;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_unicodeToArray.js
init_process();
init_buffer();
var rsAstralRange2 = "\\ud800-\\udfff";
var rsComboMarksRange2 = "\\u0300-\\u036f";
var reComboHalfMarksRange2 = "\\ufe20-\\ufe2f";
var rsComboSymbolsRange2 = "\\u20d0-\\u20ff";
var rsComboRange2 = rsComboMarksRange2 + reComboHalfMarksRange2 + rsComboSymbolsRange2;
var rsVarRange2 = "\\ufe0e\\ufe0f";
var rsAstral = "[" + rsAstralRange2 + "]";
var rsCombo = "[" + rsComboRange2 + "]";
var rsFitz = "\\ud83c[\\udffb-\\udfff]";
var rsModifier = "(?:" + rsCombo + "|" + rsFitz + ")";
var rsNonAstral = "[^" + rsAstralRange2 + "]";
var rsRegional = "(?:\\ud83c[\\udde6-\\uddff]){2}";
var rsSurrPair = "[\\ud800-\\udbff][\\udc00-\\udfff]";
var rsZWJ2 = "\\u200d";
var reOptMod = rsModifier + "?";
var rsOptVar = "[" + rsVarRange2 + "]?";
var rsOptJoin = "(?:" + rsZWJ2 + "(?:" + [rsNonAstral, rsRegional, rsSurrPair].join("|") + ")" + rsOptVar + reOptMod + ")*";
var rsSeq = rsOptVar + reOptMod + rsOptJoin;
var rsSymbol = "(?:" + [rsNonAstral + rsCombo + "?", rsCombo, rsRegional, rsSurrPair, rsAstral].join("|") + ")";
var reUnicode = RegExp(rsFitz + "(?=" + rsFitz + ")|" + rsSymbol + rsSeq, "g");
function unicodeToArray(string) {
  return string.match(reUnicode) || [];
}
var unicodeToArray_default = unicodeToArray;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_stringToArray.js
function stringToArray(string) {
  return hasUnicode_default(string) ? unicodeToArray_default(string) : asciiToArray_default(string);
}
var stringToArray_default = stringToArray;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_createCaseFirst.js
function createCaseFirst(methodName) {
  return function(string) {
    string = toString_default(string);
    var strSymbols = hasUnicode_default(string) ? stringToArray_default(string) : void 0;
    var chr = strSymbols ? strSymbols[0] : string.charAt(0);
    var trailing = strSymbols ? castSlice_default(strSymbols, 1).join("") : string.slice(1);
    return chr[methodName]() + trailing;
  };
}
var createCaseFirst_default = createCaseFirst;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/upperFirst.js
var upperFirst = createCaseFirst_default("toUpperCase");
var upperFirst_default = upperFirst;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/capitalize.js
function capitalize(string) {
  return upperFirst_default(toString_default(string).toLowerCase());
}
var capitalize_default = capitalize;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_createCompounder.js
init_process();
init_buffer();

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_arrayReduce.js
init_process();
init_buffer();
function arrayReduce(array, iteratee, accumulator, initAccum) {
  var index = -1, length = array == null ? 0 : array.length;
  if (initAccum && length) {
    accumulator = array[++index];
  }
  while (++index < length) {
    accumulator = iteratee(accumulator, array[index], index, array);
  }
  return accumulator;
}
var arrayReduce_default = arrayReduce;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/deburr.js
init_process();
init_buffer();

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_deburrLetter.js
init_process();
init_buffer();

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_basePropertyOf.js
init_process();
init_buffer();
function basePropertyOf(object) {
  return function(key) {
    return object == null ? void 0 : object[key];
  };
}
var basePropertyOf_default = basePropertyOf;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_deburrLetter.js
var deburredLetters = {
  // Latin-1 Supplement block.
  "\xC0": "A",
  "\xC1": "A",
  "\xC2": "A",
  "\xC3": "A",
  "\xC4": "A",
  "\xC5": "A",
  "\xE0": "a",
  "\xE1": "a",
  "\xE2": "a",
  "\xE3": "a",
  "\xE4": "a",
  "\xE5": "a",
  "\xC7": "C",
  "\xE7": "c",
  "\xD0": "D",
  "\xF0": "d",
  "\xC8": "E",
  "\xC9": "E",
  "\xCA": "E",
  "\xCB": "E",
  "\xE8": "e",
  "\xE9": "e",
  "\xEA": "e",
  "\xEB": "e",
  "\xCC": "I",
  "\xCD": "I",
  "\xCE": "I",
  "\xCF": "I",
  "\xEC": "i",
  "\xED": "i",
  "\xEE": "i",
  "\xEF": "i",
  "\xD1": "N",
  "\xF1": "n",
  "\xD2": "O",
  "\xD3": "O",
  "\xD4": "O",
  "\xD5": "O",
  "\xD6": "O",
  "\xD8": "O",
  "\xF2": "o",
  "\xF3": "o",
  "\xF4": "o",
  "\xF5": "o",
  "\xF6": "o",
  "\xF8": "o",
  "\xD9": "U",
  "\xDA": "U",
  "\xDB": "U",
  "\xDC": "U",
  "\xF9": "u",
  "\xFA": "u",
  "\xFB": "u",
  "\xFC": "u",
  "\xDD": "Y",
  "\xFD": "y",
  "\xFF": "y",
  "\xC6": "Ae",
  "\xE6": "ae",
  "\xDE": "Th",
  "\xFE": "th",
  "\xDF": "ss",
  // Latin Extended-A block.
  "\u0100": "A",
  "\u0102": "A",
  "\u0104": "A",
  "\u0101": "a",
  "\u0103": "a",
  "\u0105": "a",
  "\u0106": "C",
  "\u0108": "C",
  "\u010A": "C",
  "\u010C": "C",
  "\u0107": "c",
  "\u0109": "c",
  "\u010B": "c",
  "\u010D": "c",
  "\u010E": "D",
  "\u0110": "D",
  "\u010F": "d",
  "\u0111": "d",
  "\u0112": "E",
  "\u0114": "E",
  "\u0116": "E",
  "\u0118": "E",
  "\u011A": "E",
  "\u0113": "e",
  "\u0115": "e",
  "\u0117": "e",
  "\u0119": "e",
  "\u011B": "e",
  "\u011C": "G",
  "\u011E": "G",
  "\u0120": "G",
  "\u0122": "G",
  "\u011D": "g",
  "\u011F": "g",
  "\u0121": "g",
  "\u0123": "g",
  "\u0124": "H",
  "\u0126": "H",
  "\u0125": "h",
  "\u0127": "h",
  "\u0128": "I",
  "\u012A": "I",
  "\u012C": "I",
  "\u012E": "I",
  "\u0130": "I",
  "\u0129": "i",
  "\u012B": "i",
  "\u012D": "i",
  "\u012F": "i",
  "\u0131": "i",
  "\u0134": "J",
  "\u0135": "j",
  "\u0136": "K",
  "\u0137": "k",
  "\u0138": "k",
  "\u0139": "L",
  "\u013B": "L",
  "\u013D": "L",
  "\u013F": "L",
  "\u0141": "L",
  "\u013A": "l",
  "\u013C": "l",
  "\u013E": "l",
  "\u0140": "l",
  "\u0142": "l",
  "\u0143": "N",
  "\u0145": "N",
  "\u0147": "N",
  "\u014A": "N",
  "\u0144": "n",
  "\u0146": "n",
  "\u0148": "n",
  "\u014B": "n",
  "\u014C": "O",
  "\u014E": "O",
  "\u0150": "O",
  "\u014D": "o",
  "\u014F": "o",
  "\u0151": "o",
  "\u0154": "R",
  "\u0156": "R",
  "\u0158": "R",
  "\u0155": "r",
  "\u0157": "r",
  "\u0159": "r",
  "\u015A": "S",
  "\u015C": "S",
  "\u015E": "S",
  "\u0160": "S",
  "\u015B": "s",
  "\u015D": "s",
  "\u015F": "s",
  "\u0161": "s",
  "\u0162": "T",
  "\u0164": "T",
  "\u0166": "T",
  "\u0163": "t",
  "\u0165": "t",
  "\u0167": "t",
  "\u0168": "U",
  "\u016A": "U",
  "\u016C": "U",
  "\u016E": "U",
  "\u0170": "U",
  "\u0172": "U",
  "\u0169": "u",
  "\u016B": "u",
  "\u016D": "u",
  "\u016F": "u",
  "\u0171": "u",
  "\u0173": "u",
  "\u0174": "W",
  "\u0175": "w",
  "\u0176": "Y",
  "\u0177": "y",
  "\u0178": "Y",
  "\u0179": "Z",
  "\u017B": "Z",
  "\u017D": "Z",
  "\u017A": "z",
  "\u017C": "z",
  "\u017E": "z",
  "\u0132": "IJ",
  "\u0133": "ij",
  "\u0152": "Oe",
  "\u0153": "oe",
  "\u0149": "'n",
  "\u017F": "s"
};
var deburrLetter = basePropertyOf_default(deburredLetters);
var deburrLetter_default = deburrLetter;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/deburr.js
var reLatin = /[\xc0-\xd6\xd8-\xf6\xf8-\xff\u0100-\u017f]/g;
var rsComboMarksRange3 = "\\u0300-\\u036f";
var reComboHalfMarksRange3 = "\\ufe20-\\ufe2f";
var rsComboSymbolsRange3 = "\\u20d0-\\u20ff";
var rsComboRange3 = rsComboMarksRange3 + reComboHalfMarksRange3 + rsComboSymbolsRange3;
var rsCombo2 = "[" + rsComboRange3 + "]";
var reComboMark = RegExp(rsCombo2, "g");
function deburr(string) {
  string = toString_default(string);
  return string && string.replace(reLatin, deburrLetter_default).replace(reComboMark, "");
}
var deburr_default = deburr;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/words.js
init_process();
init_buffer();

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_asciiWords.js
init_process();
init_buffer();
var reAsciiWord = /[^\x00-\x2f\x3a-\x40\x5b-\x60\x7b-\x7f]+/g;
function asciiWords(string) {
  return string.match(reAsciiWord) || [];
}
var asciiWords_default = asciiWords;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_hasUnicodeWord.js
init_process();
init_buffer();
var reHasUnicodeWord = /[a-z][A-Z]|[A-Z]{2}[a-z]|[0-9][a-zA-Z]|[a-zA-Z][0-9]|[^a-zA-Z0-9 ]/;
function hasUnicodeWord(string) {
  return reHasUnicodeWord.test(string);
}
var hasUnicodeWord_default = hasUnicodeWord;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_unicodeWords.js
init_process();
init_buffer();
var rsAstralRange3 = "\\ud800-\\udfff";
var rsComboMarksRange4 = "\\u0300-\\u036f";
var reComboHalfMarksRange4 = "\\ufe20-\\ufe2f";
var rsComboSymbolsRange4 = "\\u20d0-\\u20ff";
var rsComboRange4 = rsComboMarksRange4 + reComboHalfMarksRange4 + rsComboSymbolsRange4;
var rsDingbatRange = "\\u2700-\\u27bf";
var rsLowerRange = "a-z\\xdf-\\xf6\\xf8-\\xff";
var rsMathOpRange = "\\xac\\xb1\\xd7\\xf7";
var rsNonCharRange = "\\x00-\\x2f\\x3a-\\x40\\x5b-\\x60\\x7b-\\xbf";
var rsPunctuationRange = "\\u2000-\\u206f";
var rsSpaceRange = " \\t\\x0b\\f\\xa0\\ufeff\\n\\r\\u2028\\u2029\\u1680\\u180e\\u2000\\u2001\\u2002\\u2003\\u2004\\u2005\\u2006\\u2007\\u2008\\u2009\\u200a\\u202f\\u205f\\u3000";
var rsUpperRange = "A-Z\\xc0-\\xd6\\xd8-\\xde";
var rsVarRange3 = "\\ufe0e\\ufe0f";
var rsBreakRange = rsMathOpRange + rsNonCharRange + rsPunctuationRange + rsSpaceRange;
var rsApos = "['\u2019]";
var rsBreak = "[" + rsBreakRange + "]";
var rsCombo3 = "[" + rsComboRange4 + "]";
var rsDigits = "\\d+";
var rsDingbat = "[" + rsDingbatRange + "]";
var rsLower = "[" + rsLowerRange + "]";
var rsMisc = "[^" + rsAstralRange3 + rsBreakRange + rsDigits + rsDingbatRange + rsLowerRange + rsUpperRange + "]";
var rsFitz2 = "\\ud83c[\\udffb-\\udfff]";
var rsModifier2 = "(?:" + rsCombo3 + "|" + rsFitz2 + ")";
var rsNonAstral2 = "[^" + rsAstralRange3 + "]";
var rsRegional2 = "(?:\\ud83c[\\udde6-\\uddff]){2}";
var rsSurrPair2 = "[\\ud800-\\udbff][\\udc00-\\udfff]";
var rsUpper = "[" + rsUpperRange + "]";
var rsZWJ3 = "\\u200d";
var rsMiscLower = "(?:" + rsLower + "|" + rsMisc + ")";
var rsMiscUpper = "(?:" + rsUpper + "|" + rsMisc + ")";
var rsOptContrLower = "(?:" + rsApos + "(?:d|ll|m|re|s|t|ve))?";
var rsOptContrUpper = "(?:" + rsApos + "(?:D|LL|M|RE|S|T|VE))?";
var reOptMod2 = rsModifier2 + "?";
var rsOptVar2 = "[" + rsVarRange3 + "]?";
var rsOptJoin2 = "(?:" + rsZWJ3 + "(?:" + [rsNonAstral2, rsRegional2, rsSurrPair2].join("|") + ")" + rsOptVar2 + reOptMod2 + ")*";
var rsOrdLower = "\\d*(?:1st|2nd|3rd|(?![123])\\dth)(?=\\b|[A-Z_])";
var rsOrdUpper = "\\d*(?:1ST|2ND|3RD|(?![123])\\dTH)(?=\\b|[a-z_])";
var rsSeq2 = rsOptVar2 + reOptMod2 + rsOptJoin2;
var rsEmoji = "(?:" + [rsDingbat, rsRegional2, rsSurrPair2].join("|") + ")" + rsSeq2;
var reUnicodeWord = RegExp([
  rsUpper + "?" + rsLower + "+" + rsOptContrLower + "(?=" + [rsBreak, rsUpper, "$"].join("|") + ")",
  rsMiscUpper + "+" + rsOptContrUpper + "(?=" + [rsBreak, rsUpper + rsMiscLower, "$"].join("|") + ")",
  rsUpper + "?" + rsMiscLower + "+" + rsOptContrLower,
  rsUpper + "+" + rsOptContrUpper,
  rsOrdUpper,
  rsOrdLower,
  rsDigits,
  rsEmoji
].join("|"), "g");
function unicodeWords(string) {
  return string.match(reUnicodeWord) || [];
}
var unicodeWords_default = unicodeWords;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/words.js
function words(string, pattern, guard) {
  string = toString_default(string);
  pattern = guard ? void 0 : pattern;
  if (pattern === void 0) {
    return hasUnicodeWord_default(string) ? unicodeWords_default(string) : asciiWords_default(string);
  }
  return string.match(pattern) || [];
}
var words_default = words;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_createCompounder.js
var rsApos2 = "['\u2019]";
var reApos = RegExp(rsApos2, "g");
function createCompounder(callback) {
  return function(string) {
    return arrayReduce_default(words_default(deburr_default(string).replace(reApos, "")), callback, "");
  };
}
var createCompounder_default = createCompounder;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/camelCase.js
var camelCase = createCompounder_default(function(result, word, index) {
  word = word.toLowerCase();
  return result + (index ? capitalize_default(word) : word);
});
var camelCase_default = camelCase;

// ../../browser-compatible-base/lib/ast/index.js
init_process();
init_buffer();

// ../../browser-compatible-base/lib/ast/AbstractAstNode.js
init_process();
init_buffer();
var AbstractAstNode = class {
};

// ../../browser-compatible-base/lib/ast/AbstractWriter.js
init_process();
init_buffer();

// ../../browser-compatible-base/lib/ast/CodeBlock.js
init_process();
init_buffer();
var CodeBlock = class extends AbstractAstNode {
  constructor(value) {
    super();
    __publicField(this, "value");
    this.value = value;
  }
  write(writer) {
    if (typeof this.value === "string") {
      writer.write(this.value);
    } else {
      this.value(writer);
    }
  }
};

// ../../browser-compatible-base/lib/ast/AbstractWriter.js
var TAB_SIZE = 4;
var AbstractWriter = class {
  constructor() {
    /* The contents being written */
    __publicField(this, "buffer", "");
    /* Indentation level (multiple of 4) */
    __publicField(this, "indentLevel", 0);
    /* Whether anything has been written to the buffer */
    __publicField(this, "hasWrittenAnything", false);
    /* Whether the last character written was a newline */
    __publicField(this, "lastCharacterIsNewline", false);
  }
  /**
   * Writes arbitrary text
   * @param text
   */
  write(text) {
    const textEndsInNewline = text.length > 0 && text.endsWith("\n");
    const textWithoutNewline = textEndsInNewline ? text.substring(0, text.length - 1) : text;
    const indent = this.getIndentString();
    let indentedText = textWithoutNewline.replaceAll("\n", `
${indent}`);
    if (this.isAtStartOfLine()) {
      indentedText = indent + indentedText;
    }
    if (textEndsInNewline) {
      indentedText += "\n";
    }
    this.writeInternal(indentedText);
  }
  /**
   * Writes arbitrary text without indentation
   * @param text
   */
  writeNoIndent(text) {
    const currIndentLevel = this.indentLevel;
    this.indentLevel = 0;
    this.write(text);
    this.indentLevel = currIndentLevel;
  }
  /**
   * Writes a node
   * @param node
   */
  writeNode(node) {
    node.write(this);
  }
  /**
   * Writes a node but then suffixes with a `;` and new line
   * @param node
   */
  writeNodeStatement(node) {
    node.write(this);
    this.write(";");
    this.writeNewLineIfLastLineNot();
  }
  /**
   * Writes text but then suffixes with a `;`
   * @param node
   */
  writeTextStatement(text) {
    const codeBlock = new CodeBlock(text);
    codeBlock.write(this);
    this.write(";");
    this.writeNewLineIfLastLineNot();
  }
  /**
   * Writes text but then suffixes with a `;`
   * @param node
   */
  controlFlow(prefix, statement) {
    const codeBlock = new CodeBlock(prefix);
    codeBlock.write(this);
    this.write(" (");
    this.writeNode(statement);
    this.write(") {");
    this.writeNewLineIfLastLineNot();
    this.indent();
  }
  /**
   * Writes text but then suffixes with a `;`
   * @param node
   */
  endControlFlow() {
    this.dedent();
    this.writeLine("}");
  }
  /**
   * Please try to not use this. It is here for swift.
   * @param titles
   * @param openingCharacter
   * @param callback
   * @param closingCharacter
   */
  openBlock(titles, openingCharacter = "{", callback, closingCharacter = "}") {
    const filteredTitles = titles.filter((title2) => title2 !== void 0).join(" ");
    if (filteredTitles) {
      this.write(`${filteredTitles} ${openingCharacter != null ? openingCharacter : ""}`);
    } else {
      this.write(openingCharacter != null ? openingCharacter : "");
    }
    try {
      this.indent();
      callback();
      this.dedent();
    } finally {
      this.write(closingCharacter != null ? closingCharacter : "");
    }
  }
  /* Only writes a newline if last line in the buffer is not a newline */
  writeLine(text = "") {
    this.write(text);
    this.writeNewLineIfLastLineNot();
  }
  /* Always writes newline */
  newLine() {
    this.writeInternal("\n");
  }
  writeNewLineIfLastLineNot() {
    if (!this.lastCharacterIsNewline) {
      this.writeInternal("\n");
    }
  }
  indent() {
    this.indentLevel++;
  }
  dedent() {
    this.indentLevel--;
  }
  delimit({ nodes, delimiter, writeFunction }) {
    if (nodes.length > 0) {
      const firstNode = nodes[0];
      if (firstNode != null) {
        writeFunction(firstNode);
      }
      for (let i = 1; i < nodes.length; i++) {
        this.write(delimiter);
        const node = nodes[i];
        if (node != null) {
          writeFunction(node);
        }
      }
    }
  }
  /*******************************
   * Helper Methods
   *******************************/
  writeInternal(text) {
    if (text.length > 0) {
      this.hasWrittenAnything = true;
      this.lastCharacterIsNewline = text.endsWith("\n");
    }
    return this.buffer += text;
  }
  isAtStartOfLine() {
    return this.lastCharacterIsNewline || !this.hasWrittenAnything;
  }
  getIndentString() {
    return " ".repeat(this.indentLevel * TAB_SIZE);
  }
};

// ../../browser-compatible-base/lib/dynamic-snippets/index.js
init_process();
init_buffer();

// ../../browser-compatible-base/lib/dynamic-snippets/AbstractDynamicSnippetsGeneratorContext.js
init_process();
init_buffer();

// ../../../packages/cli/fern-definition/schema/lib/index.js
init_process();
init_buffer();

// ../../../packages/cli/fern-definition/schema/lib/utils/HttpEndpointReferenceParser.js
init_process();
init_buffer();
var HttpEndpointReferenceParser = class {
  constructor() {
    //eslint-disable-next-line
    __publicField(this, "REFERENCE_REGEX", /^(GET|POST|PUT|DELETE|PATCH)\s(\/[a-zA-Z0-9\/{}_-]*)$/);
  }
  validate(reference2) {
    const validFormat = this.REFERENCE_REGEX.test(reference2);
    if (!validFormat) {
      return { type: "invalid" };
    }
    return { type: "valid" };
  }
  tryParse(reference2) {
    const validationResponse = this.validate(reference2);
    if (validationResponse.type === "invalid") {
      return void 0;
    }
    const match = reference2.match(this.REFERENCE_REGEX);
    if (match == null || match[1] == null || match[2] == null) {
      return void 0;
    }
    return {
      method: match[1],
      path: match[2]
    };
  }
};

// ../../browser-compatible-base/lib/dynamic-snippets/ErrorReporter.js
init_process();
init_buffer();
var Severity = {
  Critical: "CRITICAL",
  Warning: "WARNING"
};
var ErrorReporter = class _ErrorReporter {
  constructor() {
    __publicField(this, "errors");
    __publicField(this, "path");
    this.errors = [];
    this.path = [];
  }
  add(err) {
    this.errors.push(__spreadProps(__spreadValues({}, err), {
      path: [...this.path]
    }));
  }
  scope(path) {
    this.path.push(path);
  }
  unscope() {
    this.path.pop();
  }
  getBySeverity(severity) {
    return this.errors.filter((err) => err.severity === severity);
  }
  empty() {
    return this.errors.length === 0;
  }
  size() {
    return this.errors.length;
  }
  clone() {
    const clone = new _ErrorReporter();
    clone.errors = [...this.errors];
    clone.path = [...this.path];
    return clone;
  }
  reset() {
    this.errors = [];
    this.path = [];
  }
  toDynamicSnippetErrors() {
    return this.errors.map((err) => ({
      severity: err.severity,
      path: err.path != null ? this.pathToStringArray(err.path) : void 0,
      message: err.message
    }));
  }
  pathToStringArray(path) {
    const result = [];
    for (const item of path) {
      if (typeof item === "string") {
        result.push(item);
        continue;
      }
      result[result.length - 1] += `[${item.index}]`;
    }
    return result;
  }
};

// ../../browser-compatible-base/lib/dynamic-snippets/AbstractDynamicSnippetsGeneratorContext.js
var AbstractDynamicSnippetsGeneratorContext = class {
  constructor({ ir, config: config2 }) {
    __publicField(this, "config");
    __publicField(this, "errors");
    __publicField(this, "_ir");
    __publicField(this, "httpEndpointReferenceParser");
    this._ir = ir;
    this.config = config2;
    this.errors = new ErrorReporter();
    this.httpEndpointReferenceParser = new HttpEndpointReferenceParser();
  }
  associateQueryParametersByWireValue({ parameters, values }) {
    const instances = [];
    for (const [key, value] of Object.entries(values)) {
      this.errors.scope(key);
      try {
        const parameter2 = parameters.find((param) => param.name.wireValue === key);
        if (parameter2 == null) {
          throw this.newParameterNotRecognizedError(key);
        }
        const typeInstanceValue = this.isListTypeReference(parameter2.typeReference) && !Array.isArray(value) ? [value] : value;
        instances.push({
          name: parameter2.name,
          typeReference: parameter2.typeReference,
          value: typeInstanceValue
        });
      } finally {
        this.errors.unscope();
      }
    }
    return instances;
  }
  associateByWireValue({ parameters, values, ignoreMissingParameters }) {
    const instances = [];
    for (const [key, value] of Object.entries(values)) {
      this.errors.scope(key);
      try {
        const parameter2 = parameters.find((param) => param.name.wireValue === key);
        if (parameter2 == null) {
          if (ignoreMissingParameters) {
            continue;
          }
          this.errors.add({
            severity: Severity.Critical,
            message: this.newParameterNotRecognizedError(key).message
          });
          continue;
        }
        instances.push({
          name: parameter2.name,
          typeReference: parameter2.typeReference,
          value
        });
      } finally {
        this.errors.unscope();
      }
    }
    return instances;
  }
  getSingleFileValue({ property, record }) {
    const fileValue = record[property.wireValue];
    if (fileValue == null) {
      return void 0;
    }
    if (typeof fileValue !== "string") {
      this.errors.add({
        severity: Severity.Critical,
        message: `Expected file value to be a string, got ${typeof fileValue}`
      });
      return void 0;
    }
    return fileValue;
  }
  getFileArrayValues({ property, record }) {
    const fileArrayValue = record[property.wireValue];
    if (fileArrayValue == null) {
      return void 0;
    }
    if (!Array.isArray(fileArrayValue)) {
      this.errors.add({
        severity: Severity.Critical,
        message: `Expected file array value to be an array of strings, got ${typeof fileArrayValue}`
      });
      return void 0;
    }
    const stringValues = [];
    for (const value of fileArrayValue) {
      if (typeof value !== "string") {
        this.errors.add({
          severity: Severity.Critical,
          message: `Expected file array value to be an array of strings, got ${typeof value}`
        });
        return void 0;
      }
      stringValues.push(value);
    }
    return stringValues;
  }
  getRecord(value) {
    if (typeof value !== "object" || Array.isArray(value)) {
      this.errors.add({
        severity: Severity.Critical,
        message: `Expected object with key, value pairs but got: ${Array.isArray(value) ? "array" : typeof value}`
      });
      return void 0;
    }
    if (value == null) {
      return {};
    }
    return value;
  }
  resolveNamedType({ typeId }) {
    const namedType = this._ir.types[typeId];
    if (namedType == null) {
      this.errors.add({
        severity: Severity.Critical,
        message: `Type identified by "${typeId}" could not be found`
      });
      return void 0;
    }
    return namedType;
  }
  resolveDiscriminatedUnionTypeInstance({ discriminatedUnion, value }) {
    const record = this.getRecord(value);
    if (record == null) {
      return void 0;
    }
    const discriminantFieldName = discriminatedUnion.discriminant.wireValue;
    const discriminantValue = record[discriminantFieldName];
    if (discriminantValue == null) {
      this.errors.add({
        severity: Severity.Critical,
        message: this.newParameterNotRecognizedError(discriminantFieldName).message
      });
      return void 0;
    }
    if (typeof discriminantValue !== "string") {
      this.errors.add({
        severity: Severity.Critical,
        message: `Expected discriminant value to be a string but got: ${typeof discriminantValue}`
      });
      return void 0;
    }
    const singleDiscriminatedUnionType = discriminatedUnion.types[discriminantValue];
    if (singleDiscriminatedUnionType == null) {
      this.errors.add({
        severity: Severity.Critical,
        message: `No type found for discriminant value "${discriminantValue}"`
      });
      return void 0;
    }
    const _a = record, { [discriminantFieldName]: _ } = _a, filtered = __objRest(_a, [__restKey(discriminantFieldName)]);
    return {
      singleDiscriminatedUnionType,
      discriminantValue: singleDiscriminatedUnionType.discriminantValue,
      value: filtered
    };
  }
  resolveEndpointOrThrow(rawEndpoint) {
    const parsedEndpoint = this.httpEndpointReferenceParser.tryParse(rawEndpoint);
    if (parsedEndpoint == null) {
      throw new Error(`Failed to parse endpoint reference "${rawEndpoint}"`);
    }
    return this.resolveEndpointLocationOrThrow(parsedEndpoint);
  }
  resolveEndpointLocationOrThrow(location) {
    const endpoints = [];
    for (const endpoint of Object.values(this._ir.endpoints)) {
      if (this.parsedEndpointMatches({ endpoint, parsedEndpoint: location })) {
        endpoints.push(endpoint);
      }
    }
    if (endpoints.length === 0) {
      throw new Error(`Failed to find endpoint identified by "${location.method} ${location.path}"`);
    }
    return endpoints;
  }
  needsRequestParameter({ request, inlinePathParameters, inlineFileProperties }) {
    var _a;
    if (this.includePathParametersInWrappedRequest({ request, inlinePathParameters })) {
      return true;
    }
    if (request.queryParameters != null && request.queryParameters.length > 0) {
      return true;
    }
    if (request.headers != null && request.headers.length > 0) {
      return true;
    }
    if (request.body != null) {
      return this.includeRequestBodyInWrappedRequest({ body: request.body, inlineFileProperties });
    }
    if ((_a = request.metadata) == null ? void 0 : _a.onlyPathParameters) {
      return false;
    }
    return true;
  }
  includePathParametersInWrappedRequest({ request, inlinePathParameters }) {
    var _a, _b;
    return inlinePathParameters && ((_b = (_a = request.metadata) == null ? void 0 : _a.includePathParameters) != null ? _b : false);
  }
  isFileUploadRequestBody(body) {
    switch (body.type) {
      case "fileUpload":
        return true;
      case "properties":
      case "referenced":
        return false;
      default:
        assertNever(body);
    }
  }
  resolveEnvironmentName(environmentID) {
    if (this._ir.environments == null) {
      return void 0;
    }
    const environments = this._ir.environments.environments;
    switch (environments.type) {
      case "singleBaseUrl": {
        const environment = environments.environments.find((env2) => env2.id === environmentID);
        if (environment == null) {
          return void 0;
        }
        return environment.name;
      }
      case "multipleBaseUrls": {
        const environment = environments.environments.find((env2) => env2.id === environmentID);
        if (environment == null) {
          return void 0;
        }
        return environment.name;
      }
      default:
        assertNever(environments);
    }
  }
  isSingleEnvironmentID(environment) {
    return typeof environment === "string";
  }
  isMultiEnvironmentValues(environment) {
    return typeof environment === "object";
  }
  validateMultiEnvironmentUrlValues(multiEnvironmentUrlValues) {
    if (this._ir.environments == null) {
      this.errors.add({
        severity: Severity.Critical,
        message: "Multiple environments are not supported for single base URL environments; use the baseUrl option instead"
      });
      return false;
    }
    const environments = this._ir.environments.environments;
    switch (environments.type) {
      case "singleBaseUrl": {
        this.errors.add({
          severity: Severity.Critical,
          message: "Multiple environments are not supported for single base URL environments; use the baseUrl option instead"
        });
        return false;
      }
      case "multipleBaseUrls": {
        const firstEnvironment = environments.environments[0];
        if (firstEnvironment == null) {
          this.errors.add({
            severity: Severity.Critical,
            message: "Multiple environments are not supported; use the baseUrl option instead"
          });
          return false;
        }
        const expectedKeys = new Set(keys(firstEnvironment.urls));
        for (const key of keys(multiEnvironmentUrlValues)) {
          if (expectedKeys.has(key)) {
            expectedKeys.delete(key);
          }
        }
        if (expectedKeys.size > 0) {
          this.errors.add({
            severity: Severity.Critical,
            message: `The provided environments are invalid; got: [${Object.keys(multiEnvironmentUrlValues).join(", ")}], expected: [${keys(firstEnvironment.urls).join(", ")}]`
          });
          return false;
        }
        return true;
      }
    }
  }
  getValueAsNumber({ value }) {
    if (typeof value !== "number") {
      this.errors.add({
        severity: Severity.Critical,
        message: this.newTypeMismatchError({ expected: "number", value }).message
      });
      return void 0;
    }
    return value;
  }
  getValueAsBoolean({ value }) {
    if (typeof value !== "boolean") {
      this.errors.add({
        severity: Severity.Critical,
        message: this.newTypeMismatchError({ expected: "boolean", value }).message
      });
      return void 0;
    }
    return value;
  }
  getValueAsString({ value }) {
    if (typeof value !== "string") {
      this.errors.add({
        severity: Severity.Critical,
        message: this.newTypeMismatchError({ expected: "string", value }).message
      });
      return void 0;
    }
    return value;
  }
  newAuthMismatchError({ auth, values }) {
    return new Error(`Expected auth type ${auth.type}, got ${values.type}`);
  }
  newParameterNotRecognizedError(parameterName) {
    return new Error(`"${parameterName}" is not a recognized parameter for this endpoint`);
  }
  newTypeMismatchError({ expected, value }) {
    return new Error(`Expected ${expected}, got ${typeof value}`);
  }
  includeRequestBodyInWrappedRequest({ body, inlineFileProperties }) {
    switch (body.type) {
      case "properties":
      case "referenced":
        return true;
      case "fileUpload":
        return this.includeFileUploadBodyInWrappedRequest({ fileUpload: body, inlineFileProperties });
      default:
        assertNever(body);
    }
  }
  includeFileUploadBodyInWrappedRequest({ fileUpload, inlineFileProperties }) {
    return this.fileUploadHasBodyProperties({ fileUpload }) || inlineFileProperties && this.fileUploadHasFileProperties({ fileUpload });
  }
  fileUploadHasBodyProperties({ fileUpload }) {
    return fileUpload.properties.some((property) => {
      switch (property.type) {
        case "file":
        case "fileArray":
          return false;
        case "bodyProperty":
          return true;
        default:
          assertNever(property);
      }
    });
  }
  fileUploadHasFileProperties({ fileUpload }) {
    return fileUpload.properties.some((property) => {
      switch (property.type) {
        case "file":
        case "fileArray":
          return true;
        case "bodyProperty":
          return false;
        default:
          assertNever(property);
      }
    });
  }
  isListTypeReference(typeReference) {
    if (typeReference.type === "optional") {
      return this.isListTypeReference(typeReference.value);
    }
    return typeReference.type === "list" || typeReference.type === "set";
  }
  parsedEndpointMatches({ endpoint, parsedEndpoint }) {
    return endpoint.location.method === parsedEndpoint.method && endpoint.location.path === parsedEndpoint.path;
  }
};

// ../ast/lib/index.js
init_process();
init_buffer();

// ../ast/lib/typescript.js
var typescript_exports = {};
__export(typescript_exports, {
  AstNode: () => AstNode,
  ClassInstantiation: () => ClassInstantiation,
  CodeBlock: () => CodeBlock2,
  Comment: () => Comment,
  Function: () => Function2,
  FunctionInvocation: () => FunctionInvocation,
  MethodInvocation: () => MethodInvocation,
  Parameter: () => Parameter,
  Reference: () => Reference,
  Type: () => Type,
  TypeLiteral: () => TypeLiteral,
  Types: () => Type,
  Variable: () => Variable,
  Writer: () => Writer,
  codeblock: () => codeblock,
  function_: () => function_,
  instantiateClass: () => instantiateClass,
  invokeFunction: () => invokeFunction,
  invokeMethod: () => invokeMethod,
  parameter: () => parameter,
  reference: () => reference,
  variable: () => variable
});
init_process();
init_buffer();

// ../ast/lib/ast/index.js
init_process();
init_buffer();

// ../ast/lib/ast/core/index.js
init_process();
init_buffer();

// ../ast/lib/ast/core/AstNode.js
init_process();
init_buffer();

// ../ast/lib/ast/core/Writer.js
init_process();
init_buffer();
var Writer = class extends AbstractWriter {
  constructor({ customConfig }) {
    super();
    __publicField(this, "customConfig");
    __publicField(this, "imports", {});
    __publicField(this, "defaultImports", {});
    __publicField(this, "starImportAliases", {});
    __publicField(this, "starImportAliasesInverse", {});
    this.customConfig = customConfig;
  }
  /**
   * Adds the given import under its module name.
   */
  addImport(reference2) {
    var _a, _b, _c;
    if (reference2.importFrom != null) {
      switch (reference2.importFrom.type) {
        case "default": {
          this.validateDefault(reference2);
          break;
        }
        case "named": {
          this.validateNamed(reference2);
          break;
        }
        case "star": {
          this.validateStar(reference2);
          break;
        }
      }
      const moduleImports = (_c = (_a = this.imports)[_b = reference2.importFrom.moduleName]) != null ? _c : _a[_b] = [];
      const names = moduleImports.map((import_) => import_.name);
      if (!names.includes(reference2.name)) {
        moduleImports.push(reference2);
      }
    }
  }
  validateDefault(reference2) {
    var _a, _b, _c, _d;
    if (((_a = reference2.importFrom) == null ? void 0 : _a.type) !== "default") {
      return;
    }
    const moduleDefault = (_d = (_b = this.defaultImports)[_c = reference2.importFrom.moduleName]) != null ? _d : _b[_c] = reference2;
    if (moduleDefault.name !== reference2.name) {
      throw new Error(`Cannot have multiple default imports for module ${reference2.importFrom.moduleName}: got ${reference2.name} but already had ${moduleDefault.name}`);
    }
  }
  validateNamed(reference2) {
    var _a, _b, _c, _d, _e;
    if (((_a = reference2.importFrom) == null ? void 0 : _a.type) !== "named") {
      return;
    }
    const existing = (_b = this.imports[reference2.importFrom.moduleName]) != null ? _b : [];
    const existingStar = existing.filter((e) => {
      var _a2;
      return ((_a2 = e.importFrom) == null ? void 0 : _a2.type) === "star";
    });
    if (existingStar.length > 0) {
      throw new Error(`Cannot add named import ${reference2.name} because non-named imports ${existingStar.map((e) => e.name)} already exist`);
    }
    const duplicates = [];
    for (const references of Object.values(this.imports)) {
      for (const ref of references) {
        if (((_c = ref.importFrom) == null ? void 0 : _c.type) === "named" && ref.importFrom.moduleName !== reference2.importFrom.moduleName && ref.name === reference2.name) {
          duplicates.push(ref);
        }
      }
    }
    if (duplicates.length > 0) {
      throw new Error(`Cannot add named import from module ${reference2.importFrom.moduleName} because it is already imported from ${(_e = (_d = duplicates[0]) == null ? void 0 : _d.importFrom) == null ? void 0 : _e.moduleName}`);
    }
  }
  validateStar(reference2) {
    var _a, _b, _c, _d, _e, _f, _g;
    if (((_a = reference2.importFrom) == null ? void 0 : _a.type) !== "star") {
      return;
    }
    const moduleAlias = (_d = (_b = this.starImportAliases)[_c = reference2.importFrom.moduleName]) != null ? _d : _b[_c] = reference2.importFrom.starImportAlias;
    if (moduleAlias !== reference2.importFrom.starImportAlias) {
      throw new Error(`Cannot have more than one alias for non-named imports from a module: got ${reference2.importFrom.starImportAlias} but already have ${moduleAlias}.`);
    }
    const aliasModule = (_g = (_e = this.starImportAliasesInverse)[_f = reference2.importFrom.starImportAlias]) != null ? _g : _e[_f] = reference2.importFrom.moduleName;
    if (aliasModule !== reference2.importFrom.moduleName) {
      throw new Error(`Attempted to use alias ${reference2.importFrom.starImportAlias} for more than one module in the same file`);
    }
  }
  toString() {
    const imports = this.stringifyImports();
    if (imports.length > 0) {
      return imports + "\n" + this.buffer;
    }
    return this.buffer;
  }
  stringifyImports() {
    let result = "";
    for (const [module2, references] of Object.entries(this.imports)) {
      const defaultImport = this.defaultImports[module2];
      let stringifiedNonDefault = "";
      const named = references.filter((r) => {
        var _a;
        return ((_a = r.importFrom) == null ? void 0 : _a.type) === "named";
      });
      const starImportAlias = this.starImportAliases[module2];
      if (named.length > 0 || defaultImport != null || starImportAlias != null) {
        result += "import";
        if (defaultImport != null) {
          result += ` ${defaultImport.name}`;
        }
        if (named.length > 0) {
          for (const ref of named.slice(0, -1)) {
            stringifiedNonDefault += `${ref.name}, `;
          }
          const lastRef = named[named.length - 1];
          if (lastRef != null) {
            stringifiedNonDefault += `${lastRef.name}`;
          }
          if (defaultImport != null) {
            result += ",";
          }
          result += ` { ${stringifiedNonDefault} }`;
        }
        if (starImportAlias != null) {
          if (defaultImport != null || named.length > 0) {
            result += ", ";
          }
          result += ` * as ${starImportAlias}`;
        }
        result += ` from "${module2}";
`;
      }
    }
    return result;
  }
};

// ../ast/lib/ast/core/AstNode.js
var AstNode = class extends AbstractAstNode {
  /**
   * Writes the node to a string.
   */
  async toString({ customConfig }) {
    const writer = new Writer({ customConfig });
    this.write(writer);
    return writer.toString();
  }
  toStringSync({ customConfig }) {
    const writer = new Writer({ customConfig });
    this.write(writer);
    return writer.toString();
  }
};

// ../ast/lib/ast/CodeBlock.js
init_process();
init_buffer();
var CodeBlock2 = class extends AstNode {
  constructor(args) {
    super();
    __publicField(this, "args");
    this.args = args;
  }
  write(writer) {
    const commonCodeBlock = new CodeBlock(this.args);
    return commonCodeBlock.write(writer);
  }
};

// ../ast/lib/ast/Type.js
init_process();
init_buffer();
var Type = class extends AstNode {
  constructor(internalType) {
    super();
    __publicField(this, "internalType");
    this.internalType = internalType;
  }
  write(writer) {
    switch (this.internalType.type) {
      case "string":
        writer.write("string");
        break;
      case "number":
        writer.write("number");
        break;
      case "bigint":
        writer.write("bigint");
        break;
      case "boolean":
        writer.write("boolean");
        break;
      case "array":
        this.internalType.valueType.write(writer);
        writer.write("[]");
        break;
      case "map":
        writer.write("Record<");
        this.internalType.keyType.write(writer);
        writer.write(", ");
        this.internalType.valueType.write(writer);
        writer.write(">");
        break;
      case "object":
        writer.write("{");
        writer.indent();
        for (const [key, value] of Object.entries(this.internalType.fields)) {
          writer.write(`${key}: `);
          value.write(writer);
          writer.writeLine(",");
        }
        writer.dedent();
        writer.write("}");
        break;
      case "enum":
        writer.write("enum");
        break;
      case "any":
        writer.write("any");
        break;
      case "promise":
        writer.write("Promise<");
        this.internalType.value.write(writer);
        writer.write(">");
        break;
      case "unknown":
        writer.write("unknown");
        break;
      case "void":
        writer.write("void");
        break;
      case "undefined":
        writer.write("undefined");
        break;
      case "null":
        writer.write("null");
        break;
      case "never":
        writer.write("never");
        break;
      case "nop":
        break;
      default:
        assertNever(this.internalType);
    }
  }
  /* Static factory methods for creating a Type */
  static string() {
    return new this({
      type: "string"
    });
  }
  static number() {
    return new this({
      type: "number"
    });
  }
  static bigint() {
    return new this({
      type: "bigint"
    });
  }
  static boolean() {
    return new this({
      type: "boolean"
    });
  }
  static array(valueType) {
    return new this({
      type: "array",
      valueType
    });
  }
  static object(fields) {
    return new this({
      type: "object",
      fields
    });
  }
  static enum(values) {
    return new this({
      type: "enum",
      values
    });
  }
  static any() {
    return new this({
      type: "any"
    });
  }
  static promise(value) {
    if (value.internalType.type === "promise") {
      return value;
    }
    return new this({
      type: "promise",
      value
    });
  }
  static unknown() {
    return new this({
      type: "unknown"
    });
  }
  static void() {
    return new this({
      type: "void"
    });
  }
  static undefined() {
    return new this({
      type: "undefined"
    });
  }
  static null() {
    return new this({
      type: "null"
    });
  }
  static never() {
    return new this({
      type: "never"
    });
  }
  static nop() {
    return new this({
      type: "nop"
    });
  }
};

// ../ast/lib/ast/TypeLiteral.js
init_process();
init_buffer();
var TypeLiteral = class _TypeLiteral extends AstNode {
  constructor(internalType) {
    super();
    __publicField(this, "internalType");
    this.internalType = internalType;
  }
  write(writer) {
    var _a, _b, _c, _d;
    switch (this.internalType.type) {
      case "array": {
        this.writeIterable({ writer, iterable: this.internalType });
        break;
      }
      case "blob": {
        if ((_a = writer.customConfig) == null ? void 0 : _a.noSerdeLayer) {
          writer.writeNode(_TypeLiteral.string(this.internalType.value));
          return;
        }
        writer.write("new Blob([");
        writer.writeNode(_TypeLiteral.string(this.internalType.value));
        writer.write("])");
        break;
      }
      case "boolean": {
        writer.write(this.internalType.value.toString());
        break;
      }
      case "bigint": {
        if ((_b = writer.customConfig) == null ? void 0 : _b.noSerdeLayer) {
          writer.writeNode(_TypeLiteral.string(this.internalType.value.toString()));
          return;
        }
        writer.write(`BigInt(${this.internalType.value.toString()})`);
        break;
      }
      case "datetime": {
        if ((_c = writer.customConfig) == null ? void 0 : _c.noSerdeLayer) {
          writer.writeNode(_TypeLiteral.string(this.internalType.value));
          return;
        }
        writer.write("new Date(");
        writer.writeNode(_TypeLiteral.string(this.internalType.value));
        writer.write(")");
        break;
      }
      case "number": {
        writer.write(this.internalType.value.toString());
        break;
      }
      case "object": {
        this.writeObject({ writer, object: this.internalType });
        break;
      }
      case "record": {
        this.writeRecord({ writer, record: this.internalType });
        break;
      }
      case "reference": {
        writer.writeNode(this.internalType.value);
        break;
      }
      case "set": {
        if (((_d = writer.customConfig) == null ? void 0 : _d.noSerdeLayer) || this.isSetOfObjects()) {
          writer.writeNode(_TypeLiteral.array({ values: this.internalType.values }));
          return;
        }
        writer.write("new Set(");
        this.writeIterable({ writer, iterable: this.internalType });
        writer.write(")");
        break;
      }
      case "string": {
        if (this.internalType.value.includes("\n")) {
          this.writeStringWithBackticks({ writer, value: this.internalType.value });
        } else {
          writer.write(`"${this.internalType.value.replaceAll('"', '\\"')}"`);
        }
        break;
      }
      case "tuple": {
        this.writeIterable({ writer, iterable: this.internalType });
        break;
      }
      case "unknown": {
        this.writeUnknown({ writer, value: this.internalType.value });
        break;
      }
      case "nop":
        break;
      default:
        assertNever(this.internalType);
    }
  }
  isObject() {
    return this.internalType.type === "object";
  }
  asObjectOrThrow() {
    if (this.isObject()) {
      return this.internalType;
    }
    throw new Error("Internal error; ts.TypeLiteral is not an object");
  }
  isSet() {
    return this.internalType.type === "set";
  }
  asSetOrThrow() {
    if (this.isSet()) {
      return this.internalType;
    }
    throw new Error("Internal error; ts.TypeLiteral is not a set");
  }
  isSetOfObjects() {
    return this.isSet() && this.asSetOrThrow().values.every((value) => value.isObject());
  }
  writeStringWithBackticks({ writer, value }) {
    writer.write("`");
    const parts = value.split("\n");
    const head = parts[0] + "\n";
    const tail = parts.slice(1).join("\n");
    writer.write(head.replaceAll("`", "\\`"));
    writer.writeNoIndent(tail.replaceAll("`", "\\`"));
    writer.write("`");
  }
  writeIterable({ writer, iterable }) {
    const values = filterNopValues({ values: iterable.values });
    if (values.length === 0) {
      writer.write("[]");
      return;
    }
    writer.writeLine("[");
    writer.indent();
    for (const value of values) {
      value.write(writer);
      writer.writeLine(",");
    }
    writer.dedent();
    writer.write("]");
  }
  writeRecord({ writer, record }) {
    const entries = filterNopRecordEntries({ entries: record.entries });
    if (entries.length === 0) {
      writer.write("{}");
      return;
    }
    writer.writeLine("{");
    writer.indent();
    for (const entry of entries) {
      entry.key.write(writer);
      writer.write(": ");
      entry.value.write(writer);
      writer.writeLine(",");
    }
    writer.dedent();
    writer.write("}");
  }
  writeObject({ writer, object }) {
    const fields = filterNopObjectFields({ fields: object.fields });
    if (fields.length === 0) {
      writer.write("{}");
      return;
    }
    writer.writeLine("{");
    writer.indent();
    for (const field of fields) {
      writer.write(`${field.name}: `);
      field.value.write(writer);
      writer.writeLine(",");
    }
    writer.dedent();
    writer.write("}");
  }
  /* Static factory methods for creating a TypeLiteral */
  static array({ values }) {
    return new this({
      type: "array",
      values
    });
  }
  static bigint(value) {
    return new this({ type: "bigint", value });
  }
  static blob(value) {
    return new this({ type: "blob", value });
  }
  static boolean(value) {
    return new this({ type: "boolean", value });
  }
  static datetime(value) {
    return new this({ type: "datetime", value });
  }
  static number(value) {
    return new this({ type: "number", value });
  }
  static object({ fields }) {
    return new this({
      type: "object",
      fields
    });
  }
  static record({ entries }) {
    return new this({
      type: "record",
      entries
    });
  }
  static reference(value) {
    return new this({
      type: "reference",
      value
    });
  }
  static set({ values }) {
    return new this({
      type: "set",
      values
    });
  }
  static string(value) {
    return new this({
      type: "string",
      value
    });
  }
  static tuple({ values }) {
    return new this({
      type: "tuple",
      values
    });
  }
  static unknown(value) {
    return new this({ type: "unknown", value });
  }
  static nop() {
    return new this({ type: "nop" });
  }
  static isNop(typeLiteral) {
    return typeLiteral.internalType.type === "nop";
  }
  writeUnknown({ writer, value }) {
    switch (typeof value) {
      case "boolean":
        writer.write(value.toString());
        return;
      case "string":
        writer.write(value.includes('"') ? `\`${value}\`` : `"${value}"`);
        return;
      case "number":
        writer.write(value.toString());
        return;
      case "object":
        if (value == null) {
          writer.write("null");
          return;
        }
        if (Array.isArray(value)) {
          this.writeUnknownArray({ writer, value });
          return;
        }
        this.writeUnknownObject({ writer, value });
        return;
      default:
        throw new Error(`Internal error; unsupported unknown type: ${typeof value}`);
    }
  }
  writeUnknownArray({ writer, value }) {
    if (value.length === 0) {
      writer.write("[]");
      return;
    }
    writer.writeLine("[");
    writer.indent();
    for (const element of value) {
      writer.writeNode(_TypeLiteral.unknown(element));
      writer.writeLine(",");
    }
    writer.dedent();
    writer.write("]");
  }
  writeUnknownObject({ writer, value }) {
    const entries = Object.entries(value);
    if (entries.length === 0) {
      writer.write("{}");
      return;
    }
    writer.writeLine("{");
    writer.indent();
    for (const [key, val] of entries) {
      writer.write(`${key}: `);
      writer.writeNode(_TypeLiteral.unknown(val));
      writer.writeLine(",");
    }
    writer.dedent();
    writer.write("}");
  }
};
function filterNopObjectFields({ fields }) {
  return fields.filter((field) => !TypeLiteral.isNop(field.value));
}
function filterNopRecordEntries({ entries }) {
  return entries.filter((entry) => !TypeLiteral.isNop(entry.key) && !TypeLiteral.isNop(entry.value));
}
function filterNopValues({ values }) {
  return values.filter((value) => !TypeLiteral.isNop(value));
}

// ../ast/lib/ast/Reference.js
init_process();
init_buffer();
var Reference = class extends AstNode {
  constructor({ name, importFrom, memberName }) {
    super();
    __publicField(this, "name");
    __publicField(this, "importFrom");
    __publicField(this, "memberName");
    this.name = name;
    this.importFrom = importFrom;
    this.memberName = memberName;
  }
  write(writer) {
    var _a;
    if (this.importFrom != null) {
      writer.addImport(this);
    }
    const prefix = ((_a = this.importFrom) == null ? void 0 : _a.type) === "star" ? `${this.importFrom.starImportAlias}.` : "";
    const suffix = this.memberName != null ? `.${this.memberName}` : "";
    writer.write(`${prefix}${this.name}${suffix}`);
  }
};

// ../ast/lib/ast/Variable.js
init_process();
init_buffer();
var Variable = class extends AstNode {
  constructor(args) {
    super();
    __publicField(this, "args");
    this.args = args;
  }
  write(writer) {
    if (this.args.export) {
      writer.write("export ");
    }
    if (this.args.const) {
      writer.write("const ");
    } else {
      writer.write("let ");
    }
    writer.write(`${this.args.name} = `);
    writer.writeNode(this.args.initializer);
  }
};

// ../ast/lib/ast/Parameter.js
init_process();
init_buffer();

// ../ast/lib/ast/Comment.js
init_process();
init_buffer();
var Comment = class extends AstNode {
  constructor({ docs } = { docs: void 0 }) {
    super();
    __publicField(this, "docs");
    this.docs = docs;
  }
  write(writer) {
    if (this.docs != null) {
      writer.writeLine("/**");
      this.docs.split("\n").forEach((line) => {
        writer.writeLine(` * ${line}`);
      });
      writer.writeLine("*/");
    }
  }
};

// ../ast/lib/ast/Parameter.js
var Parameter = class extends AstNode {
  constructor({ name, type, docs }) {
    super();
    __publicField(this, "name");
    __publicField(this, "type");
    __publicField(this, "docs");
    this.name = name;
    this.type = type;
    this.docs = docs;
  }
  write(writer) {
    writer.write(`${this.name}`);
  }
  writeWithType(writer) {
    if (this.docs != null) {
      writer.writeNode(new Comment({ docs: this.docs }));
    }
    writer.write(`${this.name}: `);
    this.type.write(writer);
  }
};

// ../ast/lib/ast/Function.js
init_process();
init_buffer();
var Function2 = class extends AstNode {
  constructor({ name, parameters, async, body, return_, docs }) {
    super();
    __publicField(this, "name");
    __publicField(this, "parameters");
    __publicField(this, "async");
    __publicField(this, "body");
    __publicField(this, "return_");
    __publicField(this, "docs");
    this.name = name;
    this.parameters = parameters;
    this.async = async != null ? async : false;
    this.body = body;
    this.return_ = return_;
    this.docs = docs;
  }
  write(writer) {
    var _a;
    writer.writeNode(new Comment({ docs: this.docs }));
    if (this.async) {
      writer.write("async ");
    }
    writer.write("function ");
    writer.write(`${this.name}`);
    this.writeParameters(writer);
    if (this.return_ != null) {
      writer.write(": ");
      writer.writeNode(this.async ? Type.promise(this.return_) : this.return_);
    }
    writer.writeLine(" {");
    writer.indent();
    (_a = this.body) == null ? void 0 : _a.write(writer);
    writer.dedent();
    writer.writeNewLineIfLastLineNot();
    writer.writeLine("}");
  }
  writeParameters(writer) {
    if (this.parameters.length === 0) {
      writer.write("()");
      return;
    }
    writer.writeLine("(");
    writer.delimit({
      nodes: this.parameters,
      delimiter: ",\n",
      writeFunction: (parameter2) => parameter2.writeWithType(writer)
    });
    writer.write(")");
  }
};

// ../ast/lib/ast/FunctionInvocation.js
init_process();
init_buffer();
var FunctionInvocation = class extends AstNode {
  constructor({ function_: function_2, arguments_ }) {
    super();
    __publicField(this, "function_");
    __publicField(this, "arguments_");
    this.function_ = function_2;
    this.arguments_ = arguments_;
  }
  write(writer) {
    writer.writeNode(this.function_);
    writer.write("(");
    writer.delimit({
      nodes: this.arguments_,
      delimiter: ", ",
      writeFunction: (argument) => argument.write(writer)
    });
    writer.write(")");
  }
};

// ../ast/lib/ast/MethodInvocation.js
init_process();
init_buffer();
var MethodInvocation = class extends AstNode {
  constructor({ on: on2, method, arguments_, async }) {
    super();
    __publicField(this, "on");
    __publicField(this, "method");
    __publicField(this, "arguments_");
    __publicField(this, "async");
    this.on = on2;
    this.method = method;
    this.arguments_ = arguments_;
    this.async = async;
  }
  write(writer) {
    if (this.async) {
      writer.write("await ");
    }
    this.on.write(writer);
    writer.write(".");
    writer.write(this.method);
    writer.write("(");
    writer.delimit({
      nodes: this.arguments_,
      delimiter: ", ",
      writeFunction: (argument) => argument.write(writer)
    });
    writer.write(")");
  }
};

// ../ast/lib/ast/ClassInstantiation.js
init_process();
init_buffer();
var ClassInstantiation = class extends AstNode {
  constructor({ class_, arguments_ }) {
    super();
    __publicField(this, "class_");
    __publicField(this, "arguments_");
    this.class_ = class_;
    this.arguments_ = arguments_;
  }
  write(writer) {
    writer.write("new ");
    writer.writeNode(this.class_);
    writer.write("(");
    writer.delimit({
      nodes: this.arguments_,
      delimiter: ", ",
      writeFunction: (argument) => argument.write(writer)
    });
    writer.write(")");
  }
};

// ../ast/lib/typescript.js
function codeblock(arg) {
  return new CodeBlock2(arg);
}
function function_(args) {
  return new Function2(args);
}
function instantiateClass(args) {
  return new ClassInstantiation(args);
}
function invokeFunction(args) {
  return new FunctionInvocation(args);
}
function invokeMethod(args) {
  return new MethodInvocation(args);
}
function parameter(args) {
  return new Parameter(args);
}
function reference(arg) {
  return new Reference(arg);
}
function variable(arg) {
  return new Variable(arg);
}

// ../browser-compatible-base/lib/utils/index.js
init_process();
init_buffer();

// ../browser-compatible-base/lib/utils/constructNpmPackage.js
init_process();
init_buffer();
function constructNpmPackage({ generatorConfig, isPackagePrivate }) {
  var _a;
  const outputMode = generatorConfig.output.mode;
  switch (outputMode.type) {
    case "downloadFiles":
      return void 0;
    case "publish":
      return {
        packageName: outputMode.registriesV2.npm.packageName,
        version: outputMode.version,
        private: isPackagePrivate,
        publishInfo: {
          registryUrl: outputMode.registriesV2.npm.registryUrl,
          token: outputMode.registriesV2.npm.token
        },
        license: void 0,
        repoUrl: void 0
      };
    case "github":
      if (outputMode.publishInfo != null && outputMode.publishInfo.type !== "npm") {
        throw new Error(`Expected to receive npm publish info but received ${outputMode.publishInfo.type} instead`);
      }
      return {
        packageName: outputMode.publishInfo != null ? outputMode.publishInfo.packageName : "",
        version: outputMode.version,
        private: isPackagePrivate,
        publishInfo: void 0,
        repoUrl: outputMode.repoUrl,
        license: (_a = generatorConfig.license) == null ? void 0 : _a._visit({
          basic: (basic) => basic.id,
          custom: (custom) => `See ${custom.filename}`,
          _other: () => {
            return void 0;
          }
        })
      };
    default:
      throw new Error(`Encountered unknown output mode: ${outputMode}`);
  }
}

// ../browser-compatible-base/lib/utils/getNamespaceExport.js
init_process();
init_buffer();
function getNamespaceExport({ organization, workspaceName, namespaceExport }) {
  return namespaceExport != null ? namespaceExport : `${upperFirst_default(camelCase_default(organization))}${upperFirst_default(camelCase_default(workspaceName))}`;
}

// src/context/DynamicTypeLiteralMapper.ts
init_process();
init_buffer();
var UNION_VALUE_KEY = "value";
var DynamicTypeLiteralMapper = class {
  constructor({ context }) {
    __publicField(this, "context");
    this.context = context;
  }
  convert(args) {
    if (args.value == null) {
      return typescript_exports.TypeLiteral.nop();
    }
    switch (args.typeReference.type) {
      case "list":
        return this.convertList({ list: args.typeReference.value, value: args.value });
      case "literal":
        return this.convertLiteral({ literalType: args.typeReference.value, value: args.value });
      case "map":
        return this.convertMap({ map: args.typeReference, value: args.value });
      case "named": {
        const named = this.context.resolveNamedType({ typeId: args.typeReference.value });
        if (named == null) {
          return typescript_exports.TypeLiteral.nop();
        }
        return this.convertNamed({ named, value: args.value, as: args.as });
      }
      case "optional":
        return this.convert({ typeReference: args.typeReference.value, value: args.value, as: args.as });
      case "primitive":
        return this.convertPrimitive({ primitive: args.typeReference.value, value: args.value, as: args.as });
      case "set":
        return this.convertSet({ set: args.typeReference.value, value: args.value });
      case "unknown":
        return this.convertUnknown({ value: args.value });
      default:
        assertNever(args.typeReference);
    }
  }
  convertLiteral({
    literalType,
    value
  }) {
    switch (literalType.type) {
      case "boolean": {
        const bool = this.context.getValueAsBoolean({ value });
        if (bool == null) {
          return typescript_exports.TypeLiteral.nop();
        }
        return typescript_exports.TypeLiteral.boolean(bool);
      }
      case "string": {
        const str = this.context.getValueAsString({ value });
        if (str == null) {
          return typescript_exports.TypeLiteral.nop();
        }
        return typescript_exports.TypeLiteral.string(str);
      }
      default:
        assertNever(literalType);
    }
  }
  convertList({ list, value }) {
    if (!Array.isArray(value)) {
      this.context.errors.add({
        severity: Severity.Critical,
        message: `Expected array but got: ${typeof value}`
      });
      return typescript_exports.TypeLiteral.nop();
    }
    return typescript_exports.TypeLiteral.array({
      values: value.map((v, index) => {
        this.context.errors.scope({ index });
        try {
          return this.convert({ typeReference: list, value: v });
        } finally {
          this.context.errors.unscope();
        }
      })
    });
  }
  convertSet({ set, value }) {
    if (!Array.isArray(value)) {
      this.context.errors.add({
        severity: Severity.Critical,
        message: `Expected array but got: ${typeof value}`
      });
      return typescript_exports.TypeLiteral.nop();
    }
    return typescript_exports.TypeLiteral.set({
      values: value.map((v, index) => {
        this.context.errors.scope({ index });
        try {
          return this.convert({ typeReference: set, value: v });
        } finally {
          this.context.errors.unscope();
        }
      })
    });
  }
  convertMap({ map, value }) {
    if (typeof value !== "object" || value == null) {
      this.context.errors.add({
        severity: Severity.Critical,
        message: `Expected object but got: ${value == null ? "null" : typeof value}`
      });
      return typescript_exports.TypeLiteral.nop();
    }
    return typescript_exports.TypeLiteral.record({
      entries: Object.entries(value).map(([key, value2]) => {
        this.context.errors.scope(key);
        try {
          return {
            key: this.convert({ typeReference: map.key, value: key, as: "key" }),
            value: this.convert({ typeReference: map.value, value: value2 })
          };
        } finally {
          this.context.errors.unscope();
        }
      })
    });
  }
  convertNamed({
    named,
    value,
    as
  }) {
    var _a;
    switch (named.type) {
      case "alias": {
        if ((_a = this.context.customConfig) == null ? void 0 : _a.useBrandedStringAliases) {
          return typescript_exports.TypeLiteral.reference(
            typescript_exports.codeblock((writer) => {
              writer.writeNode(
                typescript_exports.reference({
                  name: this.context.namespaceExport,
                  importFrom: this.context.getModuleImport(),
                  memberName: this.context.getFullyQualifiedReference({
                    declaration: named.declaration
                  })
                })
              );
              writer.write("(");
              writer.writeNode(this.convert({ typeReference: named.typeReference, value, as }));
              writer.write(")");
            })
          );
        }
        return this.convert({ typeReference: named.typeReference, value, as });
      }
      case "discriminatedUnion":
        return this.convertDiscriminatedUnion({
          discriminatedUnion: named,
          value
        });
      case "enum":
        return this.convertEnum({ enum_: named, value });
      case "object":
        return this.convertObject({ object_: named, value });
      case "undiscriminatedUnion":
        return this.convertUndicriminatedUnion({ undicriminatedUnion: named, value });
      default:
        assertNever(named);
    }
  }
  convertDiscriminatedUnion({
    discriminatedUnion,
    value
  }) {
    var _a;
    const discriminatedUnionTypeInstance = this.context.resolveDiscriminatedUnionTypeInstance({
      discriminatedUnion,
      value
    });
    if (discriminatedUnionTypeInstance == null) {
      return typescript_exports.TypeLiteral.nop();
    }
    const unionVariant = discriminatedUnionTypeInstance.singleDiscriminatedUnionType;
    const unionProperties = this.convertDiscriminatedUnionProperties({
      discriminatedUnionTypeInstance,
      unionVariant
    });
    if (unionProperties == null) {
      return typescript_exports.TypeLiteral.nop();
    }
    if ((_a = this.context.customConfig) == null ? void 0 : _a.includeUtilsOnUnionMembers) {
      return typescript_exports.TypeLiteral.reference(
        typescript_exports.codeblock((writer) => {
          writer.writeNode(
            typescript_exports.invokeMethod({
              on: typescript_exports.reference({
                name: this.context.namespaceExport,
                importFrom: this.context.getModuleImport(),
                memberName: this.context.getFullyQualifiedReference({
                  declaration: discriminatedUnion.declaration
                })
              }),
              method: this.context.getMethodName(unionVariant.discriminantValue.name),
              arguments_: this.convertDiscriminatedUnionUtilsArgs({
                discriminatedUnionTypeInstance,
                unionVariant,
                unionProperties
              })
            })
          );
        })
      );
    }
    const discriminantProperty = {
      name: this.context.getPropertyName(discriminatedUnion.discriminant.name),
      value: typescript_exports.TypeLiteral.string(unionVariant.discriminantValue.wireValue)
    };
    return typescript_exports.TypeLiteral.object({
      fields: [discriminantProperty, ...unionProperties]
    });
  }
  convertDiscriminatedUnionProperties({
    discriminatedUnionTypeInstance,
    unionVariant
  }) {
    const baseFields = this.getBaseFields({
      discriminatedUnionTypeInstance,
      singleDiscriminatedUnionType: unionVariant
    });
    switch (unionVariant.type) {
      case "samePropertiesAsObject": {
        const named = this.context.resolveNamedType({
          typeId: unionVariant.typeId
        });
        if (named == null) {
          return void 0;
        }
        const converted = this.convertNamed({ named, value: discriminatedUnionTypeInstance.value });
        if (!converted.isObject()) {
          this.context.errors.add({
            severity: Severity.Critical,
            message: "Internal error; expected union value to be an object"
          });
          return void 0;
        }
        const object_ = converted.asObjectOrThrow();
        return [...baseFields, ...object_.fields];
      }
      case "singleProperty": {
        try {
          this.context.errors.scope(unionVariant.discriminantValue.wireValue);
          const record = this.context.getRecord(discriminatedUnionTypeInstance.value);
          if (record == null) {
            return [
              ...baseFields,
              {
                name: UNION_VALUE_KEY,
                value: this.convert({
                  typeReference: unionVariant.typeReference,
                  value: discriminatedUnionTypeInstance.value
                })
              }
            ];
          }
          return [
            ...baseFields,
            {
              name: this.context.getPropertyName(unionVariant.discriminantValue.name),
              value: this.convert({
                typeReference: unionVariant.typeReference,
                value: record[unionVariant.discriminantValue.wireValue]
              })
            }
          ];
        } finally {
          this.context.errors.unscope();
        }
      }
      case "noProperties":
        return baseFields;
      default:
        assertNever(unionVariant);
    }
  }
  convertDiscriminatedUnionUtilsArgs({
    discriminatedUnionTypeInstance,
    unionVariant,
    unionProperties
  }) {
    if (unionVariant.type === "singleProperty") {
      const record = this.context.getRecord(discriminatedUnionTypeInstance.value);
      if (record == null && unionProperties.length === 1) {
        return [
          this.convert({
            typeReference: unionVariant.typeReference,
            value: discriminatedUnionTypeInstance.value
          })
        ];
      }
    }
    return unionProperties.length > 0 ? [typescript_exports.TypeLiteral.object({ fields: unionProperties })] : [];
  }
  getBaseFields({
    discriminatedUnionTypeInstance,
    singleDiscriminatedUnionType
  }) {
    var _a, _b;
    const properties = this.context.associateByWireValue({
      parameters: (_a = singleDiscriminatedUnionType.properties) != null ? _a : [],
      values: (_b = this.context.getRecord(discriminatedUnionTypeInstance.value)) != null ? _b : {},
      // We're only selecting the base properties here. The rest of the properties
      // are handled by the union variant.
      ignoreMissingParameters: true
    });
    return properties.map((property) => {
      this.context.errors.scope(property.name.wireValue);
      try {
        return {
          name: this.context.getPropertyName(property.name.name),
          value: this.convert(property)
        };
      } finally {
        this.context.errors.unscope();
      }
    });
  }
  convertObject({ object_, value }) {
    var _a;
    const properties = this.context.associateByWireValue({
      parameters: object_.properties,
      values: (_a = this.context.getRecord(value)) != null ? _a : {}
    });
    return typescript_exports.TypeLiteral.object({
      fields: properties.map((property) => {
        this.context.errors.scope(property.name.wireValue);
        try {
          return {
            name: this.context.getPropertyName(property.name.name),
            value: this.convert(property)
          };
        } finally {
          this.context.errors.unscope();
        }
      })
    });
  }
  convertEnum({ enum_, value }) {
    const enumValue = this.getEnumValue({ enum_, value });
    if (enumValue == null) {
      return typescript_exports.TypeLiteral.nop();
    }
    return typescript_exports.TypeLiteral.string(enumValue);
  }
  getEnumValue({ enum_, value }) {
    if (typeof value !== "string") {
      this.context.errors.add({
        severity: Severity.Critical,
        message: `Expected enum value string, got: ${typeof value}`
      });
      return void 0;
    }
    const enumValue = enum_.values.find((v) => v.wireValue === value);
    if (enumValue == null) {
      this.context.errors.add({
        severity: Severity.Critical,
        message: `An enum value named "${value}" does not exist in this context`
      });
      return void 0;
    }
    return value;
  }
  convertUndicriminatedUnion({
    undicriminatedUnion,
    value
  }) {
    const result = this.findMatchingUndiscriminatedUnionType({
      undicriminatedUnion,
      value
    });
    if (result == null) {
      return typescript_exports.TypeLiteral.nop();
    }
    return result;
  }
  findMatchingUndiscriminatedUnionType({
    undicriminatedUnion,
    value
  }) {
    for (const typeReference of undicriminatedUnion.types) {
      try {
        return this.convert({ typeReference, value });
      } catch (e) {
        continue;
      }
    }
    this.context.errors.add({
      severity: Severity.Critical,
      message: `None of the types in the undicriminated union matched the given "${typeof value}" value`
    });
    return void 0;
  }
  convertUnknown({ value }) {
    return typescript_exports.TypeLiteral.unknown(value);
  }
  convertPrimitive({
    primitive,
    value,
    as
  }) {
    var _a, _b;
    switch (primitive) {
      case "INTEGER":
      case "UINT": {
        const num = this.getValueAsNumber({ value, as });
        if (num == null) {
          return typescript_exports.TypeLiteral.nop();
        }
        return typescript_exports.TypeLiteral.number(num);
      }
      case "LONG":
      case "UINT_64": {
        const num = this.getValueAsNumber({ value, as });
        if (num == null) {
          return typescript_exports.TypeLiteral.nop();
        }
        if ((_a = this.context.customConfig) == null ? void 0 : _a.useBigInt) {
          return typescript_exports.TypeLiteral.bigint(BigInt(num));
        }
        return typescript_exports.TypeLiteral.number(num);
      }
      case "FLOAT":
      case "DOUBLE": {
        const num = this.getValueAsNumber({ value });
        if (num == null) {
          return typescript_exports.TypeLiteral.nop();
        }
        return typescript_exports.TypeLiteral.number(num);
      }
      case "BOOLEAN": {
        const bool = this.getValueAsBoolean({ value, as });
        if (bool == null) {
          return typescript_exports.TypeLiteral.nop();
        }
        return typescript_exports.TypeLiteral.boolean(bool);
      }
      case "BASE_64":
      case "DATE":
      case "UUID":
      case "STRING": {
        const str = this.context.getValueAsString({ value });
        if (str == null) {
          return typescript_exports.TypeLiteral.nop();
        }
        return typescript_exports.TypeLiteral.string(str);
      }
      case "DATE_TIME": {
        const str = this.context.getValueAsString({ value });
        if (str == null) {
          return typescript_exports.TypeLiteral.nop();
        }
        return typescript_exports.TypeLiteral.datetime(str);
      }
      case "BIG_INTEGER": {
        const bigInt = this.context.getValueAsString({ value });
        if (bigInt == null) {
          return typescript_exports.TypeLiteral.nop();
        }
        if ((_b = this.context.customConfig) == null ? void 0 : _b.useBigInt) {
          return typescript_exports.TypeLiteral.bigint(BigInt(bigInt));
        }
        return typescript_exports.TypeLiteral.string(bigInt);
      }
      default:
        assertNever(primitive);
    }
  }
  getValueAsNumber({
    value,
    as
  }) {
    const num = as === "key" ? typeof value === "string" ? Number(value) : value : value;
    return this.context.getValueAsNumber({ value: num });
  }
  getValueAsBoolean({
    value,
    as
  }) {
    const bool = as === "key" ? typeof value === "string" ? value === "true" : value === "false" ? false : value : value;
    return this.context.getValueAsBoolean({ value: bool });
  }
};

// src/context/FilePropertyMapper.ts
init_process();
init_buffer();
var FilePropertyMapper = class {
  constructor({ context }) {
    __publicField(this, "context");
    this.context = context;
  }
  getFilePropertyInfo({
    body,
    value
  }) {
    var _a;
    const result = {
      fileFields: [],
      bodyPropertyFields: []
    };
    const record = (_a = this.context.getRecord(value)) != null ? _a : {};
    for (const property of body.properties) {
      switch (property.type) {
        case "file":
          result.fileFields.push({
            name: this.context.getPropertyName(property.name),
            value: this.getSingleFileProperty({ property, record })
          });
          break;
        case "fileArray":
          result.fileFields.push({
            name: this.context.getPropertyName(property.name),
            value: this.getArrayFileProperty({ property, record })
          });
          break;
        case "bodyProperty":
          result.bodyPropertyFields.push({
            name: this.context.getPropertyName(property.name.name),
            value: this.getBodyProperty({ property, record })
          });
          break;
        default:
          assertNever(property);
      }
    }
    return result;
  }
  getSingleFileProperty({
    property,
    record
  }) {
    const fileValue = this.context.getSingleFileValue({ property, record });
    if (fileValue == null) {
      return typescript_exports.TypeLiteral.nop();
    }
    return typescript_exports.TypeLiteral.blob(fileValue);
  }
  getArrayFileProperty({
    property,
    record
  }) {
    const fileValues = this.context.getFileArrayValues({ property, record });
    if (fileValues == null) {
      return typescript_exports.TypeLiteral.nop();
    }
    return typescript_exports.TypeLiteral.array({ values: fileValues.map((value) => typescript_exports.TypeLiteral.blob(value)) });
  }
  getBodyProperty({
    property,
    record
  }) {
    const bodyPropertyValue = record[property.name.wireValue];
    if (bodyPropertyValue == null) {
      return typescript_exports.TypeLiteral.nop();
    }
    return this.context.dynamicTypeLiteralMapper.convert({
      typeReference: property.typeReference,
      value: bodyPropertyValue
    });
  }
};

// src/context/DynamicSnippetsGeneratorContext.ts
var DynamicSnippetsGeneratorContext = class _DynamicSnippetsGeneratorContext extends AbstractDynamicSnippetsGeneratorContext {
  constructor({
    ir,
    config: config2
  }) {
    var _a;
    super({ ir, config: config2 });
    __publicField(this, "ir");
    __publicField(this, "customConfig");
    __publicField(this, "dynamicTypeLiteralMapper");
    __publicField(this, "filePropertyMapper");
    __publicField(this, "moduleName");
    __publicField(this, "namespaceExport");
    this.ir = ir;
    this.customConfig = config2.customConfig != null ? config2.customConfig : void 0;
    this.dynamicTypeLiteralMapper = new DynamicTypeLiteralMapper({ context: this });
    this.filePropertyMapper = new FilePropertyMapper({ context: this });
    this.moduleName = getModuleName({ config: config2, customConfig: this.customConfig });
    this.namespaceExport = getNamespaceExport({
      organization: config2.organization,
      workspaceName: config2.workspaceName,
      namespaceExport: (_a = this.customConfig) == null ? void 0 : _a.namespaceExport
    });
  }
  clone() {
    return new _DynamicSnippetsGeneratorContext({
      ir: this.ir,
      config: this.config
    });
  }
  getModuleImport() {
    return {
      type: "named",
      moduleName: this.moduleName
    };
  }
  getRootClientName() {
    return `${this.namespaceExport}Client`;
  }
  getPropertyName(name) {
    var _a, _b;
    if (((_a = this.customConfig) == null ? void 0 : _a.retainOriginalCasing) || ((_b = this.customConfig) == null ? void 0 : _b.noSerdeLayer)) {
      return this.formatOriginalPropertyName(name.originalName);
    }
    return name.camelCase.unsafeName;
  }
  getMethodName(name) {
    return name.camelCase.unsafeName;
  }
  getTypeName(name) {
    return name.pascalCase.unsafeName;
  }
  getEnvironmentTypeReferenceFromID(environmentID) {
    const environmentName = this.resolveEnvironmentName(environmentID);
    if (environmentName == null) {
      return void 0;
    }
    return this.getEnvironmentsTypeReference(environmentName);
  }
  getFullyQualifiedReference({ declaration }) {
    if (declaration.fernFilepath.allParts.length > 0) {
      return `${declaration.fernFilepath.allParts.map((val) => val.camelCase.unsafeName).join(".")}.${this.getTypeName(declaration.name)}`;
    }
    return `${this.getTypeName(declaration.name)}`;
  }
  getEnvironmentsTypeReference(name) {
    return typescript_exports.reference({
      name: `${this.namespaceExport}Environments`,
      importFrom: this.getModuleImport(),
      memberName: this.getTypeName(name)
    });
  }
  formatOriginalPropertyName(value) {
    if (value.includes("-")) {
      return `"${value}"`;
    }
    return value;
  }
};
function getModuleName({
  config: config2,
  customConfig
}) {
  var _a, _b, _c;
  return (_c = (_b = constructNpmPackage({
    generatorConfig: config2,
    isPackagePrivate: (_a = customConfig == null ? void 0 : customConfig.private) != null ? _a : false
  })) == null ? void 0 : _b.packageName) != null ? _c : config2.organization;
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  DynamicSnippetsGeneratorContext
});
/*! Bundled license information:

@esbuild-plugins/node-globals-polyfill/Buffer.js:
  (*!
   * The buffer module from node.js, for the browser.
   *
   * @author   Feross Aboukhadijeh <feross@feross.org> <http://feross.org>
   * @license  MIT
   *)

lodash-es/lodash.js:
  (**
   * @license
   * Lodash (Custom Build) <https://lodash.com/>
   * Build: `lodash modularize exports="es" -o ./`
   * Copyright OpenJS Foundation and other contributors <https://openjsf.org/>
   * Released under MIT license <https://lodash.com/license>
   * Based on Underscore.js 1.8.3 <http://underscorejs.org/LICENSE>
   * Copyright Jeremy Ashkenas, DocumentCloud and Investigative Reporters & Editors
   *)
*/
