"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __restKey = (key) => typeof key === "symbol" ? key : key + "";
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
var __esm = (fn, res) => function __init() {
  return fn && (res = (0, fn[__getOwnPropNames(fn)[0]])(fn = 0)), res;
};
var __commonJS = (cb, mod) => function __require() {
  return mod || (0, cb[__getOwnPropNames(cb)[0]])((mod = { exports: {} }).exports, mod), mod.exports;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from2, except, desc) => {
  if (from2 && typeof from2 === "object" || typeof from2 === "function") {
    for (let key of __getOwnPropNames(from2))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from2[key], enumerable: !(desc = __getOwnPropDesc(from2, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __publicField = (obj, key, value) => __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);

// ../../../node_modules/.pnpm/@esbuild-plugins+node-globals-polyfill@0.2.3_esbuild@0.24.0/node_modules/@esbuild-plugins/node-globals-polyfill/process.js
function defaultSetTimout() {
  throw new Error("setTimeout has not been defined");
}
function defaultClearTimeout() {
  throw new Error("clearTimeout has not been defined");
}
function runTimeout(fun) {
  if (cachedSetTimeout === setTimeout) {
    return setTimeout(fun, 0);
  }
  if ((cachedSetTimeout === defaultSetTimout || !cachedSetTimeout) && setTimeout) {
    cachedSetTimeout = setTimeout;
    return setTimeout(fun, 0);
  }
  try {
    return cachedSetTimeout(fun, 0);
  } catch (e) {
    try {
      return cachedSetTimeout.call(null, fun, 0);
    } catch (e2) {
      return cachedSetTimeout.call(this, fun, 0);
    }
  }
}
function runClearTimeout(marker) {
  if (cachedClearTimeout === clearTimeout) {
    return clearTimeout(marker);
  }
  if ((cachedClearTimeout === defaultClearTimeout || !cachedClearTimeout) && clearTimeout) {
    cachedClearTimeout = clearTimeout;
    return clearTimeout(marker);
  }
  try {
    return cachedClearTimeout(marker);
  } catch (e) {
    try {
      return cachedClearTimeout.call(null, marker);
    } catch (e2) {
      return cachedClearTimeout.call(this, marker);
    }
  }
}
function cleanUpNextTick() {
  if (!draining || !currentQueue) {
    return;
  }
  draining = false;
  if (currentQueue.length) {
    queue = currentQueue.concat(queue);
  } else {
    queueIndex = -1;
  }
  if (queue.length) {
    drainQueue();
  }
}
function drainQueue() {
  if (draining) {
    return;
  }
  var timeout = runTimeout(cleanUpNextTick);
  draining = true;
  var len = queue.length;
  while (len) {
    currentQueue = queue;
    queue = [];
    while (++queueIndex < len) {
      if (currentQueue) {
        currentQueue[queueIndex].run();
      }
    }
    queueIndex = -1;
    len = queue.length;
  }
  currentQueue = null;
  draining = false;
  runClearTimeout(timeout);
}
function nextTick(fun) {
  var args = new Array(arguments.length - 1);
  if (arguments.length > 1) {
    for (var i = 1; i < arguments.length; i++) {
      args[i - 1] = arguments[i];
    }
  }
  queue.push(new Item(fun, args));
  if (queue.length === 1 && !draining) {
    runTimeout(drainQueue);
  }
}
function Item(fun, array) {
  this.fun = fun;
  this.array = array;
}
function noop() {
}
function binding(name) {
  throw new Error("process.binding is not supported");
}
function cwd() {
  return "/";
}
function chdir(dir) {
  throw new Error("process.chdir is not supported");
}
function umask() {
  return 0;
}
function hrtime(previousTimestamp) {
  var clocktime = performanceNow.call(performance) * 1e-3;
  var seconds = Math.floor(clocktime);
  var nanoseconds = Math.floor(clocktime % 1 * 1e9);
  if (previousTimestamp) {
    seconds = seconds - previousTimestamp[0];
    nanoseconds = nanoseconds - previousTimestamp[1];
    if (nanoseconds < 0) {
      seconds--;
      nanoseconds += 1e9;
    }
  }
  return [seconds, nanoseconds];
}
function uptime() {
  var currentTime = /* @__PURE__ */ new Date();
  var dif = currentTime - startTime;
  return dif / 1e3;
}
var cachedSetTimeout, cachedClearTimeout, queue, draining, currentQueue, queueIndex, title, platform, browser, env, argv, version, versions, release, config, on, addListener, once, off, removeListener, removeAllListeners, emit, performance, performanceNow, startTime, process, defines;
var init_process = __esm({
  "../../../node_modules/.pnpm/@esbuild-plugins+node-globals-polyfill@0.2.3_esbuild@0.24.0/node_modules/@esbuild-plugins/node-globals-polyfill/process.js"() {
    "use strict";
    cachedSetTimeout = defaultSetTimout;
    cachedClearTimeout = defaultClearTimeout;
    if (typeof globalThis.setTimeout === "function") {
      cachedSetTimeout = setTimeout;
    }
    if (typeof globalThis.clearTimeout === "function") {
      cachedClearTimeout = clearTimeout;
    }
    queue = [];
    draining = false;
    queueIndex = -1;
    Item.prototype.run = function() {
      this.fun.apply(null, this.array);
    };
    title = "browser";
    platform = "browser";
    browser = true;
    env = {};
    argv = [];
    version = "";
    versions = {};
    release = {};
    config = {};
    on = noop;
    addListener = noop;
    once = noop;
    off = noop;
    removeListener = noop;
    removeAllListeners = noop;
    emit = noop;
    performance = globalThis.performance || {};
    performanceNow = performance.now || performance.mozNow || performance.msNow || performance.oNow || performance.webkitNow || function() {
      return (/* @__PURE__ */ new Date()).getTime();
    };
    startTime = /* @__PURE__ */ new Date();
    process = {
      nextTick,
      title,
      browser,
      env,
      argv,
      version,
      versions,
      on,
      addListener,
      once,
      off,
      removeListener,
      removeAllListeners,
      emit,
      binding,
      cwd,
      chdir,
      umask,
      hrtime,
      platform,
      release,
      config,
      uptime
    };
    defines = {};
    Object.keys(defines).forEach((key) => {
      const segs = key.split(".");
      let target = process;
      for (let i = 0; i < segs.length; i++) {
        const seg = segs[i];
        if (i === segs.length - 1) {
          target[seg] = defines[key];
        } else {
          target = target[seg] || (target[seg] = {});
        }
      }
    });
  }
});

// ../../../node_modules/.pnpm/@esbuild-plugins+node-globals-polyfill@0.2.3_esbuild@0.24.0/node_modules/@esbuild-plugins/node-globals-polyfill/Buffer.js
function init() {
  inited = true;
  var code = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
  for (var i = 0, len = code.length; i < len; ++i) {
    lookup[i] = code[i];
    revLookup[code.charCodeAt(i)] = i;
  }
  revLookup["-".charCodeAt(0)] = 62;
  revLookup["_".charCodeAt(0)] = 63;
}
function base64toByteArray(b64) {
  if (!inited) {
    init();
  }
  var i, j, l, tmp, placeHolders, arr;
  var len = b64.length;
  if (len % 4 > 0) {
    throw new Error("Invalid string. Length must be a multiple of 4");
  }
  placeHolders = b64[len - 2] === "=" ? 2 : b64[len - 1] === "=" ? 1 : 0;
  arr = new Arr(len * 3 / 4 - placeHolders);
  l = placeHolders > 0 ? len - 4 : len;
  var L = 0;
  for (i = 0, j = 0; i < l; i += 4, j += 3) {
    tmp = revLookup[b64.charCodeAt(i)] << 18 | revLookup[b64.charCodeAt(i + 1)] << 12 | revLookup[b64.charCodeAt(i + 2)] << 6 | revLookup[b64.charCodeAt(i + 3)];
    arr[L++] = tmp >> 16 & 255;
    arr[L++] = tmp >> 8 & 255;
    arr[L++] = tmp & 255;
  }
  if (placeHolders === 2) {
    tmp = revLookup[b64.charCodeAt(i)] << 2 | revLookup[b64.charCodeAt(i + 1)] >> 4;
    arr[L++] = tmp & 255;
  } else if (placeHolders === 1) {
    tmp = revLookup[b64.charCodeAt(i)] << 10 | revLookup[b64.charCodeAt(i + 1)] << 4 | revLookup[b64.charCodeAt(i + 2)] >> 2;
    arr[L++] = tmp >> 8 & 255;
    arr[L++] = tmp & 255;
  }
  return arr;
}
function tripletToBase64(num) {
  return lookup[num >> 18 & 63] + lookup[num >> 12 & 63] + lookup[num >> 6 & 63] + lookup[num & 63];
}
function encodeChunk(uint8, start, end) {
  var tmp;
  var output = [];
  for (var i = start; i < end; i += 3) {
    tmp = (uint8[i] << 16) + (uint8[i + 1] << 8) + uint8[i + 2];
    output.push(tripletToBase64(tmp));
  }
  return output.join("");
}
function base64fromByteArray(uint8) {
  if (!inited) {
    init();
  }
  var tmp;
  var len = uint8.length;
  var extraBytes = len % 3;
  var output = "";
  var parts = [];
  var maxChunkLength = 16383;
  for (var i = 0, len2 = len - extraBytes; i < len2; i += maxChunkLength) {
    parts.push(
      encodeChunk(
        uint8,
        i,
        i + maxChunkLength > len2 ? len2 : i + maxChunkLength
      )
    );
  }
  if (extraBytes === 1) {
    tmp = uint8[len - 1];
    output += lookup[tmp >> 2];
    output += lookup[tmp << 4 & 63];
    output += "==";
  } else if (extraBytes === 2) {
    tmp = (uint8[len - 2] << 8) + uint8[len - 1];
    output += lookup[tmp >> 10];
    output += lookup[tmp >> 4 & 63];
    output += lookup[tmp << 2 & 63];
    output += "=";
  }
  parts.push(output);
  return parts.join("");
}
function kMaxLength() {
  return Buffer2.TYPED_ARRAY_SUPPORT ? 2147483647 : 1073741823;
}
function createBuffer(that, length) {
  if (kMaxLength() < length) {
    throw new RangeError("Invalid typed array length");
  }
  if (Buffer2.TYPED_ARRAY_SUPPORT) {
    that = new Uint8Array(length);
    that.__proto__ = Buffer2.prototype;
  } else {
    if (that === null) {
      that = new Buffer2(length);
    }
    that.length = length;
  }
  return that;
}
function Buffer2(arg, encodingOrOffset, length) {
  if (!Buffer2.TYPED_ARRAY_SUPPORT && !(this instanceof Buffer2)) {
    return new Buffer2(arg, encodingOrOffset, length);
  }
  if (typeof arg === "number") {
    if (typeof encodingOrOffset === "string") {
      throw new Error(
        "If encoding is specified then the first argument must be a string"
      );
    }
    return allocUnsafe(this, arg);
  }
  return from(this, arg, encodingOrOffset, length);
}
function from(that, value, encodingOrOffset, length) {
  if (typeof value === "number") {
    throw new TypeError('"value" argument must not be a number');
  }
  if (typeof ArrayBuffer !== "undefined" && value instanceof ArrayBuffer) {
    return fromArrayBuffer(that, value, encodingOrOffset, length);
  }
  if (typeof value === "string") {
    return fromString(that, value, encodingOrOffset);
  }
  return fromObject(that, value);
}
function assertSize(size) {
  if (typeof size !== "number") {
    throw new TypeError('"size" argument must be a number');
  } else if (size < 0) {
    throw new RangeError('"size" argument must not be negative');
  }
}
function alloc(that, size, fill2, encoding) {
  assertSize(size);
  if (size <= 0) {
    return createBuffer(that, size);
  }
  if (fill2 !== void 0) {
    return typeof encoding === "string" ? createBuffer(that, size).fill(fill2, encoding) : createBuffer(that, size).fill(fill2);
  }
  return createBuffer(that, size);
}
function allocUnsafe(that, size) {
  assertSize(size);
  that = createBuffer(that, size < 0 ? 0 : checked(size) | 0);
  if (!Buffer2.TYPED_ARRAY_SUPPORT) {
    for (var i = 0; i < size; ++i) {
      that[i] = 0;
    }
  }
  return that;
}
function fromString(that, string, encoding) {
  if (typeof encoding !== "string" || encoding === "") {
    encoding = "utf8";
  }
  if (!Buffer2.isEncoding(encoding)) {
    throw new TypeError('"encoding" must be a valid string encoding');
  }
  var length = byteLength(string, encoding) | 0;
  that = createBuffer(that, length);
  var actual = that.write(string, encoding);
  if (actual !== length) {
    that = that.slice(0, actual);
  }
  return that;
}
function fromArrayLike(that, array) {
  var length = array.length < 0 ? 0 : checked(array.length) | 0;
  that = createBuffer(that, length);
  for (var i = 0; i < length; i += 1) {
    that[i] = array[i] & 255;
  }
  return that;
}
function fromArrayBuffer(that, array, byteOffset, length) {
  array.byteLength;
  if (byteOffset < 0 || array.byteLength < byteOffset) {
    throw new RangeError("'offset' is out of bounds");
  }
  if (array.byteLength < byteOffset + (length || 0)) {
    throw new RangeError("'length' is out of bounds");
  }
  if (byteOffset === void 0 && length === void 0) {
    array = new Uint8Array(array);
  } else if (length === void 0) {
    array = new Uint8Array(array, byteOffset);
  } else {
    array = new Uint8Array(array, byteOffset, length);
  }
  if (Buffer2.TYPED_ARRAY_SUPPORT) {
    that = array;
    that.__proto__ = Buffer2.prototype;
  } else {
    that = fromArrayLike(that, array);
  }
  return that;
}
function fromObject(that, obj) {
  if (internalIsBuffer(obj)) {
    var len = checked(obj.length) | 0;
    that = createBuffer(that, len);
    if (that.length === 0) {
      return that;
    }
    obj.copy(that, 0, 0, len);
    return that;
  }
  if (obj) {
    if (typeof ArrayBuffer !== "undefined" && obj.buffer instanceof ArrayBuffer || "length" in obj) {
      if (typeof obj.length !== "number" || isnan(obj.length)) {
        return createBuffer(that, 0);
      }
      return fromArrayLike(that, obj);
    }
    if (obj.type === "Buffer" && Array.isArray(obj.data)) {
      return fromArrayLike(that, obj.data);
    }
  }
  throw new TypeError(
    "First argument must be a string, Buffer, ArrayBuffer, Array, or array-like object."
  );
}
function checked(length) {
  if (length >= kMaxLength()) {
    throw new RangeError(
      "Attempt to allocate Buffer larger than maximum size: 0x" + kMaxLength().toString(16) + " bytes"
    );
  }
  return length | 0;
}
function internalIsBuffer(b) {
  return !!(b != null && b._isBuffer);
}
function byteLength(string, encoding) {
  if (internalIsBuffer(string)) {
    return string.length;
  }
  if (typeof ArrayBuffer !== "undefined" && typeof ArrayBuffer.isView === "function" && (ArrayBuffer.isView(string) || string instanceof ArrayBuffer)) {
    return string.byteLength;
  }
  if (typeof string !== "string") {
    string = "" + string;
  }
  var len = string.length;
  if (len === 0) return 0;
  var loweredCase = false;
  for (; ; ) {
    switch (encoding) {
      case "ascii":
      case "latin1":
      case "binary":
        return len;
      case "utf8":
      case "utf-8":
      case void 0:
        return utf8ToBytes(string).length;
      case "ucs2":
      case "ucs-2":
      case "utf16le":
      case "utf-16le":
        return len * 2;
      case "hex":
        return len >>> 1;
      case "base64":
        return base64ToBytes(string).length;
      default:
        if (loweredCase) return utf8ToBytes(string).length;
        encoding = ("" + encoding).toLowerCase();
        loweredCase = true;
    }
  }
}
function slowToString(encoding, start, end) {
  var loweredCase = false;
  if (start === void 0 || start < 0) {
    start = 0;
  }
  if (start > this.length) {
    return "";
  }
  if (end === void 0 || end > this.length) {
    end = this.length;
  }
  if (end <= 0) {
    return "";
  }
  end >>>= 0;
  start >>>= 0;
  if (end <= start) {
    return "";
  }
  if (!encoding) encoding = "utf8";
  while (true) {
    switch (encoding) {
      case "hex":
        return hexSlice(this, start, end);
      case "utf8":
      case "utf-8":
        return utf8Slice(this, start, end);
      case "ascii":
        return asciiSlice(this, start, end);
      case "latin1":
      case "binary":
        return latin1Slice(this, start, end);
      case "base64":
        return base64Slice(this, start, end);
      case "ucs2":
      case "ucs-2":
      case "utf16le":
      case "utf-16le":
        return utf16leSlice(this, start, end);
      default:
        if (loweredCase)
          throw new TypeError("Unknown encoding: " + encoding);
        encoding = (encoding + "").toLowerCase();
        loweredCase = true;
    }
  }
}
function swap(b, n, m) {
  var i = b[n];
  b[n] = b[m];
  b[m] = i;
}
function bidirectionalIndexOf(buffer, val, byteOffset, encoding, dir) {
  if (buffer.length === 0) return -1;
  if (typeof byteOffset === "string") {
    encoding = byteOffset;
    byteOffset = 0;
  } else if (byteOffset > 2147483647) {
    byteOffset = 2147483647;
  } else if (byteOffset < -2147483648) {
    byteOffset = -2147483648;
  }
  byteOffset = +byteOffset;
  if (isNaN(byteOffset)) {
    byteOffset = dir ? 0 : buffer.length - 1;
  }
  if (byteOffset < 0) byteOffset = buffer.length + byteOffset;
  if (byteOffset >= buffer.length) {
    if (dir) return -1;
    else byteOffset = buffer.length - 1;
  } else if (byteOffset < 0) {
    if (dir) byteOffset = 0;
    else return -1;
  }
  if (typeof val === "string") {
    val = Buffer2.from(val, encoding);
  }
  if (internalIsBuffer(val)) {
    if (val.length === 0) {
      return -1;
    }
    return arrayIndexOf(buffer, val, byteOffset, encoding, dir);
  } else if (typeof val === "number") {
    val = val & 255;
    if (Buffer2.TYPED_ARRAY_SUPPORT && typeof Uint8Array.prototype.indexOf === "function") {
      if (dir) {
        return Uint8Array.prototype.indexOf.call(
          buffer,
          val,
          byteOffset
        );
      } else {
        return Uint8Array.prototype.lastIndexOf.call(
          buffer,
          val,
          byteOffset
        );
      }
    }
    return arrayIndexOf(buffer, [val], byteOffset, encoding, dir);
  }
  throw new TypeError("val must be string, number or Buffer");
}
function arrayIndexOf(arr, val, byteOffset, encoding, dir) {
  var indexSize = 1;
  var arrLength = arr.length;
  var valLength = val.length;
  if (encoding !== void 0) {
    encoding = String(encoding).toLowerCase();
    if (encoding === "ucs2" || encoding === "ucs-2" || encoding === "utf16le" || encoding === "utf-16le") {
      if (arr.length < 2 || val.length < 2) {
        return -1;
      }
      indexSize = 2;
      arrLength /= 2;
      valLength /= 2;
      byteOffset /= 2;
    }
  }
  function read(buf, i2) {
    if (indexSize === 1) {
      return buf[i2];
    } else {
      return buf.readUInt16BE(i2 * indexSize);
    }
  }
  var i;
  if (dir) {
    var foundIndex = -1;
    for (i = byteOffset; i < arrLength; i++) {
      if (read(arr, i) === read(val, foundIndex === -1 ? 0 : i - foundIndex)) {
        if (foundIndex === -1) foundIndex = i;
        if (i - foundIndex + 1 === valLength)
          return foundIndex * indexSize;
      } else {
        if (foundIndex !== -1) i -= i - foundIndex;
        foundIndex = -1;
      }
    }
  } else {
    if (byteOffset + valLength > arrLength)
      byteOffset = arrLength - valLength;
    for (i = byteOffset; i >= 0; i--) {
      var found = true;
      for (var j = 0; j < valLength; j++) {
        if (read(arr, i + j) !== read(val, j)) {
          found = false;
          break;
        }
      }
      if (found) return i;
    }
  }
  return -1;
}
function hexWrite(buf, string, offset, length) {
  offset = Number(offset) || 0;
  var remaining = buf.length - offset;
  if (!length) {
    length = remaining;
  } else {
    length = Number(length);
    if (length > remaining) {
      length = remaining;
    }
  }
  var strLen = string.length;
  if (strLen % 2 !== 0) throw new TypeError("Invalid hex string");
  if (length > strLen / 2) {
    length = strLen / 2;
  }
  for (var i = 0; i < length; ++i) {
    var parsed = parseInt(string.substr(i * 2, 2), 16);
    if (isNaN(parsed)) return i;
    buf[offset + i] = parsed;
  }
  return i;
}
function utf8Write(buf, string, offset, length) {
  return blitBuffer(
    utf8ToBytes(string, buf.length - offset),
    buf,
    offset,
    length
  );
}
function asciiWrite(buf, string, offset, length) {
  return blitBuffer(asciiToBytes(string), buf, offset, length);
}
function latin1Write(buf, string, offset, length) {
  return asciiWrite(buf, string, offset, length);
}
function base64Write(buf, string, offset, length) {
  return blitBuffer(base64ToBytes(string), buf, offset, length);
}
function ucs2Write(buf, string, offset, length) {
  return blitBuffer(
    utf16leToBytes(string, buf.length - offset),
    buf,
    offset,
    length
  );
}
function base64Slice(buf, start, end) {
  if (start === 0 && end === buf.length) {
    return base64fromByteArray(buf);
  } else {
    return base64fromByteArray(buf.slice(start, end));
  }
}
function utf8Slice(buf, start, end) {
  end = Math.min(buf.length, end);
  var res = [];
  var i = start;
  while (i < end) {
    var firstByte = buf[i];
    var codePoint = null;
    var bytesPerSequence = firstByte > 239 ? 4 : firstByte > 223 ? 3 : firstByte > 191 ? 2 : 1;
    if (i + bytesPerSequence <= end) {
      var secondByte, thirdByte, fourthByte, tempCodePoint;
      switch (bytesPerSequence) {
        case 1:
          if (firstByte < 128) {
            codePoint = firstByte;
          }
          break;
        case 2:
          secondByte = buf[i + 1];
          if ((secondByte & 192) === 128) {
            tempCodePoint = (firstByte & 31) << 6 | secondByte & 63;
            if (tempCodePoint > 127) {
              codePoint = tempCodePoint;
            }
          }
          break;
        case 3:
          secondByte = buf[i + 1];
          thirdByte = buf[i + 2];
          if ((secondByte & 192) === 128 && (thirdByte & 192) === 128) {
            tempCodePoint = (firstByte & 15) << 12 | (secondByte & 63) << 6 | thirdByte & 63;
            if (tempCodePoint > 2047 && (tempCodePoint < 55296 || tempCodePoint > 57343)) {
              codePoint = tempCodePoint;
            }
          }
          break;
        case 4:
          secondByte = buf[i + 1];
          thirdByte = buf[i + 2];
          fourthByte = buf[i + 3];
          if ((secondByte & 192) === 128 && (thirdByte & 192) === 128 && (fourthByte & 192) === 128) {
            tempCodePoint = (firstByte & 15) << 18 | (secondByte & 63) << 12 | (thirdByte & 63) << 6 | fourthByte & 63;
            if (tempCodePoint > 65535 && tempCodePoint < 1114112) {
              codePoint = tempCodePoint;
            }
          }
      }
    }
    if (codePoint === null) {
      codePoint = 65533;
      bytesPerSequence = 1;
    } else if (codePoint > 65535) {
      codePoint -= 65536;
      res.push(codePoint >>> 10 & 1023 | 55296);
      codePoint = 56320 | codePoint & 1023;
    }
    res.push(codePoint);
    i += bytesPerSequence;
  }
  return decodeCodePointsArray(res);
}
function decodeCodePointsArray(codePoints) {
  var len = codePoints.length;
  if (len <= MAX_ARGUMENTS_LENGTH) {
    return String.fromCharCode.apply(String, codePoints);
  }
  var res = "";
  var i = 0;
  while (i < len) {
    res += String.fromCharCode.apply(
      String,
      codePoints.slice(i, i += MAX_ARGUMENTS_LENGTH)
    );
  }
  return res;
}
function asciiSlice(buf, start, end) {
  var ret = "";
  end = Math.min(buf.length, end);
  for (var i = start; i < end; ++i) {
    ret += String.fromCharCode(buf[i] & 127);
  }
  return ret;
}
function latin1Slice(buf, start, end) {
  var ret = "";
  end = Math.min(buf.length, end);
  for (var i = start; i < end; ++i) {
    ret += String.fromCharCode(buf[i]);
  }
  return ret;
}
function hexSlice(buf, start, end) {
  var len = buf.length;
  if (!start || start < 0) start = 0;
  if (!end || end < 0 || end > len) end = len;
  var out = "";
  for (var i = start; i < end; ++i) {
    out += toHex(buf[i]);
  }
  return out;
}
function utf16leSlice(buf, start, end) {
  var bytes = buf.slice(start, end);
  var res = "";
  for (var i = 0; i < bytes.length; i += 2) {
    res += String.fromCharCode(bytes[i] + bytes[i + 1] * 256);
  }
  return res;
}
function checkOffset(offset, ext, length) {
  if (offset % 1 !== 0 || offset < 0)
    throw new RangeError("offset is not uint");
  if (offset + ext > length)
    throw new RangeError("Trying to access beyond buffer length");
}
function checkInt(buf, value, offset, ext, max, min) {
  if (!internalIsBuffer(buf))
    throw new TypeError('"buffer" argument must be a Buffer instance');
  if (value > max || value < min)
    throw new RangeError('"value" argument is out of bounds');
  if (offset + ext > buf.length) throw new RangeError("Index out of range");
}
function objectWriteUInt16(buf, value, offset, littleEndian) {
  if (value < 0) value = 65535 + value + 1;
  for (var i = 0, j = Math.min(buf.length - offset, 2); i < j; ++i) {
    buf[offset + i] = (value & 255 << 8 * (littleEndian ? i : 1 - i)) >>> (littleEndian ? i : 1 - i) * 8;
  }
}
function objectWriteUInt32(buf, value, offset, littleEndian) {
  if (value < 0) value = 4294967295 + value + 1;
  for (var i = 0, j = Math.min(buf.length - offset, 4); i < j; ++i) {
    buf[offset + i] = value >>> (littleEndian ? i : 3 - i) * 8 & 255;
  }
}
function checkIEEE754(buf, value, offset, ext, max, min) {
  if (offset + ext > buf.length) throw new RangeError("Index out of range");
  if (offset < 0) throw new RangeError("Index out of range");
}
function writeFloat(buf, value, offset, littleEndian, noAssert) {
  if (!noAssert) {
    checkIEEE754(
      buf,
      value,
      offset,
      4,
      34028234663852886e22,
      -34028234663852886e22
    );
  }
  ieee754write(buf, value, offset, littleEndian, 23, 4);
  return offset + 4;
}
function writeDouble(buf, value, offset, littleEndian, noAssert) {
  if (!noAssert) {
    checkIEEE754(
      buf,
      value,
      offset,
      8,
      17976931348623157e292,
      -17976931348623157e292
    );
  }
  ieee754write(buf, value, offset, littleEndian, 52, 8);
  return offset + 8;
}
function base64clean(str) {
  str = stringtrim(str).replace(INVALID_BASE64_RE, "");
  if (str.length < 2) return "";
  while (str.length % 4 !== 0) {
    str = str + "=";
  }
  return str;
}
function stringtrim(str) {
  if (str.trim) return str.trim();
  return str.replace(/^\s+|\s+$/g, "");
}
function toHex(n) {
  if (n < 16) return "0" + n.toString(16);
  return n.toString(16);
}
function utf8ToBytes(string, units) {
  units = units || Infinity;
  var codePoint;
  var length = string.length;
  var leadSurrogate = null;
  var bytes = [];
  for (var i = 0; i < length; ++i) {
    codePoint = string.charCodeAt(i);
    if (codePoint > 55295 && codePoint < 57344) {
      if (!leadSurrogate) {
        if (codePoint > 56319) {
          if ((units -= 3) > -1) bytes.push(239, 191, 189);
          continue;
        } else if (i + 1 === length) {
          if ((units -= 3) > -1) bytes.push(239, 191, 189);
          continue;
        }
        leadSurrogate = codePoint;
        continue;
      }
      if (codePoint < 56320) {
        if ((units -= 3) > -1) bytes.push(239, 191, 189);
        leadSurrogate = codePoint;
        continue;
      }
      codePoint = (leadSurrogate - 55296 << 10 | codePoint - 56320) + 65536;
    } else if (leadSurrogate) {
      if ((units -= 3) > -1) bytes.push(239, 191, 189);
    }
    leadSurrogate = null;
    if (codePoint < 128) {
      if ((units -= 1) < 0) break;
      bytes.push(codePoint);
    } else if (codePoint < 2048) {
      if ((units -= 2) < 0) break;
      bytes.push(codePoint >> 6 | 192, codePoint & 63 | 128);
    } else if (codePoint < 65536) {
      if ((units -= 3) < 0) break;
      bytes.push(
        codePoint >> 12 | 224,
        codePoint >> 6 & 63 | 128,
        codePoint & 63 | 128
      );
    } else if (codePoint < 1114112) {
      if ((units -= 4) < 0) break;
      bytes.push(
        codePoint >> 18 | 240,
        codePoint >> 12 & 63 | 128,
        codePoint >> 6 & 63 | 128,
        codePoint & 63 | 128
      );
    } else {
      throw new Error("Invalid code point");
    }
  }
  return bytes;
}
function asciiToBytes(str) {
  var byteArray = [];
  for (var i = 0; i < str.length; ++i) {
    byteArray.push(str.charCodeAt(i) & 255);
  }
  return byteArray;
}
function utf16leToBytes(str, units) {
  var c, hi, lo;
  var byteArray = [];
  for (var i = 0; i < str.length; ++i) {
    if ((units -= 2) < 0) break;
    c = str.charCodeAt(i);
    hi = c >> 8;
    lo = c % 256;
    byteArray.push(lo);
    byteArray.push(hi);
  }
  return byteArray;
}
function base64ToBytes(str) {
  return base64toByteArray(base64clean(str));
}
function blitBuffer(src, dst, offset, length) {
  for (var i = 0; i < length; ++i) {
    if (i + offset >= dst.length || i >= src.length) break;
    dst[i + offset] = src[i];
  }
  return i;
}
function isnan(val) {
  return val !== val;
}
function isBuffer(obj) {
  return obj != null && (!!obj._isBuffer || isFastBuffer(obj) || isSlowBuffer(obj));
}
function isFastBuffer(obj) {
  return !!obj.constructor && typeof obj.constructor.isBuffer === "function" && obj.constructor.isBuffer(obj);
}
function isSlowBuffer(obj) {
  return typeof obj.readFloatLE === "function" && typeof obj.slice === "function" && isFastBuffer(obj.slice(0, 0));
}
function ieee754read(buffer, offset, isLE, mLen, nBytes) {
  var e, m;
  var eLen = nBytes * 8 - mLen - 1;
  var eMax = (1 << eLen) - 1;
  var eBias = eMax >> 1;
  var nBits = -7;
  var i = isLE ? nBytes - 1 : 0;
  var d = isLE ? -1 : 1;
  var s = buffer[offset + i];
  i += d;
  e = s & (1 << -nBits) - 1;
  s >>= -nBits;
  nBits += eLen;
  for (; nBits > 0; e = e * 256 + buffer[offset + i], i += d, nBits -= 8) {
  }
  m = e & (1 << -nBits) - 1;
  e >>= -nBits;
  nBits += mLen;
  for (; nBits > 0; m = m * 256 + buffer[offset + i], i += d, nBits -= 8) {
  }
  if (e === 0) {
    e = 1 - eBias;
  } else if (e === eMax) {
    return m ? NaN : (s ? -1 : 1) * Infinity;
  } else {
    m = m + Math.pow(2, mLen);
    e = e - eBias;
  }
  return (s ? -1 : 1) * m * Math.pow(2, e - mLen);
}
function ieee754write(buffer, value, offset, isLE, mLen, nBytes) {
  var e, m, c;
  var eLen = nBytes * 8 - mLen - 1;
  var eMax = (1 << eLen) - 1;
  var eBias = eMax >> 1;
  var rt = mLen === 23 ? Math.pow(2, -24) - Math.pow(2, -77) : 0;
  var i = isLE ? 0 : nBytes - 1;
  var d = isLE ? 1 : -1;
  var s = value < 0 || value === 0 && 1 / value < 0 ? 1 : 0;
  value = Math.abs(value);
  if (isNaN(value) || value === Infinity) {
    m = isNaN(value) ? 1 : 0;
    e = eMax;
  } else {
    e = Math.floor(Math.log(value) / Math.LN2);
    if (value * (c = Math.pow(2, -e)) < 1) {
      e--;
      c *= 2;
    }
    if (e + eBias >= 1) {
      value += rt / c;
    } else {
      value += rt * Math.pow(2, 1 - eBias);
    }
    if (value * c >= 2) {
      e++;
      c /= 2;
    }
    if (e + eBias >= eMax) {
      m = 0;
      e = eMax;
    } else if (e + eBias >= 1) {
      m = (value * c - 1) * Math.pow(2, mLen);
      e = e + eBias;
    } else {
      m = value * Math.pow(2, eBias - 1) * Math.pow(2, mLen);
      e = 0;
    }
  }
  for (; mLen >= 8; buffer[offset + i] = m & 255, i += d, m /= 256, mLen -= 8) {
  }
  e = e << mLen | m;
  eLen += mLen;
  for (; eLen > 0; buffer[offset + i] = e & 255, i += d, e /= 256, eLen -= 8) {
  }
  buffer[offset + i - d] |= s * 128;
}
var lookup, revLookup, Arr, inited, MAX_ARGUMENTS_LENGTH, INVALID_BASE64_RE;
var init_Buffer = __esm({
  "../../../node_modules/.pnpm/@esbuild-plugins+node-globals-polyfill@0.2.3_esbuild@0.24.0/node_modules/@esbuild-plugins/node-globals-polyfill/Buffer.js"() {
    "use strict";
    init_process();
    init_buffer();
    lookup = [];
    revLookup = [];
    Arr = typeof Uint8Array !== "undefined" ? Uint8Array : Array;
    inited = false;
    Buffer2.TYPED_ARRAY_SUPPORT = globalThis.TYPED_ARRAY_SUPPORT !== void 0 ? globalThis.TYPED_ARRAY_SUPPORT : true;
    Buffer2.poolSize = 8192;
    Buffer2._augment = function(arr) {
      arr.__proto__ = Buffer2.prototype;
      return arr;
    };
    Buffer2.from = function(value, encodingOrOffset, length) {
      return from(null, value, encodingOrOffset, length);
    };
    Buffer2.kMaxLength = kMaxLength();
    if (Buffer2.TYPED_ARRAY_SUPPORT) {
      Buffer2.prototype.__proto__ = Uint8Array.prototype;
      Buffer2.__proto__ = Uint8Array;
      if (typeof Symbol !== "undefined" && Symbol.species && Buffer2[Symbol.species] === Buffer2) {
      }
    }
    Buffer2.alloc = function(size, fill2, encoding) {
      return alloc(null, size, fill2, encoding);
    };
    Buffer2.allocUnsafe = function(size) {
      return allocUnsafe(null, size);
    };
    Buffer2.allocUnsafeSlow = function(size) {
      return allocUnsafe(null, size);
    };
    Buffer2.isBuffer = isBuffer;
    Buffer2.compare = function compare(a, b) {
      if (!internalIsBuffer(a) || !internalIsBuffer(b)) {
        throw new TypeError("Arguments must be Buffers");
      }
      if (a === b) return 0;
      var x = a.length;
      var y = b.length;
      for (var i = 0, len = Math.min(x, y); i < len; ++i) {
        if (a[i] !== b[i]) {
          x = a[i];
          y = b[i];
          break;
        }
      }
      if (x < y) return -1;
      if (y < x) return 1;
      return 0;
    };
    Buffer2.isEncoding = function isEncoding(encoding) {
      switch (String(encoding).toLowerCase()) {
        case "hex":
        case "utf8":
        case "utf-8":
        case "ascii":
        case "latin1":
        case "binary":
        case "base64":
        case "ucs2":
        case "ucs-2":
        case "utf16le":
        case "utf-16le":
          return true;
        default:
          return false;
      }
    };
    Buffer2.concat = function concat(list, length) {
      if (!Array.isArray(list)) {
        throw new TypeError('"list" argument must be an Array of Buffers');
      }
      if (list.length === 0) {
        return Buffer2.alloc(0);
      }
      var i;
      if (length === void 0) {
        length = 0;
        for (i = 0; i < list.length; ++i) {
          length += list[i].length;
        }
      }
      var buffer = Buffer2.allocUnsafe(length);
      var pos = 0;
      for (i = 0; i < list.length; ++i) {
        var buf = list[i];
        if (!internalIsBuffer(buf)) {
          throw new TypeError('"list" argument must be an Array of Buffers');
        }
        buf.copy(buffer, pos);
        pos += buf.length;
      }
      return buffer;
    };
    Buffer2.byteLength = byteLength;
    Buffer2.prototype._isBuffer = true;
    Buffer2.prototype.swap16 = function swap16() {
      var len = this.length;
      if (len % 2 !== 0) {
        throw new RangeError("Buffer size must be a multiple of 16-bits");
      }
      for (var i = 0; i < len; i += 2) {
        swap(this, i, i + 1);
      }
      return this;
    };
    Buffer2.prototype.swap32 = function swap32() {
      var len = this.length;
      if (len % 4 !== 0) {
        throw new RangeError("Buffer size must be a multiple of 32-bits");
      }
      for (var i = 0; i < len; i += 4) {
        swap(this, i, i + 3);
        swap(this, i + 1, i + 2);
      }
      return this;
    };
    Buffer2.prototype.swap64 = function swap64() {
      var len = this.length;
      if (len % 8 !== 0) {
        throw new RangeError("Buffer size must be a multiple of 64-bits");
      }
      for (var i = 0; i < len; i += 8) {
        swap(this, i, i + 7);
        swap(this, i + 1, i + 6);
        swap(this, i + 2, i + 5);
        swap(this, i + 3, i + 4);
      }
      return this;
    };
    Buffer2.prototype.toString = function toString() {
      var length = this.length | 0;
      if (length === 0) return "";
      if (arguments.length === 0) return utf8Slice(this, 0, length);
      return slowToString.apply(this, arguments);
    };
    Buffer2.prototype.equals = function equals(b) {
      if (!internalIsBuffer(b)) throw new TypeError("Argument must be a Buffer");
      if (this === b) return true;
      return Buffer2.compare(this, b) === 0;
    };
    Buffer2.prototype.compare = function compare2(target, start, end, thisStart, thisEnd) {
      if (!internalIsBuffer(target)) {
        throw new TypeError("Argument must be a Buffer");
      }
      if (start === void 0) {
        start = 0;
      }
      if (end === void 0) {
        end = target ? target.length : 0;
      }
      if (thisStart === void 0) {
        thisStart = 0;
      }
      if (thisEnd === void 0) {
        thisEnd = this.length;
      }
      if (start < 0 || end > target.length || thisStart < 0 || thisEnd > this.length) {
        throw new RangeError("out of range index");
      }
      if (thisStart >= thisEnd && start >= end) {
        return 0;
      }
      if (thisStart >= thisEnd) {
        return -1;
      }
      if (start >= end) {
        return 1;
      }
      start >>>= 0;
      end >>>= 0;
      thisStart >>>= 0;
      thisEnd >>>= 0;
      if (this === target) return 0;
      var x = thisEnd - thisStart;
      var y = end - start;
      var len = Math.min(x, y);
      var thisCopy = this.slice(thisStart, thisEnd);
      var targetCopy = target.slice(start, end);
      for (var i = 0; i < len; ++i) {
        if (thisCopy[i] !== targetCopy[i]) {
          x = thisCopy[i];
          y = targetCopy[i];
          break;
        }
      }
      if (x < y) return -1;
      if (y < x) return 1;
      return 0;
    };
    Buffer2.prototype.includes = function includes(val, byteOffset, encoding) {
      return this.indexOf(val, byteOffset, encoding) !== -1;
    };
    Buffer2.prototype.indexOf = function indexOf(val, byteOffset, encoding) {
      return bidirectionalIndexOf(this, val, byteOffset, encoding, true);
    };
    Buffer2.prototype.lastIndexOf = function lastIndexOf(val, byteOffset, encoding) {
      return bidirectionalIndexOf(this, val, byteOffset, encoding, false);
    };
    Buffer2.prototype.write = function write(string, offset, length, encoding) {
      if (offset === void 0) {
        encoding = "utf8";
        length = this.length;
        offset = 0;
      } else if (length === void 0 && typeof offset === "string") {
        encoding = offset;
        length = this.length;
        offset = 0;
      } else if (isFinite(offset)) {
        offset = offset | 0;
        if (isFinite(length)) {
          length = length | 0;
          if (encoding === void 0) encoding = "utf8";
        } else {
          encoding = length;
          length = void 0;
        }
      } else {
        throw new Error(
          "Buffer.write(string, encoding, offset[, length]) is no longer supported"
        );
      }
      var remaining = this.length - offset;
      if (length === void 0 || length > remaining) length = remaining;
      if (string.length > 0 && (length < 0 || offset < 0) || offset > this.length) {
        throw new RangeError("Attempt to write outside buffer bounds");
      }
      if (!encoding) encoding = "utf8";
      var loweredCase = false;
      for (; ; ) {
        switch (encoding) {
          case "hex":
            return hexWrite(this, string, offset, length);
          case "utf8":
          case "utf-8":
            return utf8Write(this, string, offset, length);
          case "ascii":
            return asciiWrite(this, string, offset, length);
          case "latin1":
          case "binary":
            return latin1Write(this, string, offset, length);
          case "base64":
            return base64Write(this, string, offset, length);
          case "ucs2":
          case "ucs-2":
          case "utf16le":
          case "utf-16le":
            return ucs2Write(this, string, offset, length);
          default:
            if (loweredCase)
              throw new TypeError("Unknown encoding: " + encoding);
            encoding = ("" + encoding).toLowerCase();
            loweredCase = true;
        }
      }
    };
    Buffer2.prototype.toJSON = function toJSON() {
      return {
        type: "Buffer",
        data: Array.prototype.slice.call(this._arr || this, 0)
      };
    };
    MAX_ARGUMENTS_LENGTH = 4096;
    Buffer2.prototype.slice = function slice(start, end) {
      var len = this.length;
      start = ~~start;
      end = end === void 0 ? len : ~~end;
      if (start < 0) {
        start += len;
        if (start < 0) start = 0;
      } else if (start > len) {
        start = len;
      }
      if (end < 0) {
        end += len;
        if (end < 0) end = 0;
      } else if (end > len) {
        end = len;
      }
      if (end < start) end = start;
      var newBuf;
      if (Buffer2.TYPED_ARRAY_SUPPORT) {
        newBuf = this.subarray(start, end);
        newBuf.__proto__ = Buffer2.prototype;
      } else {
        var sliceLen = end - start;
        newBuf = new Buffer2(sliceLen, void 0);
        for (var i = 0; i < sliceLen; ++i) {
          newBuf[i] = this[i + start];
        }
      }
      return newBuf;
    };
    Buffer2.prototype.readUIntLE = function readUIntLE(offset, byteLength2, noAssert) {
      offset = offset | 0;
      byteLength2 = byteLength2 | 0;
      if (!noAssert) checkOffset(offset, byteLength2, this.length);
      var val = this[offset];
      var mul = 1;
      var i = 0;
      while (++i < byteLength2 && (mul *= 256)) {
        val += this[offset + i] * mul;
      }
      return val;
    };
    Buffer2.prototype.readUIntBE = function readUIntBE(offset, byteLength2, noAssert) {
      offset = offset | 0;
      byteLength2 = byteLength2 | 0;
      if (!noAssert) {
        checkOffset(offset, byteLength2, this.length);
      }
      var val = this[offset + --byteLength2];
      var mul = 1;
      while (byteLength2 > 0 && (mul *= 256)) {
        val += this[offset + --byteLength2] * mul;
      }
      return val;
    };
    Buffer2.prototype.readUInt8 = function readUInt8(offset, noAssert) {
      if (!noAssert) checkOffset(offset, 1, this.length);
      return this[offset];
    };
    Buffer2.prototype.readUInt16LE = function readUInt16LE(offset, noAssert) {
      if (!noAssert) checkOffset(offset, 2, this.length);
      return this[offset] | this[offset + 1] << 8;
    };
    Buffer2.prototype.readUInt16BE = function readUInt16BE(offset, noAssert) {
      if (!noAssert) checkOffset(offset, 2, this.length);
      return this[offset] << 8 | this[offset + 1];
    };
    Buffer2.prototype.readUInt32LE = function readUInt32LE(offset, noAssert) {
      if (!noAssert) checkOffset(offset, 4, this.length);
      return (this[offset] | this[offset + 1] << 8 | this[offset + 2] << 16) + this[offset + 3] * 16777216;
    };
    Buffer2.prototype.readUInt32BE = function readUInt32BE(offset, noAssert) {
      if (!noAssert) checkOffset(offset, 4, this.length);
      return this[offset] * 16777216 + (this[offset + 1] << 16 | this[offset + 2] << 8 | this[offset + 3]);
    };
    Buffer2.prototype.readIntLE = function readIntLE(offset, byteLength2, noAssert) {
      offset = offset | 0;
      byteLength2 = byteLength2 | 0;
      if (!noAssert) checkOffset(offset, byteLength2, this.length);
      var val = this[offset];
      var mul = 1;
      var i = 0;
      while (++i < byteLength2 && (mul *= 256)) {
        val += this[offset + i] * mul;
      }
      mul *= 128;
      if (val >= mul) val -= Math.pow(2, 8 * byteLength2);
      return val;
    };
    Buffer2.prototype.readIntBE = function readIntBE(offset, byteLength2, noAssert) {
      offset = offset | 0;
      byteLength2 = byteLength2 | 0;
      if (!noAssert) checkOffset(offset, byteLength2, this.length);
      var i = byteLength2;
      var mul = 1;
      var val = this[offset + --i];
      while (i > 0 && (mul *= 256)) {
        val += this[offset + --i] * mul;
      }
      mul *= 128;
      if (val >= mul) val -= Math.pow(2, 8 * byteLength2);
      return val;
    };
    Buffer2.prototype.readInt8 = function readInt8(offset, noAssert) {
      if (!noAssert) checkOffset(offset, 1, this.length);
      if (!(this[offset] & 128)) return this[offset];
      return (255 - this[offset] + 1) * -1;
    };
    Buffer2.prototype.readInt16LE = function readInt16LE(offset, noAssert) {
      if (!noAssert) checkOffset(offset, 2, this.length);
      var val = this[offset] | this[offset + 1] << 8;
      return val & 32768 ? val | 4294901760 : val;
    };
    Buffer2.prototype.readInt16BE = function readInt16BE(offset, noAssert) {
      if (!noAssert) checkOffset(offset, 2, this.length);
      var val = this[offset + 1] | this[offset] << 8;
      return val & 32768 ? val | 4294901760 : val;
    };
    Buffer2.prototype.readInt32LE = function readInt32LE(offset, noAssert) {
      if (!noAssert) checkOffset(offset, 4, this.length);
      return this[offset] | this[offset + 1] << 8 | this[offset + 2] << 16 | this[offset + 3] << 24;
    };
    Buffer2.prototype.readInt32BE = function readInt32BE(offset, noAssert) {
      if (!noAssert) checkOffset(offset, 4, this.length);
      return this[offset] << 24 | this[offset + 1] << 16 | this[offset + 2] << 8 | this[offset + 3];
    };
    Buffer2.prototype.readFloatLE = function readFloatLE(offset, noAssert) {
      if (!noAssert) checkOffset(offset, 4, this.length);
      return ieee754read(this, offset, true, 23, 4);
    };
    Buffer2.prototype.readFloatBE = function readFloatBE(offset, noAssert) {
      if (!noAssert) checkOffset(offset, 4, this.length);
      return ieee754read(this, offset, false, 23, 4);
    };
    Buffer2.prototype.readDoubleLE = function readDoubleLE(offset, noAssert) {
      if (!noAssert) checkOffset(offset, 8, this.length);
      return ieee754read(this, offset, true, 52, 8);
    };
    Buffer2.prototype.readDoubleBE = function readDoubleBE(offset, noAssert) {
      if (!noAssert) checkOffset(offset, 8, this.length);
      return ieee754read(this, offset, false, 52, 8);
    };
    Buffer2.prototype.writeUIntLE = function writeUIntLE(value, offset, byteLength2, noAssert) {
      value = +value;
      offset = offset | 0;
      byteLength2 = byteLength2 | 0;
      if (!noAssert) {
        var maxBytes = Math.pow(2, 8 * byteLength2) - 1;
        checkInt(this, value, offset, byteLength2, maxBytes, 0);
      }
      var mul = 1;
      var i = 0;
      this[offset] = value & 255;
      while (++i < byteLength2 && (mul *= 256)) {
        this[offset + i] = value / mul & 255;
      }
      return offset + byteLength2;
    };
    Buffer2.prototype.writeUIntBE = function writeUIntBE(value, offset, byteLength2, noAssert) {
      value = +value;
      offset = offset | 0;
      byteLength2 = byteLength2 | 0;
      if (!noAssert) {
        var maxBytes = Math.pow(2, 8 * byteLength2) - 1;
        checkInt(this, value, offset, byteLength2, maxBytes, 0);
      }
      var i = byteLength2 - 1;
      var mul = 1;
      this[offset + i] = value & 255;
      while (--i >= 0 && (mul *= 256)) {
        this[offset + i] = value / mul & 255;
      }
      return offset + byteLength2;
    };
    Buffer2.prototype.writeUInt8 = function writeUInt8(value, offset, noAssert) {
      value = +value;
      offset = offset | 0;
      if (!noAssert) checkInt(this, value, offset, 1, 255, 0);
      if (!Buffer2.TYPED_ARRAY_SUPPORT) value = Math.floor(value);
      this[offset] = value & 255;
      return offset + 1;
    };
    Buffer2.prototype.writeUInt16LE = function writeUInt16LE(value, offset, noAssert) {
      value = +value;
      offset = offset | 0;
      if (!noAssert) checkInt(this, value, offset, 2, 65535, 0);
      if (Buffer2.TYPED_ARRAY_SUPPORT) {
        this[offset] = value & 255;
        this[offset + 1] = value >>> 8;
      } else {
        objectWriteUInt16(this, value, offset, true);
      }
      return offset + 2;
    };
    Buffer2.prototype.writeUInt16BE = function writeUInt16BE(value, offset, noAssert) {
      value = +value;
      offset = offset | 0;
      if (!noAssert) checkInt(this, value, offset, 2, 65535, 0);
      if (Buffer2.TYPED_ARRAY_SUPPORT) {
        this[offset] = value >>> 8;
        this[offset + 1] = value & 255;
      } else {
        objectWriteUInt16(this, value, offset, false);
      }
      return offset + 2;
    };
    Buffer2.prototype.writeUInt32LE = function writeUInt32LE(value, offset, noAssert) {
      value = +value;
      offset = offset | 0;
      if (!noAssert) checkInt(this, value, offset, 4, 4294967295, 0);
      if (Buffer2.TYPED_ARRAY_SUPPORT) {
        this[offset + 3] = value >>> 24;
        this[offset + 2] = value >>> 16;
        this[offset + 1] = value >>> 8;
        this[offset] = value & 255;
      } else {
        objectWriteUInt32(this, value, offset, true);
      }
      return offset + 4;
    };
    Buffer2.prototype.writeUInt32BE = function writeUInt32BE(value, offset, noAssert) {
      value = +value;
      offset = offset | 0;
      if (!noAssert) checkInt(this, value, offset, 4, 4294967295, 0);
      if (Buffer2.TYPED_ARRAY_SUPPORT) {
        this[offset] = value >>> 24;
        this[offset + 1] = value >>> 16;
        this[offset + 2] = value >>> 8;
        this[offset + 3] = value & 255;
      } else {
        objectWriteUInt32(this, value, offset, false);
      }
      return offset + 4;
    };
    Buffer2.prototype.writeIntLE = function writeIntLE(value, offset, byteLength2, noAssert) {
      value = +value;
      offset = offset | 0;
      if (!noAssert) {
        var limit = Math.pow(2, 8 * byteLength2 - 1);
        checkInt(this, value, offset, byteLength2, limit - 1, -limit);
      }
      var i = 0;
      var mul = 1;
      var sub = 0;
      this[offset] = value & 255;
      while (++i < byteLength2 && (mul *= 256)) {
        if (value < 0 && sub === 0 && this[offset + i - 1] !== 0) {
          sub = 1;
        }
        this[offset + i] = (value / mul >> 0) - sub & 255;
      }
      return offset + byteLength2;
    };
    Buffer2.prototype.writeIntBE = function writeIntBE(value, offset, byteLength2, noAssert) {
      value = +value;
      offset = offset | 0;
      if (!noAssert) {
        var limit = Math.pow(2, 8 * byteLength2 - 1);
        checkInt(this, value, offset, byteLength2, limit - 1, -limit);
      }
      var i = byteLength2 - 1;
      var mul = 1;
      var sub = 0;
      this[offset + i] = value & 255;
      while (--i >= 0 && (mul *= 256)) {
        if (value < 0 && sub === 0 && this[offset + i + 1] !== 0) {
          sub = 1;
        }
        this[offset + i] = (value / mul >> 0) - sub & 255;
      }
      return offset + byteLength2;
    };
    Buffer2.prototype.writeInt8 = function writeInt8(value, offset, noAssert) {
      value = +value;
      offset = offset | 0;
      if (!noAssert) checkInt(this, value, offset, 1, 127, -128);
      if (!Buffer2.TYPED_ARRAY_SUPPORT) value = Math.floor(value);
      if (value < 0) value = 255 + value + 1;
      this[offset] = value & 255;
      return offset + 1;
    };
    Buffer2.prototype.writeInt16LE = function writeInt16LE(value, offset, noAssert) {
      value = +value;
      offset = offset | 0;
      if (!noAssert) checkInt(this, value, offset, 2, 32767, -32768);
      if (Buffer2.TYPED_ARRAY_SUPPORT) {
        this[offset] = value & 255;
        this[offset + 1] = value >>> 8;
      } else {
        objectWriteUInt16(this, value, offset, true);
      }
      return offset + 2;
    };
    Buffer2.prototype.writeInt16BE = function writeInt16BE(value, offset, noAssert) {
      value = +value;
      offset = offset | 0;
      if (!noAssert) checkInt(this, value, offset, 2, 32767, -32768);
      if (Buffer2.TYPED_ARRAY_SUPPORT) {
        this[offset] = value >>> 8;
        this[offset + 1] = value & 255;
      } else {
        objectWriteUInt16(this, value, offset, false);
      }
      return offset + 2;
    };
    Buffer2.prototype.writeInt32LE = function writeInt32LE(value, offset, noAssert) {
      value = +value;
      offset = offset | 0;
      if (!noAssert) checkInt(this, value, offset, 4, 2147483647, -2147483648);
      if (Buffer2.TYPED_ARRAY_SUPPORT) {
        this[offset] = value & 255;
        this[offset + 1] = value >>> 8;
        this[offset + 2] = value >>> 16;
        this[offset + 3] = value >>> 24;
      } else {
        objectWriteUInt32(this, value, offset, true);
      }
      return offset + 4;
    };
    Buffer2.prototype.writeInt32BE = function writeInt32BE(value, offset, noAssert) {
      value = +value;
      offset = offset | 0;
      if (!noAssert) checkInt(this, value, offset, 4, 2147483647, -2147483648);
      if (value < 0) value = 4294967295 + value + 1;
      if (Buffer2.TYPED_ARRAY_SUPPORT) {
        this[offset] = value >>> 24;
        this[offset + 1] = value >>> 16;
        this[offset + 2] = value >>> 8;
        this[offset + 3] = value & 255;
      } else {
        objectWriteUInt32(this, value, offset, false);
      }
      return offset + 4;
    };
    Buffer2.prototype.writeFloatLE = function writeFloatLE(value, offset, noAssert) {
      return writeFloat(this, value, offset, true, noAssert);
    };
    Buffer2.prototype.writeFloatBE = function writeFloatBE(value, offset, noAssert) {
      return writeFloat(this, value, offset, false, noAssert);
    };
    Buffer2.prototype.writeDoubleLE = function writeDoubleLE(value, offset, noAssert) {
      return writeDouble(this, value, offset, true, noAssert);
    };
    Buffer2.prototype.writeDoubleBE = function writeDoubleBE(value, offset, noAssert) {
      return writeDouble(this, value, offset, false, noAssert);
    };
    Buffer2.prototype.copy = function copy(target, targetStart, start, end) {
      if (!start) start = 0;
      if (!end && end !== 0) end = this.length;
      if (targetStart >= target.length) targetStart = target.length;
      if (!targetStart) targetStart = 0;
      if (end > 0 && end < start) end = start;
      if (end === start) return 0;
      if (target.length === 0 || this.length === 0) return 0;
      if (targetStart < 0) {
        throw new RangeError("targetStart out of bounds");
      }
      if (start < 0 || start >= this.length)
        throw new RangeError("sourceStart out of bounds");
      if (end < 0) throw new RangeError("sourceEnd out of bounds");
      if (end > this.length) end = this.length;
      if (target.length - targetStart < end - start) {
        end = target.length - targetStart + start;
      }
      var len = end - start;
      var i;
      if (this === target && start < targetStart && targetStart < end) {
        for (i = len - 1; i >= 0; --i) {
          target[i + targetStart] = this[i + start];
        }
      } else if (len < 1e3 || !Buffer2.TYPED_ARRAY_SUPPORT) {
        for (i = 0; i < len; ++i) {
          target[i + targetStart] = this[i + start];
        }
      } else {
        Uint8Array.prototype.set.call(
          target,
          this.subarray(start, start + len),
          targetStart
        );
      }
      return len;
    };
    Buffer2.prototype.fill = function fill(val, start, end, encoding) {
      if (typeof val === "string") {
        if (typeof start === "string") {
          encoding = start;
          start = 0;
          end = this.length;
        } else if (typeof end === "string") {
          encoding = end;
          end = this.length;
        }
        if (val.length === 1) {
          var code = val.charCodeAt(0);
          if (code < 256) {
            val = code;
          }
        }
        if (encoding !== void 0 && typeof encoding !== "string") {
          throw new TypeError("encoding must be a string");
        }
        if (typeof encoding === "string" && !Buffer2.isEncoding(encoding)) {
          throw new TypeError("Unknown encoding: " + encoding);
        }
      } else if (typeof val === "number") {
        val = val & 255;
      }
      if (start < 0 || this.length < start || this.length < end) {
        throw new RangeError("Out of range index");
      }
      if (end <= start) {
        return this;
      }
      start = start >>> 0;
      end = end === void 0 ? this.length : end >>> 0;
      if (!val) val = 0;
      var i;
      if (typeof val === "number") {
        for (i = start; i < end; ++i) {
          this[i] = val;
        }
      } else {
        var bytes = internalIsBuffer(val) ? val : utf8ToBytes(new Buffer2(val, encoding).toString());
        var len = bytes.length;
        for (i = 0; i < end - start; ++i) {
          this[i + start] = bytes[i % len];
        }
      }
      return this;
    };
    INVALID_BASE64_RE = /[^+\/0-9A-Za-z-_]/g;
  }
});

// ../../../node_modules/.pnpm/@esbuild-plugins+node-globals-polyfill@0.2.3_esbuild@0.24.0/node_modules/@esbuild-plugins/node-globals-polyfill/_buffer.js
var init_buffer = __esm({
  "../../../node_modules/.pnpm/@esbuild-plugins+node-globals-polyfill@0.2.3_esbuild@0.24.0/node_modules/@esbuild-plugins/node-globals-polyfill/_buffer.js"() {
    "use strict";
    init_Buffer();
  }
});

// ../../../node_modules/.pnpm/function-bind@1.1.2/node_modules/function-bind/implementation.js
var require_implementation = __commonJS({
  "../../../node_modules/.pnpm/function-bind@1.1.2/node_modules/function-bind/implementation.js"(exports2, module2) {
    "use strict";
    init_process();
    init_buffer();
    var ERROR_MESSAGE = "Function.prototype.bind called on incompatible ";
    var toStr = Object.prototype.toString;
    var max = Math.max;
    var funcType = "[object Function]";
    var concatty = function concatty2(a, b) {
      var arr = [];
      for (var i = 0; i < a.length; i += 1) {
        arr[i] = a[i];
      }
      for (var j = 0; j < b.length; j += 1) {
        arr[j + a.length] = b[j];
      }
      return arr;
    };
    var slicy = function slicy2(arrLike, offset) {
      var arr = [];
      for (var i = offset || 0, j = 0; i < arrLike.length; i += 1, j += 1) {
        arr[j] = arrLike[i];
      }
      return arr;
    };
    var joiny = function(arr, joiner) {
      var str = "";
      for (var i = 0; i < arr.length; i += 1) {
        str += arr[i];
        if (i + 1 < arr.length) {
          str += joiner;
        }
      }
      return str;
    };
    module2.exports = function bind(that) {
      var target = this;
      if (typeof target !== "function" || toStr.apply(target) !== funcType) {
        throw new TypeError(ERROR_MESSAGE + target);
      }
      var args = slicy(arguments, 1);
      var bound;
      var binder = function() {
        if (this instanceof bound) {
          var result = target.apply(
            this,
            concatty(args, arguments)
          );
          if (Object(result) === result) {
            return result;
          }
          return this;
        }
        return target.apply(
          that,
          concatty(args, arguments)
        );
      };
      var boundLength = max(0, target.length - args.length);
      var boundArgs = [];
      for (var i = 0; i < boundLength; i++) {
        boundArgs[i] = "$" + i;
      }
      bound = Function("binder", "return function (" + joiny(boundArgs, ",") + "){ return binder.apply(this,arguments); }")(binder);
      if (target.prototype) {
        var Empty = function Empty2() {
        };
        Empty.prototype = target.prototype;
        bound.prototype = new Empty();
        Empty.prototype = null;
      }
      return bound;
    };
  }
});

// ../../../node_modules/.pnpm/function-bind@1.1.2/node_modules/function-bind/index.js
var require_function_bind = __commonJS({
  "../../../node_modules/.pnpm/function-bind@1.1.2/node_modules/function-bind/index.js"(exports2, module2) {
    "use strict";
    init_process();
    init_buffer();
    var implementation = require_implementation();
    module2.exports = Function.prototype.bind || implementation;
  }
});

// ../../../node_modules/.pnpm/es-errors@1.3.0/node_modules/es-errors/index.js
var require_es_errors = __commonJS({
  "../../../node_modules/.pnpm/es-errors@1.3.0/node_modules/es-errors/index.js"(exports2, module2) {
    "use strict";
    init_process();
    init_buffer();
    module2.exports = Error;
  }
});

// ../../../node_modules/.pnpm/es-errors@1.3.0/node_modules/es-errors/eval.js
var require_eval = __commonJS({
  "../../../node_modules/.pnpm/es-errors@1.3.0/node_modules/es-errors/eval.js"(exports2, module2) {
    "use strict";
    init_process();
    init_buffer();
    module2.exports = EvalError;
  }
});

// ../../../node_modules/.pnpm/es-errors@1.3.0/node_modules/es-errors/range.js
var require_range = __commonJS({
  "../../../node_modules/.pnpm/es-errors@1.3.0/node_modules/es-errors/range.js"(exports2, module2) {
    "use strict";
    init_process();
    init_buffer();
    module2.exports = RangeError;
  }
});

// ../../../node_modules/.pnpm/es-errors@1.3.0/node_modules/es-errors/ref.js
var require_ref = __commonJS({
  "../../../node_modules/.pnpm/es-errors@1.3.0/node_modules/es-errors/ref.js"(exports2, module2) {
    "use strict";
    init_process();
    init_buffer();
    module2.exports = ReferenceError;
  }
});

// ../../../node_modules/.pnpm/es-errors@1.3.0/node_modules/es-errors/syntax.js
var require_syntax = __commonJS({
  "../../../node_modules/.pnpm/es-errors@1.3.0/node_modules/es-errors/syntax.js"(exports2, module2) {
    "use strict";
    init_process();
    init_buffer();
    module2.exports = SyntaxError;
  }
});

// ../../../node_modules/.pnpm/es-errors@1.3.0/node_modules/es-errors/type.js
var require_type = __commonJS({
  "../../../node_modules/.pnpm/es-errors@1.3.0/node_modules/es-errors/type.js"(exports2, module2) {
    "use strict";
    init_process();
    init_buffer();
    module2.exports = TypeError;
  }
});

// ../../../node_modules/.pnpm/es-errors@1.3.0/node_modules/es-errors/uri.js
var require_uri = __commonJS({
  "../../../node_modules/.pnpm/es-errors@1.3.0/node_modules/es-errors/uri.js"(exports2, module2) {
    "use strict";
    init_process();
    init_buffer();
    module2.exports = URIError;
  }
});

// ../../../node_modules/.pnpm/has-symbols@1.0.3/node_modules/has-symbols/shams.js
var require_shams = __commonJS({
  "../../../node_modules/.pnpm/has-symbols@1.0.3/node_modules/has-symbols/shams.js"(exports2, module2) {
    "use strict";
    init_process();
    init_buffer();
    module2.exports = function hasSymbols() {
      if (typeof Symbol !== "function" || typeof Object.getOwnPropertySymbols !== "function") {
        return false;
      }
      if (typeof Symbol.iterator === "symbol") {
        return true;
      }
      var obj = {};
      var sym = Symbol("test");
      var symObj = Object(sym);
      if (typeof sym === "string") {
        return false;
      }
      if (Object.prototype.toString.call(sym) !== "[object Symbol]") {
        return false;
      }
      if (Object.prototype.toString.call(symObj) !== "[object Symbol]") {
        return false;
      }
      var symVal = 42;
      obj[sym] = symVal;
      for (sym in obj) {
        return false;
      }
      if (typeof Object.keys === "function" && Object.keys(obj).length !== 0) {
        return false;
      }
      if (typeof Object.getOwnPropertyNames === "function" && Object.getOwnPropertyNames(obj).length !== 0) {
        return false;
      }
      var syms = Object.getOwnPropertySymbols(obj);
      if (syms.length !== 1 || syms[0] !== sym) {
        return false;
      }
      if (!Object.prototype.propertyIsEnumerable.call(obj, sym)) {
        return false;
      }
      if (typeof Object.getOwnPropertyDescriptor === "function") {
        var descriptor = Object.getOwnPropertyDescriptor(obj, sym);
        if (descriptor.value !== symVal || descriptor.enumerable !== true) {
          return false;
        }
      }
      return true;
    };
  }
});

// ../../../node_modules/.pnpm/has-symbols@1.0.3/node_modules/has-symbols/index.js
var require_has_symbols = __commonJS({
  "../../../node_modules/.pnpm/has-symbols@1.0.3/node_modules/has-symbols/index.js"(exports2, module2) {
    "use strict";
    init_process();
    init_buffer();
    var origSymbol = typeof Symbol !== "undefined" && Symbol;
    var hasSymbolSham = require_shams();
    module2.exports = function hasNativeSymbols() {
      if (typeof origSymbol !== "function") {
        return false;
      }
      if (typeof Symbol !== "function") {
        return false;
      }
      if (typeof origSymbol("foo") !== "symbol") {
        return false;
      }
      if (typeof Symbol("bar") !== "symbol") {
        return false;
      }
      return hasSymbolSham();
    };
  }
});

// ../../../node_modules/.pnpm/has-proto@1.0.3/node_modules/has-proto/index.js
var require_has_proto = __commonJS({
  "../../../node_modules/.pnpm/has-proto@1.0.3/node_modules/has-proto/index.js"(exports2, module2) {
    "use strict";
    init_process();
    init_buffer();
    var test = {
      __proto__: null,
      foo: {}
    };
    var $Object = Object;
    module2.exports = function hasProto() {
      return { __proto__: test }.foo === test.foo && !(test instanceof $Object);
    };
  }
});

// ../../../node_modules/.pnpm/hasown@2.0.2/node_modules/hasown/index.js
var require_hasown = __commonJS({
  "../../../node_modules/.pnpm/hasown@2.0.2/node_modules/hasown/index.js"(exports2, module2) {
    "use strict";
    init_process();
    init_buffer();
    var call = Function.prototype.call;
    var $hasOwn = Object.prototype.hasOwnProperty;
    var bind = require_function_bind();
    module2.exports = bind.call(call, $hasOwn);
  }
});

// ../../../node_modules/.pnpm/get-intrinsic@1.2.4/node_modules/get-intrinsic/index.js
var require_get_intrinsic = __commonJS({
  "../../../node_modules/.pnpm/get-intrinsic@1.2.4/node_modules/get-intrinsic/index.js"(exports2, module2) {
    "use strict";
    init_process();
    init_buffer();
    var undefined2;
    var $Error = require_es_errors();
    var $EvalError = require_eval();
    var $RangeError = require_range();
    var $ReferenceError = require_ref();
    var $SyntaxError = require_syntax();
    var $TypeError = require_type();
    var $URIError = require_uri();
    var $Function = Function;
    var getEvalledConstructor = function(expressionSyntax) {
      try {
        return $Function('"use strict"; return (' + expressionSyntax + ").constructor;")();
      } catch (e) {
      }
    };
    var $gOPD = Object.getOwnPropertyDescriptor;
    if ($gOPD) {
      try {
        $gOPD({}, "");
      } catch (e) {
        $gOPD = null;
      }
    }
    var throwTypeError = function() {
      throw new $TypeError();
    };
    var ThrowTypeError = $gOPD ? function() {
      try {
        arguments.callee;
        return throwTypeError;
      } catch (calleeThrows) {
        try {
          return $gOPD(arguments, "callee").get;
        } catch (gOPDthrows) {
          return throwTypeError;
        }
      }
    }() : throwTypeError;
    var hasSymbols = require_has_symbols()();
    var hasProto = require_has_proto()();
    var getProto = Object.getPrototypeOf || (hasProto ? function(x) {
      return x.__proto__;
    } : null);
    var needsEval = {};
    var TypedArray = typeof Uint8Array === "undefined" || !getProto ? undefined2 : getProto(Uint8Array);
    var INTRINSICS = {
      __proto__: null,
      "%AggregateError%": typeof AggregateError === "undefined" ? undefined2 : AggregateError,
      "%Array%": Array,
      "%ArrayBuffer%": typeof ArrayBuffer === "undefined" ? undefined2 : ArrayBuffer,
      "%ArrayIteratorPrototype%": hasSymbols && getProto ? getProto([][Symbol.iterator]()) : undefined2,
      "%AsyncFromSyncIteratorPrototype%": undefined2,
      "%AsyncFunction%": needsEval,
      "%AsyncGenerator%": needsEval,
      "%AsyncGeneratorFunction%": needsEval,
      "%AsyncIteratorPrototype%": needsEval,
      "%Atomics%": typeof Atomics === "undefined" ? undefined2 : Atomics,
      "%BigInt%": typeof BigInt === "undefined" ? undefined2 : BigInt,
      "%BigInt64Array%": typeof BigInt64Array === "undefined" ? undefined2 : BigInt64Array,
      "%BigUint64Array%": typeof BigUint64Array === "undefined" ? undefined2 : BigUint64Array,
      "%Boolean%": Boolean,
      "%DataView%": typeof DataView === "undefined" ? undefined2 : DataView,
      "%Date%": Date,
      "%decodeURI%": decodeURI,
      "%decodeURIComponent%": decodeURIComponent,
      "%encodeURI%": encodeURI,
      "%encodeURIComponent%": encodeURIComponent,
      "%Error%": $Error,
      "%eval%": eval,
      // eslint-disable-line no-eval
      "%EvalError%": $EvalError,
      "%Float32Array%": typeof Float32Array === "undefined" ? undefined2 : Float32Array,
      "%Float64Array%": typeof Float64Array === "undefined" ? undefined2 : Float64Array,
      "%FinalizationRegistry%": typeof FinalizationRegistry === "undefined" ? undefined2 : FinalizationRegistry,
      "%Function%": $Function,
      "%GeneratorFunction%": needsEval,
      "%Int8Array%": typeof Int8Array === "undefined" ? undefined2 : Int8Array,
      "%Int16Array%": typeof Int16Array === "undefined" ? undefined2 : Int16Array,
      "%Int32Array%": typeof Int32Array === "undefined" ? undefined2 : Int32Array,
      "%isFinite%": isFinite,
      "%isNaN%": isNaN,
      "%IteratorPrototype%": hasSymbols && getProto ? getProto(getProto([][Symbol.iterator]())) : undefined2,
      "%JSON%": typeof JSON === "object" ? JSON : undefined2,
      "%Map%": typeof Map === "undefined" ? undefined2 : Map,
      "%MapIteratorPrototype%": typeof Map === "undefined" || !hasSymbols || !getProto ? undefined2 : getProto((/* @__PURE__ */ new Map())[Symbol.iterator]()),
      "%Math%": Math,
      "%Number%": Number,
      "%Object%": Object,
      "%parseFloat%": parseFloat,
      "%parseInt%": parseInt,
      "%Promise%": typeof Promise === "undefined" ? undefined2 : Promise,
      "%Proxy%": typeof Proxy === "undefined" ? undefined2 : Proxy,
      "%RangeError%": $RangeError,
      "%ReferenceError%": $ReferenceError,
      "%Reflect%": typeof Reflect === "undefined" ? undefined2 : Reflect,
      "%RegExp%": RegExp,
      "%Set%": typeof Set === "undefined" ? undefined2 : Set,
      "%SetIteratorPrototype%": typeof Set === "undefined" || !hasSymbols || !getProto ? undefined2 : getProto((/* @__PURE__ */ new Set())[Symbol.iterator]()),
      "%SharedArrayBuffer%": typeof SharedArrayBuffer === "undefined" ? undefined2 : SharedArrayBuffer,
      "%String%": String,
      "%StringIteratorPrototype%": hasSymbols && getProto ? getProto(""[Symbol.iterator]()) : undefined2,
      "%Symbol%": hasSymbols ? Symbol : undefined2,
      "%SyntaxError%": $SyntaxError,
      "%ThrowTypeError%": ThrowTypeError,
      "%TypedArray%": TypedArray,
      "%TypeError%": $TypeError,
      "%Uint8Array%": typeof Uint8Array === "undefined" ? undefined2 : Uint8Array,
      "%Uint8ClampedArray%": typeof Uint8ClampedArray === "undefined" ? undefined2 : Uint8ClampedArray,
      "%Uint16Array%": typeof Uint16Array === "undefined" ? undefined2 : Uint16Array,
      "%Uint32Array%": typeof Uint32Array === "undefined" ? undefined2 : Uint32Array,
      "%URIError%": $URIError,
      "%WeakMap%": typeof WeakMap === "undefined" ? undefined2 : WeakMap,
      "%WeakRef%": typeof WeakRef === "undefined" ? undefined2 : WeakRef,
      "%WeakSet%": typeof WeakSet === "undefined" ? undefined2 : WeakSet
    };
    if (getProto) {
      try {
        null.error;
      } catch (e) {
        errorProto = getProto(getProto(e));
        INTRINSICS["%Error.prototype%"] = errorProto;
      }
    }
    var errorProto;
    var doEval = function doEval2(name) {
      var value;
      if (name === "%AsyncFunction%") {
        value = getEvalledConstructor("async function () {}");
      } else if (name === "%GeneratorFunction%") {
        value = getEvalledConstructor("function* () {}");
      } else if (name === "%AsyncGeneratorFunction%") {
        value = getEvalledConstructor("async function* () {}");
      } else if (name === "%AsyncGenerator%") {
        var fn = doEval2("%AsyncGeneratorFunction%");
        if (fn) {
          value = fn.prototype;
        }
      } else if (name === "%AsyncIteratorPrototype%") {
        var gen = doEval2("%AsyncGenerator%");
        if (gen && getProto) {
          value = getProto(gen.prototype);
        }
      }
      INTRINSICS[name] = value;
      return value;
    };
    var LEGACY_ALIASES = {
      __proto__: null,
      "%ArrayBufferPrototype%": ["ArrayBuffer", "prototype"],
      "%ArrayPrototype%": ["Array", "prototype"],
      "%ArrayProto_entries%": ["Array", "prototype", "entries"],
      "%ArrayProto_forEach%": ["Array", "prototype", "forEach"],
      "%ArrayProto_keys%": ["Array", "prototype", "keys"],
      "%ArrayProto_values%": ["Array", "prototype", "values"],
      "%AsyncFunctionPrototype%": ["AsyncFunction", "prototype"],
      "%AsyncGenerator%": ["AsyncGeneratorFunction", "prototype"],
      "%AsyncGeneratorPrototype%": ["AsyncGeneratorFunction", "prototype", "prototype"],
      "%BooleanPrototype%": ["Boolean", "prototype"],
      "%DataViewPrototype%": ["DataView", "prototype"],
      "%DatePrototype%": ["Date", "prototype"],
      "%ErrorPrototype%": ["Error", "prototype"],
      "%EvalErrorPrototype%": ["EvalError", "prototype"],
      "%Float32ArrayPrototype%": ["Float32Array", "prototype"],
      "%Float64ArrayPrototype%": ["Float64Array", "prototype"],
      "%FunctionPrototype%": ["Function", "prototype"],
      "%Generator%": ["GeneratorFunction", "prototype"],
      "%GeneratorPrototype%": ["GeneratorFunction", "prototype", "prototype"],
      "%Int8ArrayPrototype%": ["Int8Array", "prototype"],
      "%Int16ArrayPrototype%": ["Int16Array", "prototype"],
      "%Int32ArrayPrototype%": ["Int32Array", "prototype"],
      "%JSONParse%": ["JSON", "parse"],
      "%JSONStringify%": ["JSON", "stringify"],
      "%MapPrototype%": ["Map", "prototype"],
      "%NumberPrototype%": ["Number", "prototype"],
      "%ObjectPrototype%": ["Object", "prototype"],
      "%ObjProto_toString%": ["Object", "prototype", "toString"],
      "%ObjProto_valueOf%": ["Object", "prototype", "valueOf"],
      "%PromisePrototype%": ["Promise", "prototype"],
      "%PromiseProto_then%": ["Promise", "prototype", "then"],
      "%Promise_all%": ["Promise", "all"],
      "%Promise_reject%": ["Promise", "reject"],
      "%Promise_resolve%": ["Promise", "resolve"],
      "%RangeErrorPrototype%": ["RangeError", "prototype"],
      "%ReferenceErrorPrototype%": ["ReferenceError", "prototype"],
      "%RegExpPrototype%": ["RegExp", "prototype"],
      "%SetPrototype%": ["Set", "prototype"],
      "%SharedArrayBufferPrototype%": ["SharedArrayBuffer", "prototype"],
      "%StringPrototype%": ["String", "prototype"],
      "%SymbolPrototype%": ["Symbol", "prototype"],
      "%SyntaxErrorPrototype%": ["SyntaxError", "prototype"],
      "%TypedArrayPrototype%": ["TypedArray", "prototype"],
      "%TypeErrorPrototype%": ["TypeError", "prototype"],
      "%Uint8ArrayPrototype%": ["Uint8Array", "prototype"],
      "%Uint8ClampedArrayPrototype%": ["Uint8ClampedArray", "prototype"],
      "%Uint16ArrayPrototype%": ["Uint16Array", "prototype"],
      "%Uint32ArrayPrototype%": ["Uint32Array", "prototype"],
      "%URIErrorPrototype%": ["URIError", "prototype"],
      "%WeakMapPrototype%": ["WeakMap", "prototype"],
      "%WeakSetPrototype%": ["WeakSet", "prototype"]
    };
    var bind = require_function_bind();
    var hasOwn = require_hasown();
    var $concat = bind.call(Function.call, Array.prototype.concat);
    var $spliceApply = bind.call(Function.apply, Array.prototype.splice);
    var $replace = bind.call(Function.call, String.prototype.replace);
    var $strSlice = bind.call(Function.call, String.prototype.slice);
    var $exec = bind.call(Function.call, RegExp.prototype.exec);
    var rePropName = /[^%.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|%$))/g;
    var reEscapeChar = /\\(\\)?/g;
    var stringToPath = function stringToPath2(string) {
      var first = $strSlice(string, 0, 1);
      var last = $strSlice(string, -1);
      if (first === "%" && last !== "%") {
        throw new $SyntaxError("invalid intrinsic syntax, expected closing `%`");
      } else if (last === "%" && first !== "%") {
        throw new $SyntaxError("invalid intrinsic syntax, expected opening `%`");
      }
      var result = [];
      $replace(string, rePropName, function(match, number, quote, subString) {
        result[result.length] = quote ? $replace(subString, reEscapeChar, "$1") : number || match;
      });
      return result;
    };
    var getBaseIntrinsic = function getBaseIntrinsic2(name, allowMissing) {
      var intrinsicName = name;
      var alias;
      if (hasOwn(LEGACY_ALIASES, intrinsicName)) {
        alias = LEGACY_ALIASES[intrinsicName];
        intrinsicName = "%" + alias[0] + "%";
      }
      if (hasOwn(INTRINSICS, intrinsicName)) {
        var value = INTRINSICS[intrinsicName];
        if (value === needsEval) {
          value = doEval(intrinsicName);
        }
        if (typeof value === "undefined" && !allowMissing) {
          throw new $TypeError("intrinsic " + name + " exists, but is not available. Please file an issue!");
        }
        return {
          alias,
          name: intrinsicName,
          value
        };
      }
      throw new $SyntaxError("intrinsic " + name + " does not exist!");
    };
    module2.exports = function GetIntrinsic(name, allowMissing) {
      if (typeof name !== "string" || name.length === 0) {
        throw new $TypeError("intrinsic name must be a non-empty string");
      }
      if (arguments.length > 1 && typeof allowMissing !== "boolean") {
        throw new $TypeError('"allowMissing" argument must be a boolean');
      }
      if ($exec(/^%?[^%]*%?$/, name) === null) {
        throw new $SyntaxError("`%` may not be present anywhere but at the beginning and end of the intrinsic name");
      }
      var parts = stringToPath(name);
      var intrinsicBaseName = parts.length > 0 ? parts[0] : "";
      var intrinsic = getBaseIntrinsic("%" + intrinsicBaseName + "%", allowMissing);
      var intrinsicRealName = intrinsic.name;
      var value = intrinsic.value;
      var skipFurtherCaching = false;
      var alias = intrinsic.alias;
      if (alias) {
        intrinsicBaseName = alias[0];
        $spliceApply(parts, $concat([0, 1], alias));
      }
      for (var i = 1, isOwn = true; i < parts.length; i += 1) {
        var part = parts[i];
        var first = $strSlice(part, 0, 1);
        var last = $strSlice(part, -1);
        if ((first === '"' || first === "'" || first === "`" || (last === '"' || last === "'" || last === "`")) && first !== last) {
          throw new $SyntaxError("property names with quotes must have matching quotes");
        }
        if (part === "constructor" || !isOwn) {
          skipFurtherCaching = true;
        }
        intrinsicBaseName += "." + part;
        intrinsicRealName = "%" + intrinsicBaseName + "%";
        if (hasOwn(INTRINSICS, intrinsicRealName)) {
          value = INTRINSICS[intrinsicRealName];
        } else if (value != null) {
          if (!(part in value)) {
            if (!allowMissing) {
              throw new $TypeError("base intrinsic for " + name + " exists, but the property is not available.");
            }
            return void 0;
          }
          if ($gOPD && i + 1 >= parts.length) {
            var desc = $gOPD(value, part);
            isOwn = !!desc;
            if (isOwn && "get" in desc && !("originalValue" in desc.get)) {
              value = desc.get;
            } else {
              value = value[part];
            }
          } else {
            isOwn = hasOwn(value, part);
            value = value[part];
          }
          if (isOwn && !skipFurtherCaching) {
            INTRINSICS[intrinsicRealName] = value;
          }
        }
      }
      return value;
    };
  }
});

// ../../../node_modules/.pnpm/es-define-property@1.0.0/node_modules/es-define-property/index.js
var require_es_define_property = __commonJS({
  "../../../node_modules/.pnpm/es-define-property@1.0.0/node_modules/es-define-property/index.js"(exports2, module2) {
    "use strict";
    init_process();
    init_buffer();
    var GetIntrinsic = require_get_intrinsic();
    var $defineProperty = GetIntrinsic("%Object.defineProperty%", true) || false;
    if ($defineProperty) {
      try {
        $defineProperty({}, "a", { value: 1 });
      } catch (e) {
        $defineProperty = false;
      }
    }
    module2.exports = $defineProperty;
  }
});

// ../../../node_modules/.pnpm/gopd@1.0.1/node_modules/gopd/index.js
var require_gopd = __commonJS({
  "../../../node_modules/.pnpm/gopd@1.0.1/node_modules/gopd/index.js"(exports2, module2) {
    "use strict";
    init_process();
    init_buffer();
    var GetIntrinsic = require_get_intrinsic();
    var $gOPD = GetIntrinsic("%Object.getOwnPropertyDescriptor%", true);
    if ($gOPD) {
      try {
        $gOPD([], "length");
      } catch (e) {
        $gOPD = null;
      }
    }
    module2.exports = $gOPD;
  }
});

// ../../../node_modules/.pnpm/define-data-property@1.1.4/node_modules/define-data-property/index.js
var require_define_data_property = __commonJS({
  "../../../node_modules/.pnpm/define-data-property@1.1.4/node_modules/define-data-property/index.js"(exports2, module2) {
    "use strict";
    init_process();
    init_buffer();
    var $defineProperty = require_es_define_property();
    var $SyntaxError = require_syntax();
    var $TypeError = require_type();
    var gopd = require_gopd();
    module2.exports = function defineDataProperty(obj, property, value) {
      if (!obj || typeof obj !== "object" && typeof obj !== "function") {
        throw new $TypeError("`obj` must be an object or a function`");
      }
      if (typeof property !== "string" && typeof property !== "symbol") {
        throw new $TypeError("`property` must be a string or a symbol`");
      }
      if (arguments.length > 3 && typeof arguments[3] !== "boolean" && arguments[3] !== null) {
        throw new $TypeError("`nonEnumerable`, if provided, must be a boolean or null");
      }
      if (arguments.length > 4 && typeof arguments[4] !== "boolean" && arguments[4] !== null) {
        throw new $TypeError("`nonWritable`, if provided, must be a boolean or null");
      }
      if (arguments.length > 5 && typeof arguments[5] !== "boolean" && arguments[5] !== null) {
        throw new $TypeError("`nonConfigurable`, if provided, must be a boolean or null");
      }
      if (arguments.length > 6 && typeof arguments[6] !== "boolean") {
        throw new $TypeError("`loose`, if provided, must be a boolean");
      }
      var nonEnumerable = arguments.length > 3 ? arguments[3] : null;
      var nonWritable = arguments.length > 4 ? arguments[4] : null;
      var nonConfigurable = arguments.length > 5 ? arguments[5] : null;
      var loose = arguments.length > 6 ? arguments[6] : false;
      var desc = !!gopd && gopd(obj, property);
      if ($defineProperty) {
        $defineProperty(obj, property, {
          configurable: nonConfigurable === null && desc ? desc.configurable : !nonConfigurable,
          enumerable: nonEnumerable === null && desc ? desc.enumerable : !nonEnumerable,
          value,
          writable: nonWritable === null && desc ? desc.writable : !nonWritable
        });
      } else if (loose || !nonEnumerable && !nonWritable && !nonConfigurable) {
        obj[property] = value;
      } else {
        throw new $SyntaxError("This environment does not support defining a property as non-configurable, non-writable, or non-enumerable.");
      }
    };
  }
});

// ../../../node_modules/.pnpm/has-property-descriptors@1.0.2/node_modules/has-property-descriptors/index.js
var require_has_property_descriptors = __commonJS({
  "../../../node_modules/.pnpm/has-property-descriptors@1.0.2/node_modules/has-property-descriptors/index.js"(exports2, module2) {
    "use strict";
    init_process();
    init_buffer();
    var $defineProperty = require_es_define_property();
    var hasPropertyDescriptors = function hasPropertyDescriptors2() {
      return !!$defineProperty;
    };
    hasPropertyDescriptors.hasArrayLengthDefineBug = function hasArrayLengthDefineBug() {
      if (!$defineProperty) {
        return null;
      }
      try {
        return $defineProperty([], "length", { value: 1 }).length !== 1;
      } catch (e) {
        return true;
      }
    };
    module2.exports = hasPropertyDescriptors;
  }
});

// ../../../node_modules/.pnpm/set-function-length@1.2.2/node_modules/set-function-length/index.js
var require_set_function_length = __commonJS({
  "../../../node_modules/.pnpm/set-function-length@1.2.2/node_modules/set-function-length/index.js"(exports2, module2) {
    "use strict";
    init_process();
    init_buffer();
    var GetIntrinsic = require_get_intrinsic();
    var define = require_define_data_property();
    var hasDescriptors = require_has_property_descriptors()();
    var gOPD = require_gopd();
    var $TypeError = require_type();
    var $floor = GetIntrinsic("%Math.floor%");
    module2.exports = function setFunctionLength(fn, length) {
      if (typeof fn !== "function") {
        throw new $TypeError("`fn` is not a function");
      }
      if (typeof length !== "number" || length < 0 || length > 4294967295 || $floor(length) !== length) {
        throw new $TypeError("`length` must be a positive 32-bit integer");
      }
      var loose = arguments.length > 2 && !!arguments[2];
      var functionLengthIsConfigurable = true;
      var functionLengthIsWritable = true;
      if ("length" in fn && gOPD) {
        var desc = gOPD(fn, "length");
        if (desc && !desc.configurable) {
          functionLengthIsConfigurable = false;
        }
        if (desc && !desc.writable) {
          functionLengthIsWritable = false;
        }
      }
      if (functionLengthIsConfigurable || functionLengthIsWritable || !loose) {
        if (hasDescriptors) {
          define(
            /** @type {Parameters<define>[0]} */
            fn,
            "length",
            length,
            true,
            true
          );
        } else {
          define(
            /** @type {Parameters<define>[0]} */
            fn,
            "length",
            length
          );
        }
      }
      return fn;
    };
  }
});

// ../../../node_modules/.pnpm/call-bind@1.0.7/node_modules/call-bind/index.js
var require_call_bind = __commonJS({
  "../../../node_modules/.pnpm/call-bind@1.0.7/node_modules/call-bind/index.js"(exports2, module2) {
    "use strict";
    init_process();
    init_buffer();
    var bind = require_function_bind();
    var GetIntrinsic = require_get_intrinsic();
    var setFunctionLength = require_set_function_length();
    var $TypeError = require_type();
    var $apply = GetIntrinsic("%Function.prototype.apply%");
    var $call = GetIntrinsic("%Function.prototype.call%");
    var $reflectApply = GetIntrinsic("%Reflect.apply%", true) || bind.call($call, $apply);
    var $defineProperty = require_es_define_property();
    var $max = GetIntrinsic("%Math.max%");
    module2.exports = function callBind(originalFunction) {
      if (typeof originalFunction !== "function") {
        throw new $TypeError("a function is required");
      }
      var func = $reflectApply(bind, $call, arguments);
      return setFunctionLength(
        func,
        1 + $max(0, originalFunction.length - (arguments.length - 1)),
        true
      );
    };
    var applyBind = function applyBind2() {
      return $reflectApply(bind, $apply, arguments);
    };
    if ($defineProperty) {
      $defineProperty(module2.exports, "apply", { value: applyBind });
    } else {
      module2.exports.apply = applyBind;
    }
  }
});

// ../../../node_modules/.pnpm/object-keys@1.1.1/node_modules/object-keys/isArguments.js
var require_isArguments = __commonJS({
  "../../../node_modules/.pnpm/object-keys@1.1.1/node_modules/object-keys/isArguments.js"(exports2, module2) {
    "use strict";
    init_process();
    init_buffer();
    var toStr = Object.prototype.toString;
    module2.exports = function isArguments(value) {
      var str = toStr.call(value);
      var isArgs = str === "[object Arguments]";
      if (!isArgs) {
        isArgs = str !== "[object Array]" && value !== null && typeof value === "object" && typeof value.length === "number" && value.length >= 0 && toStr.call(value.callee) === "[object Function]";
      }
      return isArgs;
    };
  }
});

// ../../../node_modules/.pnpm/object-keys@1.1.1/node_modules/object-keys/implementation.js
var require_implementation2 = __commonJS({
  "../../../node_modules/.pnpm/object-keys@1.1.1/node_modules/object-keys/implementation.js"(exports2, module2) {
    "use strict";
    init_process();
    init_buffer();
    var keysShim;
    if (!Object.keys) {
      has = Object.prototype.hasOwnProperty;
      toStr = Object.prototype.toString;
      isArgs = require_isArguments();
      isEnumerable = Object.prototype.propertyIsEnumerable;
      hasDontEnumBug = !isEnumerable.call({ toString: null }, "toString");
      hasProtoEnumBug = isEnumerable.call(function() {
      }, "prototype");
      dontEnums = [
        "toString",
        "toLocaleString",
        "valueOf",
        "hasOwnProperty",
        "isPrototypeOf",
        "propertyIsEnumerable",
        "constructor"
      ];
      equalsConstructorPrototype = function(o) {
        var ctor = o.constructor;
        return ctor && ctor.prototype === o;
      };
      excludedKeys = {
        $applicationCache: true,
        $console: true,
        $external: true,
        $frame: true,
        $frameElement: true,
        $frames: true,
        $innerHeight: true,
        $innerWidth: true,
        $onmozfullscreenchange: true,
        $onmozfullscreenerror: true,
        $outerHeight: true,
        $outerWidth: true,
        $pageXOffset: true,
        $pageYOffset: true,
        $parent: true,
        $scrollLeft: true,
        $scrollTop: true,
        $scrollX: true,
        $scrollY: true,
        $self: true,
        $webkitIndexedDB: true,
        $webkitStorageInfo: true,
        $window: true
      };
      hasAutomationEqualityBug = function() {
        if (typeof window === "undefined") {
          return false;
        }
        for (var k in window) {
          try {
            if (!excludedKeys["$" + k] && has.call(window, k) && window[k] !== null && typeof window[k] === "object") {
              try {
                equalsConstructorPrototype(window[k]);
              } catch (e) {
                return true;
              }
            }
          } catch (e) {
            return true;
          }
        }
        return false;
      }();
      equalsConstructorPrototypeIfNotBuggy = function(o) {
        if (typeof window === "undefined" || !hasAutomationEqualityBug) {
          return equalsConstructorPrototype(o);
        }
        try {
          return equalsConstructorPrototype(o);
        } catch (e) {
          return false;
        }
      };
      keysShim = function keys2(object) {
        var isObject2 = object !== null && typeof object === "object";
        var isFunction2 = toStr.call(object) === "[object Function]";
        var isArguments = isArgs(object);
        var isString2 = isObject2 && toStr.call(object) === "[object String]";
        var theKeys = [];
        if (!isObject2 && !isFunction2 && !isArguments) {
          throw new TypeError("Object.keys called on a non-object");
        }
        var skipProto = hasProtoEnumBug && isFunction2;
        if (isString2 && object.length > 0 && !has.call(object, 0)) {
          for (var i = 0; i < object.length; ++i) {
            theKeys.push(String(i));
          }
        }
        if (isArguments && object.length > 0) {
          for (var j = 0; j < object.length; ++j) {
            theKeys.push(String(j));
          }
        } else {
          for (var name in object) {
            if (!(skipProto && name === "prototype") && has.call(object, name)) {
              theKeys.push(String(name));
            }
          }
        }
        if (hasDontEnumBug) {
          var skipConstructor = equalsConstructorPrototypeIfNotBuggy(object);
          for (var k = 0; k < dontEnums.length; ++k) {
            if (!(skipConstructor && dontEnums[k] === "constructor") && has.call(object, dontEnums[k])) {
              theKeys.push(dontEnums[k]);
            }
          }
        }
        return theKeys;
      };
    }
    var has;
    var toStr;
    var isArgs;
    var isEnumerable;
    var hasDontEnumBug;
    var hasProtoEnumBug;
    var dontEnums;
    var equalsConstructorPrototype;
    var excludedKeys;
    var hasAutomationEqualityBug;
    var equalsConstructorPrototypeIfNotBuggy;
    module2.exports = keysShim;
  }
});

// ../../../node_modules/.pnpm/object-keys@1.1.1/node_modules/object-keys/index.js
var require_object_keys = __commonJS({
  "../../../node_modules/.pnpm/object-keys@1.1.1/node_modules/object-keys/index.js"(exports2, module2) {
    "use strict";
    init_process();
    init_buffer();
    var slice2 = Array.prototype.slice;
    var isArgs = require_isArguments();
    var origKeys = Object.keys;
    var keysShim = origKeys ? function keys2(o) {
      return origKeys(o);
    } : require_implementation2();
    var originalKeys = Object.keys;
    keysShim.shim = function shimObjectKeys() {
      if (Object.keys) {
        var keysWorksWithArguments = function() {
          var args = Object.keys(arguments);
          return args && args.length === arguments.length;
        }(1, 2);
        if (!keysWorksWithArguments) {
          Object.keys = function keys2(object) {
            if (isArgs(object)) {
              return originalKeys(slice2.call(object));
            }
            return originalKeys(object);
          };
        }
      } else {
        Object.keys = keysShim;
      }
      return Object.keys || keysShim;
    };
    module2.exports = keysShim;
  }
});

// ../../../node_modules/.pnpm/define-properties@1.2.1/node_modules/define-properties/index.js
var require_define_properties = __commonJS({
  "../../../node_modules/.pnpm/define-properties@1.2.1/node_modules/define-properties/index.js"(exports2, module2) {
    "use strict";
    init_process();
    init_buffer();
    var keys2 = require_object_keys();
    var hasSymbols = typeof Symbol === "function" && typeof Symbol("foo") === "symbol";
    var toStr = Object.prototype.toString;
    var concat2 = Array.prototype.concat;
    var defineDataProperty = require_define_data_property();
    var isFunction2 = function(fn) {
      return typeof fn === "function" && toStr.call(fn) === "[object Function]";
    };
    var supportsDescriptors = require_has_property_descriptors()();
    var defineProperty = function(object, name, value, predicate) {
      if (name in object) {
        if (predicate === true) {
          if (object[name] === value) {
            return;
          }
        } else if (!isFunction2(predicate) || !predicate()) {
          return;
        }
      }
      if (supportsDescriptors) {
        defineDataProperty(object, name, value, true);
      } else {
        defineDataProperty(object, name, value);
      }
    };
    var defineProperties = function(object, map) {
      var predicates = arguments.length > 2 ? arguments[2] : {};
      var props = keys2(map);
      if (hasSymbols) {
        props = concat2.call(props, Object.getOwnPropertySymbols(map));
      }
      for (var i = 0; i < props.length; i += 1) {
        defineProperty(object, props[i], map[props[i]], predicates[props[i]]);
      }
    };
    defineProperties.supportsDescriptors = !!supportsDescriptors;
    module2.exports = defineProperties;
  }
});

// ../../../node_modules/.pnpm/call-bind@1.0.7/node_modules/call-bind/callBound.js
var require_callBound = __commonJS({
  "../../../node_modules/.pnpm/call-bind@1.0.7/node_modules/call-bind/callBound.js"(exports2, module2) {
    "use strict";
    init_process();
    init_buffer();
    var GetIntrinsic = require_get_intrinsic();
    var callBind = require_call_bind();
    var $indexOf = callBind(GetIntrinsic("String.prototype.indexOf"));
    module2.exports = function callBoundIntrinsic(name, allowMissing) {
      var intrinsic = GetIntrinsic(name, !!allowMissing);
      if (typeof intrinsic === "function" && $indexOf(name, ".prototype.") > -1) {
        return callBind(intrinsic);
      }
      return intrinsic;
    };
  }
});

// ../../../node_modules/.pnpm/es-abstract@1.23.5/node_modules/es-abstract/helpers/IsArray.js
var require_IsArray = __commonJS({
  "../../../node_modules/.pnpm/es-abstract@1.23.5/node_modules/es-abstract/helpers/IsArray.js"(exports2, module2) {
    "use strict";
    init_process();
    init_buffer();
    var GetIntrinsic = require_get_intrinsic();
    var $Array = GetIntrinsic("%Array%");
    var toStr = !$Array.isArray && require_callBound()("Object.prototype.toString");
    module2.exports = $Array.isArray || function IsArray(argument) {
      return toStr(argument) === "[object Array]";
    };
  }
});

// ../../../node_modules/.pnpm/es-abstract@1.23.5/node_modules/es-abstract/2024/IsArray.js
var require_IsArray2 = __commonJS({
  "../../../node_modules/.pnpm/es-abstract@1.23.5/node_modules/es-abstract/2024/IsArray.js"(exports2, module2) {
    "use strict";
    init_process();
    init_buffer();
    module2.exports = require_IsArray();
  }
});

// ../../../node_modules/.pnpm/es-abstract@1.23.5/node_modules/es-abstract/2024/Call.js
var require_Call = __commonJS({
  "../../../node_modules/.pnpm/es-abstract@1.23.5/node_modules/es-abstract/2024/Call.js"(exports2, module2) {
    "use strict";
    init_process();
    init_buffer();
    var GetIntrinsic = require_get_intrinsic();
    var callBound = require_callBound();
    var $TypeError = require_type();
    var IsArray = require_IsArray2();
    var $apply = GetIntrinsic("%Reflect.apply%", true) || callBound("Function.prototype.apply");
    module2.exports = function Call(F, V) {
      var argumentsList = arguments.length > 2 ? arguments[2] : [];
      if (!IsArray(argumentsList)) {
        throw new $TypeError("Assertion failed: optional `argumentsList`, if provided, must be a List");
      }
      return $apply(F, V, argumentsList);
    };
  }
});

// node-modules-polyfills:process
function defaultSetTimout2() {
  throw new Error("setTimeout has not been defined");
}
function defaultClearTimeout2() {
  throw new Error("clearTimeout has not been defined");
}
function runTimeout2(fun) {
  if (cachedSetTimeout2 === setTimeout) {
    return setTimeout(fun, 0);
  }
  if ((cachedSetTimeout2 === defaultSetTimout2 || !cachedSetTimeout2) && setTimeout) {
    cachedSetTimeout2 = setTimeout;
    return setTimeout(fun, 0);
  }
  try {
    return cachedSetTimeout2(fun, 0);
  } catch (e) {
    try {
      return cachedSetTimeout2.call(null, fun, 0);
    } catch (e2) {
      return cachedSetTimeout2.call(this, fun, 0);
    }
  }
}
function runClearTimeout2(marker) {
  if (cachedClearTimeout2 === clearTimeout) {
    return clearTimeout(marker);
  }
  if ((cachedClearTimeout2 === defaultClearTimeout2 || !cachedClearTimeout2) && clearTimeout) {
    cachedClearTimeout2 = clearTimeout;
    return clearTimeout(marker);
  }
  try {
    return cachedClearTimeout2(marker);
  } catch (e) {
    try {
      return cachedClearTimeout2.call(null, marker);
    } catch (e2) {
      return cachedClearTimeout2.call(this, marker);
    }
  }
}
function cleanUpNextTick2() {
  if (!draining2 || !currentQueue2) {
    return;
  }
  draining2 = false;
  if (currentQueue2.length) {
    queue2 = currentQueue2.concat(queue2);
  } else {
    queueIndex2 = -1;
  }
  if (queue2.length) {
    drainQueue2();
  }
}
function drainQueue2() {
  if (draining2) {
    return;
  }
  var timeout = runTimeout2(cleanUpNextTick2);
  draining2 = true;
  var len = queue2.length;
  while (len) {
    currentQueue2 = queue2;
    queue2 = [];
    while (++queueIndex2 < len) {
      if (currentQueue2) {
        currentQueue2[queueIndex2].run();
      }
    }
    queueIndex2 = -1;
    len = queue2.length;
  }
  currentQueue2 = null;
  draining2 = false;
  runClearTimeout2(timeout);
}
function nextTick2(fun) {
  var args = new Array(arguments.length - 1);
  if (arguments.length > 1) {
    for (var i = 1; i < arguments.length; i++) {
      args[i - 1] = arguments[i];
    }
  }
  queue2.push(new Item2(fun, args));
  if (queue2.length === 1 && !draining2) {
    runTimeout2(drainQueue2);
  }
}
function Item2(fun, array) {
  this.fun = fun;
  this.array = array;
}
function noop2() {
}
function binding2(name) {
  throw new Error("process.binding is not supported");
}
function cwd2() {
  return "/";
}
function chdir2(dir) {
  throw new Error("process.chdir is not supported");
}
function umask2() {
  return 0;
}
function hrtime2(previousTimestamp) {
  var clocktime = performanceNow2.call(performance2) * 1e-3;
  var seconds = Math.floor(clocktime);
  var nanoseconds = Math.floor(clocktime % 1 * 1e9);
  if (previousTimestamp) {
    seconds = seconds - previousTimestamp[0];
    nanoseconds = nanoseconds - previousTimestamp[1];
    if (nanoseconds < 0) {
      seconds--;
      nanoseconds += 1e9;
    }
  }
  return [seconds, nanoseconds];
}
function uptime2() {
  var currentTime = /* @__PURE__ */ new Date();
  var dif = currentTime - startTime2;
  return dif / 1e3;
}
var cachedSetTimeout2, cachedClearTimeout2, queue2, draining2, currentQueue2, queueIndex2, title2, platform2, browser2, env2, argv2, version2, versions2, release2, config2, on2, addListener2, once2, off2, removeListener2, removeAllListeners2, emit2, performance2, performanceNow2, startTime2, browser$1, process_default;
var init_process2 = __esm({
  "node-modules-polyfills:process"() {
    "use strict";
    init_process();
    init_buffer();
    cachedSetTimeout2 = defaultSetTimout2;
    cachedClearTimeout2 = defaultClearTimeout2;
    if (typeof globalThis.setTimeout === "function") {
      cachedSetTimeout2 = setTimeout;
    }
    if (typeof globalThis.clearTimeout === "function") {
      cachedClearTimeout2 = clearTimeout;
    }
    queue2 = [];
    draining2 = false;
    queueIndex2 = -1;
    Item2.prototype.run = function() {
      this.fun.apply(null, this.array);
    };
    title2 = "browser";
    platform2 = "browser";
    browser2 = true;
    env2 = {};
    argv2 = [];
    version2 = "";
    versions2 = {};
    release2 = {};
    config2 = {};
    on2 = noop2;
    addListener2 = noop2;
    once2 = noop2;
    off2 = noop2;
    removeListener2 = noop2;
    removeAllListeners2 = noop2;
    emit2 = noop2;
    performance2 = globalThis.performance || {};
    performanceNow2 = performance2.now || performance2.mozNow || performance2.msNow || performance2.oNow || performance2.webkitNow || function() {
      return (/* @__PURE__ */ new Date()).getTime();
    };
    startTime2 = /* @__PURE__ */ new Date();
    browser$1 = {
      nextTick: nextTick2,
      title: title2,
      browser: browser2,
      env: env2,
      argv: argv2,
      version: version2,
      versions: versions2,
      on: on2,
      addListener: addListener2,
      once: once2,
      off: off2,
      removeListener: removeListener2,
      removeAllListeners: removeAllListeners2,
      emit: emit2,
      binding: binding2,
      cwd: cwd2,
      chdir: chdir2,
      umask: umask2,
      hrtime: hrtime2,
      platform: platform2,
      release: release2,
      config: config2,
      uptime: uptime2
    };
    process_default = browser$1;
  }
});

// ../../../node_modules/.pnpm/rollup-plugin-node-polyfills@0.2.1/node_modules/rollup-plugin-node-polyfills/polyfills/inherits.js
var inherits, inherits_default;
var init_inherits = __esm({
  "../../../node_modules/.pnpm/rollup-plugin-node-polyfills@0.2.1/node_modules/rollup-plugin-node-polyfills/polyfills/inherits.js"() {
    "use strict";
    init_process();
    init_buffer();
    if (typeof Object.create === "function") {
      inherits = function inherits2(ctor, superCtor) {
        ctor.super_ = superCtor;
        ctor.prototype = Object.create(superCtor.prototype, {
          constructor: {
            value: ctor,
            enumerable: false,
            writable: true,
            configurable: true
          }
        });
      };
    } else {
      inherits = function inherits2(ctor, superCtor) {
        ctor.super_ = superCtor;
        var TempCtor = function() {
        };
        TempCtor.prototype = superCtor.prototype;
        ctor.prototype = new TempCtor();
        ctor.prototype.constructor = ctor;
      };
    }
    inherits_default = inherits;
  }
});

// node-modules-polyfills:util
var util_exports = {};
__export(util_exports, {
  _extend: () => _extend,
  debuglog: () => debuglog,
  default: () => util_default,
  deprecate: () => deprecate,
  format: () => format,
  inherits: () => inherits_default,
  inspect: () => inspect,
  isArray: () => isArray,
  isBoolean: () => isBoolean,
  isBuffer: () => isBuffer2,
  isDate: () => isDate,
  isError: () => isError,
  isFunction: () => isFunction,
  isNull: () => isNull,
  isNullOrUndefined: () => isNullOrUndefined,
  isNumber: () => isNumber,
  isObject: () => isObject,
  isPrimitive: () => isPrimitive,
  isRegExp: () => isRegExp,
  isString: () => isString,
  isSymbol: () => isSymbol,
  isUndefined: () => isUndefined,
  log: () => log
});
function format(f) {
  if (!isString(f)) {
    var objects = [];
    for (var i = 0; i < arguments.length; i++) {
      objects.push(inspect(arguments[i]));
    }
    return objects.join(" ");
  }
  var i = 1;
  var args = arguments;
  var len = args.length;
  var str = String(f).replace(formatRegExp, function(x2) {
    if (x2 === "%%") return "%";
    if (i >= len) return x2;
    switch (x2) {
      case "%s":
        return String(args[i++]);
      case "%d":
        return Number(args[i++]);
      case "%j":
        try {
          return JSON.stringify(args[i++]);
        } catch (_) {
          return "[Circular]";
        }
      default:
        return x2;
    }
  });
  for (var x = args[i]; i < len; x = args[++i]) {
    if (isNull(x) || !isObject(x)) {
      str += " " + x;
    } else {
      str += " " + inspect(x);
    }
  }
  return str;
}
function deprecate(fn, msg) {
  if (isUndefined(globalThis.process)) {
    return function() {
      return deprecate(fn, msg).apply(this, arguments);
    };
  }
  if (process_default.noDeprecation === true) {
    return fn;
  }
  var warned = false;
  function deprecated() {
    if (!warned) {
      if (process_default.throwDeprecation) {
        throw new Error(msg);
      } else if (process_default.traceDeprecation) {
        console.trace(msg);
      } else {
        console.error(msg);
      }
      warned = true;
    }
    return fn.apply(this, arguments);
  }
  return deprecated;
}
function debuglog(set) {
  if (isUndefined(debugEnviron))
    debugEnviron = process_default.env.NODE_DEBUG || "";
  set = set.toUpperCase();
  if (!debugs[set]) {
    if (new RegExp("\\b" + set + "\\b", "i").test(debugEnviron)) {
      var pid = 0;
      debugs[set] = function() {
        var msg = format.apply(null, arguments);
        console.error("%s %d: %s", set, pid, msg);
      };
    } else {
      debugs[set] = function() {
      };
    }
  }
  return debugs[set];
}
function inspect(obj, opts) {
  var ctx = {
    seen: [],
    stylize: stylizeNoColor
  };
  if (arguments.length >= 3) ctx.depth = arguments[2];
  if (arguments.length >= 4) ctx.colors = arguments[3];
  if (isBoolean(opts)) {
    ctx.showHidden = opts;
  } else if (opts) {
    _extend(ctx, opts);
  }
  if (isUndefined(ctx.showHidden)) ctx.showHidden = false;
  if (isUndefined(ctx.depth)) ctx.depth = 2;
  if (isUndefined(ctx.colors)) ctx.colors = false;
  if (isUndefined(ctx.customInspect)) ctx.customInspect = true;
  if (ctx.colors) ctx.stylize = stylizeWithColor;
  return formatValue(ctx, obj, ctx.depth);
}
function stylizeWithColor(str, styleType) {
  var style = inspect.styles[styleType];
  if (style) {
    return "\x1B[" + inspect.colors[style][0] + "m" + str + "\x1B[" + inspect.colors[style][1] + "m";
  } else {
    return str;
  }
}
function stylizeNoColor(str, styleType) {
  return str;
}
function arrayToHash(array) {
  var hash = {};
  array.forEach(function(val, idx) {
    hash[val] = true;
  });
  return hash;
}
function formatValue(ctx, value, recurseTimes) {
  if (ctx.customInspect && value && isFunction(value.inspect) && // Filter out the util module, it's inspect function is special
  value.inspect !== inspect && // Also filter out any prototype objects using the circular check.
  !(value.constructor && value.constructor.prototype === value)) {
    var ret = value.inspect(recurseTimes, ctx);
    if (!isString(ret)) {
      ret = formatValue(ctx, ret, recurseTimes);
    }
    return ret;
  }
  var primitive = formatPrimitive(ctx, value);
  if (primitive) {
    return primitive;
  }
  var keys2 = Object.keys(value);
  var visibleKeys = arrayToHash(keys2);
  if (ctx.showHidden) {
    keys2 = Object.getOwnPropertyNames(value);
  }
  if (isError(value) && (keys2.indexOf("message") >= 0 || keys2.indexOf("description") >= 0)) {
    return formatError(value);
  }
  if (keys2.length === 0) {
    if (isFunction(value)) {
      var name = value.name ? ": " + value.name : "";
      return ctx.stylize("[Function" + name + "]", "special");
    }
    if (isRegExp(value)) {
      return ctx.stylize(RegExp.prototype.toString.call(value), "regexp");
    }
    if (isDate(value)) {
      return ctx.stylize(Date.prototype.toString.call(value), "date");
    }
    if (isError(value)) {
      return formatError(value);
    }
  }
  var base = "", array = false, braces = ["{", "}"];
  if (isArray(value)) {
    array = true;
    braces = ["[", "]"];
  }
  if (isFunction(value)) {
    var n = value.name ? ": " + value.name : "";
    base = " [Function" + n + "]";
  }
  if (isRegExp(value)) {
    base = " " + RegExp.prototype.toString.call(value);
  }
  if (isDate(value)) {
    base = " " + Date.prototype.toUTCString.call(value);
  }
  if (isError(value)) {
    base = " " + formatError(value);
  }
  if (keys2.length === 0 && (!array || value.length == 0)) {
    return braces[0] + base + braces[1];
  }
  if (recurseTimes < 0) {
    if (isRegExp(value)) {
      return ctx.stylize(RegExp.prototype.toString.call(value), "regexp");
    } else {
      return ctx.stylize("[Object]", "special");
    }
  }
  ctx.seen.push(value);
  var output;
  if (array) {
    output = formatArray(ctx, value, recurseTimes, visibleKeys, keys2);
  } else {
    output = keys2.map(function(key) {
      return formatProperty(ctx, value, recurseTimes, visibleKeys, key, array);
    });
  }
  ctx.seen.pop();
  return reduceToSingleString(output, base, braces);
}
function formatPrimitive(ctx, value) {
  if (isUndefined(value))
    return ctx.stylize("undefined", "undefined");
  if (isString(value)) {
    var simple = "'" + JSON.stringify(value).replace(/^"|"$/g, "").replace(/'/g, "\\'").replace(/\\"/g, '"') + "'";
    return ctx.stylize(simple, "string");
  }
  if (isNumber(value))
    return ctx.stylize("" + value, "number");
  if (isBoolean(value))
    return ctx.stylize("" + value, "boolean");
  if (isNull(value))
    return ctx.stylize("null", "null");
}
function formatError(value) {
  return "[" + Error.prototype.toString.call(value) + "]";
}
function formatArray(ctx, value, recurseTimes, visibleKeys, keys2) {
  var output = [];
  for (var i = 0, l = value.length; i < l; ++i) {
    if (hasOwnProperty(value, String(i))) {
      output.push(formatProperty(
        ctx,
        value,
        recurseTimes,
        visibleKeys,
        String(i),
        true
      ));
    } else {
      output.push("");
    }
  }
  keys2.forEach(function(key) {
    if (!key.match(/^\d+$/)) {
      output.push(formatProperty(
        ctx,
        value,
        recurseTimes,
        visibleKeys,
        key,
        true
      ));
    }
  });
  return output;
}
function formatProperty(ctx, value, recurseTimes, visibleKeys, key, array) {
  var name, str, desc;
  desc = Object.getOwnPropertyDescriptor(value, key) || { value: value[key] };
  if (desc.get) {
    if (desc.set) {
      str = ctx.stylize("[Getter/Setter]", "special");
    } else {
      str = ctx.stylize("[Getter]", "special");
    }
  } else {
    if (desc.set) {
      str = ctx.stylize("[Setter]", "special");
    }
  }
  if (!hasOwnProperty(visibleKeys, key)) {
    name = "[" + key + "]";
  }
  if (!str) {
    if (ctx.seen.indexOf(desc.value) < 0) {
      if (isNull(recurseTimes)) {
        str = formatValue(ctx, desc.value, null);
      } else {
        str = formatValue(ctx, desc.value, recurseTimes - 1);
      }
      if (str.indexOf("\n") > -1) {
        if (array) {
          str = str.split("\n").map(function(line) {
            return "  " + line;
          }).join("\n").substr(2);
        } else {
          str = "\n" + str.split("\n").map(function(line) {
            return "   " + line;
          }).join("\n");
        }
      }
    } else {
      str = ctx.stylize("[Circular]", "special");
    }
  }
  if (isUndefined(name)) {
    if (array && key.match(/^\d+$/)) {
      return str;
    }
    name = JSON.stringify("" + key);
    if (name.match(/^"([a-zA-Z_][a-zA-Z_0-9]*)"$/)) {
      name = name.substr(1, name.length - 2);
      name = ctx.stylize(name, "name");
    } else {
      name = name.replace(/'/g, "\\'").replace(/\\"/g, '"').replace(/(^"|"$)/g, "'");
      name = ctx.stylize(name, "string");
    }
  }
  return name + ": " + str;
}
function reduceToSingleString(output, base, braces) {
  var numLinesEst = 0;
  var length = output.reduce(function(prev, cur) {
    numLinesEst++;
    if (cur.indexOf("\n") >= 0) numLinesEst++;
    return prev + cur.replace(/\u001b\[\d\d?m/g, "").length + 1;
  }, 0);
  if (length > 60) {
    return braces[0] + (base === "" ? "" : base + "\n ") + " " + output.join(",\n  ") + " " + braces[1];
  }
  return braces[0] + base + " " + output.join(", ") + " " + braces[1];
}
function isArray(ar) {
  return Array.isArray(ar);
}
function isBoolean(arg) {
  return typeof arg === "boolean";
}
function isNull(arg) {
  return arg === null;
}
function isNullOrUndefined(arg) {
  return arg == null;
}
function isNumber(arg) {
  return typeof arg === "number";
}
function isString(arg) {
  return typeof arg === "string";
}
function isSymbol(arg) {
  return typeof arg === "symbol";
}
function isUndefined(arg) {
  return arg === void 0;
}
function isRegExp(re) {
  return isObject(re) && objectToString(re) === "[object RegExp]";
}
function isObject(arg) {
  return typeof arg === "object" && arg !== null;
}
function isDate(d) {
  return isObject(d) && objectToString(d) === "[object Date]";
}
function isError(e) {
  return isObject(e) && (objectToString(e) === "[object Error]" || e instanceof Error);
}
function isFunction(arg) {
  return typeof arg === "function";
}
function isPrimitive(arg) {
  return arg === null || typeof arg === "boolean" || typeof arg === "number" || typeof arg === "string" || typeof arg === "symbol" || // ES6 symbol
  typeof arg === "undefined";
}
function isBuffer2(maybeBuf) {
  return Buffer2.isBuffer(maybeBuf);
}
function objectToString(o) {
  return Object.prototype.toString.call(o);
}
function pad(n) {
  return n < 10 ? "0" + n.toString(10) : n.toString(10);
}
function timestamp() {
  var d = /* @__PURE__ */ new Date();
  var time = [
    pad(d.getHours()),
    pad(d.getMinutes()),
    pad(d.getSeconds())
  ].join(":");
  return [d.getDate(), months[d.getMonth()], time].join(" ");
}
function log() {
  console.log("%s - %s", timestamp(), format.apply(null, arguments));
}
function _extend(origin, add) {
  if (!add || !isObject(add)) return origin;
  var keys2 = Object.keys(add);
  var i = keys2.length;
  while (i--) {
    origin[keys2[i]] = add[keys2[i]];
  }
  return origin;
}
function hasOwnProperty(obj, prop) {
  return Object.prototype.hasOwnProperty.call(obj, prop);
}
var formatRegExp, debugs, debugEnviron, months, util_default;
var init_util = __esm({
  "node-modules-polyfills:util"() {
    "use strict";
    init_process();
    init_buffer();
    init_process2();
    init_inherits();
    formatRegExp = /%[sdj%]/g;
    debugs = {};
    inspect.colors = {
      "bold": [1, 22],
      "italic": [3, 23],
      "underline": [4, 24],
      "inverse": [7, 27],
      "white": [37, 39],
      "grey": [90, 39],
      "black": [30, 39],
      "blue": [34, 39],
      "cyan": [36, 39],
      "green": [32, 39],
      "magenta": [35, 39],
      "red": [31, 39],
      "yellow": [33, 39]
    };
    inspect.styles = {
      "special": "cyan",
      "number": "yellow",
      "boolean": "yellow",
      "undefined": "grey",
      "null": "bold",
      "string": "green",
      "date": "magenta",
      // "name": intentionally not styling
      "regexp": "red"
    };
    months = [
      "Jan",
      "Feb",
      "Mar",
      "Apr",
      "May",
      "Jun",
      "Jul",
      "Aug",
      "Sep",
      "Oct",
      "Nov",
      "Dec"
    ];
    util_default = {
      inherits: inherits_default,
      _extend,
      log,
      isBuffer: isBuffer2,
      isPrimitive,
      isFunction,
      isError,
      isDate,
      isObject,
      isRegExp,
      isUndefined,
      isSymbol,
      isString,
      isNumber,
      isNullOrUndefined,
      isNull,
      isBoolean,
      isArray,
      inspect,
      deprecate,
      format,
      debuglog
    };
  }
});

// node-modules-polyfills-commonjs:util
var require_util = __commonJS({
  "node-modules-polyfills-commonjs:util"(exports2, module2) {
    "use strict";
    init_process();
    init_buffer();
    var polyfill = (init_util(), __toCommonJS(util_exports));
    if (polyfill && polyfill.default) {
      module2.exports = polyfill.default;
      for (let k in polyfill) {
        module2.exports[k] = polyfill[k];
      }
    } else if (polyfill) {
      module2.exports = polyfill;
    }
  }
});

// ../../../node_modules/.pnpm/object-inspect@1.13.3/node_modules/object-inspect/util.inspect.js
var require_util_inspect = __commonJS({
  "../../../node_modules/.pnpm/object-inspect@1.13.3/node_modules/object-inspect/util.inspect.js"(exports2, module2) {
    "use strict";
    init_process();
    init_buffer();
    module2.exports = require_util().inspect;
  }
});

// ../../../node_modules/.pnpm/object-inspect@1.13.3/node_modules/object-inspect/index.js
var require_object_inspect = __commonJS({
  "../../../node_modules/.pnpm/object-inspect@1.13.3/node_modules/object-inspect/index.js"(exports2, module2) {
    "use strict";
    init_process();
    init_buffer();
    var hasMap = typeof Map === "function" && Map.prototype;
    var mapSizeDescriptor = Object.getOwnPropertyDescriptor && hasMap ? Object.getOwnPropertyDescriptor(Map.prototype, "size") : null;
    var mapSize = hasMap && mapSizeDescriptor && typeof mapSizeDescriptor.get === "function" ? mapSizeDescriptor.get : null;
    var mapForEach = hasMap && Map.prototype.forEach;
    var hasSet = typeof Set === "function" && Set.prototype;
    var setSizeDescriptor = Object.getOwnPropertyDescriptor && hasSet ? Object.getOwnPropertyDescriptor(Set.prototype, "size") : null;
    var setSize = hasSet && setSizeDescriptor && typeof setSizeDescriptor.get === "function" ? setSizeDescriptor.get : null;
    var setForEach = hasSet && Set.prototype.forEach;
    var hasWeakMap = typeof WeakMap === "function" && WeakMap.prototype;
    var weakMapHas = hasWeakMap ? WeakMap.prototype.has : null;
    var hasWeakSet = typeof WeakSet === "function" && WeakSet.prototype;
    var weakSetHas = hasWeakSet ? WeakSet.prototype.has : null;
    var hasWeakRef = typeof WeakRef === "function" && WeakRef.prototype;
    var weakRefDeref = hasWeakRef ? WeakRef.prototype.deref : null;
    var booleanValueOf = Boolean.prototype.valueOf;
    var objectToString3 = Object.prototype.toString;
    var functionToString = Function.prototype.toString;
    var $match = String.prototype.match;
    var $slice = String.prototype.slice;
    var $replace = String.prototype.replace;
    var $toUpperCase = String.prototype.toUpperCase;
    var $toLowerCase = String.prototype.toLowerCase;
    var $test = RegExp.prototype.test;
    var $concat = Array.prototype.concat;
    var $join = Array.prototype.join;
    var $arrSlice = Array.prototype.slice;
    var $floor = Math.floor;
    var bigIntValueOf = typeof BigInt === "function" ? BigInt.prototype.valueOf : null;
    var gOPS = Object.getOwnPropertySymbols;
    var symToString = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? Symbol.prototype.toString : null;
    var hasShammedSymbols = typeof Symbol === "function" && typeof Symbol.iterator === "object";
    var toStringTag = typeof Symbol === "function" && Symbol.toStringTag && (typeof Symbol.toStringTag === hasShammedSymbols ? "object" : "symbol") ? Symbol.toStringTag : null;
    var isEnumerable = Object.prototype.propertyIsEnumerable;
    var gPO = (typeof Reflect === "function" ? Reflect.getPrototypeOf : Object.getPrototypeOf) || ([].__proto__ === Array.prototype ? function(O) {
      return O.__proto__;
    } : null);
    function addNumericSeparator(num, str) {
      if (num === Infinity || num === -Infinity || num !== num || num && num > -1e3 && num < 1e3 || $test.call(/e/, str)) {
        return str;
      }
      var sepRegex = /[0-9](?=(?:[0-9]{3})+(?![0-9]))/g;
      if (typeof num === "number") {
        var int = num < 0 ? -$floor(-num) : $floor(num);
        if (int !== num) {
          var intStr = String(int);
          var dec = $slice.call(str, intStr.length + 1);
          return $replace.call(intStr, sepRegex, "$&_") + "." + $replace.call($replace.call(dec, /([0-9]{3})/g, "$&_"), /_$/, "");
        }
      }
      return $replace.call(str, sepRegex, "$&_");
    }
    var utilInspect = require_util_inspect();
    var inspectCustom = utilInspect.custom;
    var inspectSymbol = isSymbol3(inspectCustom) ? inspectCustom : null;
    var quotes = {
      __proto__: null,
      "double": '"',
      single: "'"
    };
    var quoteREs = {
      __proto__: null,
      "double": /(["\\])/g,
      single: /(['\\])/g
    };
    module2.exports = function inspect_(obj, options, depth, seen) {
      var opts = options || {};
      if (has(opts, "quoteStyle") && !has(quotes, opts.quoteStyle)) {
        throw new TypeError('option "quoteStyle" must be "single" or "double"');
      }
      if (has(opts, "maxStringLength") && (typeof opts.maxStringLength === "number" ? opts.maxStringLength < 0 && opts.maxStringLength !== Infinity : opts.maxStringLength !== null)) {
        throw new TypeError('option "maxStringLength", if provided, must be a positive integer, Infinity, or `null`');
      }
      var customInspect = has(opts, "customInspect") ? opts.customInspect : true;
      if (typeof customInspect !== "boolean" && customInspect !== "symbol") {
        throw new TypeError("option \"customInspect\", if provided, must be `true`, `false`, or `'symbol'`");
      }
      if (has(opts, "indent") && opts.indent !== null && opts.indent !== "	" && !(parseInt(opts.indent, 10) === opts.indent && opts.indent > 0)) {
        throw new TypeError('option "indent" must be "\\t", an integer > 0, or `null`');
      }
      if (has(opts, "numericSeparator") && typeof opts.numericSeparator !== "boolean") {
        throw new TypeError('option "numericSeparator", if provided, must be `true` or `false`');
      }
      var numericSeparator = opts.numericSeparator;
      if (typeof obj === "undefined") {
        return "undefined";
      }
      if (obj === null) {
        return "null";
      }
      if (typeof obj === "boolean") {
        return obj ? "true" : "false";
      }
      if (typeof obj === "string") {
        return inspectString(obj, opts);
      }
      if (typeof obj === "number") {
        if (obj === 0) {
          return Infinity / obj > 0 ? "0" : "-0";
        }
        var str = String(obj);
        return numericSeparator ? addNumericSeparator(obj, str) : str;
      }
      if (typeof obj === "bigint") {
        var bigIntStr = String(obj) + "n";
        return numericSeparator ? addNumericSeparator(obj, bigIntStr) : bigIntStr;
      }
      var maxDepth = typeof opts.depth === "undefined" ? 5 : opts.depth;
      if (typeof depth === "undefined") {
        depth = 0;
      }
      if (depth >= maxDepth && maxDepth > 0 && typeof obj === "object") {
        return isArray3(obj) ? "[Array]" : "[Object]";
      }
      var indent = getIndent(opts, depth);
      if (typeof seen === "undefined") {
        seen = [];
      } else if (indexOf2(seen, obj) >= 0) {
        return "[Circular]";
      }
      function inspect2(value, from2, noIndent) {
        if (from2) {
          seen = $arrSlice.call(seen);
          seen.push(from2);
        }
        if (noIndent) {
          var newOpts = {
            depth: opts.depth
          };
          if (has(opts, "quoteStyle")) {
            newOpts.quoteStyle = opts.quoteStyle;
          }
          return inspect_(value, newOpts, depth + 1, seen);
        }
        return inspect_(value, opts, depth + 1, seen);
      }
      if (typeof obj === "function" && !isRegExp2(obj)) {
        var name = nameOf(obj);
        var keys2 = arrObjKeys(obj, inspect2);
        return "[Function" + (name ? ": " + name : " (anonymous)") + "]" + (keys2.length > 0 ? " { " + $join.call(keys2, ", ") + " }" : "");
      }
      if (isSymbol3(obj)) {
        var symString = hasShammedSymbols ? $replace.call(String(obj), /^(Symbol\(.*\))_[^)]*$/, "$1") : symToString.call(obj);
        return typeof obj === "object" && !hasShammedSymbols ? markBoxed(symString) : symString;
      }
      if (isElement(obj)) {
        var s = "<" + $toLowerCase.call(String(obj.nodeName));
        var attrs = obj.attributes || [];
        for (var i = 0; i < attrs.length; i++) {
          s += " " + attrs[i].name + "=" + wrapQuotes(quote(attrs[i].value), "double", opts);
        }
        s += ">";
        if (obj.childNodes && obj.childNodes.length) {
          s += "...";
        }
        s += "</" + $toLowerCase.call(String(obj.nodeName)) + ">";
        return s;
      }
      if (isArray3(obj)) {
        if (obj.length === 0) {
          return "[]";
        }
        var xs = arrObjKeys(obj, inspect2);
        if (indent && !singleLineValues(xs)) {
          return "[" + indentedJoin(xs, indent) + "]";
        }
        return "[ " + $join.call(xs, ", ") + " ]";
      }
      if (isError2(obj)) {
        var parts = arrObjKeys(obj, inspect2);
        if (!("cause" in Error.prototype) && "cause" in obj && !isEnumerable.call(obj, "cause")) {
          return "{ [" + String(obj) + "] " + $join.call($concat.call("[cause]: " + inspect2(obj.cause), parts), ", ") + " }";
        }
        if (parts.length === 0) {
          return "[" + String(obj) + "]";
        }
        return "{ [" + String(obj) + "] " + $join.call(parts, ", ") + " }";
      }
      if (typeof obj === "object" && customInspect) {
        if (inspectSymbol && typeof obj[inspectSymbol] === "function" && utilInspect) {
          return utilInspect(obj, { depth: maxDepth - depth });
        } else if (customInspect !== "symbol" && typeof obj.inspect === "function") {
          return obj.inspect();
        }
      }
      if (isMap(obj)) {
        var mapParts = [];
        if (mapForEach) {
          mapForEach.call(obj, function(value, key) {
            mapParts.push(inspect2(key, obj, true) + " => " + inspect2(value, obj));
          });
        }
        return collectionOf("Map", mapSize.call(obj), mapParts, indent);
      }
      if (isSet(obj)) {
        var setParts = [];
        if (setForEach) {
          setForEach.call(obj, function(value) {
            setParts.push(inspect2(value, obj));
          });
        }
        return collectionOf("Set", setSize.call(obj), setParts, indent);
      }
      if (isWeakMap(obj)) {
        return weakCollectionOf("WeakMap");
      }
      if (isWeakSet(obj)) {
        return weakCollectionOf("WeakSet");
      }
      if (isWeakRef(obj)) {
        return weakCollectionOf("WeakRef");
      }
      if (isNumber2(obj)) {
        return markBoxed(inspect2(Number(obj)));
      }
      if (isBigInt(obj)) {
        return markBoxed(inspect2(bigIntValueOf.call(obj)));
      }
      if (isBoolean2(obj)) {
        return markBoxed(booleanValueOf.call(obj));
      }
      if (isString2(obj)) {
        return markBoxed(inspect2(String(obj)));
      }
      if (typeof window !== "undefined" && obj === window) {
        return "{ [object Window] }";
      }
      if (typeof globalThis !== "undefined" && obj === globalThis || typeof globalThis !== "undefined" && obj === globalThis) {
        return "{ [object globalThis] }";
      }
      if (!isDate2(obj) && !isRegExp2(obj)) {
        var ys = arrObjKeys(obj, inspect2);
        var isPlainObject = gPO ? gPO(obj) === Object.prototype : obj instanceof Object || obj.constructor === Object;
        var protoTag = obj instanceof Object ? "" : "null prototype";
        var stringTag = !isPlainObject && toStringTag && Object(obj) === obj && toStringTag in obj ? $slice.call(toStr(obj), 8, -1) : protoTag ? "Object" : "";
        var constructorTag = isPlainObject || typeof obj.constructor !== "function" ? "" : obj.constructor.name ? obj.constructor.name + " " : "";
        var tag = constructorTag + (stringTag || protoTag ? "[" + $join.call($concat.call([], stringTag || [], protoTag || []), ": ") + "] " : "");
        if (ys.length === 0) {
          return tag + "{}";
        }
        if (indent) {
          return tag + "{" + indentedJoin(ys, indent) + "}";
        }
        return tag + "{ " + $join.call(ys, ", ") + " }";
      }
      return String(obj);
    };
    function wrapQuotes(s, defaultStyle, opts) {
      var style = opts.quoteStyle || defaultStyle;
      var quoteChar = quotes[style];
      return quoteChar + s + quoteChar;
    }
    function quote(s) {
      return $replace.call(String(s), /"/g, "&quot;");
    }
    function isArray3(obj) {
      return toStr(obj) === "[object Array]" && (!toStringTag || !(typeof obj === "object" && toStringTag in obj));
    }
    function isDate2(obj) {
      return toStr(obj) === "[object Date]" && (!toStringTag || !(typeof obj === "object" && toStringTag in obj));
    }
    function isRegExp2(obj) {
      return toStr(obj) === "[object RegExp]" && (!toStringTag || !(typeof obj === "object" && toStringTag in obj));
    }
    function isError2(obj) {
      return toStr(obj) === "[object Error]" && (!toStringTag || !(typeof obj === "object" && toStringTag in obj));
    }
    function isString2(obj) {
      return toStr(obj) === "[object String]" && (!toStringTag || !(typeof obj === "object" && toStringTag in obj));
    }
    function isNumber2(obj) {
      return toStr(obj) === "[object Number]" && (!toStringTag || !(typeof obj === "object" && toStringTag in obj));
    }
    function isBoolean2(obj) {
      return toStr(obj) === "[object Boolean]" && (!toStringTag || !(typeof obj === "object" && toStringTag in obj));
    }
    function isSymbol3(obj) {
      if (hasShammedSymbols) {
        return obj && typeof obj === "object" && obj instanceof Symbol;
      }
      if (typeof obj === "symbol") {
        return true;
      }
      if (!obj || typeof obj !== "object" || !symToString) {
        return false;
      }
      try {
        symToString.call(obj);
        return true;
      } catch (e) {
      }
      return false;
    }
    function isBigInt(obj) {
      if (!obj || typeof obj !== "object" || !bigIntValueOf) {
        return false;
      }
      try {
        bigIntValueOf.call(obj);
        return true;
      } catch (e) {
      }
      return false;
    }
    var hasOwn = Object.prototype.hasOwnProperty || function(key) {
      return key in this;
    };
    function has(obj, key) {
      return hasOwn.call(obj, key);
    }
    function toStr(obj) {
      return objectToString3.call(obj);
    }
    function nameOf(f) {
      if (f.name) {
        return f.name;
      }
      var m = $match.call(functionToString.call(f), /^function\s*([\w$]+)/);
      if (m) {
        return m[1];
      }
      return null;
    }
    function indexOf2(xs, x) {
      if (xs.indexOf) {
        return xs.indexOf(x);
      }
      for (var i = 0, l = xs.length; i < l; i++) {
        if (xs[i] === x) {
          return i;
        }
      }
      return -1;
    }
    function isMap(x) {
      if (!mapSize || !x || typeof x !== "object") {
        return false;
      }
      try {
        mapSize.call(x);
        try {
          setSize.call(x);
        } catch (s) {
          return true;
        }
        return x instanceof Map;
      } catch (e) {
      }
      return false;
    }
    function isWeakMap(x) {
      if (!weakMapHas || !x || typeof x !== "object") {
        return false;
      }
      try {
        weakMapHas.call(x, weakMapHas);
        try {
          weakSetHas.call(x, weakSetHas);
        } catch (s) {
          return true;
        }
        return x instanceof WeakMap;
      } catch (e) {
      }
      return false;
    }
    function isWeakRef(x) {
      if (!weakRefDeref || !x || typeof x !== "object") {
        return false;
      }
      try {
        weakRefDeref.call(x);
        return true;
      } catch (e) {
      }
      return false;
    }
    function isSet(x) {
      if (!setSize || !x || typeof x !== "object") {
        return false;
      }
      try {
        setSize.call(x);
        try {
          mapSize.call(x);
        } catch (m) {
          return true;
        }
        return x instanceof Set;
      } catch (e) {
      }
      return false;
    }
    function isWeakSet(x) {
      if (!weakSetHas || !x || typeof x !== "object") {
        return false;
      }
      try {
        weakSetHas.call(x, weakSetHas);
        try {
          weakMapHas.call(x, weakMapHas);
        } catch (s) {
          return true;
        }
        return x instanceof WeakSet;
      } catch (e) {
      }
      return false;
    }
    function isElement(x) {
      if (!x || typeof x !== "object") {
        return false;
      }
      if (typeof HTMLElement !== "undefined" && x instanceof HTMLElement) {
        return true;
      }
      return typeof x.nodeName === "string" && typeof x.getAttribute === "function";
    }
    function inspectString(str, opts) {
      if (str.length > opts.maxStringLength) {
        var remaining = str.length - opts.maxStringLength;
        var trailer = "... " + remaining + " more character" + (remaining > 1 ? "s" : "");
        return inspectString($slice.call(str, 0, opts.maxStringLength), opts) + trailer;
      }
      var quoteRE = quoteREs[opts.quoteStyle || "single"];
      quoteRE.lastIndex = 0;
      var s = $replace.call($replace.call(str, quoteRE, "\\$1"), /[\x00-\x1f]/g, lowbyte);
      return wrapQuotes(s, "single", opts);
    }
    function lowbyte(c) {
      var n = c.charCodeAt(0);
      var x = {
        8: "b",
        9: "t",
        10: "n",
        12: "f",
        13: "r"
      }[n];
      if (x) {
        return "\\" + x;
      }
      return "\\x" + (n < 16 ? "0" : "") + $toUpperCase.call(n.toString(16));
    }
    function markBoxed(str) {
      return "Object(" + str + ")";
    }
    function weakCollectionOf(type) {
      return type + " { ? }";
    }
    function collectionOf(type, size, entries, indent) {
      var joinedEntries = indent ? indentedJoin(entries, indent) : $join.call(entries, ", ");
      return type + " (" + size + ") {" + joinedEntries + "}";
    }
    function singleLineValues(xs) {
      for (var i = 0; i < xs.length; i++) {
        if (indexOf2(xs[i], "\n") >= 0) {
          return false;
        }
      }
      return true;
    }
    function getIndent(opts, depth) {
      var baseIndent;
      if (opts.indent === "	") {
        baseIndent = "	";
      } else if (typeof opts.indent === "number" && opts.indent > 0) {
        baseIndent = $join.call(Array(opts.indent + 1), " ");
      } else {
        return null;
      }
      return {
        base: baseIndent,
        prev: $join.call(Array(depth + 1), baseIndent)
      };
    }
    function indentedJoin(xs, indent) {
      if (xs.length === 0) {
        return "";
      }
      var lineJoiner = "\n" + indent.prev + indent.base;
      return lineJoiner + $join.call(xs, "," + lineJoiner) + "\n" + indent.prev;
    }
    function arrObjKeys(obj, inspect2) {
      var isArr = isArray3(obj);
      var xs = [];
      if (isArr) {
        xs.length = obj.length;
        for (var i = 0; i < obj.length; i++) {
          xs[i] = has(obj, i) ? inspect2(obj[i], obj) : "";
        }
      }
      var syms = typeof gOPS === "function" ? gOPS(obj) : [];
      var symMap;
      if (hasShammedSymbols) {
        symMap = {};
        for (var k = 0; k < syms.length; k++) {
          symMap["$" + syms[k]] = syms[k];
        }
      }
      for (var key in obj) {
        if (!has(obj, key)) {
          continue;
        }
        if (isArr && String(Number(key)) === key && key < obj.length) {
          continue;
        }
        if (hasShammedSymbols && symMap["$" + key] instanceof Symbol) {
          continue;
        } else if ($test.call(/[^\w$]/, key)) {
          xs.push(inspect2(key, obj) + ": " + inspect2(obj[key], obj));
        } else {
          xs.push(key + ": " + inspect2(obj[key], obj));
        }
      }
      if (typeof gOPS === "function") {
        for (var j = 0; j < syms.length; j++) {
          if (isEnumerable.call(obj, syms[j])) {
            xs.push("[" + inspect2(syms[j]) + "]: " + inspect2(obj[syms[j]], obj));
          }
        }
      }
      return xs;
    }
  }
});

// ../../../node_modules/.pnpm/es-abstract@1.23.5/node_modules/es-abstract/2024/IsPropertyKey.js
var require_IsPropertyKey = __commonJS({
  "../../../node_modules/.pnpm/es-abstract@1.23.5/node_modules/es-abstract/2024/IsPropertyKey.js"(exports2, module2) {
    "use strict";
    init_process();
    init_buffer();
    module2.exports = function IsPropertyKey(argument) {
      return typeof argument === "string" || typeof argument === "symbol";
    };
  }
});

// ../../../node_modules/.pnpm/es-abstract@1.23.5/node_modules/es-abstract/2024/GetV.js
var require_GetV = __commonJS({
  "../../../node_modules/.pnpm/es-abstract@1.23.5/node_modules/es-abstract/2024/GetV.js"(exports2, module2) {
    "use strict";
    init_process();
    init_buffer();
    var $TypeError = require_type();
    var inspect2 = require_object_inspect();
    var IsPropertyKey = require_IsPropertyKey();
    module2.exports = function GetV(V, P) {
      if (!IsPropertyKey(P)) {
        throw new $TypeError("Assertion failed: IsPropertyKey(P) is not true, got " + inspect2(P));
      }
      return V[P];
    };
  }
});

// ../../../node_modules/.pnpm/is-callable@1.2.7/node_modules/is-callable/index.js
var require_is_callable = __commonJS({
  "../../../node_modules/.pnpm/is-callable@1.2.7/node_modules/is-callable/index.js"(exports2, module2) {
    "use strict";
    init_process();
    init_buffer();
    var fnToStr = Function.prototype.toString;
    var reflectApply = typeof Reflect === "object" && Reflect !== null && Reflect.apply;
    var badArrayLike;
    var isCallableMarker;
    if (typeof reflectApply === "function" && typeof Object.defineProperty === "function") {
      try {
        badArrayLike = Object.defineProperty({}, "length", {
          get: function() {
            throw isCallableMarker;
          }
        });
        isCallableMarker = {};
        reflectApply(function() {
          throw 42;
        }, null, badArrayLike);
      } catch (_) {
        if (_ !== isCallableMarker) {
          reflectApply = null;
        }
      }
    } else {
      reflectApply = null;
    }
    var constructorRegex = /^\s*class\b/;
    var isES6ClassFn = function isES6ClassFunction(value) {
      try {
        var fnStr = fnToStr.call(value);
        return constructorRegex.test(fnStr);
      } catch (e) {
        return false;
      }
    };
    var tryFunctionObject = function tryFunctionToStr(value) {
      try {
        if (isES6ClassFn(value)) {
          return false;
        }
        fnToStr.call(value);
        return true;
      } catch (e) {
        return false;
      }
    };
    var toStr = Object.prototype.toString;
    var objectClass = "[object Object]";
    var fnClass = "[object Function]";
    var genClass = "[object GeneratorFunction]";
    var ddaClass = "[object HTMLAllCollection]";
    var ddaClass2 = "[object HTML document.all class]";
    var ddaClass3 = "[object HTMLCollection]";
    var hasToStringTag = typeof Symbol === "function" && !!Symbol.toStringTag;
    var isIE68 = !(0 in [,]);
    var isDDA = function isDocumentDotAll() {
      return false;
    };
    if (typeof document === "object") {
      all = document.all;
      if (toStr.call(all) === toStr.call(document.all)) {
        isDDA = function isDocumentDotAll(value) {
          if ((isIE68 || !value) && (typeof value === "undefined" || typeof value === "object")) {
            try {
              var str = toStr.call(value);
              return (str === ddaClass || str === ddaClass2 || str === ddaClass3 || str === objectClass) && value("") == null;
            } catch (e) {
            }
          }
          return false;
        };
      }
    }
    var all;
    module2.exports = reflectApply ? function isCallable(value) {
      if (isDDA(value)) {
        return true;
      }
      if (!value) {
        return false;
      }
      if (typeof value !== "function" && typeof value !== "object") {
        return false;
      }
      try {
        reflectApply(value, null, badArrayLike);
      } catch (e) {
        if (e !== isCallableMarker) {
          return false;
        }
      }
      return !isES6ClassFn(value) && tryFunctionObject(value);
    } : function isCallable(value) {
      if (isDDA(value)) {
        return true;
      }
      if (!value) {
        return false;
      }
      if (typeof value !== "function" && typeof value !== "object") {
        return false;
      }
      if (hasToStringTag) {
        return tryFunctionObject(value);
      }
      if (isES6ClassFn(value)) {
        return false;
      }
      var strClass = toStr.call(value);
      if (strClass !== fnClass && strClass !== genClass && !/^\[object HTML/.test(strClass)) {
        return false;
      }
      return tryFunctionObject(value);
    };
  }
});

// ../../../node_modules/.pnpm/es-abstract@1.23.5/node_modules/es-abstract/2024/IsCallable.js
var require_IsCallable = __commonJS({
  "../../../node_modules/.pnpm/es-abstract@1.23.5/node_modules/es-abstract/2024/IsCallable.js"(exports2, module2) {
    "use strict";
    init_process();
    init_buffer();
    module2.exports = require_is_callable();
  }
});

// ../../../node_modules/.pnpm/es-abstract@1.23.5/node_modules/es-abstract/2024/GetMethod.js
var require_GetMethod = __commonJS({
  "../../../node_modules/.pnpm/es-abstract@1.23.5/node_modules/es-abstract/2024/GetMethod.js"(exports2, module2) {
    "use strict";
    init_process();
    init_buffer();
    var $TypeError = require_type();
    var GetV = require_GetV();
    var IsCallable = require_IsCallable();
    var IsPropertyKey = require_IsPropertyKey();
    var inspect2 = require_object_inspect();
    module2.exports = function GetMethod(O, P) {
      if (!IsPropertyKey(P)) {
        throw new $TypeError("Assertion failed: IsPropertyKey(P) is not true");
      }
      var func = GetV(O, P);
      if (func == null) {
        return void 0;
      }
      if (!IsCallable(func)) {
        throw new $TypeError(inspect2(P) + " is not a function: " + inspect2(func));
      }
      return func;
    };
  }
});

// ../../../node_modules/.pnpm/has-tostringtag@1.0.2/node_modules/has-tostringtag/shams.js
var require_shams2 = __commonJS({
  "../../../node_modules/.pnpm/has-tostringtag@1.0.2/node_modules/has-tostringtag/shams.js"(exports2, module2) {
    "use strict";
    init_process();
    init_buffer();
    var hasSymbols = require_shams();
    module2.exports = function hasToStringTagShams() {
      return hasSymbols() && !!Symbol.toStringTag;
    };
  }
});

// ../../../node_modules/.pnpm/is-regex@1.1.4/node_modules/is-regex/index.js
var require_is_regex = __commonJS({
  "../../../node_modules/.pnpm/is-regex@1.1.4/node_modules/is-regex/index.js"(exports2, module2) {
    "use strict";
    init_process();
    init_buffer();
    var callBound = require_callBound();
    var hasToStringTag = require_shams2()();
    var has;
    var $exec;
    var isRegexMarker;
    var badStringifier;
    if (hasToStringTag) {
      has = callBound("Object.prototype.hasOwnProperty");
      $exec = callBound("RegExp.prototype.exec");
      isRegexMarker = {};
      throwRegexMarker = function() {
        throw isRegexMarker;
      };
      badStringifier = {
        toString: throwRegexMarker,
        valueOf: throwRegexMarker
      };
      if (typeof Symbol.toPrimitive === "symbol") {
        badStringifier[Symbol.toPrimitive] = throwRegexMarker;
      }
    }
    var throwRegexMarker;
    var $toString = callBound("Object.prototype.toString");
    var gOPD = Object.getOwnPropertyDescriptor;
    var regexClass = "[object RegExp]";
    module2.exports = hasToStringTag ? function isRegex(value) {
      if (!value || typeof value !== "object") {
        return false;
      }
      var descriptor = gOPD(value, "lastIndex");
      var hasLastIndexDataProperty = descriptor && has(descriptor, "value");
      if (!hasLastIndexDataProperty) {
        return false;
      }
      try {
        $exec(value, badStringifier);
      } catch (e) {
        return e === isRegexMarker;
      }
    } : function isRegex(value) {
      if (!value || typeof value !== "object" && typeof value !== "function") {
        return false;
      }
      return $toString(value) === regexClass;
    };
  }
});

// ../../../node_modules/.pnpm/safe-regex-test@1.0.3/node_modules/safe-regex-test/index.js
var require_safe_regex_test = __commonJS({
  "../../../node_modules/.pnpm/safe-regex-test@1.0.3/node_modules/safe-regex-test/index.js"(exports2, module2) {
    "use strict";
    init_process();
    init_buffer();
    var callBound = require_callBound();
    var isRegex = require_is_regex();
    var $exec = callBound("RegExp.prototype.exec");
    var $TypeError = require_type();
    module2.exports = function regexTester(regex) {
      if (!isRegex(regex)) {
        throw new $TypeError("`regex` must be a RegExp");
      }
      return function test(s) {
        return $exec(regex, s) !== null;
      };
    };
  }
});

// ../../../node_modules/.pnpm/es-abstract@1.23.5/node_modules/es-abstract/helpers/every.js
var require_every = __commonJS({
  "../../../node_modules/.pnpm/es-abstract@1.23.5/node_modules/es-abstract/helpers/every.js"(exports2, module2) {
    "use strict";
    init_process();
    init_buffer();
    module2.exports = function every(array, predicate) {
      for (var i = 0; i < array.length; i += 1) {
        if (!predicate(array[i], i, array)) {
          return false;
        }
      }
      return true;
    };
  }
});

// ../../../node_modules/.pnpm/es-abstract@1.23.5/node_modules/es-abstract/5/Type.js
var require_Type = __commonJS({
  "../../../node_modules/.pnpm/es-abstract@1.23.5/node_modules/es-abstract/5/Type.js"(exports2, module2) {
    "use strict";
    init_process();
    init_buffer();
    module2.exports = function Type2(x) {
      if (x === null) {
        return "Null";
      }
      if (typeof x === "undefined") {
        return "Undefined";
      }
      if (typeof x === "function" || typeof x === "object") {
        return "Object";
      }
      if (typeof x === "number") {
        return "Number";
      }
      if (typeof x === "boolean") {
        return "Boolean";
      }
      if (typeof x === "string") {
        return "String";
      }
    };
  }
});

// ../../../node_modules/.pnpm/es-abstract@1.23.5/node_modules/es-abstract/2024/Type.js
var require_Type2 = __commonJS({
  "../../../node_modules/.pnpm/es-abstract@1.23.5/node_modules/es-abstract/2024/Type.js"(exports2, module2) {
    "use strict";
    init_process();
    init_buffer();
    var ES5Type = require_Type();
    module2.exports = function Type2(x) {
      if (typeof x === "symbol") {
        return "Symbol";
      }
      if (typeof x === "bigint") {
        return "BigInt";
      }
      return ES5Type(x);
    };
  }
});

// ../../../node_modules/.pnpm/es-abstract@1.23.5/node_modules/es-abstract/2024/Get.js
var require_Get = __commonJS({
  "../../../node_modules/.pnpm/es-abstract@1.23.5/node_modules/es-abstract/2024/Get.js"(exports2, module2) {
    "use strict";
    init_process();
    init_buffer();
    var $TypeError = require_type();
    var inspect2 = require_object_inspect();
    var IsPropertyKey = require_IsPropertyKey();
    var Type2 = require_Type2();
    module2.exports = function Get(O, P) {
      if (Type2(O) !== "Object") {
        throw new $TypeError("Assertion failed: Type(O) is not Object");
      }
      if (!IsPropertyKey(P)) {
        throw new $TypeError("Assertion failed: IsPropertyKey(P) is not true, got " + inspect2(P));
      }
      return O[P];
    };
  }
});

// ../../../node_modules/.pnpm/es-abstract@1.23.5/node_modules/es-abstract/2024/min.js
var require_min = __commonJS({
  "../../../node_modules/.pnpm/es-abstract@1.23.5/node_modules/es-abstract/2024/min.js"(exports2, module2) {
    "use strict";
    init_process();
    init_buffer();
    var GetIntrinsic = require_get_intrinsic();
    module2.exports = GetIntrinsic("%Math.min%");
  }
});

// ../../../node_modules/.pnpm/es-abstract@1.23.5/node_modules/es-abstract/helpers/isNaN.js
var require_isNaN = __commonJS({
  "../../../node_modules/.pnpm/es-abstract@1.23.5/node_modules/es-abstract/helpers/isNaN.js"(exports2, module2) {
    "use strict";
    init_process();
    init_buffer();
    module2.exports = Number.isNaN || function isNaN2(a) {
      return a !== a;
    };
  }
});

// ../../../node_modules/.pnpm/es-abstract@1.23.5/node_modules/es-abstract/helpers/isFinite.js
var require_isFinite = __commonJS({
  "../../../node_modules/.pnpm/es-abstract@1.23.5/node_modules/es-abstract/helpers/isFinite.js"(exports2, module2) {
    "use strict";
    init_process();
    init_buffer();
    var $isNaN = require_isNaN();
    module2.exports = function(x) {
      return (typeof x === "number" || typeof x === "bigint") && !$isNaN(x) && x !== Infinity && x !== -Infinity;
    };
  }
});

// ../../../node_modules/.pnpm/es-abstract@1.23.5/node_modules/es-abstract/helpers/isInteger.js
var require_isInteger = __commonJS({
  "../../../node_modules/.pnpm/es-abstract@1.23.5/node_modules/es-abstract/helpers/isInteger.js"(exports2, module2) {
    "use strict";
    init_process();
    init_buffer();
    var GetIntrinsic = require_get_intrinsic();
    var $abs = GetIntrinsic("%Math.abs%");
    var $floor = GetIntrinsic("%Math.floor%");
    var $isNaN = require_isNaN();
    var $isFinite = require_isFinite();
    module2.exports = function isInteger(argument) {
      if (typeof argument !== "number" || $isNaN(argument) || !$isFinite(argument)) {
        return false;
      }
      var absValue = $abs(argument);
      return $floor(absValue) === absValue;
    };
  }
});

// ../../../node_modules/.pnpm/es-abstract@1.23.5/node_modules/es-abstract/2024/StringIndexOf.js
var require_StringIndexOf = __commonJS({
  "../../../node_modules/.pnpm/es-abstract@1.23.5/node_modules/es-abstract/2024/StringIndexOf.js"(exports2, module2) {
    "use strict";
    init_process();
    init_buffer();
    var callBound = require_callBound();
    var $TypeError = require_type();
    var isInteger = require_isInteger();
    var $slice = callBound("String.prototype.slice");
    module2.exports = function StringIndexOf(string, searchValue, fromIndex) {
      if (typeof string !== "string") {
        throw new $TypeError("Assertion failed: `string` must be a String");
      }
      if (typeof searchValue !== "string") {
        throw new $TypeError("Assertion failed: `searchValue` must be a String");
      }
      if (!isInteger(fromIndex) || fromIndex < 0) {
        throw new $TypeError("Assertion failed: `fromIndex` must be a non-negative integer");
      }
      var len = string.length;
      if (searchValue === "" && fromIndex <= len) {
        return fromIndex;
      }
      var searchLen = searchValue.length;
      for (var i = fromIndex; i <= len - searchLen; i += 1) {
        var candidate = $slice(string, i, i + searchLen);
        if (candidate === searchValue) {
          return i;
        }
      }
      return -1;
    };
  }
});

// ../../../node_modules/.pnpm/es-object-atoms@1.0.0/node_modules/es-object-atoms/RequireObjectCoercible.js
var require_RequireObjectCoercible = __commonJS({
  "../../../node_modules/.pnpm/es-object-atoms@1.0.0/node_modules/es-object-atoms/RequireObjectCoercible.js"(exports2, module2) {
    "use strict";
    init_process();
    init_buffer();
    var $TypeError = require_type();
    module2.exports = function RequireObjectCoercible(value) {
      if (value == null) {
        throw new $TypeError(arguments.length > 0 && arguments[1] || "Cannot call method on " + value);
      }
      return value;
    };
  }
});

// ../../../node_modules/.pnpm/es-abstract@1.23.5/node_modules/es-abstract/2024/ToString.js
var require_ToString = __commonJS({
  "../../../node_modules/.pnpm/es-abstract@1.23.5/node_modules/es-abstract/2024/ToString.js"(exports2, module2) {
    "use strict";
    init_process();
    init_buffer();
    var GetIntrinsic = require_get_intrinsic();
    var $String = GetIntrinsic("%String%");
    var $TypeError = require_type();
    module2.exports = function ToString(argument) {
      if (typeof argument === "symbol") {
        throw new $TypeError("Cannot convert a Symbol value to a string");
      }
      return $String(argument);
    };
  }
});

// ../../../node_modules/.pnpm/string.prototype.trim@1.2.9/node_modules/string.prototype.trim/implementation.js
var require_implementation3 = __commonJS({
  "../../../node_modules/.pnpm/string.prototype.trim@1.2.9/node_modules/string.prototype.trim/implementation.js"(exports2, module2) {
    "use strict";
    init_process();
    init_buffer();
    var RequireObjectCoercible = require_RequireObjectCoercible();
    var ToString = require_ToString();
    var callBound = require_callBound();
    var $replace = callBound("String.prototype.replace");
    var mvsIsWS = /^\s$/.test("\u180E");
    var leftWhitespace = mvsIsWS ? /^[\x09\x0A\x0B\x0C\x0D\x20\xA0\u1680\u180E\u2000\u2001\u2002\u2003\u2004\u2005\u2006\u2007\u2008\u2009\u200A\u202F\u205F\u3000\u2028\u2029\uFEFF]+/ : /^[\x09\x0A\x0B\x0C\x0D\x20\xA0\u1680\u2000\u2001\u2002\u2003\u2004\u2005\u2006\u2007\u2008\u2009\u200A\u202F\u205F\u3000\u2028\u2029\uFEFF]+/;
    var rightWhitespace = mvsIsWS ? /[\x09\x0A\x0B\x0C\x0D\x20\xA0\u1680\u180E\u2000\u2001\u2002\u2003\u2004\u2005\u2006\u2007\u2008\u2009\u200A\u202F\u205F\u3000\u2028\u2029\uFEFF]+$/ : /[\x09\x0A\x0B\x0C\x0D\x20\xA0\u1680\u2000\u2001\u2002\u2003\u2004\u2005\u2006\u2007\u2008\u2009\u200A\u202F\u205F\u3000\u2028\u2029\uFEFF]+$/;
    module2.exports = function trim() {
      var S = ToString(RequireObjectCoercible(this));
      return $replace($replace(S, leftWhitespace, ""), rightWhitespace, "");
    };
  }
});

// ../../../node_modules/.pnpm/string.prototype.trim@1.2.9/node_modules/string.prototype.trim/polyfill.js
var require_polyfill = __commonJS({
  "../../../node_modules/.pnpm/string.prototype.trim@1.2.9/node_modules/string.prototype.trim/polyfill.js"(exports2, module2) {
    "use strict";
    init_process();
    init_buffer();
    var implementation = require_implementation3();
    var zeroWidthSpace = "\u200B";
    var mongolianVowelSeparator = "\u180E";
    module2.exports = function getPolyfill() {
      if (String.prototype.trim && zeroWidthSpace.trim() === zeroWidthSpace && mongolianVowelSeparator.trim() === mongolianVowelSeparator && ("_" + mongolianVowelSeparator).trim() === "_" + mongolianVowelSeparator && (mongolianVowelSeparator + "_").trim() === mongolianVowelSeparator + "_") {
        return String.prototype.trim;
      }
      return implementation;
    };
  }
});

// ../../../node_modules/.pnpm/string.prototype.trim@1.2.9/node_modules/string.prototype.trim/shim.js
var require_shim = __commonJS({
  "../../../node_modules/.pnpm/string.prototype.trim@1.2.9/node_modules/string.prototype.trim/shim.js"(exports2, module2) {
    "use strict";
    init_process();
    init_buffer();
    var define = require_define_properties();
    var getPolyfill = require_polyfill();
    module2.exports = function shimStringTrim() {
      var polyfill = getPolyfill();
      define(String.prototype, { trim: polyfill }, {
        trim: function testTrim() {
          return String.prototype.trim !== polyfill;
        }
      });
      return polyfill;
    };
  }
});

// ../../../node_modules/.pnpm/string.prototype.trim@1.2.9/node_modules/string.prototype.trim/index.js
var require_string_prototype = __commonJS({
  "../../../node_modules/.pnpm/string.prototype.trim@1.2.9/node_modules/string.prototype.trim/index.js"(exports2, module2) {
    "use strict";
    init_process();
    init_buffer();
    var callBind = require_call_bind();
    var define = require_define_properties();
    var RequireObjectCoercible = require_RequireObjectCoercible();
    var implementation = require_implementation3();
    var getPolyfill = require_polyfill();
    var shim = require_shim();
    var bound = callBind(getPolyfill());
    var boundMethod = function trim(receiver) {
      RequireObjectCoercible(receiver);
      return bound(receiver);
    };
    define(boundMethod, {
      getPolyfill,
      implementation,
      shim
    });
    module2.exports = boundMethod;
  }
});

// ../../../node_modules/.pnpm/es-abstract@1.23.5/node_modules/es-abstract/2024/StringToNumber.js
var require_StringToNumber = __commonJS({
  "../../../node_modules/.pnpm/es-abstract@1.23.5/node_modules/es-abstract/2024/StringToNumber.js"(exports2, module2) {
    "use strict";
    init_process();
    init_buffer();
    var GetIntrinsic = require_get_intrinsic();
    var $Number = GetIntrinsic("%Number%");
    var $RegExp = GetIntrinsic("%RegExp%");
    var $TypeError = require_type();
    var $parseInteger = GetIntrinsic("%parseInt%");
    var callBound = require_callBound();
    var regexTester = require_safe_regex_test();
    var $strSlice = callBound("String.prototype.slice");
    var isBinary = regexTester(/^0b[01]+$/i);
    var isOctal = regexTester(/^0o[0-7]+$/i);
    var isInvalidHexLiteral = regexTester(/^[-+]0x[0-9a-f]+$/i);
    var nonWS = ["\x85", "\u200B", "\uFFFE"].join("");
    var nonWSregex = new $RegExp("[" + nonWS + "]", "g");
    var hasNonWS = regexTester(nonWSregex);
    var $trim = require_string_prototype();
    module2.exports = function StringToNumber(argument) {
      if (typeof argument !== "string") {
        throw new $TypeError("Assertion failed: `argument` is not a String");
      }
      if (isBinary(argument)) {
        return $Number($parseInteger($strSlice(argument, 2), 2));
      }
      if (isOctal(argument)) {
        return $Number($parseInteger($strSlice(argument, 2), 8));
      }
      if (hasNonWS(argument) || isInvalidHexLiteral(argument)) {
        return NaN;
      }
      var trimmed = $trim(argument);
      if (trimmed !== argument) {
        return StringToNumber(trimmed);
      }
      return $Number(argument);
    };
  }
});

// ../../../node_modules/.pnpm/es-abstract@1.23.5/node_modules/es-abstract/2024/substring.js
var require_substring = __commonJS({
  "../../../node_modules/.pnpm/es-abstract@1.23.5/node_modules/es-abstract/2024/substring.js"(exports2, module2) {
    "use strict";
    init_process();
    init_buffer();
    var $TypeError = require_type();
    var isInteger = require_isInteger();
    var callBound = require_callBound();
    var $slice = callBound("String.prototype.slice");
    module2.exports = function substring(S, inclusiveStart, exclusiveEnd) {
      if (typeof S !== "string" || !isInteger(inclusiveStart) || arguments.length > 2 && !isInteger(exclusiveEnd)) {
        throw new $TypeError("`S` must be a String, and `inclusiveStart` and `exclusiveEnd` must be integers");
      }
      return $slice(S, inclusiveStart, arguments.length > 2 ? exclusiveEnd : S.length);
    };
  }
});

// ../../../node_modules/.pnpm/es-abstract@1.23.5/node_modules/es-abstract/helpers/isStringOrUndefined.js
var require_isStringOrUndefined = __commonJS({
  "../../../node_modules/.pnpm/es-abstract@1.23.5/node_modules/es-abstract/helpers/isStringOrUndefined.js"(exports2, module2) {
    "use strict";
    init_process();
    init_buffer();
    module2.exports = function isStringOrUndefined(item) {
      return typeof item === "string" || typeof item === "undefined";
    };
  }
});

// ../../../node_modules/.pnpm/es-abstract@1.23.5/node_modules/es-abstract/helpers/isPrefixOf.js
var require_isPrefixOf = __commonJS({
  "../../../node_modules/.pnpm/es-abstract@1.23.5/node_modules/es-abstract/helpers/isPrefixOf.js"(exports2, module2) {
    "use strict";
    init_process();
    init_buffer();
    var $strSlice = require_callBound()("String.prototype.slice");
    module2.exports = function isPrefixOf(prefix, string) {
      if (prefix === string) {
        return true;
      }
      if (prefix.length > string.length) {
        return false;
      }
      return $strSlice(string, 0, prefix.length) === prefix;
    };
  }
});

// ../../../node_modules/.pnpm/es-abstract@1.23.5/node_modules/es-abstract/2024/GetSubstitution.js
var require_GetSubstitution = __commonJS({
  "../../../node_modules/.pnpm/es-abstract@1.23.5/node_modules/es-abstract/2024/GetSubstitution.js"(exports2, module2) {
    "use strict";
    init_process();
    init_buffer();
    var $TypeError = require_type();
    var regexTester = require_safe_regex_test();
    var every = require_every();
    var inspect2 = require_object_inspect();
    var Get = require_Get();
    var IsArray = require_IsArray2();
    var min = require_min();
    var StringIndexOf = require_StringIndexOf();
    var StringToNumber = require_StringToNumber();
    var substring = require_substring();
    var ToString = require_ToString();
    var Type2 = require_Type2();
    var isInteger = require_isInteger();
    var isStringOrUndefined = require_isStringOrUndefined();
    var isPrefixOf = require_isPrefixOf();
    var startsWithDollarDigit = regexTester(/^\$[0-9]/);
    var startsWithDollarTwoDigit = regexTester(/^\$[0-9][0-9]/);
    module2.exports = function GetSubstitution(matched, str, position, captures, namedCaptures, replacementTemplate) {
      if (typeof matched !== "string") {
        throw new $TypeError("Assertion failed: `matched` must be a String");
      }
      if (typeof str !== "string") {
        throw new $TypeError("Assertion failed: `str` must be a String");
      }
      if (!isInteger(position) || position < 0) {
        throw new $TypeError("Assertion failed: `position` must be a nonnegative integer, got " + inspect2(position));
      }
      if (!IsArray(captures) || !every(captures, isStringOrUndefined)) {
        throw new $TypeError("Assertion failed: `captures` must be a possibly-empty List of Strings or `undefined`, got " + inspect2(captures));
      }
      if (typeof namedCaptures !== "undefined" && Type2(namedCaptures) !== "Object") {
        throw new $TypeError("Assertion failed: `namedCaptures` must be `undefined` or an Object");
      }
      if (typeof replacementTemplate !== "string") {
        throw new $TypeError("Assertion failed: `replacementTemplate` must be a String");
      }
      var stringLength = str.length;
      if (position > stringLength) {
        throw new $TypeError("Assertion failed: position > stringLength, got " + inspect2(position));
      }
      var templateRemainder = replacementTemplate;
      var result = "";
      while (templateRemainder !== "") {
        var ref, refReplacement, capture;
        if (isPrefixOf("$$", templateRemainder)) {
          ref = "$$";
          refReplacement = "$";
        } else if (isPrefixOf("$`", templateRemainder)) {
          ref = "$`";
          refReplacement = substring(str, 0, position);
        } else if (isPrefixOf("$&", templateRemainder)) {
          ref = "$&";
          refReplacement = matched;
        } else if (isPrefixOf("$'", templateRemainder)) {
          ref = "$'";
          var matchLength = matched.length;
          var tailPos = position + matchLength;
          refReplacement = substring(str, min(tailPos, stringLength));
        } else if (startsWithDollarDigit(templateRemainder)) {
          var digitCount = startsWithDollarTwoDigit(templateRemainder) ? 2 : 1;
          var digits = substring(templateRemainder, 1, 1 + digitCount);
          var index = StringToNumber(digits);
          if (index < 0 || index > 99) {
            throw new $TypeError("Assertion failed: `index` must be >= 0 and <= 99");
          }
          var captureLen = captures.length;
          if (index > captureLen && digitCount === 2) {
            digitCount = 1;
            digits = substring(digits, 0, 1);
            index = StringToNumber(digits);
          }
          ref = substring(templateRemainder, 0, 1 + digitCount);
          if (1 <= index && index <= captureLen) {
            capture = captures[index - 1];
            if (typeof capture === "undefined") {
              refReplacement = "";
            } else {
              refReplacement = capture;
            }
          } else {
            refReplacement = ref;
          }
        } else if (isPrefixOf("$<", templateRemainder)) {
          var gtPos = StringIndexOf(templateRemainder, ">", 0);
          if (gtPos === -1 || typeof namedCaptures === "undefined") {
            ref = "$<";
            refReplacement = ref;
          } else {
            ref = substring(templateRemainder, 0, gtPos + 1);
            var groupName = substring(templateRemainder, 2, gtPos);
            if (Type2(namedCaptures) !== "Object") {
              throw new $TypeError("Assertion failed: Type(namedCaptures) is not Object");
            }
            capture = Get(namedCaptures, groupName);
            if (typeof capture === "undefined") {
              refReplacement = "";
            } else {
              refReplacement = ToString(capture);
            }
          }
        } else {
          ref = substring(templateRemainder, 0, 1);
          refReplacement = ref;
        }
        var refLength = ref.length;
        templateRemainder = substring(templateRemainder, refLength);
        result += refReplacement;
      }
      return result;
    };
  }
});

// ../../../node_modules/.pnpm/string.prototype.replaceall@1.0.10/node_modules/string.prototype.replaceall/implementation.js
var require_implementation4 = __commonJS({
  "../../../node_modules/.pnpm/string.prototype.replaceall@1.0.10/node_modules/string.prototype.replaceall/implementation.js"(exports2, module2) {
    "use strict";
    init_process();
    init_buffer();
    var Call = require_Call();
    var GetMethod = require_GetMethod();
    var GetSubstitution = require_GetSubstitution();
    var IsCallable = require_IsCallable();
    var RequireObjectCoercible = require_RequireObjectCoercible();
    var ToString = require_ToString();
    var StringIndexOf = require_StringIndexOf();
    var GetIntrinsic = require_get_intrinsic();
    var callBound = require_callBound();
    var hasSymbols = require_has_symbols()();
    var isRegex = require_is_regex();
    var max = GetIntrinsic("%Math.max%");
    var $TypeError = require_type();
    var $push = callBound("Array.prototype.push");
    var $slice = callBound("String.prototype.slice");
    var $indexOf = callBound("String.prototype.indexOf");
    var $replace = callBound("String.prototype.replace");
    module2.exports = function replaceAll(searchValue, replaceValue) {
      var O = RequireObjectCoercible(this);
      var searchValueIsRegex = isRegex(searchValue);
      if (searchValueIsRegex && $indexOf($slice(searchValue, searchValue.source.length + 2), "g") === -1) {
        throw new $TypeError("use .replace for a non-global regex. NOTE: this may be allowed in the future.");
      }
      if (hasSymbols && Symbol.replace) {
        if (searchValue != null) {
          var replacer = GetMethod(searchValue, Symbol.replace);
          if (typeof replacer !== "undefined") {
            return Call(replacer, searchValue, [O, replaceValue]);
          }
        }
      } else if (searchValueIsRegex) {
        return $replace(O, searchValue, replaceValue);
      }
      var string = ToString(O);
      var searchString = ToString(searchValue);
      var functionalReplace = IsCallable(replaceValue);
      if (!functionalReplace) {
        replaceValue = ToString(replaceValue);
      }
      var searchLength = searchString.length;
      var advanceBy = max(1, searchLength);
      var matchPositions = [];
      var position = StringIndexOf(string, searchString, 0);
      while (position !== -1) {
        $push(matchPositions, position);
        position = StringIndexOf(string, searchString, position + advanceBy);
      }
      var endOfLastMatch = 0;
      var result = "";
      for (var i = 0; i < matchPositions.length; i += 1) {
        var replacement;
        if (functionalReplace) {
          replacement = ToString(Call(replaceValue, void 0, [searchString, matchPositions[i], string]));
        } else {
          if (typeof replaceValue !== "string") {
            throw new $TypeError("Assertion failed: `replaceValue` should be a string at this point");
          }
          var captures = [];
          replacement = GetSubstitution(searchString, string, matchPositions[i], captures, void 0, replaceValue);
        }
        var stringSlice = $slice(string, endOfLastMatch, matchPositions[i]);
        result += stringSlice + replacement;
        endOfLastMatch = matchPositions[i] + searchLength;
      }
      if (endOfLastMatch < string.length) {
        result += $slice(string, endOfLastMatch);
      }
      return result;
    };
  }
});

// ../../../node_modules/.pnpm/string.prototype.replaceall@1.0.10/node_modules/string.prototype.replaceall/polyfill.js
var require_polyfill2 = __commonJS({
  "../../../node_modules/.pnpm/string.prototype.replaceall@1.0.10/node_modules/string.prototype.replaceall/polyfill.js"(exports2, module2) {
    "use strict";
    init_process();
    init_buffer();
    var implementation = require_implementation4();
    module2.exports = function getPolyfill() {
      return String.prototype.replaceAll || implementation;
    };
  }
});

// ../../../node_modules/.pnpm/string.prototype.replaceall@1.0.10/node_modules/string.prototype.replaceall/shim.js
var require_shim2 = __commonJS({
  "../../../node_modules/.pnpm/string.prototype.replaceall@1.0.10/node_modules/string.prototype.replaceall/shim.js"(exports2, module2) {
    "use strict";
    init_process();
    init_buffer();
    var define = require_define_properties();
    var getPolyfill = require_polyfill2();
    module2.exports = function shimReplaceAll() {
      var polyfill = getPolyfill();
      define(
        String.prototype,
        { replaceAll: polyfill },
        { replaceAll: function() {
          return String.prototype.replaceAll !== polyfill;
        } }
      );
      return polyfill;
    };
  }
});

// ../../../node_modules/.pnpm/string.prototype.replaceall@1.0.10/node_modules/string.prototype.replaceall/index.js
var require_string_prototype2 = __commonJS({
  "../../../node_modules/.pnpm/string.prototype.replaceall@1.0.10/node_modules/string.prototype.replaceall/index.js"(exports2, module2) {
    "use strict";
    init_process();
    init_buffer();
    var callBind = require_call_bind();
    var define = require_define_properties();
    var implementation = require_implementation4();
    var getPolyfill = require_polyfill2();
    var shim = require_shim2();
    var boundReplaceAll = callBind(implementation);
    define(boundReplaceAll, {
      getPolyfill,
      implementation,
      shim
    });
    module2.exports = boundReplaceAll;
  }
});

// src/index.ts
var src_exports = {};
__export(src_exports, {
  DynamicSnippetsGenerator: () => DynamicSnippetsGenerator
});
module.exports = __toCommonJS(src_exports);
init_process();
init_buffer();
var import_string_prototype = __toESM(require_string_prototype2(), 1);

// src/DynamicSnippetsGenerator.ts
init_process();
init_buffer();

// ../../../packages/commons/core-utils/lib/index.js
init_process();
init_buffer();

// ../../../packages/commons/core-utils/lib/assertNever.js
init_process();
init_buffer();
function assertNever(x) {
  throw new Error("Unexpected value: " + JSON.stringify(x));
}

// ../../../packages/commons/core-utils/lib/objects/keys.js
init_process();
init_buffer();
function keys(object) {
  return Object.keys(object);
}

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/lodash.js
init_process();
init_buffer();

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isSymbol.js
init_process();
init_buffer();

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseGetTag.js
init_process();
init_buffer();

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_Symbol.js
init_process();
init_buffer();

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_root.js
init_process();
init_buffer();

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_freeGlobal.js
init_process();
init_buffer();
var freeGlobal = typeof globalThis == "object" && globalThis && globalThis.Object === Object && globalThis;
var freeGlobal_default = freeGlobal;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_root.js
var freeSelf = typeof self == "object" && self && self.Object === Object && self;
var root = freeGlobal_default || freeSelf || Function("return this")();
var root_default = root;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_Symbol.js
var Symbol2 = root_default.Symbol;
var Symbol_default = Symbol2;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_getRawTag.js
init_process();
init_buffer();
var objectProto = Object.prototype;
var hasOwnProperty2 = objectProto.hasOwnProperty;
var nativeObjectToString = objectProto.toString;
var symToStringTag = Symbol_default ? Symbol_default.toStringTag : void 0;
function getRawTag(value) {
  var isOwn = hasOwnProperty2.call(value, symToStringTag), tag = value[symToStringTag];
  try {
    value[symToStringTag] = void 0;
    var unmasked = true;
  } catch (e) {
  }
  var result = nativeObjectToString.call(value);
  if (unmasked) {
    if (isOwn) {
      value[symToStringTag] = tag;
    } else {
      delete value[symToStringTag];
    }
  }
  return result;
}
var getRawTag_default = getRawTag;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_objectToString.js
init_process();
init_buffer();
var objectProto2 = Object.prototype;
var nativeObjectToString2 = objectProto2.toString;
function objectToString2(value) {
  return nativeObjectToString2.call(value);
}
var objectToString_default = objectToString2;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseGetTag.js
var nullTag = "[object Null]";
var undefinedTag = "[object Undefined]";
var symToStringTag2 = Symbol_default ? Symbol_default.toStringTag : void 0;
function baseGetTag(value) {
  if (value == null) {
    return value === void 0 ? undefinedTag : nullTag;
  }
  return symToStringTag2 && symToStringTag2 in Object(value) ? getRawTag_default(value) : objectToString_default(value);
}
var baseGetTag_default = baseGetTag;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isObjectLike.js
init_process();
init_buffer();
function isObjectLike(value) {
  return value != null && typeof value == "object";
}
var isObjectLike_default = isObjectLike;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isSymbol.js
var symbolTag = "[object Symbol]";
function isSymbol2(value) {
  return typeof value == "symbol" || isObjectLike_default(value) && baseGetTag_default(value) == symbolTag;
}
var isSymbol_default = isSymbol2;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseToString.js
init_process();
init_buffer();

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_arrayMap.js
init_process();
init_buffer();
function arrayMap(array, iteratee) {
  var index = -1, length = array == null ? 0 : array.length, result = Array(length);
  while (++index < length) {
    result[index] = iteratee(array[index], index, array);
  }
  return result;
}
var arrayMap_default = arrayMap;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isArray.js
init_process();
init_buffer();
var isArray2 = Array.isArray;
var isArray_default = isArray2;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseToString.js
var INFINITY = 1 / 0;
var symbolProto = Symbol_default ? Symbol_default.prototype : void 0;
var symbolToString = symbolProto ? symbolProto.toString : void 0;
function baseToString(value) {
  if (typeof value == "string") {
    return value;
  }
  if (isArray_default(value)) {
    return arrayMap_default(value, baseToString) + "";
  }
  if (isSymbol_default(value)) {
    return symbolToString ? symbolToString.call(value) : "";
  }
  var result = value + "";
  return result == "0" && 1 / value == -INFINITY ? "-0" : result;
}
var baseToString_default = baseToString;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/toString.js
init_process();
init_buffer();
function toString2(value) {
  return value == null ? "" : baseToString_default(value);
}
var toString_default = toString2;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/camelCase.js
init_process();
init_buffer();

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/capitalize.js
init_process();
init_buffer();

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/upperFirst.js
init_process();
init_buffer();

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_createCaseFirst.js
init_process();
init_buffer();

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_castSlice.js
init_process();
init_buffer();

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseSlice.js
init_process();
init_buffer();
function baseSlice(array, start, end) {
  var index = -1, length = array.length;
  if (start < 0) {
    start = -start > length ? 0 : length + start;
  }
  end = end > length ? length : end;
  if (end < 0) {
    end += length;
  }
  length = start > end ? 0 : end - start >>> 0;
  start >>>= 0;
  var result = Array(length);
  while (++index < length) {
    result[index] = array[index + start];
  }
  return result;
}
var baseSlice_default = baseSlice;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_castSlice.js
function castSlice(array, start, end) {
  var length = array.length;
  end = end === void 0 ? length : end;
  return !start && end >= length ? array : baseSlice_default(array, start, end);
}
var castSlice_default = castSlice;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_hasUnicode.js
init_process();
init_buffer();
var rsAstralRange = "\\ud800-\\udfff";
var rsComboMarksRange = "\\u0300-\\u036f";
var reComboHalfMarksRange = "\\ufe20-\\ufe2f";
var rsComboSymbolsRange = "\\u20d0-\\u20ff";
var rsComboRange = rsComboMarksRange + reComboHalfMarksRange + rsComboSymbolsRange;
var rsVarRange = "\\ufe0e\\ufe0f";
var rsZWJ = "\\u200d";
var reHasUnicode = RegExp("[" + rsZWJ + rsAstralRange + rsComboRange + rsVarRange + "]");
function hasUnicode(string) {
  return reHasUnicode.test(string);
}
var hasUnicode_default = hasUnicode;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_stringToArray.js
init_process();
init_buffer();

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_asciiToArray.js
init_process();
init_buffer();
function asciiToArray(string) {
  return string.split("");
}
var asciiToArray_default = asciiToArray;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_unicodeToArray.js
init_process();
init_buffer();
var rsAstralRange2 = "\\ud800-\\udfff";
var rsComboMarksRange2 = "\\u0300-\\u036f";
var reComboHalfMarksRange2 = "\\ufe20-\\ufe2f";
var rsComboSymbolsRange2 = "\\u20d0-\\u20ff";
var rsComboRange2 = rsComboMarksRange2 + reComboHalfMarksRange2 + rsComboSymbolsRange2;
var rsVarRange2 = "\\ufe0e\\ufe0f";
var rsAstral = "[" + rsAstralRange2 + "]";
var rsCombo = "[" + rsComboRange2 + "]";
var rsFitz = "\\ud83c[\\udffb-\\udfff]";
var rsModifier = "(?:" + rsCombo + "|" + rsFitz + ")";
var rsNonAstral = "[^" + rsAstralRange2 + "]";
var rsRegional = "(?:\\ud83c[\\udde6-\\uddff]){2}";
var rsSurrPair = "[\\ud800-\\udbff][\\udc00-\\udfff]";
var rsZWJ2 = "\\u200d";
var reOptMod = rsModifier + "?";
var rsOptVar = "[" + rsVarRange2 + "]?";
var rsOptJoin = "(?:" + rsZWJ2 + "(?:" + [rsNonAstral, rsRegional, rsSurrPair].join("|") + ")" + rsOptVar + reOptMod + ")*";
var rsSeq = rsOptVar + reOptMod + rsOptJoin;
var rsSymbol = "(?:" + [rsNonAstral + rsCombo + "?", rsCombo, rsRegional, rsSurrPair, rsAstral].join("|") + ")";
var reUnicode = RegExp(rsFitz + "(?=" + rsFitz + ")|" + rsSymbol + rsSeq, "g");
function unicodeToArray(string) {
  return string.match(reUnicode) || [];
}
var unicodeToArray_default = unicodeToArray;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_stringToArray.js
function stringToArray(string) {
  return hasUnicode_default(string) ? unicodeToArray_default(string) : asciiToArray_default(string);
}
var stringToArray_default = stringToArray;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_createCaseFirst.js
function createCaseFirst(methodName) {
  return function(string) {
    string = toString_default(string);
    var strSymbols = hasUnicode_default(string) ? stringToArray_default(string) : void 0;
    var chr = strSymbols ? strSymbols[0] : string.charAt(0);
    var trailing = strSymbols ? castSlice_default(strSymbols, 1).join("") : string.slice(1);
    return chr[methodName]() + trailing;
  };
}
var createCaseFirst_default = createCaseFirst;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/upperFirst.js
var upperFirst = createCaseFirst_default("toUpperCase");
var upperFirst_default = upperFirst;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/capitalize.js
function capitalize(string) {
  return upperFirst_default(toString_default(string).toLowerCase());
}
var capitalize_default = capitalize;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_createCompounder.js
init_process();
init_buffer();

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_arrayReduce.js
init_process();
init_buffer();
function arrayReduce(array, iteratee, accumulator, initAccum) {
  var index = -1, length = array == null ? 0 : array.length;
  if (initAccum && length) {
    accumulator = array[++index];
  }
  while (++index < length) {
    accumulator = iteratee(accumulator, array[index], index, array);
  }
  return accumulator;
}
var arrayReduce_default = arrayReduce;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/deburr.js
init_process();
init_buffer();

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_deburrLetter.js
init_process();
init_buffer();

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_basePropertyOf.js
init_process();
init_buffer();
function basePropertyOf(object) {
  return function(key) {
    return object == null ? void 0 : object[key];
  };
}
var basePropertyOf_default = basePropertyOf;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_deburrLetter.js
var deburredLetters = {
  // Latin-1 Supplement block.
  "\xC0": "A",
  "\xC1": "A",
  "\xC2": "A",
  "\xC3": "A",
  "\xC4": "A",
  "\xC5": "A",
  "\xE0": "a",
  "\xE1": "a",
  "\xE2": "a",
  "\xE3": "a",
  "\xE4": "a",
  "\xE5": "a",
  "\xC7": "C",
  "\xE7": "c",
  "\xD0": "D",
  "\xF0": "d",
  "\xC8": "E",
  "\xC9": "E",
  "\xCA": "E",
  "\xCB": "E",
  "\xE8": "e",
  "\xE9": "e",
  "\xEA": "e",
  "\xEB": "e",
  "\xCC": "I",
  "\xCD": "I",
  "\xCE": "I",
  "\xCF": "I",
  "\xEC": "i",
  "\xED": "i",
  "\xEE": "i",
  "\xEF": "i",
  "\xD1": "N",
  "\xF1": "n",
  "\xD2": "O",
  "\xD3": "O",
  "\xD4": "O",
  "\xD5": "O",
  "\xD6": "O",
  "\xD8": "O",
  "\xF2": "o",
  "\xF3": "o",
  "\xF4": "o",
  "\xF5": "o",
  "\xF6": "o",
  "\xF8": "o",
  "\xD9": "U",
  "\xDA": "U",
  "\xDB": "U",
  "\xDC": "U",
  "\xF9": "u",
  "\xFA": "u",
  "\xFB": "u",
  "\xFC": "u",
  "\xDD": "Y",
  "\xFD": "y",
  "\xFF": "y",
  "\xC6": "Ae",
  "\xE6": "ae",
  "\xDE": "Th",
  "\xFE": "th",
  "\xDF": "ss",
  // Latin Extended-A block.
  "\u0100": "A",
  "\u0102": "A",
  "\u0104": "A",
  "\u0101": "a",
  "\u0103": "a",
  "\u0105": "a",
  "\u0106": "C",
  "\u0108": "C",
  "\u010A": "C",
  "\u010C": "C",
  "\u0107": "c",
  "\u0109": "c",
  "\u010B": "c",
  "\u010D": "c",
  "\u010E": "D",
  "\u0110": "D",
  "\u010F": "d",
  "\u0111": "d",
  "\u0112": "E",
  "\u0114": "E",
  "\u0116": "E",
  "\u0118": "E",
  "\u011A": "E",
  "\u0113": "e",
  "\u0115": "e",
  "\u0117": "e",
  "\u0119": "e",
  "\u011B": "e",
  "\u011C": "G",
  "\u011E": "G",
  "\u0120": "G",
  "\u0122": "G",
  "\u011D": "g",
  "\u011F": "g",
  "\u0121": "g",
  "\u0123": "g",
  "\u0124": "H",
  "\u0126": "H",
  "\u0125": "h",
  "\u0127": "h",
  "\u0128": "I",
  "\u012A": "I",
  "\u012C": "I",
  "\u012E": "I",
  "\u0130": "I",
  "\u0129": "i",
  "\u012B": "i",
  "\u012D": "i",
  "\u012F": "i",
  "\u0131": "i",
  "\u0134": "J",
  "\u0135": "j",
  "\u0136": "K",
  "\u0137": "k",
  "\u0138": "k",
  "\u0139": "L",
  "\u013B": "L",
  "\u013D": "L",
  "\u013F": "L",
  "\u0141": "L",
  "\u013A": "l",
  "\u013C": "l",
  "\u013E": "l",
  "\u0140": "l",
  "\u0142": "l",
  "\u0143": "N",
  "\u0145": "N",
  "\u0147": "N",
  "\u014A": "N",
  "\u0144": "n",
  "\u0146": "n",
  "\u0148": "n",
  "\u014B": "n",
  "\u014C": "O",
  "\u014E": "O",
  "\u0150": "O",
  "\u014D": "o",
  "\u014F": "o",
  "\u0151": "o",
  "\u0154": "R",
  "\u0156": "R",
  "\u0158": "R",
  "\u0155": "r",
  "\u0157": "r",
  "\u0159": "r",
  "\u015A": "S",
  "\u015C": "S",
  "\u015E": "S",
  "\u0160": "S",
  "\u015B": "s",
  "\u015D": "s",
  "\u015F": "s",
  "\u0161": "s",
  "\u0162": "T",
  "\u0164": "T",
  "\u0166": "T",
  "\u0163": "t",
  "\u0165": "t",
  "\u0167": "t",
  "\u0168": "U",
  "\u016A": "U",
  "\u016C": "U",
  "\u016E": "U",
  "\u0170": "U",
  "\u0172": "U",
  "\u0169": "u",
  "\u016B": "u",
  "\u016D": "u",
  "\u016F": "u",
  "\u0171": "u",
  "\u0173": "u",
  "\u0174": "W",
  "\u0175": "w",
  "\u0176": "Y",
  "\u0177": "y",
  "\u0178": "Y",
  "\u0179": "Z",
  "\u017B": "Z",
  "\u017D": "Z",
  "\u017A": "z",
  "\u017C": "z",
  "\u017E": "z",
  "\u0132": "IJ",
  "\u0133": "ij",
  "\u0152": "Oe",
  "\u0153": "oe",
  "\u0149": "'n",
  "\u017F": "s"
};
var deburrLetter = basePropertyOf_default(deburredLetters);
var deburrLetter_default = deburrLetter;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/deburr.js
var reLatin = /[\xc0-\xd6\xd8-\xf6\xf8-\xff\u0100-\u017f]/g;
var rsComboMarksRange3 = "\\u0300-\\u036f";
var reComboHalfMarksRange3 = "\\ufe20-\\ufe2f";
var rsComboSymbolsRange3 = "\\u20d0-\\u20ff";
var rsComboRange3 = rsComboMarksRange3 + reComboHalfMarksRange3 + rsComboSymbolsRange3;
var rsCombo2 = "[" + rsComboRange3 + "]";
var reComboMark = RegExp(rsCombo2, "g");
function deburr(string) {
  string = toString_default(string);
  return string && string.replace(reLatin, deburrLetter_default).replace(reComboMark, "");
}
var deburr_default = deburr;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/words.js
init_process();
init_buffer();

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_asciiWords.js
init_process();
init_buffer();
var reAsciiWord = /[^\x00-\x2f\x3a-\x40\x5b-\x60\x7b-\x7f]+/g;
function asciiWords(string) {
  return string.match(reAsciiWord) || [];
}
var asciiWords_default = asciiWords;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_hasUnicodeWord.js
init_process();
init_buffer();
var reHasUnicodeWord = /[a-z][A-Z]|[A-Z]{2}[a-z]|[0-9][a-zA-Z]|[a-zA-Z][0-9]|[^a-zA-Z0-9 ]/;
function hasUnicodeWord(string) {
  return reHasUnicodeWord.test(string);
}
var hasUnicodeWord_default = hasUnicodeWord;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_unicodeWords.js
init_process();
init_buffer();
var rsAstralRange3 = "\\ud800-\\udfff";
var rsComboMarksRange4 = "\\u0300-\\u036f";
var reComboHalfMarksRange4 = "\\ufe20-\\ufe2f";
var rsComboSymbolsRange4 = "\\u20d0-\\u20ff";
var rsComboRange4 = rsComboMarksRange4 + reComboHalfMarksRange4 + rsComboSymbolsRange4;
var rsDingbatRange = "\\u2700-\\u27bf";
var rsLowerRange = "a-z\\xdf-\\xf6\\xf8-\\xff";
var rsMathOpRange = "\\xac\\xb1\\xd7\\xf7";
var rsNonCharRange = "\\x00-\\x2f\\x3a-\\x40\\x5b-\\x60\\x7b-\\xbf";
var rsPunctuationRange = "\\u2000-\\u206f";
var rsSpaceRange = " \\t\\x0b\\f\\xa0\\ufeff\\n\\r\\u2028\\u2029\\u1680\\u180e\\u2000\\u2001\\u2002\\u2003\\u2004\\u2005\\u2006\\u2007\\u2008\\u2009\\u200a\\u202f\\u205f\\u3000";
var rsUpperRange = "A-Z\\xc0-\\xd6\\xd8-\\xde";
var rsVarRange3 = "\\ufe0e\\ufe0f";
var rsBreakRange = rsMathOpRange + rsNonCharRange + rsPunctuationRange + rsSpaceRange;
var rsApos = "['\u2019]";
var rsBreak = "[" + rsBreakRange + "]";
var rsCombo3 = "[" + rsComboRange4 + "]";
var rsDigits = "\\d+";
var rsDingbat = "[" + rsDingbatRange + "]";
var rsLower = "[" + rsLowerRange + "]";
var rsMisc = "[^" + rsAstralRange3 + rsBreakRange + rsDigits + rsDingbatRange + rsLowerRange + rsUpperRange + "]";
var rsFitz2 = "\\ud83c[\\udffb-\\udfff]";
var rsModifier2 = "(?:" + rsCombo3 + "|" + rsFitz2 + ")";
var rsNonAstral2 = "[^" + rsAstralRange3 + "]";
var rsRegional2 = "(?:\\ud83c[\\udde6-\\uddff]){2}";
var rsSurrPair2 = "[\\ud800-\\udbff][\\udc00-\\udfff]";
var rsUpper = "[" + rsUpperRange + "]";
var rsZWJ3 = "\\u200d";
var rsMiscLower = "(?:" + rsLower + "|" + rsMisc + ")";
var rsMiscUpper = "(?:" + rsUpper + "|" + rsMisc + ")";
var rsOptContrLower = "(?:" + rsApos + "(?:d|ll|m|re|s|t|ve))?";
var rsOptContrUpper = "(?:" + rsApos + "(?:D|LL|M|RE|S|T|VE))?";
var reOptMod2 = rsModifier2 + "?";
var rsOptVar2 = "[" + rsVarRange3 + "]?";
var rsOptJoin2 = "(?:" + rsZWJ3 + "(?:" + [rsNonAstral2, rsRegional2, rsSurrPair2].join("|") + ")" + rsOptVar2 + reOptMod2 + ")*";
var rsOrdLower = "\\d*(?:1st|2nd|3rd|(?![123])\\dth)(?=\\b|[A-Z_])";
var rsOrdUpper = "\\d*(?:1ST|2ND|3RD|(?![123])\\dTH)(?=\\b|[a-z_])";
var rsSeq2 = rsOptVar2 + reOptMod2 + rsOptJoin2;
var rsEmoji = "(?:" + [rsDingbat, rsRegional2, rsSurrPair2].join("|") + ")" + rsSeq2;
var reUnicodeWord = RegExp([
  rsUpper + "?" + rsLower + "+" + rsOptContrLower + "(?=" + [rsBreak, rsUpper, "$"].join("|") + ")",
  rsMiscUpper + "+" + rsOptContrUpper + "(?=" + [rsBreak, rsUpper + rsMiscLower, "$"].join("|") + ")",
  rsUpper + "?" + rsMiscLower + "+" + rsOptContrLower,
  rsUpper + "+" + rsOptContrUpper,
  rsOrdUpper,
  rsOrdLower,
  rsDigits,
  rsEmoji
].join("|"), "g");
function unicodeWords(string) {
  return string.match(reUnicodeWord) || [];
}
var unicodeWords_default = unicodeWords;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/words.js
function words(string, pattern, guard) {
  string = toString_default(string);
  pattern = guard ? void 0 : pattern;
  if (pattern === void 0) {
    return hasUnicodeWord_default(string) ? unicodeWords_default(string) : asciiWords_default(string);
  }
  return string.match(pattern) || [];
}
var words_default = words;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_createCompounder.js
var rsApos2 = "['\u2019]";
var reApos = RegExp(rsApos2, "g");
function createCompounder(callback) {
  return function(string) {
    return arrayReduce_default(words_default(deburr_default(string).replace(reApos, "")), callback, "");
  };
}
var createCompounder_default = createCompounder;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/camelCase.js
var camelCase = createCompounder_default(function(result, word, index) {
  word = word.toLowerCase();
  return result + (index ? capitalize_default(word) : word);
});
var camelCase_default = camelCase;

// ../../browser-compatible-base/lib/ast/index.js
init_process();
init_buffer();

// ../../browser-compatible-base/lib/ast/AbstractAstNode.js
init_process();
init_buffer();
var AbstractAstNode = class {
};

// ../../browser-compatible-base/lib/ast/AbstractWriter.js
init_process();
init_buffer();

// ../../browser-compatible-base/lib/ast/CodeBlock.js
init_process();
init_buffer();
var CodeBlock = class extends AbstractAstNode {
  constructor(value) {
    super();
    __publicField(this, "value");
    this.value = value;
  }
  write(writer) {
    if (typeof this.value === "string") {
      writer.write(this.value);
    } else {
      this.value(writer);
    }
  }
};

// ../../browser-compatible-base/lib/ast/AbstractWriter.js
var TAB_SIZE = 4;
var AbstractWriter = class {
  constructor() {
    /* The contents being written */
    __publicField(this, "buffer", "");
    /* Indentation level (multiple of 4) */
    __publicField(this, "indentLevel", 0);
    /* Whether anything has been written to the buffer */
    __publicField(this, "hasWrittenAnything", false);
    /* Whether the last character written was a newline */
    __publicField(this, "lastCharacterIsNewline", false);
  }
  /**
   * Writes arbitrary text
   * @param text
   */
  write(text) {
    const textEndsInNewline = text.length > 0 && text.endsWith("\n");
    const textWithoutNewline = textEndsInNewline ? text.substring(0, text.length - 1) : text;
    const indent = this.getIndentString();
    let indentedText = textWithoutNewline.replaceAll("\n", `
${indent}`);
    if (this.isAtStartOfLine()) {
      indentedText = indent + indentedText;
    }
    if (textEndsInNewline) {
      indentedText += "\n";
    }
    this.writeInternal(indentedText);
  }
  /**
   * Writes arbitrary text without indentation
   * @param text
   */
  writeNoIndent(text) {
    const currIndentLevel = this.indentLevel;
    this.indentLevel = 0;
    this.write(text);
    this.indentLevel = currIndentLevel;
  }
  /**
   * Writes a node
   * @param node
   */
  writeNode(node) {
    node.write(this);
  }
  /**
   * Writes a node but then suffixes with a `;` and new line
   * @param node
   */
  writeNodeStatement(node) {
    node.write(this);
    this.write(";");
    this.writeNewLineIfLastLineNot();
  }
  /**
   * Writes text but then suffixes with a `;`
   * @param node
   */
  writeTextStatement(text) {
    const codeBlock = new CodeBlock(text);
    codeBlock.write(this);
    this.write(";");
    this.writeNewLineIfLastLineNot();
  }
  /**
   * Writes text but then suffixes with a `;`
   * @param node
   */
  controlFlow(prefix, statement) {
    const codeBlock = new CodeBlock(prefix);
    codeBlock.write(this);
    this.write(" (");
    this.writeNode(statement);
    this.write(") {");
    this.writeNewLineIfLastLineNot();
    this.indent();
  }
  /**
   * Writes text but then suffixes with a `;`
   * @param node
   */
  endControlFlow() {
    this.dedent();
    this.writeLine("}");
  }
  /**
   * Please try to not use this. It is here for swift.
   * @param titles
   * @param openingCharacter
   * @param callback
   * @param closingCharacter
   */
  openBlock(titles, openingCharacter = "{", callback, closingCharacter = "}") {
    const filteredTitles = titles.filter((title3) => title3 !== void 0).join(" ");
    if (filteredTitles) {
      this.write(`${filteredTitles} ${openingCharacter != null ? openingCharacter : ""}`);
    } else {
      this.write(openingCharacter != null ? openingCharacter : "");
    }
    try {
      this.indent();
      callback();
      this.dedent();
    } finally {
      this.write(closingCharacter != null ? closingCharacter : "");
    }
  }
  /* Only writes a newline if last line in the buffer is not a newline */
  writeLine(text = "") {
    this.write(text);
    this.writeNewLineIfLastLineNot();
  }
  /* Always writes newline */
  newLine() {
    this.writeInternal("\n");
  }
  writeNewLineIfLastLineNot() {
    if (!this.lastCharacterIsNewline) {
      this.writeInternal("\n");
    }
  }
  indent() {
    this.indentLevel++;
  }
  dedent() {
    this.indentLevel--;
  }
  delimit({ nodes, delimiter, writeFunction }) {
    if (nodes.length > 0) {
      const firstNode = nodes[0];
      if (firstNode != null) {
        writeFunction(firstNode);
      }
      for (let i = 1; i < nodes.length; i++) {
        this.write(delimiter);
        const node = nodes[i];
        if (node != null) {
          writeFunction(node);
        }
      }
    }
  }
  /*******************************
   * Helper Methods
   *******************************/
  writeInternal(text) {
    if (text.length > 0) {
      this.hasWrittenAnything = true;
      this.lastCharacterIsNewline = text.endsWith("\n");
    }
    return this.buffer += text;
  }
  isAtStartOfLine() {
    return this.lastCharacterIsNewline || !this.hasWrittenAnything;
  }
  getIndentString() {
    return " ".repeat(this.indentLevel * TAB_SIZE);
  }
};

// ../../browser-compatible-base/lib/dynamic-snippets/index.js
init_process();
init_buffer();

// ../../browser-compatible-base/lib/dynamic-snippets/AbstractDynamicSnippetsGenerator.js
init_process();
init_buffer();
var AbstractDynamicSnippetsGenerator = class {
  constructor(context) {
    __publicField(this, "context");
    this.context = context;
  }
};

// ../../browser-compatible-base/lib/dynamic-snippets/AbstractDynamicSnippetsGeneratorContext.js
init_process();
init_buffer();

// ../../../packages/cli/fern-definition/schema/lib/index.js
init_process();
init_buffer();

// ../../../packages/cli/fern-definition/schema/lib/utils/HttpEndpointReferenceParser.js
init_process();
init_buffer();
var HttpEndpointReferenceParser = class {
  constructor() {
    //eslint-disable-next-line
    __publicField(this, "REFERENCE_REGEX", /^(GET|POST|PUT|DELETE|PATCH)\s(\/[a-zA-Z0-9\/{}_-]*)$/);
  }
  validate(reference2) {
    const validFormat = this.REFERENCE_REGEX.test(reference2);
    if (!validFormat) {
      return { type: "invalid" };
    }
    return { type: "valid" };
  }
  tryParse(reference2) {
    const validationResponse = this.validate(reference2);
    if (validationResponse.type === "invalid") {
      return void 0;
    }
    const match = reference2.match(this.REFERENCE_REGEX);
    if (match == null || match[1] == null || match[2] == null) {
      return void 0;
    }
    return {
      method: match[1],
      path: match[2]
    };
  }
};

// ../../browser-compatible-base/lib/dynamic-snippets/ErrorReporter.js
init_process();
init_buffer();
var Severity = {
  Critical: "CRITICAL",
  Warning: "WARNING"
};
var ErrorReporter = class _ErrorReporter {
  constructor() {
    __publicField(this, "errors");
    __publicField(this, "path");
    this.errors = [];
    this.path = [];
  }
  add(err) {
    this.errors.push(__spreadProps(__spreadValues({}, err), {
      path: [...this.path]
    }));
  }
  scope(path) {
    this.path.push(path);
  }
  unscope() {
    this.path.pop();
  }
  getBySeverity(severity) {
    return this.errors.filter((err) => err.severity === severity);
  }
  empty() {
    return this.errors.length === 0;
  }
  size() {
    return this.errors.length;
  }
  clone() {
    const clone = new _ErrorReporter();
    clone.errors = [...this.errors];
    clone.path = [...this.path];
    return clone;
  }
  reset() {
    this.errors = [];
    this.path = [];
  }
  toDynamicSnippetErrors() {
    return this.errors.map((err) => ({
      severity: err.severity,
      path: err.path != null ? this.pathToStringArray(err.path) : void 0,
      message: err.message
    }));
  }
  pathToStringArray(path) {
    const result = [];
    for (const item of path) {
      if (typeof item === "string") {
        result.push(item);
        continue;
      }
      result[result.length - 1] += `[${item.index}]`;
    }
    return result;
  }
};

// ../../browser-compatible-base/lib/dynamic-snippets/AbstractDynamicSnippetsGeneratorContext.js
var AbstractDynamicSnippetsGeneratorContext = class {
  constructor({ ir, config: config3 }) {
    __publicField(this, "config");
    __publicField(this, "errors");
    __publicField(this, "_ir");
    __publicField(this, "httpEndpointReferenceParser");
    this._ir = ir;
    this.config = config3;
    this.errors = new ErrorReporter();
    this.httpEndpointReferenceParser = new HttpEndpointReferenceParser();
  }
  associateQueryParametersByWireValue({ parameters, values }) {
    const instances = [];
    for (const [key, value] of Object.entries(values)) {
      this.errors.scope(key);
      try {
        const parameter2 = parameters.find((param) => param.name.wireValue === key);
        if (parameter2 == null) {
          throw this.newParameterNotRecognizedError(key);
        }
        const typeInstanceValue = this.isListTypeReference(parameter2.typeReference) && !Array.isArray(value) ? [value] : value;
        instances.push({
          name: parameter2.name,
          typeReference: parameter2.typeReference,
          value: typeInstanceValue
        });
      } finally {
        this.errors.unscope();
      }
    }
    return instances;
  }
  associateByWireValue({ parameters, values, ignoreMissingParameters }) {
    const instances = [];
    for (const [key, value] of Object.entries(values)) {
      this.errors.scope(key);
      try {
        const parameter2 = parameters.find((param) => param.name.wireValue === key);
        if (parameter2 == null) {
          if (ignoreMissingParameters) {
            continue;
          }
          this.errors.add({
            severity: Severity.Critical,
            message: this.newParameterNotRecognizedError(key).message
          });
          continue;
        }
        instances.push({
          name: parameter2.name,
          typeReference: parameter2.typeReference,
          value
        });
      } finally {
        this.errors.unscope();
      }
    }
    return instances;
  }
  getSingleFileValue({ property, record }) {
    const fileValue = record[property.wireValue];
    if (fileValue == null) {
      return void 0;
    }
    if (typeof fileValue !== "string") {
      this.errors.add({
        severity: Severity.Critical,
        message: `Expected file value to be a string, got ${typeof fileValue}`
      });
      return void 0;
    }
    return fileValue;
  }
  getFileArrayValues({ property, record }) {
    const fileArrayValue = record[property.wireValue];
    if (fileArrayValue == null) {
      return void 0;
    }
    if (!Array.isArray(fileArrayValue)) {
      this.errors.add({
        severity: Severity.Critical,
        message: `Expected file array value to be an array of strings, got ${typeof fileArrayValue}`
      });
      return void 0;
    }
    const stringValues = [];
    for (const value of fileArrayValue) {
      if (typeof value !== "string") {
        this.errors.add({
          severity: Severity.Critical,
          message: `Expected file array value to be an array of strings, got ${typeof value}`
        });
        return void 0;
      }
      stringValues.push(value);
    }
    return stringValues;
  }
  getRecord(value) {
    if (typeof value !== "object" || Array.isArray(value)) {
      this.errors.add({
        severity: Severity.Critical,
        message: `Expected object with key, value pairs but got: ${Array.isArray(value) ? "array" : typeof value}`
      });
      return void 0;
    }
    if (value == null) {
      return {};
    }
    return value;
  }
  resolveNamedType({ typeId }) {
    const namedType = this._ir.types[typeId];
    if (namedType == null) {
      this.errors.add({
        severity: Severity.Critical,
        message: `Type identified by "${typeId}" could not be found`
      });
      return void 0;
    }
    return namedType;
  }
  resolveDiscriminatedUnionTypeInstance({ discriminatedUnion, value }) {
    const record = this.getRecord(value);
    if (record == null) {
      return void 0;
    }
    const discriminantFieldName = discriminatedUnion.discriminant.wireValue;
    const discriminantValue = record[discriminantFieldName];
    if (discriminantValue == null) {
      this.errors.add({
        severity: Severity.Critical,
        message: this.newParameterNotRecognizedError(discriminantFieldName).message
      });
      return void 0;
    }
    if (typeof discriminantValue !== "string") {
      this.errors.add({
        severity: Severity.Critical,
        message: `Expected discriminant value to be a string but got: ${typeof discriminantValue}`
      });
      return void 0;
    }
    const singleDiscriminatedUnionType = discriminatedUnion.types[discriminantValue];
    if (singleDiscriminatedUnionType == null) {
      this.errors.add({
        severity: Severity.Critical,
        message: `No type found for discriminant value "${discriminantValue}"`
      });
      return void 0;
    }
    const _a = record, { [discriminantFieldName]: _ } = _a, filtered = __objRest(_a, [__restKey(discriminantFieldName)]);
    return {
      singleDiscriminatedUnionType,
      discriminantValue: singleDiscriminatedUnionType.discriminantValue,
      value: filtered
    };
  }
  resolveEndpointOrThrow(rawEndpoint) {
    const parsedEndpoint = this.httpEndpointReferenceParser.tryParse(rawEndpoint);
    if (parsedEndpoint == null) {
      throw new Error(`Failed to parse endpoint reference "${rawEndpoint}"`);
    }
    return this.resolveEndpointLocationOrThrow(parsedEndpoint);
  }
  resolveEndpointLocationOrThrow(location) {
    const endpoints = [];
    for (const endpoint of Object.values(this._ir.endpoints)) {
      if (this.parsedEndpointMatches({ endpoint, parsedEndpoint: location })) {
        endpoints.push(endpoint);
      }
    }
    if (endpoints.length === 0) {
      throw new Error(`Failed to find endpoint identified by "${location.method} ${location.path}"`);
    }
    return endpoints;
  }
  needsRequestParameter({ request, inlinePathParameters, inlineFileProperties }) {
    var _a;
    if (this.includePathParametersInWrappedRequest({ request, inlinePathParameters })) {
      return true;
    }
    if (request.queryParameters != null && request.queryParameters.length > 0) {
      return true;
    }
    if (request.headers != null && request.headers.length > 0) {
      return true;
    }
    if (request.body != null) {
      return this.includeRequestBodyInWrappedRequest({ body: request.body, inlineFileProperties });
    }
    if ((_a = request.metadata) == null ? void 0 : _a.onlyPathParameters) {
      return false;
    }
    return true;
  }
  includePathParametersInWrappedRequest({ request, inlinePathParameters }) {
    var _a, _b;
    return inlinePathParameters && ((_b = (_a = request.metadata) == null ? void 0 : _a.includePathParameters) != null ? _b : false);
  }
  isFileUploadRequestBody(body) {
    switch (body.type) {
      case "fileUpload":
        return true;
      case "properties":
      case "referenced":
        return false;
      default:
        assertNever(body);
    }
  }
  resolveEnvironmentName(environmentID) {
    if (this._ir.environments == null) {
      return void 0;
    }
    const environments = this._ir.environments.environments;
    switch (environments.type) {
      case "singleBaseUrl": {
        const environment = environments.environments.find((env3) => env3.id === environmentID);
        if (environment == null) {
          return void 0;
        }
        return environment.name;
      }
      case "multipleBaseUrls": {
        const environment = environments.environments.find((env3) => env3.id === environmentID);
        if (environment == null) {
          return void 0;
        }
        return environment.name;
      }
      default:
        assertNever(environments);
    }
  }
  isSingleEnvironmentID(environment) {
    return typeof environment === "string";
  }
  isMultiEnvironmentValues(environment) {
    return typeof environment === "object";
  }
  validateMultiEnvironmentUrlValues(multiEnvironmentUrlValues) {
    if (this._ir.environments == null) {
      this.errors.add({
        severity: Severity.Critical,
        message: "Multiple environments are not supported for single base URL environments; use the baseUrl option instead"
      });
      return false;
    }
    const environments = this._ir.environments.environments;
    switch (environments.type) {
      case "singleBaseUrl": {
        this.errors.add({
          severity: Severity.Critical,
          message: "Multiple environments are not supported for single base URL environments; use the baseUrl option instead"
        });
        return false;
      }
      case "multipleBaseUrls": {
        const firstEnvironment = environments.environments[0];
        if (firstEnvironment == null) {
          this.errors.add({
            severity: Severity.Critical,
            message: "Multiple environments are not supported; use the baseUrl option instead"
          });
          return false;
        }
        const expectedKeys = new Set(keys(firstEnvironment.urls));
        for (const key of keys(multiEnvironmentUrlValues)) {
          if (expectedKeys.has(key)) {
            expectedKeys.delete(key);
          }
        }
        if (expectedKeys.size > 0) {
          this.errors.add({
            severity: Severity.Critical,
            message: `The provided environments are invalid; got: [${Object.keys(multiEnvironmentUrlValues).join(", ")}], expected: [${keys(firstEnvironment.urls).join(", ")}]`
          });
          return false;
        }
        return true;
      }
    }
  }
  getValueAsNumber({ value }) {
    if (typeof value !== "number") {
      this.errors.add({
        severity: Severity.Critical,
        message: this.newTypeMismatchError({ expected: "number", value }).message
      });
      return void 0;
    }
    return value;
  }
  getValueAsBoolean({ value }) {
    if (typeof value !== "boolean") {
      this.errors.add({
        severity: Severity.Critical,
        message: this.newTypeMismatchError({ expected: "boolean", value }).message
      });
      return void 0;
    }
    return value;
  }
  getValueAsString({ value }) {
    if (typeof value !== "string") {
      this.errors.add({
        severity: Severity.Critical,
        message: this.newTypeMismatchError({ expected: "string", value }).message
      });
      return void 0;
    }
    return value;
  }
  newAuthMismatchError({ auth, values }) {
    return new Error(`Expected auth type ${auth.type}, got ${values.type}`);
  }
  newParameterNotRecognizedError(parameterName) {
    return new Error(`"${parameterName}" is not a recognized parameter for this endpoint`);
  }
  newTypeMismatchError({ expected, value }) {
    return new Error(`Expected ${expected}, got ${typeof value}`);
  }
  includeRequestBodyInWrappedRequest({ body, inlineFileProperties }) {
    switch (body.type) {
      case "properties":
      case "referenced":
        return true;
      case "fileUpload":
        return this.includeFileUploadBodyInWrappedRequest({ fileUpload: body, inlineFileProperties });
      default:
        assertNever(body);
    }
  }
  includeFileUploadBodyInWrappedRequest({ fileUpload, inlineFileProperties }) {
    return this.fileUploadHasBodyProperties({ fileUpload }) || inlineFileProperties && this.fileUploadHasFileProperties({ fileUpload });
  }
  fileUploadHasBodyProperties({ fileUpload }) {
    return fileUpload.properties.some((property) => {
      switch (property.type) {
        case "file":
        case "fileArray":
          return false;
        case "bodyProperty":
          return true;
        default:
          assertNever(property);
      }
    });
  }
  fileUploadHasFileProperties({ fileUpload }) {
    return fileUpload.properties.some((property) => {
      switch (property.type) {
        case "file":
        case "fileArray":
          return true;
        case "bodyProperty":
          return false;
        default:
          assertNever(property);
      }
    });
  }
  isListTypeReference(typeReference) {
    if (typeReference.type === "optional") {
      return this.isListTypeReference(typeReference.value);
    }
    return typeReference.type === "list" || typeReference.type === "set";
  }
  parsedEndpointMatches({ endpoint, parsedEndpoint }) {
    return endpoint.location.method === parsedEndpoint.method && endpoint.location.path === parsedEndpoint.path;
  }
};

// ../../browser-compatible-base/lib/dynamic-snippets/Result.js
init_process();
init_buffer();
var Result = class {
  constructor() {
    __publicField(this, "reporter");
    __publicField(this, "snippet");
    __publicField(this, "err");
    this.snippet = void 0;
    this.reporter = void 0;
    this.err = void 0;
  }
  update({ context, snippet }) {
    if (this.reporter == null || this.reporter.size() > context.errors.size()) {
      this.reporter = context.errors.clone();
      this.snippet = snippet;
    }
  }
  getResponseOrThrow({ endpoint }) {
    var _a;
    if (this.snippet != null && this.reporter != null) {
      return {
        snippet: this.snippet,
        errors: this.reporter.toDynamicSnippetErrors()
      };
    }
    throw (_a = this.err) != null ? _a : new Error(`Failed to generate snippet for endpoint "${endpoint.method} ${endpoint.path}"`);
  }
};

// ../../browser-compatible-base/lib/dynamic-snippets/Scope.js
init_process();
init_buffer();
var Scope = {
  PathParameters: "pathParameters",
  QueryParameters: "queryParameters",
  Headers: "headers",
  RequestBody: "requestBody"
};

// src/EndpointSnippetGenerator.ts
init_process();
init_buffer();

// ../ast/lib/index.js
init_process();
init_buffer();

// ../ast/lib/typescript.js
var typescript_exports = {};
__export(typescript_exports, {
  AstNode: () => AstNode,
  ClassInstantiation: () => ClassInstantiation,
  CodeBlock: () => CodeBlock2,
  Comment: () => Comment,
  Function: () => Function2,
  FunctionInvocation: () => FunctionInvocation,
  MethodInvocation: () => MethodInvocation,
  Parameter: () => Parameter,
  Reference: () => Reference,
  Type: () => Type,
  TypeLiteral: () => TypeLiteral,
  Types: () => Type,
  Variable: () => Variable,
  Writer: () => Writer,
  codeblock: () => codeblock,
  function_: () => function_,
  instantiateClass: () => instantiateClass,
  invokeFunction: () => invokeFunction,
  invokeMethod: () => invokeMethod,
  parameter: () => parameter,
  reference: () => reference,
  variable: () => variable
});
init_process();
init_buffer();

// ../ast/lib/ast/index.js
init_process();
init_buffer();

// ../ast/lib/ast/core/index.js
init_process();
init_buffer();

// ../ast/lib/ast/core/AstNode.js
init_process();
init_buffer();

// ../ast/lib/ast/core/Writer.js
init_process();
init_buffer();
var Writer = class extends AbstractWriter {
  constructor({ customConfig }) {
    super();
    __publicField(this, "customConfig");
    __publicField(this, "imports", {});
    __publicField(this, "defaultImports", {});
    __publicField(this, "starImportAliases", {});
    __publicField(this, "starImportAliasesInverse", {});
    this.customConfig = customConfig;
  }
  /**
   * Adds the given import under its module name.
   */
  addImport(reference2) {
    var _a, _b, _c;
    if (reference2.importFrom != null) {
      switch (reference2.importFrom.type) {
        case "default": {
          this.validateDefault(reference2);
          break;
        }
        case "named": {
          this.validateNamed(reference2);
          break;
        }
        case "star": {
          this.validateStar(reference2);
          break;
        }
      }
      const moduleImports = (_c = (_a = this.imports)[_b = reference2.importFrom.moduleName]) != null ? _c : _a[_b] = [];
      const names = moduleImports.map((import_) => import_.name);
      if (!names.includes(reference2.name)) {
        moduleImports.push(reference2);
      }
    }
  }
  validateDefault(reference2) {
    var _a, _b, _c, _d;
    if (((_a = reference2.importFrom) == null ? void 0 : _a.type) !== "default") {
      return;
    }
    const moduleDefault = (_d = (_b = this.defaultImports)[_c = reference2.importFrom.moduleName]) != null ? _d : _b[_c] = reference2;
    if (moduleDefault.name !== reference2.name) {
      throw new Error(`Cannot have multiple default imports for module ${reference2.importFrom.moduleName}: got ${reference2.name} but already had ${moduleDefault.name}`);
    }
  }
  validateNamed(reference2) {
    var _a, _b, _c, _d, _e;
    if (((_a = reference2.importFrom) == null ? void 0 : _a.type) !== "named") {
      return;
    }
    const existing = (_b = this.imports[reference2.importFrom.moduleName]) != null ? _b : [];
    const existingStar = existing.filter((e) => {
      var _a2;
      return ((_a2 = e.importFrom) == null ? void 0 : _a2.type) === "star";
    });
    if (existingStar.length > 0) {
      throw new Error(`Cannot add named import ${reference2.name} because non-named imports ${existingStar.map((e) => e.name)} already exist`);
    }
    const duplicates = [];
    for (const references of Object.values(this.imports)) {
      for (const ref of references) {
        if (((_c = ref.importFrom) == null ? void 0 : _c.type) === "named" && ref.importFrom.moduleName !== reference2.importFrom.moduleName && ref.name === reference2.name) {
          duplicates.push(ref);
        }
      }
    }
    if (duplicates.length > 0) {
      throw new Error(`Cannot add named import from module ${reference2.importFrom.moduleName} because it is already imported from ${(_e = (_d = duplicates[0]) == null ? void 0 : _d.importFrom) == null ? void 0 : _e.moduleName}`);
    }
  }
  validateStar(reference2) {
    var _a, _b, _c, _d, _e, _f, _g;
    if (((_a = reference2.importFrom) == null ? void 0 : _a.type) !== "star") {
      return;
    }
    const moduleAlias = (_d = (_b = this.starImportAliases)[_c = reference2.importFrom.moduleName]) != null ? _d : _b[_c] = reference2.importFrom.starImportAlias;
    if (moduleAlias !== reference2.importFrom.starImportAlias) {
      throw new Error(`Cannot have more than one alias for non-named imports from a module: got ${reference2.importFrom.starImportAlias} but already have ${moduleAlias}.`);
    }
    const aliasModule = (_g = (_e = this.starImportAliasesInverse)[_f = reference2.importFrom.starImportAlias]) != null ? _g : _e[_f] = reference2.importFrom.moduleName;
    if (aliasModule !== reference2.importFrom.moduleName) {
      throw new Error(`Attempted to use alias ${reference2.importFrom.starImportAlias} for more than one module in the same file`);
    }
  }
  toString() {
    const imports = this.stringifyImports();
    if (imports.length > 0) {
      return imports + "\n" + this.buffer;
    }
    return this.buffer;
  }
  stringifyImports() {
    let result = "";
    for (const [module2, references] of Object.entries(this.imports)) {
      const defaultImport = this.defaultImports[module2];
      let stringifiedNonDefault = "";
      const named = references.filter((r) => {
        var _a;
        return ((_a = r.importFrom) == null ? void 0 : _a.type) === "named";
      });
      const starImportAlias = this.starImportAliases[module2];
      if (named.length > 0 || defaultImport != null || starImportAlias != null) {
        result += "import";
        if (defaultImport != null) {
          result += ` ${defaultImport.name}`;
        }
        if (named.length > 0) {
          for (const ref of named.slice(0, -1)) {
            stringifiedNonDefault += `${ref.name}, `;
          }
          const lastRef = named[named.length - 1];
          if (lastRef != null) {
            stringifiedNonDefault += `${lastRef.name}`;
          }
          if (defaultImport != null) {
            result += ",";
          }
          result += ` { ${stringifiedNonDefault} }`;
        }
        if (starImportAlias != null) {
          if (defaultImport != null || named.length > 0) {
            result += ", ";
          }
          result += ` * as ${starImportAlias}`;
        }
        result += ` from "${module2}";
`;
      }
    }
    return result;
  }
};

// ../ast/lib/ast/core/AstNode.js
var AstNode = class extends AbstractAstNode {
  /**
   * Writes the node to a string.
   */
  async toString({ customConfig }) {
    const writer = new Writer({ customConfig });
    this.write(writer);
    return writer.toString();
  }
  toStringSync({ customConfig }) {
    const writer = new Writer({ customConfig });
    this.write(writer);
    return writer.toString();
  }
};

// ../ast/lib/ast/CodeBlock.js
init_process();
init_buffer();
var CodeBlock2 = class extends AstNode {
  constructor(args) {
    super();
    __publicField(this, "args");
    this.args = args;
  }
  write(writer) {
    const commonCodeBlock = new CodeBlock(this.args);
    return commonCodeBlock.write(writer);
  }
};

// ../ast/lib/ast/Type.js
init_process();
init_buffer();
var Type = class extends AstNode {
  constructor(internalType) {
    super();
    __publicField(this, "internalType");
    this.internalType = internalType;
  }
  write(writer) {
    switch (this.internalType.type) {
      case "string":
        writer.write("string");
        break;
      case "number":
        writer.write("number");
        break;
      case "bigint":
        writer.write("bigint");
        break;
      case "boolean":
        writer.write("boolean");
        break;
      case "array":
        this.internalType.valueType.write(writer);
        writer.write("[]");
        break;
      case "map":
        writer.write("Record<");
        this.internalType.keyType.write(writer);
        writer.write(", ");
        this.internalType.valueType.write(writer);
        writer.write(">");
        break;
      case "object":
        writer.write("{");
        writer.indent();
        for (const [key, value] of Object.entries(this.internalType.fields)) {
          writer.write(`${key}: `);
          value.write(writer);
          writer.writeLine(",");
        }
        writer.dedent();
        writer.write("}");
        break;
      case "enum":
        writer.write("enum");
        break;
      case "any":
        writer.write("any");
        break;
      case "promise":
        writer.write("Promise<");
        this.internalType.value.write(writer);
        writer.write(">");
        break;
      case "unknown":
        writer.write("unknown");
        break;
      case "void":
        writer.write("void");
        break;
      case "undefined":
        writer.write("undefined");
        break;
      case "null":
        writer.write("null");
        break;
      case "never":
        writer.write("never");
        break;
      case "nop":
        break;
      default:
        assertNever(this.internalType);
    }
  }
  /* Static factory methods for creating a Type */
  static string() {
    return new this({
      type: "string"
    });
  }
  static number() {
    return new this({
      type: "number"
    });
  }
  static bigint() {
    return new this({
      type: "bigint"
    });
  }
  static boolean() {
    return new this({
      type: "boolean"
    });
  }
  static array(valueType) {
    return new this({
      type: "array",
      valueType
    });
  }
  static object(fields) {
    return new this({
      type: "object",
      fields
    });
  }
  static enum(values) {
    return new this({
      type: "enum",
      values
    });
  }
  static any() {
    return new this({
      type: "any"
    });
  }
  static promise(value) {
    if (value.internalType.type === "promise") {
      return value;
    }
    return new this({
      type: "promise",
      value
    });
  }
  static unknown() {
    return new this({
      type: "unknown"
    });
  }
  static void() {
    return new this({
      type: "void"
    });
  }
  static undefined() {
    return new this({
      type: "undefined"
    });
  }
  static null() {
    return new this({
      type: "null"
    });
  }
  static never() {
    return new this({
      type: "never"
    });
  }
  static nop() {
    return new this({
      type: "nop"
    });
  }
};

// ../ast/lib/ast/TypeLiteral.js
init_process();
init_buffer();
var TypeLiteral = class _TypeLiteral extends AstNode {
  constructor(internalType) {
    super();
    __publicField(this, "internalType");
    this.internalType = internalType;
  }
  write(writer) {
    var _a, _b, _c, _d;
    switch (this.internalType.type) {
      case "array": {
        this.writeIterable({ writer, iterable: this.internalType });
        break;
      }
      case "blob": {
        if ((_a = writer.customConfig) == null ? void 0 : _a.noSerdeLayer) {
          writer.writeNode(_TypeLiteral.string(this.internalType.value));
          return;
        }
        writer.write("new Blob([");
        writer.writeNode(_TypeLiteral.string(this.internalType.value));
        writer.write("])");
        break;
      }
      case "boolean": {
        writer.write(this.internalType.value.toString());
        break;
      }
      case "bigint": {
        if ((_b = writer.customConfig) == null ? void 0 : _b.noSerdeLayer) {
          writer.writeNode(_TypeLiteral.string(this.internalType.value.toString()));
          return;
        }
        writer.write(`BigInt(${this.internalType.value.toString()})`);
        break;
      }
      case "datetime": {
        if ((_c = writer.customConfig) == null ? void 0 : _c.noSerdeLayer) {
          writer.writeNode(_TypeLiteral.string(this.internalType.value));
          return;
        }
        writer.write("new Date(");
        writer.writeNode(_TypeLiteral.string(this.internalType.value));
        writer.write(")");
        break;
      }
      case "number": {
        writer.write(this.internalType.value.toString());
        break;
      }
      case "object": {
        this.writeObject({ writer, object: this.internalType });
        break;
      }
      case "record": {
        this.writeRecord({ writer, record: this.internalType });
        break;
      }
      case "reference": {
        writer.writeNode(this.internalType.value);
        break;
      }
      case "set": {
        if (((_d = writer.customConfig) == null ? void 0 : _d.noSerdeLayer) || this.isSetOfObjects()) {
          writer.writeNode(_TypeLiteral.array({ values: this.internalType.values }));
          return;
        }
        writer.write("new Set(");
        this.writeIterable({ writer, iterable: this.internalType });
        writer.write(")");
        break;
      }
      case "string": {
        if (this.internalType.value.includes("\n")) {
          this.writeStringWithBackticks({ writer, value: this.internalType.value });
        } else {
          writer.write(`"${this.internalType.value.replaceAll('"', '\\"')}"`);
        }
        break;
      }
      case "tuple": {
        this.writeIterable({ writer, iterable: this.internalType });
        break;
      }
      case "unknown": {
        this.writeUnknown({ writer, value: this.internalType.value });
        break;
      }
      case "nop":
        break;
      default:
        assertNever(this.internalType);
    }
  }
  isObject() {
    return this.internalType.type === "object";
  }
  asObjectOrThrow() {
    if (this.isObject()) {
      return this.internalType;
    }
    throw new Error("Internal error; ts.TypeLiteral is not an object");
  }
  isSet() {
    return this.internalType.type === "set";
  }
  asSetOrThrow() {
    if (this.isSet()) {
      return this.internalType;
    }
    throw new Error("Internal error; ts.TypeLiteral is not a set");
  }
  isSetOfObjects() {
    return this.isSet() && this.asSetOrThrow().values.every((value) => value.isObject());
  }
  writeStringWithBackticks({ writer, value }) {
    writer.write("`");
    const parts = value.split("\n");
    const head = parts[0] + "\n";
    const tail = parts.slice(1).join("\n");
    writer.write(head.replaceAll("`", "\\`"));
    writer.writeNoIndent(tail.replaceAll("`", "\\`"));
    writer.write("`");
  }
  writeIterable({ writer, iterable }) {
    const values = filterNopValues({ values: iterable.values });
    if (values.length === 0) {
      writer.write("[]");
      return;
    }
    writer.writeLine("[");
    writer.indent();
    for (const value of values) {
      value.write(writer);
      writer.writeLine(",");
    }
    writer.dedent();
    writer.write("]");
  }
  writeRecord({ writer, record }) {
    const entries = filterNopRecordEntries({ entries: record.entries });
    if (entries.length === 0) {
      writer.write("{}");
      return;
    }
    writer.writeLine("{");
    writer.indent();
    for (const entry of entries) {
      entry.key.write(writer);
      writer.write(": ");
      entry.value.write(writer);
      writer.writeLine(",");
    }
    writer.dedent();
    writer.write("}");
  }
  writeObject({ writer, object }) {
    const fields = filterNopObjectFields({ fields: object.fields });
    if (fields.length === 0) {
      writer.write("{}");
      return;
    }
    writer.writeLine("{");
    writer.indent();
    for (const field of fields) {
      writer.write(`${field.name}: `);
      field.value.write(writer);
      writer.writeLine(",");
    }
    writer.dedent();
    writer.write("}");
  }
  /* Static factory methods for creating a TypeLiteral */
  static array({ values }) {
    return new this({
      type: "array",
      values
    });
  }
  static bigint(value) {
    return new this({ type: "bigint", value });
  }
  static blob(value) {
    return new this({ type: "blob", value });
  }
  static boolean(value) {
    return new this({ type: "boolean", value });
  }
  static datetime(value) {
    return new this({ type: "datetime", value });
  }
  static number(value) {
    return new this({ type: "number", value });
  }
  static object({ fields }) {
    return new this({
      type: "object",
      fields
    });
  }
  static record({ entries }) {
    return new this({
      type: "record",
      entries
    });
  }
  static reference(value) {
    return new this({
      type: "reference",
      value
    });
  }
  static set({ values }) {
    return new this({
      type: "set",
      values
    });
  }
  static string(value) {
    return new this({
      type: "string",
      value
    });
  }
  static tuple({ values }) {
    return new this({
      type: "tuple",
      values
    });
  }
  static unknown(value) {
    return new this({ type: "unknown", value });
  }
  static nop() {
    return new this({ type: "nop" });
  }
  static isNop(typeLiteral) {
    return typeLiteral.internalType.type === "nop";
  }
  writeUnknown({ writer, value }) {
    switch (typeof value) {
      case "boolean":
        writer.write(value.toString());
        return;
      case "string":
        writer.write(value.includes('"') ? `\`${value}\`` : `"${value}"`);
        return;
      case "number":
        writer.write(value.toString());
        return;
      case "object":
        if (value == null) {
          writer.write("null");
          return;
        }
        if (Array.isArray(value)) {
          this.writeUnknownArray({ writer, value });
          return;
        }
        this.writeUnknownObject({ writer, value });
        return;
      default:
        throw new Error(`Internal error; unsupported unknown type: ${typeof value}`);
    }
  }
  writeUnknownArray({ writer, value }) {
    if (value.length === 0) {
      writer.write("[]");
      return;
    }
    writer.writeLine("[");
    writer.indent();
    for (const element of value) {
      writer.writeNode(_TypeLiteral.unknown(element));
      writer.writeLine(",");
    }
    writer.dedent();
    writer.write("]");
  }
  writeUnknownObject({ writer, value }) {
    const entries = Object.entries(value);
    if (entries.length === 0) {
      writer.write("{}");
      return;
    }
    writer.writeLine("{");
    writer.indent();
    for (const [key, val] of entries) {
      writer.write(`${key}: `);
      writer.writeNode(_TypeLiteral.unknown(val));
      writer.writeLine(",");
    }
    writer.dedent();
    writer.write("}");
  }
};
function filterNopObjectFields({ fields }) {
  return fields.filter((field) => !TypeLiteral.isNop(field.value));
}
function filterNopRecordEntries({ entries }) {
  return entries.filter((entry) => !TypeLiteral.isNop(entry.key) && !TypeLiteral.isNop(entry.value));
}
function filterNopValues({ values }) {
  return values.filter((value) => !TypeLiteral.isNop(value));
}

// ../ast/lib/ast/Reference.js
init_process();
init_buffer();
var Reference = class extends AstNode {
  constructor({ name, importFrom, memberName }) {
    super();
    __publicField(this, "name");
    __publicField(this, "importFrom");
    __publicField(this, "memberName");
    this.name = name;
    this.importFrom = importFrom;
    this.memberName = memberName;
  }
  write(writer) {
    var _a;
    if (this.importFrom != null) {
      writer.addImport(this);
    }
    const prefix = ((_a = this.importFrom) == null ? void 0 : _a.type) === "star" ? `${this.importFrom.starImportAlias}.` : "";
    const suffix = this.memberName != null ? `.${this.memberName}` : "";
    writer.write(`${prefix}${this.name}${suffix}`);
  }
};

// ../ast/lib/ast/Variable.js
init_process();
init_buffer();
var Variable = class extends AstNode {
  constructor(args) {
    super();
    __publicField(this, "args");
    this.args = args;
  }
  write(writer) {
    if (this.args.export) {
      writer.write("export ");
    }
    if (this.args.const) {
      writer.write("const ");
    } else {
      writer.write("let ");
    }
    writer.write(`${this.args.name} = `);
    writer.writeNode(this.args.initializer);
  }
};

// ../ast/lib/ast/Parameter.js
init_process();
init_buffer();

// ../ast/lib/ast/Comment.js
init_process();
init_buffer();
var Comment = class extends AstNode {
  constructor({ docs } = { docs: void 0 }) {
    super();
    __publicField(this, "docs");
    this.docs = docs;
  }
  write(writer) {
    if (this.docs != null) {
      writer.writeLine("/**");
      this.docs.split("\n").forEach((line) => {
        writer.writeLine(` * ${line}`);
      });
      writer.writeLine("*/");
    }
  }
};

// ../ast/lib/ast/Parameter.js
var Parameter = class extends AstNode {
  constructor({ name, type, docs }) {
    super();
    __publicField(this, "name");
    __publicField(this, "type");
    __publicField(this, "docs");
    this.name = name;
    this.type = type;
    this.docs = docs;
  }
  write(writer) {
    writer.write(`${this.name}`);
  }
  writeWithType(writer) {
    if (this.docs != null) {
      writer.writeNode(new Comment({ docs: this.docs }));
    }
    writer.write(`${this.name}: `);
    this.type.write(writer);
  }
};

// ../ast/lib/ast/Function.js
init_process();
init_buffer();
var Function2 = class extends AstNode {
  constructor({ name, parameters, async, body, return_, docs }) {
    super();
    __publicField(this, "name");
    __publicField(this, "parameters");
    __publicField(this, "async");
    __publicField(this, "body");
    __publicField(this, "return_");
    __publicField(this, "docs");
    this.name = name;
    this.parameters = parameters;
    this.async = async != null ? async : false;
    this.body = body;
    this.return_ = return_;
    this.docs = docs;
  }
  write(writer) {
    var _a;
    writer.writeNode(new Comment({ docs: this.docs }));
    if (this.async) {
      writer.write("async ");
    }
    writer.write("function ");
    writer.write(`${this.name}`);
    this.writeParameters(writer);
    if (this.return_ != null) {
      writer.write(": ");
      writer.writeNode(this.async ? Type.promise(this.return_) : this.return_);
    }
    writer.writeLine(" {");
    writer.indent();
    (_a = this.body) == null ? void 0 : _a.write(writer);
    writer.dedent();
    writer.writeNewLineIfLastLineNot();
    writer.writeLine("}");
  }
  writeParameters(writer) {
    if (this.parameters.length === 0) {
      writer.write("()");
      return;
    }
    writer.writeLine("(");
    writer.delimit({
      nodes: this.parameters,
      delimiter: ",\n",
      writeFunction: (parameter2) => parameter2.writeWithType(writer)
    });
    writer.write(")");
  }
};

// ../ast/lib/ast/FunctionInvocation.js
init_process();
init_buffer();
var FunctionInvocation = class extends AstNode {
  constructor({ function_: function_2, arguments_ }) {
    super();
    __publicField(this, "function_");
    __publicField(this, "arguments_");
    this.function_ = function_2;
    this.arguments_ = arguments_;
  }
  write(writer) {
    writer.writeNode(this.function_);
    writer.write("(");
    writer.delimit({
      nodes: this.arguments_,
      delimiter: ", ",
      writeFunction: (argument) => argument.write(writer)
    });
    writer.write(")");
  }
};

// ../ast/lib/ast/MethodInvocation.js
init_process();
init_buffer();
var MethodInvocation = class extends AstNode {
  constructor({ on: on3, method, arguments_, async }) {
    super();
    __publicField(this, "on");
    __publicField(this, "method");
    __publicField(this, "arguments_");
    __publicField(this, "async");
    this.on = on3;
    this.method = method;
    this.arguments_ = arguments_;
    this.async = async;
  }
  write(writer) {
    if (this.async) {
      writer.write("await ");
    }
    this.on.write(writer);
    writer.write(".");
    writer.write(this.method);
    writer.write("(");
    writer.delimit({
      nodes: this.arguments_,
      delimiter: ", ",
      writeFunction: (argument) => argument.write(writer)
    });
    writer.write(")");
  }
};

// ../ast/lib/ast/ClassInstantiation.js
init_process();
init_buffer();
var ClassInstantiation = class extends AstNode {
  constructor({ class_, arguments_ }) {
    super();
    __publicField(this, "class_");
    __publicField(this, "arguments_");
    this.class_ = class_;
    this.arguments_ = arguments_;
  }
  write(writer) {
    writer.write("new ");
    writer.writeNode(this.class_);
    writer.write("(");
    writer.delimit({
      nodes: this.arguments_,
      delimiter: ", ",
      writeFunction: (argument) => argument.write(writer)
    });
    writer.write(")");
  }
};

// ../ast/lib/typescript.js
function codeblock(arg) {
  return new CodeBlock2(arg);
}
function function_(args) {
  return new Function2(args);
}
function instantiateClass(args) {
  return new ClassInstantiation(args);
}
function invokeFunction(args) {
  return new FunctionInvocation(args);
}
function invokeMethod(args) {
  return new MethodInvocation(args);
}
function parameter(args) {
  return new Parameter(args);
}
function reference(arg) {
  return new Reference(arg);
}
function variable(arg) {
  return new Variable(arg);
}

// src/EndpointSnippetGenerator.ts
var CLIENT_VAR_NAME = "client";
var MAIN_FUNCTION_NAME = "main";
var STRING_TYPE_REFERENCE = {
  type: "primitive",
  value: "STRING"
};
var EndpointSnippetGenerator = class {
  constructor({ context }) {
    __publicField(this, "context");
    this.context = context;
  }
  async generateSnippet({
    endpoint,
    request
  }) {
    const code = this.buildCodeBlock({ endpoint, snippet: request });
    return await code.toString({ customConfig: this.context.customConfig });
  }
  generateSnippetSync({
    endpoint,
    request
  }) {
    const code = this.buildCodeBlock({ endpoint, snippet: request });
    return code.toStringSync({ customConfig: this.context.customConfig });
  }
  buildCodeBlock({
    endpoint,
    snippet
  }) {
    return typescript_exports.codeblock((writer) => {
      writer.writeNode(
        typescript_exports.function_({
          name: MAIN_FUNCTION_NAME,
          async: true,
          parameters: [],
          body: typescript_exports.codeblock((writer2) => {
            writer2.writeNodeStatement(this.constructClient({ endpoint, snippet }));
            writer2.writeNodeStatement(this.callMethod({ endpoint, snippet }));
          })
        })
      );
      writer.writeNodeStatement(
        typescript_exports.invokeFunction({
          function_: typescript_exports.reference({
            name: MAIN_FUNCTION_NAME
          }),
          arguments_: []
        })
      );
    });
  }
  constructClient({
    endpoint,
    snippet
  }) {
    return typescript_exports.variable({
      name: CLIENT_VAR_NAME,
      const: true,
      initializer: typescript_exports.instantiateClass({
        class_: typescript_exports.reference({
          name: this.context.getRootClientName(),
          importFrom: this.context.getModuleImport()
        }),
        arguments_: [this.getConstructorArgs({ endpoint, snippet })]
      })
    });
  }
  getConstructorArgs({
    endpoint,
    snippet
  }) {
    const fields = [];
    const environmentArgs = this.getConstructorEnvironmentArgs({
      baseUrl: snippet.baseURL,
      environment: snippet.environment
    });
    if (environmentArgs.length > 0) {
      fields.push(...environmentArgs);
    }
    if (endpoint.auth != null) {
      if (snippet.auth != null) {
        fields.push(...this.getConstructorAuthArgs({ auth: endpoint.auth, values: snippet.auth }));
      } else {
        this.context.errors.add({
          severity: Severity.Warning,
          message: `Auth with ${endpoint.auth.type} configuration is required for this endpoint`
        });
      }
    }
    this.context.errors.scope(Scope.Headers);
    if (this.context.ir.headers != null && snippet.headers != null) {
      fields.push(
        ...this.getConstructorHeaderArgs({ headers: this.context.ir.headers, values: snippet.headers })
      );
    }
    this.context.errors.unscope();
    if (fields.length === 0) {
      return typescript_exports.TypeLiteral.nop();
    }
    return typescript_exports.TypeLiteral.object({ fields });
  }
  getConstructorEnvironmentArgs({
    baseUrl,
    environment
  }) {
    const environmentValue = this.getEnvironmentValue({ baseUrl, environment });
    if (environmentValue == null) {
      return [];
    }
    return [
      {
        name: "environment",
        value: environmentValue
      }
    ];
  }
  getEnvironmentValue({
    baseUrl,
    environment
  }) {
    if (baseUrl != null && environment != null) {
      this.context.errors.add({
        severity: Severity.Critical,
        message: "Cannot specify both baseUrl and environment options"
      });
      return void 0;
    }
    if (baseUrl != null) {
      return typescript_exports.TypeLiteral.string(baseUrl);
    }
    if (environment != null) {
      if (this.context.isSingleEnvironmentID(environment)) {
        const environmentTypeReference = this.context.getEnvironmentTypeReferenceFromID(environment);
        if (environmentTypeReference == null) {
          this.context.errors.add({
            severity: Severity.Warning,
            message: `Environment ${JSON.stringify(environment)} was not found`
          });
          return void 0;
        }
        return typescript_exports.TypeLiteral.reference(environmentTypeReference);
      }
      if (this.context.isMultiEnvironmentValues(environment)) {
        if (!this.context.validateMultiEnvironmentUrlValues(environment)) {
          return void 0;
        }
        return typescript_exports.TypeLiteral.object({
          fields: Object.entries(environment).map(([key, value]) => ({
            name: key,
            value: this.context.dynamicTypeLiteralMapper.convert({
              typeReference: STRING_TYPE_REFERENCE,
              value
            })
          }))
        });
      }
    }
    return void 0;
  }
  getConstructorAuthArgs({
    auth,
    values
  }) {
    switch (auth.type) {
      case "basic":
        if (values.type !== "basic") {
          this.context.errors.add({
            severity: Severity.Critical,
            message: this.context.newAuthMismatchError({ auth, values }).message
          });
          return [];
        }
        return this.getConstructorBasicAuthArg({ auth, values });
      case "bearer":
        if (values.type !== "bearer") {
          this.context.errors.add({
            severity: Severity.Critical,
            message: this.context.newAuthMismatchError({ auth, values }).message
          });
          return [];
        }
        return this.getConstructorBearerAuthArgs({ auth, values });
      case "header":
        if (values.type !== "header") {
          this.context.errors.add({
            severity: Severity.Critical,
            message: this.context.newAuthMismatchError({ auth, values }).message
          });
          return [];
        }
        return this.getConstructorHeaderAuthArgs({ auth, values });
      default:
        assertNever(auth);
    }
  }
  getConstructorBasicAuthArg({
    auth,
    values
  }) {
    return [
      {
        name: this.context.getPropertyName(auth.username),
        value: typescript_exports.TypeLiteral.string(values.username)
      },
      {
        name: this.context.getPropertyName(auth.password),
        value: typescript_exports.TypeLiteral.string(values.password)
      }
    ];
  }
  getConstructorBearerAuthArgs({
    auth,
    values
  }) {
    return [
      {
        name: this.context.getPropertyName(auth.token),
        value: typescript_exports.TypeLiteral.string(values.token)
      }
    ];
  }
  getConstructorHeaderAuthArgs({
    auth,
    values
  }) {
    return [
      {
        name: this.context.getPropertyName(auth.header.name.name),
        value: this.context.dynamicTypeLiteralMapper.convert({
          typeReference: auth.header.typeReference,
          value: values.value
        })
      }
    ];
  }
  getConstructorHeaderArgs({
    headers,
    values
  }) {
    const fields = [];
    for (const header of headers) {
      const field = this.getConstructorHeaderArg({ header, value: values.value });
      if (field != null) {
        fields.push(field);
      }
    }
    return fields;
  }
  getConstructorHeaderArg({
    header,
    value
  }) {
    const typeLiteral = this.context.dynamicTypeLiteralMapper.convert({
      typeReference: header.typeReference,
      value
    });
    if (typescript_exports.TypeLiteral.isNop(typeLiteral)) {
      return void 0;
    }
    return {
      name: this.context.getPropertyName(header.name.name),
      value: typeLiteral
    };
  }
  callMethod({
    endpoint,
    snippet
  }) {
    return typescript_exports.invokeMethod({
      on: typescript_exports.reference({ name: CLIENT_VAR_NAME }),
      method: this.getMethod({ endpoint }),
      async: true,
      arguments_: this.getMethodArgs({ endpoint, snippet })
    });
  }
  getMethodArgs({
    endpoint,
    snippet
  }) {
    switch (endpoint.request.type) {
      case "inlined":
        return this.getMethodArgsForInlinedRequest({ request: endpoint.request, snippet });
      case "body":
        return this.getMethodArgsForBodyRequest({ request: endpoint.request, snippet });
      default:
        assertNever(endpoint.request);
    }
  }
  getMethodArgsForBodyRequest({
    request,
    snippet
  }) {
    const args = [];
    this.context.errors.scope(Scope.PathParameters);
    if (request.pathParameters != null) {
      const pathParameterFields = this.getPathParameters({ namedParameters: request.pathParameters, snippet });
      args.push(...pathParameterFields.map((field) => field.value));
    }
    this.context.errors.unscope();
    this.context.errors.scope(Scope.RequestBody);
    if (request.body != null) {
      args.push(this.getBodyRequestArg({ body: request.body, value: snippet.requestBody }));
    }
    this.context.errors.unscope();
    return args;
  }
  getBodyRequestArg({
    body,
    value
  }) {
    switch (body.type) {
      case "bytes":
        return this.getBytesBodyRequestArg({ value });
      case "typeReference":
        return this.context.dynamicTypeLiteralMapper.convert({ typeReference: body.value, value });
      default:
        assertNever(body);
    }
  }
  getBytesBodyRequestArg({ value }) {
    if (typeof value !== "string") {
      this.context.errors.add({
        severity: Severity.Critical,
        message: `Expected bytes value to be a string, got ${typeof value}`
      });
      return typescript_exports.TypeLiteral.nop();
    }
    return typescript_exports.TypeLiteral.blob(value);
  }
  getMethodArgsForInlinedRequest({
    request,
    snippet
  }) {
    var _a, _b, _c, _d;
    const args = [];
    const { inlinePathParameters, inlineFileProperties } = {
      inlinePathParameters: (_b = (_a = this.context.customConfig) == null ? void 0 : _a.inlinePathParameters) != null ? _b : false,
      inlineFileProperties: (_d = (_c = this.context.customConfig) == null ? void 0 : _c.inlineFileProperties) != null ? _d : false
    };
    this.context.errors.scope(Scope.PathParameters);
    const pathParameterFields = [];
    if (request.pathParameters != null) {
      pathParameterFields.push(...this.getPathParameters({ namedParameters: request.pathParameters, snippet }));
    }
    this.context.errors.unscope();
    this.context.errors.scope(Scope.RequestBody);
    const filePropertyInfo = this.getFilePropertyInfo({ request, snippet });
    this.context.errors.unscope();
    if (!this.context.includePathParametersInWrappedRequest({
      request,
      inlinePathParameters
    })) {
      args.push(...pathParameterFields.map((field) => field.value));
    }
    if (!inlineFileProperties) {
      args.push(...filePropertyInfo.fileFields.map((field) => field.value));
    }
    if (this.context.needsRequestParameter({
      request,
      inlinePathParameters,
      inlineFileProperties
    })) {
      args.push(
        this.getInlinedRequestArg({
          request,
          snippet,
          pathParameterFields: this.context.includePathParametersInWrappedRequest({
            request,
            inlinePathParameters
          }) ? pathParameterFields : [],
          filePropertyInfo
        })
      );
    }
    return args;
  }
  getFilePropertyInfo({
    request,
    snippet
  }) {
    if (request.body == null || !this.context.isFileUploadRequestBody(request.body)) {
      return {
        fileFields: [],
        bodyPropertyFields: []
      };
    }
    return this.context.filePropertyMapper.getFilePropertyInfo({
      body: request.body,
      value: snippet.requestBody
    });
  }
  getInlinedRequestArg({
    request,
    snippet,
    pathParameterFields,
    filePropertyInfo
  }) {
    var _a, _b, _c, _d;
    this.context.errors.scope(Scope.QueryParameters);
    const queryParameters = this.context.associateQueryParametersByWireValue({
      parameters: (_a = request.queryParameters) != null ? _a : [],
      values: (_b = snippet.queryParameters) != null ? _b : {}
    });
    const queryParameterFields = queryParameters.map((queryParameter) => ({
      name: this.context.getPropertyName(queryParameter.name.name),
      value: this.context.dynamicTypeLiteralMapper.convert(queryParameter)
    }));
    this.context.errors.unscope();
    this.context.errors.scope(Scope.Headers);
    const headers = this.context.associateByWireValue({
      parameters: (_c = request.headers) != null ? _c : [],
      values: (_d = snippet.headers) != null ? _d : {}
    });
    const headerFields = headers.map((header) => ({
      name: this.context.getPropertyName(header.name.name),
      value: this.context.dynamicTypeLiteralMapper.convert(header)
    }));
    this.context.errors.unscope();
    this.context.errors.scope(Scope.RequestBody);
    const requestBodyFields = request.body != null ? this.getInlinedRequestBodyObjectFields({
      body: request.body,
      value: snippet.requestBody,
      filePropertyInfo
    }) : [];
    this.context.errors.unscope();
    return typescript_exports.TypeLiteral.object({
      fields: [...pathParameterFields, ...queryParameterFields, ...headerFields, ...requestBodyFields]
    });
  }
  getInlinedRequestBodyObjectFields({
    body,
    value,
    filePropertyInfo
  }) {
    switch (body.type) {
      case "properties":
        return this.getInlinedRequestBodyPropertyObjectFields({ parameters: body.value, value });
      case "referenced":
        return [this.getReferencedRequestBodyPropertyObjectField({ body, value })];
      case "fileUpload":
        return this.getFileUploadRequestBodyObjectFields({ filePropertyInfo });
      default:
        assertNever(body);
    }
  }
  getFileUploadRequestBodyObjectFields({
    filePropertyInfo
  }) {
    var _a;
    if ((_a = this.context.customConfig) == null ? void 0 : _a.inlineFileProperties) {
      return [...filePropertyInfo.fileFields, ...filePropertyInfo.bodyPropertyFields];
    }
    return filePropertyInfo.bodyPropertyFields;
  }
  getReferencedRequestBodyPropertyObjectField({
    body,
    value
  }) {
    return {
      name: this.context.getPropertyName(body.bodyKey),
      value: this.getReferencedRequestBodyPropertyTypeLiteral({ body: body.bodyType, value })
    };
  }
  getReferencedRequestBodyPropertyTypeLiteral({
    body,
    value
  }) {
    switch (body.type) {
      case "bytes":
        return this.getBytesBodyRequestArg({ value });
      case "typeReference":
        return this.context.dynamicTypeLiteralMapper.convert({ typeReference: body.value, value });
      default:
        assertNever(body);
    }
  }
  getInlinedRequestBodyPropertyObjectFields({
    parameters,
    value
  }) {
    var _a;
    const fields = [];
    const bodyProperties = this.context.associateByWireValue({
      parameters,
      values: (_a = this.context.getRecord(value)) != null ? _a : {}
    });
    for (const parameter2 of bodyProperties) {
      fields.push({
        name: this.context.getPropertyName(parameter2.name.name),
        value: this.context.dynamicTypeLiteralMapper.convert(parameter2)
      });
    }
    return fields;
  }
  getPathParameters({
    namedParameters,
    snippet
  }) {
    var _a;
    const args = [];
    const pathParameters = this.context.associateByWireValue({
      parameters: namedParameters,
      values: (_a = snippet.pathParameters) != null ? _a : {}
    });
    for (const parameter2 of pathParameters) {
      args.push({
        name: this.context.getPropertyName(parameter2.name.name),
        value: this.context.dynamicTypeLiteralMapper.convert(parameter2)
      });
    }
    return args;
  }
  getMethod({ endpoint }) {
    if (endpoint.declaration.fernFilepath.allParts.length > 0) {
      return `${endpoint.declaration.fernFilepath.allParts.map((val) => this.context.getMethodName(val)).join(".")}.${this.context.getMethodName(endpoint.declaration.name)}`;
    }
    return this.context.getMethodName(endpoint.declaration.name);
  }
};

// src/context/DynamicSnippetsGeneratorContext.ts
init_process();
init_buffer();

// ../browser-compatible-base/lib/utils/index.js
init_process();
init_buffer();

// ../browser-compatible-base/lib/utils/constructNpmPackage.js
init_process();
init_buffer();
function constructNpmPackage({ generatorConfig, isPackagePrivate }) {
  var _a;
  const outputMode = generatorConfig.output.mode;
  switch (outputMode.type) {
    case "downloadFiles":
      return void 0;
    case "publish":
      return {
        packageName: outputMode.registriesV2.npm.packageName,
        version: outputMode.version,
        private: isPackagePrivate,
        publishInfo: {
          registryUrl: outputMode.registriesV2.npm.registryUrl,
          token: outputMode.registriesV2.npm.token
        },
        license: void 0,
        repoUrl: void 0
      };
    case "github":
      if (outputMode.publishInfo != null && outputMode.publishInfo.type !== "npm") {
        throw new Error(`Expected to receive npm publish info but received ${outputMode.publishInfo.type} instead`);
      }
      return {
        packageName: outputMode.publishInfo != null ? outputMode.publishInfo.packageName : "",
        version: outputMode.version,
        private: isPackagePrivate,
        publishInfo: void 0,
        repoUrl: outputMode.repoUrl,
        license: (_a = generatorConfig.license) == null ? void 0 : _a._visit({
          basic: (basic) => basic.id,
          custom: (custom) => `See ${custom.filename}`,
          _other: () => {
            return void 0;
          }
        })
      };
    default:
      throw new Error(`Encountered unknown output mode: ${outputMode}`);
  }
}

// ../browser-compatible-base/lib/utils/getNamespaceExport.js
init_process();
init_buffer();
function getNamespaceExport({ organization, workspaceName, namespaceExport }) {
  return namespaceExport != null ? namespaceExport : `${upperFirst_default(camelCase_default(organization))}${upperFirst_default(camelCase_default(workspaceName))}`;
}

// src/context/DynamicTypeLiteralMapper.ts
init_process();
init_buffer();
var UNION_VALUE_KEY = "value";
var DynamicTypeLiteralMapper = class {
  constructor({ context }) {
    __publicField(this, "context");
    this.context = context;
  }
  convert(args) {
    if (args.value == null) {
      return typescript_exports.TypeLiteral.nop();
    }
    switch (args.typeReference.type) {
      case "list":
        return this.convertList({ list: args.typeReference.value, value: args.value });
      case "literal":
        return this.convertLiteral({ literalType: args.typeReference.value, value: args.value });
      case "map":
        return this.convertMap({ map: args.typeReference, value: args.value });
      case "named": {
        const named = this.context.resolveNamedType({ typeId: args.typeReference.value });
        if (named == null) {
          return typescript_exports.TypeLiteral.nop();
        }
        return this.convertNamed({ named, value: args.value, as: args.as });
      }
      case "optional":
        return this.convert({ typeReference: args.typeReference.value, value: args.value, as: args.as });
      case "primitive":
        return this.convertPrimitive({ primitive: args.typeReference.value, value: args.value, as: args.as });
      case "set":
        return this.convertSet({ set: args.typeReference.value, value: args.value });
      case "unknown":
        return this.convertUnknown({ value: args.value });
      default:
        assertNever(args.typeReference);
    }
  }
  convertLiteral({
    literalType,
    value
  }) {
    switch (literalType.type) {
      case "boolean": {
        const bool = this.context.getValueAsBoolean({ value });
        if (bool == null) {
          return typescript_exports.TypeLiteral.nop();
        }
        return typescript_exports.TypeLiteral.boolean(bool);
      }
      case "string": {
        const str = this.context.getValueAsString({ value });
        if (str == null) {
          return typescript_exports.TypeLiteral.nop();
        }
        return typescript_exports.TypeLiteral.string(str);
      }
      default:
        assertNever(literalType);
    }
  }
  convertList({ list, value }) {
    if (!Array.isArray(value)) {
      this.context.errors.add({
        severity: Severity.Critical,
        message: `Expected array but got: ${typeof value}`
      });
      return typescript_exports.TypeLiteral.nop();
    }
    return typescript_exports.TypeLiteral.array({
      values: value.map((v, index) => {
        this.context.errors.scope({ index });
        try {
          return this.convert({ typeReference: list, value: v });
        } finally {
          this.context.errors.unscope();
        }
      })
    });
  }
  convertSet({ set, value }) {
    if (!Array.isArray(value)) {
      this.context.errors.add({
        severity: Severity.Critical,
        message: `Expected array but got: ${typeof value}`
      });
      return typescript_exports.TypeLiteral.nop();
    }
    return typescript_exports.TypeLiteral.set({
      values: value.map((v, index) => {
        this.context.errors.scope({ index });
        try {
          return this.convert({ typeReference: set, value: v });
        } finally {
          this.context.errors.unscope();
        }
      })
    });
  }
  convertMap({ map, value }) {
    if (typeof value !== "object" || value == null) {
      this.context.errors.add({
        severity: Severity.Critical,
        message: `Expected object but got: ${value == null ? "null" : typeof value}`
      });
      return typescript_exports.TypeLiteral.nop();
    }
    return typescript_exports.TypeLiteral.record({
      entries: Object.entries(value).map(([key, value2]) => {
        this.context.errors.scope(key);
        try {
          return {
            key: this.convert({ typeReference: map.key, value: key, as: "key" }),
            value: this.convert({ typeReference: map.value, value: value2 })
          };
        } finally {
          this.context.errors.unscope();
        }
      })
    });
  }
  convertNamed({
    named,
    value,
    as
  }) {
    var _a;
    switch (named.type) {
      case "alias": {
        if ((_a = this.context.customConfig) == null ? void 0 : _a.useBrandedStringAliases) {
          return typescript_exports.TypeLiteral.reference(
            typescript_exports.codeblock((writer) => {
              writer.writeNode(
                typescript_exports.reference({
                  name: this.context.namespaceExport,
                  importFrom: this.context.getModuleImport(),
                  memberName: this.context.getFullyQualifiedReference({
                    declaration: named.declaration
                  })
                })
              );
              writer.write("(");
              writer.writeNode(this.convert({ typeReference: named.typeReference, value, as }));
              writer.write(")");
            })
          );
        }
        return this.convert({ typeReference: named.typeReference, value, as });
      }
      case "discriminatedUnion":
        return this.convertDiscriminatedUnion({
          discriminatedUnion: named,
          value
        });
      case "enum":
        return this.convertEnum({ enum_: named, value });
      case "object":
        return this.convertObject({ object_: named, value });
      case "undiscriminatedUnion":
        return this.convertUndicriminatedUnion({ undicriminatedUnion: named, value });
      default:
        assertNever(named);
    }
  }
  convertDiscriminatedUnion({
    discriminatedUnion,
    value
  }) {
    var _a;
    const discriminatedUnionTypeInstance = this.context.resolveDiscriminatedUnionTypeInstance({
      discriminatedUnion,
      value
    });
    if (discriminatedUnionTypeInstance == null) {
      return typescript_exports.TypeLiteral.nop();
    }
    const unionVariant = discriminatedUnionTypeInstance.singleDiscriminatedUnionType;
    const unionProperties = this.convertDiscriminatedUnionProperties({
      discriminatedUnionTypeInstance,
      unionVariant
    });
    if (unionProperties == null) {
      return typescript_exports.TypeLiteral.nop();
    }
    if ((_a = this.context.customConfig) == null ? void 0 : _a.includeUtilsOnUnionMembers) {
      return typescript_exports.TypeLiteral.reference(
        typescript_exports.codeblock((writer) => {
          writer.writeNode(
            typescript_exports.invokeMethod({
              on: typescript_exports.reference({
                name: this.context.namespaceExport,
                importFrom: this.context.getModuleImport(),
                memberName: this.context.getFullyQualifiedReference({
                  declaration: discriminatedUnion.declaration
                })
              }),
              method: this.context.getMethodName(unionVariant.discriminantValue.name),
              arguments_: this.convertDiscriminatedUnionUtilsArgs({
                discriminatedUnionTypeInstance,
                unionVariant,
                unionProperties
              })
            })
          );
        })
      );
    }
    const discriminantProperty = {
      name: this.context.getPropertyName(discriminatedUnion.discriminant.name),
      value: typescript_exports.TypeLiteral.string(unionVariant.discriminantValue.wireValue)
    };
    return typescript_exports.TypeLiteral.object({
      fields: [discriminantProperty, ...unionProperties]
    });
  }
  convertDiscriminatedUnionProperties({
    discriminatedUnionTypeInstance,
    unionVariant
  }) {
    const baseFields = this.getBaseFields({
      discriminatedUnionTypeInstance,
      singleDiscriminatedUnionType: unionVariant
    });
    switch (unionVariant.type) {
      case "samePropertiesAsObject": {
        const named = this.context.resolveNamedType({
          typeId: unionVariant.typeId
        });
        if (named == null) {
          return void 0;
        }
        const converted = this.convertNamed({ named, value: discriminatedUnionTypeInstance.value });
        if (!converted.isObject()) {
          this.context.errors.add({
            severity: Severity.Critical,
            message: "Internal error; expected union value to be an object"
          });
          return void 0;
        }
        const object_ = converted.asObjectOrThrow();
        return [...baseFields, ...object_.fields];
      }
      case "singleProperty": {
        try {
          this.context.errors.scope(unionVariant.discriminantValue.wireValue);
          const record = this.context.getRecord(discriminatedUnionTypeInstance.value);
          if (record == null) {
            return [
              ...baseFields,
              {
                name: UNION_VALUE_KEY,
                value: this.convert({
                  typeReference: unionVariant.typeReference,
                  value: discriminatedUnionTypeInstance.value
                })
              }
            ];
          }
          return [
            ...baseFields,
            {
              name: this.context.getPropertyName(unionVariant.discriminantValue.name),
              value: this.convert({
                typeReference: unionVariant.typeReference,
                value: record[unionVariant.discriminantValue.wireValue]
              })
            }
          ];
        } finally {
          this.context.errors.unscope();
        }
      }
      case "noProperties":
        return baseFields;
      default:
        assertNever(unionVariant);
    }
  }
  convertDiscriminatedUnionUtilsArgs({
    discriminatedUnionTypeInstance,
    unionVariant,
    unionProperties
  }) {
    if (unionVariant.type === "singleProperty") {
      const record = this.context.getRecord(discriminatedUnionTypeInstance.value);
      if (record == null && unionProperties.length === 1) {
        return [
          this.convert({
            typeReference: unionVariant.typeReference,
            value: discriminatedUnionTypeInstance.value
          })
        ];
      }
    }
    return unionProperties.length > 0 ? [typescript_exports.TypeLiteral.object({ fields: unionProperties })] : [];
  }
  getBaseFields({
    discriminatedUnionTypeInstance,
    singleDiscriminatedUnionType
  }) {
    var _a, _b;
    const properties = this.context.associateByWireValue({
      parameters: (_a = singleDiscriminatedUnionType.properties) != null ? _a : [],
      values: (_b = this.context.getRecord(discriminatedUnionTypeInstance.value)) != null ? _b : {},
      // We're only selecting the base properties here. The rest of the properties
      // are handled by the union variant.
      ignoreMissingParameters: true
    });
    return properties.map((property) => {
      this.context.errors.scope(property.name.wireValue);
      try {
        return {
          name: this.context.getPropertyName(property.name.name),
          value: this.convert(property)
        };
      } finally {
        this.context.errors.unscope();
      }
    });
  }
  convertObject({ object_, value }) {
    var _a;
    const properties = this.context.associateByWireValue({
      parameters: object_.properties,
      values: (_a = this.context.getRecord(value)) != null ? _a : {}
    });
    return typescript_exports.TypeLiteral.object({
      fields: properties.map((property) => {
        this.context.errors.scope(property.name.wireValue);
        try {
          return {
            name: this.context.getPropertyName(property.name.name),
            value: this.convert(property)
          };
        } finally {
          this.context.errors.unscope();
        }
      })
    });
  }
  convertEnum({ enum_, value }) {
    const enumValue = this.getEnumValue({ enum_, value });
    if (enumValue == null) {
      return typescript_exports.TypeLiteral.nop();
    }
    return typescript_exports.TypeLiteral.string(enumValue);
  }
  getEnumValue({ enum_, value }) {
    if (typeof value !== "string") {
      this.context.errors.add({
        severity: Severity.Critical,
        message: `Expected enum value string, got: ${typeof value}`
      });
      return void 0;
    }
    const enumValue = enum_.values.find((v) => v.wireValue === value);
    if (enumValue == null) {
      this.context.errors.add({
        severity: Severity.Critical,
        message: `An enum value named "${value}" does not exist in this context`
      });
      return void 0;
    }
    return value;
  }
  convertUndicriminatedUnion({
    undicriminatedUnion,
    value
  }) {
    const result = this.findMatchingUndiscriminatedUnionType({
      undicriminatedUnion,
      value
    });
    if (result == null) {
      return typescript_exports.TypeLiteral.nop();
    }
    return result;
  }
  findMatchingUndiscriminatedUnionType({
    undicriminatedUnion,
    value
  }) {
    for (const typeReference of undicriminatedUnion.types) {
      try {
        return this.convert({ typeReference, value });
      } catch (e) {
        continue;
      }
    }
    this.context.errors.add({
      severity: Severity.Critical,
      message: `None of the types in the undicriminated union matched the given "${typeof value}" value`
    });
    return void 0;
  }
  convertUnknown({ value }) {
    return typescript_exports.TypeLiteral.unknown(value);
  }
  convertPrimitive({
    primitive,
    value,
    as
  }) {
    var _a, _b;
    switch (primitive) {
      case "INTEGER":
      case "UINT": {
        const num = this.getValueAsNumber({ value, as });
        if (num == null) {
          return typescript_exports.TypeLiteral.nop();
        }
        return typescript_exports.TypeLiteral.number(num);
      }
      case "LONG":
      case "UINT_64": {
        const num = this.getValueAsNumber({ value, as });
        if (num == null) {
          return typescript_exports.TypeLiteral.nop();
        }
        if ((_a = this.context.customConfig) == null ? void 0 : _a.useBigInt) {
          return typescript_exports.TypeLiteral.bigint(BigInt(num));
        }
        return typescript_exports.TypeLiteral.number(num);
      }
      case "FLOAT":
      case "DOUBLE": {
        const num = this.getValueAsNumber({ value });
        if (num == null) {
          return typescript_exports.TypeLiteral.nop();
        }
        return typescript_exports.TypeLiteral.number(num);
      }
      case "BOOLEAN": {
        const bool = this.getValueAsBoolean({ value, as });
        if (bool == null) {
          return typescript_exports.TypeLiteral.nop();
        }
        return typescript_exports.TypeLiteral.boolean(bool);
      }
      case "BASE_64":
      case "DATE":
      case "UUID":
      case "STRING": {
        const str = this.context.getValueAsString({ value });
        if (str == null) {
          return typescript_exports.TypeLiteral.nop();
        }
        return typescript_exports.TypeLiteral.string(str);
      }
      case "DATE_TIME": {
        const str = this.context.getValueAsString({ value });
        if (str == null) {
          return typescript_exports.TypeLiteral.nop();
        }
        return typescript_exports.TypeLiteral.datetime(str);
      }
      case "BIG_INTEGER": {
        const bigInt = this.context.getValueAsString({ value });
        if (bigInt == null) {
          return typescript_exports.TypeLiteral.nop();
        }
        if ((_b = this.context.customConfig) == null ? void 0 : _b.useBigInt) {
          return typescript_exports.TypeLiteral.bigint(BigInt(bigInt));
        }
        return typescript_exports.TypeLiteral.string(bigInt);
      }
      default:
        assertNever(primitive);
    }
  }
  getValueAsNumber({
    value,
    as
  }) {
    const num = as === "key" ? typeof value === "string" ? Number(value) : value : value;
    return this.context.getValueAsNumber({ value: num });
  }
  getValueAsBoolean({
    value,
    as
  }) {
    const bool = as === "key" ? typeof value === "string" ? value === "true" : value === "false" ? false : value : value;
    return this.context.getValueAsBoolean({ value: bool });
  }
};

// src/context/FilePropertyMapper.ts
init_process();
init_buffer();
var FilePropertyMapper = class {
  constructor({ context }) {
    __publicField(this, "context");
    this.context = context;
  }
  getFilePropertyInfo({
    body,
    value
  }) {
    var _a;
    const result = {
      fileFields: [],
      bodyPropertyFields: []
    };
    const record = (_a = this.context.getRecord(value)) != null ? _a : {};
    for (const property of body.properties) {
      switch (property.type) {
        case "file":
          result.fileFields.push({
            name: this.context.getPropertyName(property.name),
            value: this.getSingleFileProperty({ property, record })
          });
          break;
        case "fileArray":
          result.fileFields.push({
            name: this.context.getPropertyName(property.name),
            value: this.getArrayFileProperty({ property, record })
          });
          break;
        case "bodyProperty":
          result.bodyPropertyFields.push({
            name: this.context.getPropertyName(property.name.name),
            value: this.getBodyProperty({ property, record })
          });
          break;
        default:
          assertNever(property);
      }
    }
    return result;
  }
  getSingleFileProperty({
    property,
    record
  }) {
    const fileValue = this.context.getSingleFileValue({ property, record });
    if (fileValue == null) {
      return typescript_exports.TypeLiteral.nop();
    }
    return typescript_exports.TypeLiteral.blob(fileValue);
  }
  getArrayFileProperty({
    property,
    record
  }) {
    const fileValues = this.context.getFileArrayValues({ property, record });
    if (fileValues == null) {
      return typescript_exports.TypeLiteral.nop();
    }
    return typescript_exports.TypeLiteral.array({ values: fileValues.map((value) => typescript_exports.TypeLiteral.blob(value)) });
  }
  getBodyProperty({
    property,
    record
  }) {
    const bodyPropertyValue = record[property.name.wireValue];
    if (bodyPropertyValue == null) {
      return typescript_exports.TypeLiteral.nop();
    }
    return this.context.dynamicTypeLiteralMapper.convert({
      typeReference: property.typeReference,
      value: bodyPropertyValue
    });
  }
};

// src/context/DynamicSnippetsGeneratorContext.ts
var DynamicSnippetsGeneratorContext = class _DynamicSnippetsGeneratorContext extends AbstractDynamicSnippetsGeneratorContext {
  constructor({
    ir,
    config: config3
  }) {
    var _a;
    super({ ir, config: config3 });
    __publicField(this, "ir");
    __publicField(this, "customConfig");
    __publicField(this, "dynamicTypeLiteralMapper");
    __publicField(this, "filePropertyMapper");
    __publicField(this, "moduleName");
    __publicField(this, "namespaceExport");
    this.ir = ir;
    this.customConfig = config3.customConfig != null ? config3.customConfig : void 0;
    this.dynamicTypeLiteralMapper = new DynamicTypeLiteralMapper({ context: this });
    this.filePropertyMapper = new FilePropertyMapper({ context: this });
    this.moduleName = getModuleName({ config: config3, customConfig: this.customConfig });
    this.namespaceExport = getNamespaceExport({
      organization: config3.organization,
      workspaceName: config3.workspaceName,
      namespaceExport: (_a = this.customConfig) == null ? void 0 : _a.namespaceExport
    });
  }
  clone() {
    return new _DynamicSnippetsGeneratorContext({
      ir: this.ir,
      config: this.config
    });
  }
  getModuleImport() {
    return {
      type: "named",
      moduleName: this.moduleName
    };
  }
  getRootClientName() {
    return `${this.namespaceExport}Client`;
  }
  getPropertyName(name) {
    var _a, _b;
    if (((_a = this.customConfig) == null ? void 0 : _a.retainOriginalCasing) || ((_b = this.customConfig) == null ? void 0 : _b.noSerdeLayer)) {
      return this.formatOriginalPropertyName(name.originalName);
    }
    return name.camelCase.unsafeName;
  }
  getMethodName(name) {
    return name.camelCase.unsafeName;
  }
  getTypeName(name) {
    return name.pascalCase.unsafeName;
  }
  getEnvironmentTypeReferenceFromID(environmentID) {
    const environmentName = this.resolveEnvironmentName(environmentID);
    if (environmentName == null) {
      return void 0;
    }
    return this.getEnvironmentsTypeReference(environmentName);
  }
  getFullyQualifiedReference({ declaration }) {
    if (declaration.fernFilepath.allParts.length > 0) {
      return `${declaration.fernFilepath.allParts.map((val) => val.camelCase.unsafeName).join(".")}.${this.getTypeName(declaration.name)}`;
    }
    return `${this.getTypeName(declaration.name)}`;
  }
  getEnvironmentsTypeReference(name) {
    return typescript_exports.reference({
      name: `${this.namespaceExport}Environments`,
      importFrom: this.getModuleImport(),
      memberName: this.getTypeName(name)
    });
  }
  formatOriginalPropertyName(value) {
    if (value.includes("-")) {
      return `"${value}"`;
    }
    return value;
  }
};
function getModuleName({
  config: config3,
  customConfig
}) {
  var _a, _b, _c;
  return (_c = (_b = constructNpmPackage({
    generatorConfig: config3,
    isPackagePrivate: (_a = customConfig == null ? void 0 : customConfig.private) != null ? _a : false
  })) == null ? void 0 : _b.packageName) != null ? _c : config3.organization;
}

// src/DynamicSnippetsGenerator.ts
var DynamicSnippetsGenerator = class extends AbstractDynamicSnippetsGenerator {
  constructor({
    ir,
    config: config3
  }) {
    super(new DynamicSnippetsGeneratorContext({ ir, config: config3 }));
  }
  async generate(request) {
    const endpoints = this.context.resolveEndpointLocationOrThrow(request.endpoint);
    if (endpoints.length === 0) {
      throw new Error(`No endpoints found that match "${request.endpoint.method} ${request.endpoint.path}"`);
    }
    const result = new Result();
    for (const endpoint of endpoints) {
      const context = this.context.clone();
      const snippetGenerator = new EndpointSnippetGenerator({
        context
      });
      try {
        const snippet = await snippetGenerator.generateSnippet({ endpoint, request });
        if (context.errors.empty()) {
          return {
            snippet,
            errors: void 0
          };
        }
        result.update({ context, snippet });
      } catch (error) {
        if (result.err == null) {
          result.err = error;
        }
      }
    }
    return result.getResponseOrThrow({ endpoint: request.endpoint });
  }
  generateSync(request) {
    const endpoints = this.context.resolveEndpointLocationOrThrow(request.endpoint);
    if (endpoints.length === 0) {
      throw new Error(`No endpoints found that match "${request.endpoint.method} ${request.endpoint.path}"`);
    }
    const result = new Result();
    for (const endpoint of endpoints) {
      const context = this.context.clone();
      const snippetGenerator = new EndpointSnippetGenerator({
        context
      });
      try {
        const snippet = snippetGenerator.generateSnippetSync({ endpoint, request });
        if (context.errors.empty()) {
          return {
            snippet,
            errors: void 0
          };
        }
        result.update({ context, snippet });
      } catch (error) {
        if (result.err == null) {
          result.err = error;
        }
      }
    }
    return result.getResponseOrThrow({ endpoint: request.endpoint });
  }
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  DynamicSnippetsGenerator
});
/*! Bundled license information:

@esbuild-plugins/node-globals-polyfill/Buffer.js:
  (*!
   * The buffer module from node.js, for the browser.
   *
   * @author   Feross Aboukhadijeh <feross@feross.org> <http://feross.org>
   * @license  MIT
   *)

lodash-es/lodash.js:
  (**
   * @license
   * Lodash (Custom Build) <https://lodash.com/>
   * Build: `lodash modularize exports="es" -o ./`
   * Copyright OpenJS Foundation and other contributors <https://openjsf.org/>
   * Released under MIT license <https://lodash.com/license>
   * Based on Underscore.js 1.8.3 <http://underscorejs.org/LICENSE>
   * Copyright Jeremy Ashkenas, DocumentCloud and Investigative Reporters & Editors
   *)
*/
